/* Program EWBC, Version 2.3.1
*  Authors: Jochen Wolf, Marie Wolfova, Emil Krupa 2012
*/
#include <stdio.h>
#include <math.h>
#include <time.h>
#define C 143 /* Number of categories + 1 */
#define L 20 /* Maximal number of reproductive cycles */
#define T 119 /* Number of cow categories + 1 */
#define G 153 /* Number of categories of animals including subcategories + 1 */
#define P1 21 /* Maximal number of classes for fleshiness */
#define P2 21 /* Maximal number of classes for fat covering */
#define D 6 /* Maximal number of classes for calving performance */
#define NT 34 /* Number of traits + 1 */
#define ACD 30 /*Maximal number of age classes for dams */
#define ACS 25 /*Maximal number of age classes for sires */
#define ACM 60 /*Maximal dimension of matrix for gene flow */ 

void sysvar(FILE *fr, FILE *fw);
int readsyva(FILE *fr);
void inp07(FILE *fw, int n2, int zz);
void outputrw(FILE *fr, FILE *fw);
void outputr(FILE *fr);
void wrides(FILE *fr, FILE *fw);
int dsjf(int m, int d);
void dfdsjf(FILE *fw, int d2); 
void readcom(FILE *fr);
void readdes(FILE *fr);
int readmd(FILE *fr);
int readdatum(FILE *fr, FILE *fw);
float readint(FILE *fw, FILE *fr);
float readfloat(FILE *fw, FILE *fr);
float maxi(float a, float b);
void print23(float a, float b, float c, float d, FILE *fw);
double normdis(double x);
double probit (double y);
void nonsense1();
void nonsense2();
void nonsense3();
void nonsense4();
void nonsense4a();
void nonsense5();
void nonsense6();
void nonsense7();
void nonsense8();
void nonsense9();
void nonsense10();
void nonsense11();
clock_t zac, kon;

int main()
{  
  FILE *fr, *fw, *fw2, *fr2, *fw3;
  char out [128];
  int acd, acs, CC, da, dbpas, DD, deai, delta_d[NT], delta_m[NT], denm2, 
    denm3, depas, dsmp, dsnm2, dsnm3, dw0, dyscl, 
    feedcost, feedlot, flag[5], gene_flow, GG, gstd, i, i1, i2, i3, insc, 
    insh, j, k, lactcur, l_inv, LL, maturity, mo, n, n1, n2, n_sac, p1, p2, 
    pbf, pchf, prodsys, rfi_cow, rfi_f, rfi_fa, rfi_fx, rfi_h,
    tech1, to[NT], trait, TT, tt[NT], zr, zz;
  double a, a1, 
    dysff0[D][L], dysffl[D], dysffld[D], dysfflqm[D], dysfflmc,
    dysfflql[D], dysffldl[D], dysffll[D],
    dysfflqr[D], dysffldr[D], dysfflr[D],
    dysmm0[D][L], dysmml[D], dysmmld[D], dysmmlqm[D], dysmmlmc,
    dysmmlql[D], dysmmldl[D], dysmmll[D],
    dysmmlqr[D], dysmmldr[D], dysmmlr[D], hd[ACM], hm[ACM],
    l2_0[T], l2[T], l3[L], l4[L], m_gf[ACM], m_gf0[ACM], m_sum[ACM], Ncal, 
    NDEd, NDEm,
    Pcfl[P1], Pcfc[P2],Pcflqm[P1], Pcfcqm[P2], Pcfld[P1], Pcfcd[P2], 
    Pcfcmc, Pcfcmcc, Pcfcmcb, Pcfcmch, Pcfcmcca, 
    Pcflmc, Pcflmcc, Pcflmcb, Pcflmch, Pcflmcca,
    Pcflql[P1], Pcfcql[P2], Pcfldl[P1], Pcfcdl[P2], Pcfll[P1], Pcfcl[P2],
    Pc0[P1][P2], Pcflqr[P1], Pcfcqr[P2], Pcfldr[P1], Pcfcdr[P2], Pcflr[P1], 
    Pcfcr[P2],phmat1, phmat2, PM[ACM][ACM], 
    sl2, t[T][T];  
  float a2, a3, a4, aa1, aa2, aa3, aa4, aa5, aa6, ab[L], addry[C], 
    addrybbs, addrybbw, 
    addryfas[C], addrys[C], addryt, addrytb, addrytse, addryw[C], 
    adgbbt, adgcon1f, 
    adgcon1m, adgcon2f, adgcon2m, adgcon3f, adgcon3m, adgfrep, adg[G], 
    adgh1s, adgh2s, adgh2w, adgh3s, adgh3w, adgh4w, adghcal, adgs0[G], 
    adgs1[G], adgs2[G], adgs3[G], adgst, adgtm, adgw1[G], adgw2[G], 
    adgw3[G], adgw4, adgw[G], adgwsc, adgwsf, adgwsm, adgwt, agebbcull, 
    agebbm, agebbse, agebbst, agebbt, agecal, agecwsc, agecwsf, agecwsm, 
    agedcw, agedmh, agedwsc, agedwsf, agedwsm, agefrep, ageh1cal, ageh2cal, 
    ageh3cal, agehcmat, agehcmat1, agehcmat2, agehcmat3, agehmat, 
    agehmat1, agehmat2, agehmat3, agesc, agesf, agesm, agew, aic, aih, aihc,
    am, anphse, anphse1, anphse2, aphse, aphse1, aphse2, atdry[C], 
    atdrybbs, atdrybbw, atdryfas[C], atdrys[C], atdryt, atdrytb, atdrytse, 
    atdryw[C], avelifecc, avelifecy, avl, avh,
    b2, b3, b4, bm, bwf, bw[C], bwm, 
    c2, c3, c4, calfloss, cculcm[L], cculmc[L], clcm[L], clmc[L], cm, cmat[L],
    cmd, con_1, con_2, con_3, conh1, conh2, conh3, cost[C], costbb, costc, 
    costcowy, costdc, costcw, costcwf, costcwfkg, costcwm, costcwmkg,  
    costdf, costdys, costdysc, costf[C], costfas[C], 
    costfatb, costfatbkg, costfatc, costfatckg, costfath, costfathkg, 
    costfbb, costfbbs, costfbbw, costfc, 
    costff[C], costfix[C], costfixc, costfs[C], costftb, costft, 
    costftse, costfw[C], costhbb, costh[C],  costhc, 
    costhnpr, costhnprkg, costhpr, costhprkg, costi, costimc, costimh, 
    costlab, costmbb, costm[G], costo[C], costoc, costvbb, costvbbt, 
    costv[C], costvet[C], costvetc, costvfi, costvfx, costwtbb, costwt[G], 
    cowb, 
    cp2nm[L], cp3nm[L], cpin[L], cp[L], cr2nmh, cr3nmh, crcmp[L], crdys, 
    crh1mp, crhmp, crinh, dasc, dasf, davcal , davcalc, davcalh, davmat, 
    davmatc, davmath, dayshc, dbb, dcalai, dcalmat, dcalnm2, dcalnm3, 
    dccf, dcd[L], dce[L], dconai, dconnm2, dconnm3, dcostw[C], 
    dcw, ddry[C], ddrybbs, ddrybbw, ddryfas[C], ddrys[C], 
    ddryt, ddrytb, ddryts, ddryw[C], 
    dead48f[L], dead48[L], dead48m[L], deadc[L], deadfc[L], deadmc[L], 
    dfcf, dfrp, d[G], dgcxas, dgcxs, dgcxw, dgfxas, 
    dgfxs, dgfxw, dmatpas, dm, dmcf, dot, dotcalf, dotcowh, dotcowo, dotcows,
    dotexpm, dotfati, dotfatib, dotfatx, dottest, dpascal, dpasmat, dprfrep, 
    dresb, dresc, drescw, dresh, dryf[C], dryfx[C], dryhayha, drys[C], 
    drytb, dryt, drytse, dryw[C], ds0[G], ds1[G], ds2[G], ds3[G], 
    dsd[C], ds[G], dsl[C], dslg, dsp[G], dst, dsx, 
    dt, dtse, dungbb, dung[C], dungfi, dungfx, dw1[G], dw2[G], 
    dw3[G], dw4[G], dwd[C], dw[G], dwl[C], dwp1[G], dwp2[G], dwx, 
    dysav, dysf[L], 
    dysm[L], dysff[D][L], dysmm[D][L], 
    dys[L], dysmat[L], dysscoreav, dysscore[D],  
    ecr2nmc, ecr3nmc, ecrinc, edf[C],
    edfx[C], eds[C], edtb, edt, edtse, edw[C], 
    ew[NT], ew0[NT], ew_d[NT], ewdiff[NT], ew_m[NT], 
    ewr_da[NT], ewr_dd[NT], ewr_ma[NT], ewr_mm[NT], 
    ewst_d[NT], ewst_m[NT], ewsum, ewsum_d, ewsum_m, exfc, exmc, 
    fas[C], fase[C], faspdi[C], fat, fbbs, fbbse, fbbspdi, fbbw, fbbwe, 
    fbbwpdi, f[C], fe[C], fixcbb, fixcbbt, fixcbt, fixcc, fixcfi, 
    fixcfx, fixcrh, fpdi[C], fs[C], fse[C], fspdi[C], ft, ftb, ftbe, 
    ftbpdi, fte, ftpdi, fts, ftse, ftsepdi, fw0[C], fwe[C], fwpdi[C], 
    gstd_d[NT], gstd_m[NT], h1mpf, h1mprp, h2mpf, h2mprp, h3mpf, hcmat1, 
    hcmat1p, hcmat2, hcmat2p, hcmat3p, hcon1mat, hcon2mat, hcon3mat, 
    herdbook, hmpf, 
    intcm, intcmc, k2, k3, k4, kbd, kbl, kbwmf, kce, kcon2c, kcon2h, kcon3c, 
    kcon3h, kcp, kdgfxwas, kdgfxws, kdgxascf, kdgxscf, kdgxwcf, kdresb, kdresbh, 
    kdresc, kdresch, kdrescwh, kdresh, kff, kfpa, kfw, 
    kgaincf, kgainmf, kgcon1mf, kgcon2mf, kgcon3mf, khe, khp, km, 
    kmcwhmin, kmwbc, kp21, 
    kpm1, kpm2, kpr[C], kslb, kslc, kslcx, kslh, kslhx, kt, ktb, ktf, ktp, 
    l1[C], labdys[D], lengbt, lghrcyc, lgpre, lifebb, 
    life[C], lm2, lm3, lm4, lmm, 
    losc, losff, losfpa, losfw, losmw, loswf, mcw, 
    min[C], mp2, mp3, mp4, mpm, mpm0, msel, mtest, mwb, nccf, ncows, ndaycc, 
    ndaycd, 
    ndaycw, ndaydys, NDEc[C], NDEdys, NDEr[C], neas[C], nebbm, nebbs, nebbsl, 
    nebbw, nebt, ne[C], negs[C], negw[C], nems[C], nemw[C], nepc[G], nes0[G], 
    nes1[G], nes2[G], nes3[G], nescal[C], nes[G], nesl[C], nesncal[C], nesp[G], 
    net, netse, new[G], new1[G], new2[G], new3[G], new4, newcal[C],  
    newl[C], newncal[C], newp[G],newp1[G], newp2[G], Nfav, Nfc48a, 
    Nfcba, nfcf, Nfcw, Nffa, Nfmat, Nfrp, Nmc48a, Nmcba, nmcf, Nmcf, Nmcfb, 
    Nmcfc, Nmcw, np[C], npc[L], npcsn[L], npcsp[L], nphs, nphsold1, nphsold2, nr, 
    Pb[P1][P2],  
    pcalc[C], pcal[L], pcdys[L], pclos[L], pcmf, Pc[P1][P2], Pcs[P1][P2], 
    pcul[L], pdias[C], pdibbm, pdibbs, pdibbsl, pdibbw, pditb, pdidf[C], 
    pdidfx[C], pdids[C], pdidtb, pdidt, pdidtse, pdidw[C], 
    pdi[C], pdigs[C], pdigw[C], pdims[C], pdimw[C], 
    pdipc[G], pdis[G], pdis0[G], pdis1[G], pdis2[G], pdis3[G], pdiscal[C],  
    pdisl[C], pdisncal[C], pdisp[G], pdit, pditse, pdiw[G], pdiw1[G], pdiw2[G], 
    pdiw3[G], pdiw4, pdiwcal[C], pdiwl[C], pdiwncal[C], 
    pdiwp[G], pdiwp1[G], pdiwp2[G], pf[C], pff, phc1, phc2, phc3, php1, Ph[P1][P2], 
    php2, php3, phs,pinmatd[L], pinmatnd[L], pl, pm[C], pncalc[C], pncal[L], pp[C], 
    prai, prair, pras[C], prb, prbb, prbbcull, prbbsel,
    Prb[P1][P2], prc, pr[C], Prc[P1][P2], prcs, 
    Prcs[P1][P2], prdg, preg2nmc[L], preg2nmh, preg3nmc[L], preg3nmh, pregaic[L], 
    pregaih, prf[C], prh, Prh[P1][P2], prm[C], prnphse, profitab, profitabd,
    prot, prphse, prrep, 
    prs[C], prst, prtb, prt, prtse, prw[C], prwt, qc[C], qr[C], rev[C], rfi[C],
    rfis[C], rfisc, rfisf, rfit, rfitb, rfits, rfiw[C], sdcd, sdce, 
    sfrp, sigmawh, sl_1[C], sl_2[C], sl_3[C], sl[C], startbt, stcd[L], stce[L], 
    strawbb, straw[C], strawfi, strawfx, suml1, tc[C], Tcost, 
    tdry[C], tdrybbs, tdrybbse, tdrybbspdi, tdrybbw, tdrybbwe, tdrybbwpdi,
    tdrye[C], tdryfas[C], tdryfase[C], tdryfaspdi[C], tdrypdi[C],
    tdrys[C], tdryse[C], tdryspdi[C], tdryt, tdrytb, tdrytbe, tdrytbpdi, 
    tdryte, tdrytpdi, tdryts, tdrytse, tdrytspdi, 
    tdryw[C], tdrywe[C], tdrywpdi[C],
    Tprof, Tprofh, Tprofl, tr[C], Trev, tvh, tvha, tvhb, tvhc, tvhd, tvhe, 
    tvl, tvla, tvlb, tvlc, tvld, tvle, tvm, tvma, tvmb, tvmc, tvmd, tvme,
    u, vetdys[D], w1conf, w1conm, w2conf, 
    w2conm, w3conf, w3conm, wat[C], wbbse, wbbst, wbbt, wbfat, wcacal[L], 
    wccal[L], wcc[L], wccw[L], wcd[L], wcdys[L], wcfat, wcwsc, 
    wcwsf, wcwsm, wcxfat, wcxs, wcxw, wdcwf, wdcwm, wdwsc, wdwsf, wdwsm, 
    wfrep, wfxs, wfxw, wh1cal, wh2cal, wh3cal, whcal, whcmat, whcmat1, whcmat2, 
    whcmat3, whdmh, whfat, whmat, whmat1, whmat2, whmat3, whmin, whxfat, 
    wl_1[C], wl_2[C], wl_3[C], wl[C], wnphse, wphse, wpreg, ws0[G], ws1[G], ws2[G], 
    ws3, ww1[G], ww2[G], ww3[G], wwf, ww[C], wwm, zzlosc[100];
    
  zac = clock(); /* Start of measuring time for calculation */
  
/* Starting values */
  /* Integer variables */
  acd = acs = CC = da = dbpas = DD = deai = denm2 = denm3 = depas = dsmp = 
    dsnm2 = dsnm3 = dw0 = dyscl = feedcost = feedlot = gene_flow = GG = 
    gstd = i = i1 = i2 = i3 =
    insc = insh = j = k = lactcur = l_inv = LL = maturity = mo = n = n1 = n2 = 
    n_sac = p1 = p2 = pbf = pchf = prodsys = 
    rfi_cow = rfi_f = rfi_fa = rfi_fx = rfi_h = tech1 = trait = 
    TT = zr = zz = 0; 
  /* Double precision variables */
  a = a1 = dysfflmc =  dysmmlmc =  Ncal =  NDEd = NDEm =  Pcfcmc = Pcfcmcc =
    Pcfcmcb = Pcfcmch = Pcfcmcca =  Pcflmc = Pcflmcc = Pcflmcb = Pcflmch =
    Pcflmcca =  phmat1 = phmat2 = sl2 = 0.0;  
  /* Float variables */   
  addrybbs = addrybbw = addryt = addrytb = addrytse = adgbbt = adgcon1f 
    = adgcon1m = adgcon2f = adgcon2m =
    adgcon3f = adgcon3m = adgfrep =  adgh1s = adgh2s = adgh2w = adgh3s = adgh3w
    = adgh4w = adghcal = adgst = adgtm =  adgw4 = adgwsc = adgwsf = adgwsm =
    adgwt = agebbcull =  agebbm = agebbse = agebbst = agebbt = agecal = agecwsc
    = agecwsf = agecwsm =  agedcw = agedmh = agedwsc = agedwsf = agedwsm =
    agefrep = ageh1cal = ageh2cal =  ageh3cal = agehcmat = agehcmat1 = agehcmat2
    = agehcmat3 = agehmat =  agehmat1 = agehmat2 = agehmat3 = agesc = agesf =
    agesm = agew = aic = aih = aihc = am = anphse = anphse1 = anphse2 = aphse =
    aphse1 = aphse2 = atdrybbs = atdrybbw = atdryt = atdrytb = atdrytse 
    = avelifecc = avelifecy = avl = avh =
    b2 = b3 = b4 = bm = bwf = bwm =  c2 = c3 = c4 = calfloss = cm =  cmd = con_1
    = con_2 = con_3 = conh1 = conh2 = conh3 = costbb = costc =  costcowy =
    costdc = costcw = costcwf = costcwfkg = costcwm = costcwmkg =   costdf =
    costdys = costdysc = costfatb = costfatbkg = costfatc = costfatckg = 
    costfath = costfathkg =  costfbb = costfbbs = costfbbw = costfc =  costfixc
    = costftb = costft =  costftse = costhbb = costhc =  costhnpr = costhnprkg =
    costhpr = costhprkg = costi = costimc = costimh =  costlab = costmbb =
    costoc = costvbb = costvbbt =  costvetc = costvfi = costvfx = costwtbb = 
    cowb =  cr2nmh = cr3nmh = crdys =  crh1mp = crhmp = crinh = dasc = dasf =
    davcal  = davcalc = davcalh = davmat =  davmatc = davmath = dayshc = dbb =
    dcalai = dcalmat = dcalnm2 = dcalnm3 =  dccf = dconai = dconnm2 = dconnm3 =
    dcostw[C] =  dcw = ddrybbs = ddrybbw = ddryt = ddrytb = ddryts = dfcf 
    = dfrp = dgcxas = dgcxs = dgcxw
    = dgfxas =  dgfxs = dgfxw = dmatpas = dm = dmcf = dot = dotcalf = dotcowh =
    dotcowo = dotcows = dotexpm = dotfati = dotfatib = dotfatx = dottest =
    dpascal = dpasmat = dprfrep =  dresb = dresc = drescw = dresh = dryhayha = 
    drytb = dryt = drytse = dslg = dst = dsx =  dt = dtse = dungbb = dungfi =
    dungfx = dwx = dysav =  dysscoreav =  ecr2nmc = ecr3nmc = ecrinc =  edtb =
    edt = edtse =  ewsum = ewsum_d =  ewsum_m = exfc = exmc = fat = fbbs = fbbse
    = fbbspdi = fbbw = fbbwe =  fbbwpdi = fixcbb = fixcbbt = fixcbt = fixcc =
    fixcfi =  fixcfx = fixcrh = ft = ftb = ftbe =  ftbpdi = fte = ftpdi = fts =
    ftse = ftsepdi =   h1mpf = h1mprp = h2mpf = h2mprp = h3mpf = hcmat1 = 
    hcmat1p = hcmat2 = hcmat2p = hcmat3p = hcon1mat = hcon2mat = hcon3mat = 
    herdbook = hmpf =  intcm = intcmc = k2 = k3 = k4 = kbd = kbl = kbwmf = kce =
    kcon2c = kcon2h = kcon3c =  kcon3h = kcp = kdgfxwas = kdgfxws = kdgxascf =
    kdgxscf = kdgxwcf = kdresb = kdresbh =  kdresc = kdresch = kdrescwh = kdresh
    = kff = kfpa = kfw =  kgaincf = kgainmf = kgcon1mf = kgcon2mf = kgcon3mf =
    khe = khp = km =  kmcwhmin = kmwbc = kp21 =  kpm1 = kpm2 = kslb = kslc =
    kslcx = kslh = kslhx = kt = ktb = ktf = ktp =  lengbt = lghrcyc = lgpre =
    lifebb =  lm2 = lm3 = lm4 = lmm =  losc = losff = losfpa = losfw = losmw =
    loswf = mcw =  mp2 = mp3 = mp4 = mpm = mpm0 = msel = mtest = mwb = nccf =
    ncows = ndaycc =  ndaycd =  ndaycw = ndaydys = NDEdys = nebbm = nebbs =
    nebbsl =  nebbw = nebt =   net = netse = new4 = Nfav = Nfc48a =  Nfcba =
    nfcf = Nfcw = Nffa = Nfmat = Nfrp = Nmc48a = Nmcba = nmcf = Nmcf = Nmcfb = 
    Nmcfc = Nmcw = nphs = nphsold1 = nphsold2 = nr = pcmf = pdibbm = pdibbs =
    pdibbsl  = pdibbw = pdidtb = pdidt = pdidtse =  pdit = pditb =  pditse = 
    pdiw4 = pff = phc1 = phc2 = phc3 = php1 = php2 = php3 = phs = pl = prai = 
    prair = prb = prbb = prbbcull = prbbsel = prc = prcs =  prdg = preg2nmh =
    preg3nmh =  pregaih = prh = prnphse = profitab = profitabd = prot = prphse =
    prrep =  prst = prtb = prt = prtse = prwt = rfisc = rfisf = rfit = rfitb =
    rfits = sdcd = sdce   = sfrp = sigmawh = startbt =  strawbb = strawfi =
    strawfx = suml1 = Tcost = tdrybbs = tdrybbse = tdrybbspdi = tdrybbw = 
    tdrybbwe = tdrybbwpdi = tdryt = tdrytb = tdrytbe = tdrytbpdi = 
    tdryte = tdrytpdi = tdryts = tdrytse = tdrytspdi = Tprof = Tprofh = 
    Tprofl = Trev = tvh = tvl = tvm =
    u = w1conf = w1conm = w2conf =  w2conm = w3conf = w3conm = wbbse = wbbst =
    wbbt = wbfat =  wcfat = wcwsc =  wcwsf = wcwsm = wcxfat = wcxs = wcxw =
    wdcwf = wdcwm = wdwsc = wdwsf = wdwsm =  wfrep = wfxs = wfxw = wh1cal =
    wh2cal = wh3cal = whcal = whcmat = whcmat1 = whcmat2 =  whcmat3 = whdmh =
    whfat = whmat = whmat1 = whmat2 = whmat3 = whmin = whxfat =  wnphse = wphse
    = wpreg = ws3 = wwf = wwm = 0.0;
  /* Fields */
  for (j = 0; j < D; j++) {
    dysffl[j] = dysffld[j] = dysfflqm[j] = dysfflql[j] = dysffldl[j] =  
    dysffll[j] = dysfflqr[j] = dysffldr[j] = dysfflr[j] = dysmml[j] =
    dysmmld[j] = dysmmlqm[j] = dysmmlql[j] = dysmmldl[j] = dysmmll[j] =
    dysmmlqr[j] = dysmmldr[j] = dysmmlr[j] = dysscore[j] = vetdys[j] = 0.0; 
    for (i = 0; i < L; i++) {    
      dysff0[j][i] = dysmm0[j][i] = dysff[j][i] = dysmm[j][i] = 0.0; 
      }
    }
  for (j = 0; j < ACM; j++) {
    hd[j] = hm[j] = m_gf[j] = m_gf0[j] = m_sum[j] = 0.0;
    for (i = 0; i < ACM; i++) PM[j][i] = 0.0; 
    }
  for (j = 0; j < T; j++) {
    l2_0[j] = l2[j] = 0.0;
    for (i = 0; i < T; i++) t[j][i] = 0.0; 
    }
  for (i = 0; i < L; i++) {
    l3[i] = l4[i] = ab[i] = cculcm[i] = cculmc[i] = clcm[i] = clmc[i] = cmat[i] 
    = cp2nm[i] = cp3nm[i] = cpin[i] = cp[i] = crcmp[i] =  dcd[i] = dce[i] =
    dead48f[i] = dead48[i] = dead48m[i] = deadc[i] = deadfc[i] = deadmc[i] = 
    dysf[i] = dysm[i] = dys[i] = dysmat[i] = npc[i] = npcsn[i] = npcsp[i] = 
    pcal[i] = pcdys[i] = pclos[i] = pcul[i] = pinmatd[i] = pinmatnd[i] = 
    pncal[i] = preg2nmc[i] = preg3nmc[i] = pregaic[i] = stcd[i] = stce[i] =
    wcacal[i] = wccal[i] = wcc[i] = wccw[i] = wcd[i] = wcdys[i] = 0.0; 
    }
  for (i = 0; i < P1; i++) {
    Pcfl[i] = Pcflqm[i] = Pcfld[i] = Pcflql[i] = Pcfldl[i] = Pcfll[i] = 
    Pcflqr[i] = Pcfldr[i] = Pcflr[i] = 0.0;
    for (j = 0; j < P2; j++) {    
      Pc0[i][j] = Pb[i][j] = Pc[i][j] = Pcs[i][j] = Ph[i][j] = Prb[i][j] = 
      Prc[i][j] = Prcs[i][j] = Prh[i][j] = 0.0; 
      }
    }
  for (i = 0; i < P2; i++) {
    Pcfc[i] = Pcfcqm[i] = Pcfcd[i] = Pcfcql[i] = Pcfcdl[i] = Pcfcl[i] = 
    Pcfcqr[i] = Pcfcdr[i] = Pcfcr[i] = 0.0; 
    }
  for (i = 0; i < G; i++) {
    adg[i] = adgs0[i] = adgs1[i] = adgs2[i] = adgs3[i] = adgw1[i] = adgw2[i]
    =  adgw3[i] = adgw[i] = costm[i] = costwt[i] = d[i] = ds[i] = ds0[i] =
    ds1[i] = 
    ds2[i] = ds3[i] = dsp[i] = dw[i] = dw1[i] = dw2[i] = dw3[i] = dw4[i] =
    dwp1[i]  = dwp2[i] = nepc[i] = nes0[i] = nes1[i] = nes2[i] = nes3[i] =
    nes[i] = nesp[i] = new[i] =  new1[i] = new2[i] = new3[i] = newp[i] =
    newp1[i] = newp2[i] =  pdipc[i] = pdis[i] = pdis0[i] = pdis1[i] = pdis2[i]
    = pdis3[i] =  pdisp[i] = pdiw[i] = pdiw1[i] = pdiw2[i] = pdiw3[i] =
    pdiwp[i] =  pdiwp1[i] = pdiwp2[i] = ws0[i] = ws1[i] = ws2[i] = ww1[i] =
    ww2[i] = ww3[i] = 0.0;
    }
  for (i = 0; i < C; i++) {
    addry[i] = addryfas[i] = addrys[i] = addryw[i] = atdry[i] = atdryfas[i] 
    = atdrys[i] = atdryw[i] 
    = bw[i] = costf[i] = costfas[i] = 
    costff[i] = costfix[i] = costfs[i] =
    costfw[i] = costh[i] = costo[i] = costv[i] = costvet[i] = 
    dcostw[i] = ddry[i] = ddryfas[i] = ddrys[i] = ddryw[i] = 
    dryf[i] = dryfx[i] = drys[i] = dryw[i] = dsd[i] = dsl[i]
    = dung[i] = dwd[i] = dwl[i] = edf[i] = edfx[i] = eds[i] = edw[i] = fas[i] =
    fase[i] = faspdi[i] = f[i] = fe[i] = fpdi[i] = fs[i] = fse[i] =
    fspdi[i] = fw0[i] = fwe[i] = fwpdi[i] = kpr[i] = l1[i] = life[i] 
    = min[i] = NDEc[i] =
    NDEr[i] = neas[i] = ne[i] = negs[i] = negw[i] = nems[i] = nemw[i] =
    nescal[i] = nesl[i] = nesncal[i] = newcal[i] =   newl[i] = newncal[i] =
    np[i] =  pcalc[i] = pdias[i] = pdidf[i] = pdidfx[i] = pdids[i] =
    pdidw[i] = pdi[i] = pdigs[i] = pdigw[i] = pdims[i] = pdimw[i] = pdiscal[i] =
    pdisl[i] = pdisncal[i] = pdiwcal[i] = pdiwl[i] = pdiwncal[i] = pf[i] = pm[i]
    = pncalc[i] = pp[i] = pras[i] =  pr[i] = prf[i] = prm[i] = prs[i] = prw[i] =
    qc[i] = qr[i] = rev[i] = rfi[i] = rfis[i] = rfiw[i] =
    sl_1[i] = sl_2[i] = sl_3[i] = sl[i] = straw[i] =
    tc[i] = tdry[i] = tdrye[i] = tdryfas[i] = tdryfase[i] = tdryfaspdi[i] 
    = tdrypdi[i] = tdrys[i] = tdryse[i] = 
    tdryspdi[i] = tdryw[i] = tdrywe[i] 
    = tdrywpdi[i] = tr[i] = wat[i] = 
    wl_1[i] = wl_2[i] = wl_3[i] = wl[i] = ww[i] = 0.0;   
    }
  for (i = 0; i < NT; i++) {
    ew[i] = ew0[i] = ew_d[i] = ewdiff[i] = ew_m[i] = 
    ewr_da[i] = ewr_dd[i] = ewr_ma[i]= ewr_mm[i] = 
    ewst_d[i] = ewst_m[i] = gstd_d[i] = gstd_m[i] = 0.0; 
    tt[i] = delta_d[i] = delta_m[i] = 0;
    to[i] = 2;
    }
  for (i = 0; i < 100; i++) 
    zzlosc[i] = 0.0;
  for (i = 0; i < 5; i++) flag[i] = 0;
     
/* Parameters with fixed values */
  k2 = 6;
  k3 = 8.25;
  k4 = 9.25;
  km = 10;
  lghrcyc = 365;
  trait = 0;
  zr = 1;

/* Type of traits: 0 - direct, 1 - maternal, 2 - direct and maternal */
  for (i = 1; i <= 3; i++) tt[i] = 2;
  tt[4] = tt[11] = tt[13] = tt[29] = tt[33] = 1;
  for (i = 5; i <= 8; i++) tt[i] = 2;
  for (i = 24; i <= 28; i++) tt[i] = 2;
    
  printf("\n\n\nRunning EWBC Version 2.3.1, 2012\n"); 
  printf("Authors: Jochen Wolf (wolf.jochen@vuzv.cz)\n");
  printf("         Marie Wolfova (wolfova.marie@vuzv.cz)\n"); 
  printf("         Emil Krupa (krupa.emil@vuzv.cz)\n\n");

  /* Writing the head of the output file */
  fr2 = fopen("TEXT_OUT.TXT", "r"); /* File for reading text for output */
  printf("Please enter the name of the file for writing results\n");
  scanf("%s", out);
  fw = fopen(out, "w"); /* File for writing results */  
  outputrw(fr2, fw);
  
  /* Reading parameter file PARA.TXT and writing its information to output file */
  fr = fopen("PARA.TXT", "r");
  outputrw(fr, fw);
  sysvar(fr, fw);
  fclose(fr);  
  fr = fopen("PARA.TXT", "r");
  outputr(fr);
  prodsys = readsyva(fr);
  feedlot = readsyva(fr);  
  tech1 = readsyva(fr);  
  maturity = readsyva(fr);  
  lactcur = readsyva(fr); 
  feedcost = readsyva(fr);  
  insh = readsyva(fr);  
  insc = readsyva(fr);   
  gene_flow = readsyva(fr); 
  LL = readsyva(fr); 
  gstd = readsyva(fr); 
  rfi_h = readsyva(fr); 
  rfi_f = readsyva(fr); 
  rfi_cow = readsyva(fr); 
  fclose(fr); 
  if (feedlot == 1 && rfi_f == 1) rfi_fa = 1;
  if (feedlot == 2 && rfi_f == 1) rfi_fx = 1;

  /* Test of parameter LL */
  if (LL > 20 || LL < 4) {
    nonsense8();
    goto END;
  } 
  if (feedlot == 0 && rfi_f == 1) {
    fprintf(fw, "The economic weight for daily dry matter intake in intensive or extensive\n");
    fprintf(fw, "  fattening cannot be calculated because there is no fattening in the system.\n");
    fprintf(fw, "  The parameter 'Calculation of economic value for residual dry matter\n");
   fprintf(fw, "  intake of animals in fattening' was changed to zero.\n\n");    
  }
  if (feedlot == 0) rfi_f = 0;

  /* Calculation of important variables */
  TT = (LL-1)*6 + 4;
  CC = TT + 24;
  GG = CC + 10;

  outputrw(fr2, fw); /* Start of writing the parameters from the data input files */
  /* Reading input file INPUT01.TXT and writing its information to output file */
  zz = 1;
  n2 = 1;
  inp07(fw,n2,zz);
  printf("Reading data from INPUT01.TXT\n");   
  fr = fopen("INPUT01.TXT", "r");
  readcom(fr);
  /* Reading the input parameters */
  dbpas = readdatum(fr,fw);
  depas = readdatum(fr,fw);
  dsmp = readdatum(fr,fw);  
  deai = readdatum(fr,fw);
  dsnm2 = readdatum(fr,fw); 
  denm2 = readdatum(fr,fw);
  dsnm3 = readdatum(fr,fw);  
  denm3 = readdatum(fr,fw);  
  dw0 = readdatum(fr,fw);  
  if (prodsys == 1) startbt = readdatum(fr,fw);  
  fclose(fr);
  fprintf(fw, "\n\n");  

  /* Reading input file INPUT02.TXT */  
  n2 = 2;
  zz++;
  printf("Reading data from INPUT02.TXT\n"); 
  inp07(fw,n2,zz);
  fr = fopen("INPUT02.TXT", "r");
  readcom(fr);
  /* Reading the input parameters and writing them to the output file*/
  DD=readint(fw,fr);
  dyscl=readint(fw,fr);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &pp[25+i*6]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", pp[25+i*6]);
  for (i = 1; i < LL; i++) fscanf(fr, "%f", &np[25+i*6]);
    wrides(fr,fw); 
    for (i = 1; i < LL; i++) fprintf(fw, "%7.3f", np[25+i*6]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &pp[27+i*6]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", pp[27+i*6]);
  for (i = 1; i < LL; i++) fscanf(fr, "%f", &np[27+i*6]);
    wrides(fr,fw); 
    for (i = 1; i < LL; i++) fprintf(fw, "%7.3f", np[27+i*6]);
  for (i = 0; i < LL-1; i++) fscanf(fr, "%f", &npcsp[i]);
    wrides(fr,fw);
    for (i = 0; i < LL-1; i++) fprintf(fw, "%7.3f", npcsp[i]);
  for (i = 1; i < LL-1; i++) fscanf(fr, "%f", &npcsn[i]);
    wrides(fr,fw);
    for (i = 1; i < LL-1; i++) fprintf(fw, "%7.3f", npcsn[i]);
  for (i = 0; i < LL-1; i++) fscanf(fr, "%f", &pinmatd[i]);
    wrides(fr,fw);
    for (i = 0; i < LL-1; i++) fprintf(fw, "%7.3f", pinmatd[i]);
  for (i = 0; i < LL-1; i++) fscanf(fr, "%f", &pinmatnd[i]);
    wrides(fr,fw);
    for (i = 0; i < LL-1; i++) fprintf(fw, "%7.3f", pinmatnd[i]);
  pinmatd[LL-1] = 0;
  pinmatnd[LL-1] = 0; 
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &ab[i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", ab[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &stcd[i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", stcd[i]);    
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &stce[i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", stce[i]);    
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &dcd[i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dcd[i]);    
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &dce[i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dce[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[1][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysff[1][i]);    
  if (DD >= 3) {
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[2][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysff[2][i]);    
    }
    else readdes(fr);
  if (DD >= 4) {  
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[3][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysff[3][i]);    
    }
    else readdes(fr);
  if (DD >= 5) {  
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[4][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysff[4][i]);    
    }
    else readdes(fr);
  if (DD == 6) {  
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[5][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysff[5][i]);    
    }
    else readdes(fr);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[1][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysmm[1][i]);    
  if (DD >= 3) {
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[2][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysmm[2][i]);    
    }
    else readdes(fr);
  if (DD >= 4) {
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[3][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysmm[3][i]);    
    }
    else readdes(fr);
  if (DD >= 5) {
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[4][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysmm[4][i]);    
    }
    else readdes(fr);
  if (DD == 6) {
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[5][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%7.3f", dysmm[5][i]);    
    }
    else readdes(fr);
  fclose(fr);
  fprintf(fw, "\n\n");
  for (i = 0; i < LL; i++) {
    dysff[0][i] = dysmm[0][i] = 1.0;
    for (j = 1; j < DD; j++) {
      dysff[0][i] -= dysff[j][i];
      dysmm[0][i] -= dysmm[j][i];
      }
    }
  
  /* Reading input file INPUT03.TXT and writing its information to output file */
  n2 = 3;
  zz++;
  printf("Reading data from INPUT03.TXT\n"); 
  inp07(fw,n2,zz);
  fr = fopen("INPUT03.TXT", "r");
  readcom(fr);  
  /* Reading the input parameters */
  crinh=readfloat(fw,fr);
  cr2nmh=readfloat(fw,fr);
  cr3nmh=readfloat(fw,fr);
  ecrinc=readfloat(fw,fr); 
  ecr2nmc=readfloat(fw,fr);
  ecr3nmc=readfloat(fw,fr);
  lgpre=readfloat(fw,fr);
  crdys=readfloat(fw,fr); 
  cowb=readfloat(fw,fr);
  nr=readfloat(fw,fr); 
  intcm=readfloat(fw,fr);  
  fat=readfloat(fw,fr);
  prot=readfloat(fw,fr);   
  wcacal[1]=readfloat(fw,fr); 
  mcw=readfloat(fw,fr); 
  wpreg=readfloat(fw,fr);  
  drescw=readfloat(fw,fr);
  cmd=readfloat(fw,fr);
  dcw=readfloat(fw,fr);
  loswf=readfloat(fw,fr);
  losfpa=readfloat(fw,fr);
  dryhayha=readfloat(fw,fr);  
  drys[8]=readfloat(fw,fr);  
  dryw[8]=readfloat(fw,fr);
  drys[25]=readfloat(fw,fr);
  dryw[25]=readfloat(fw,fr);
  readcom(fr);  
  if (rfi_cow == 1) {
    rfis[25]=readfloat(fw,fr);
    rfiw[25]=readfloat(fw,fr);     
    }
  else for (i = 1; i <= 2; i++) readdes(fr);
  eds[25]=readfloat(fw,fr);
  eds[8]=readfloat(fw,fr);
  edw[25]=readfloat(fw,fr);
  edw[8]=readfloat(fw,fr);
  pdids[25]=readfloat(fw,fr); 
  pdids[8]=readfloat(fw,fr); 
  pdidw[25]=readfloat(fw,fr); 
  pdidw[8]=readfloat(fw,fr); 
  kbd=readfloat(fw,fr);
  kbl=readfloat(fw,fr);
  ktp=readfloat(fw,fr);
  ktb=readfloat(fw,fr);
  ktf=readfloat(fw,fr);    
  min[25]=readfloat(fw,fr);
  wat[25]=readfloat(fw,fr);
  straw[30]=readfloat(fw,fr);
  dung[30]=readfloat(fw,fr);  
  prai=readfloat(fw,fr);  
  prair=readfloat(fw,fr);
  prw[25]=readfloat(fw,fr);
  prw[8]=readfloat(fw,fr);
  prs[25]=readfloat(fw,fr);
  prs[8]=readfloat(fw,fr);
  prdg=readfloat(fw,fr);
  prm[25]=readfloat(fw,fr); 
  prm[22]=readfloat(fw,fr);   
  prst=readfloat(fw,fr);
  prwt=readfloat(fw,fr);
  pr[8]=readfloat(fw,fr);
  pr[9]=readfloat(fw,fr);
  prc=readfloat(fw,fr);
  kpr[29]=readfloat(fw,fr);
  dotcalf=readfloat(fw,fr); 
  dotcowh=readfloat(fw,fr); 
  dotcowo=readfloat(fw,fr); 
  dotcows=readfloat(fw,fr);
  dotexpm=readfloat(fw,fr); 
  herdbook=readfloat(fw,fr); 
  costdc=readfloat(fw,fr);
  costdf=readfloat(fw,fr);
  costv[30]=readfloat(fw,fr);
  vetdys[0]=readfloat(fw,fr); 
  vetdys[1]=readfloat(fw,fr); 
  if (DD >= 3) vetdys[2]=readfloat(fw,fr);
    else readdes(fr); 
  if (DD >= 4) vetdys[3]=readfloat(fw,fr); 
    else readdes(fr); 
  if (DD >= 5) vetdys[4]=readfloat(fw,fr); 
    else readdes(fr); 
  if (DD == 6) vetdys[5]=readfloat(fw,fr); 
    else readdes(fr); 
  labdys[0]=readfloat(fw,fr); 
  labdys[1]=readfloat(fw,fr); 
  if (DD >= 3) labdys[2]=readfloat(fw,fr); 
    else readdes(fr); 
  if (DD >= 4) labdys[3]=readfloat(fw,fr);
    else readdes(fr); 
  if (DD >= 5) labdys[4]=readfloat(fw,fr);
    else readdes(fr); 
  if (DD >= 6) labdys[5]=readfloat(fw,fr);
    else readdes(fr); 
  costlab=readfloat(fw,fr);
  fixcc=readfloat(fw,fr);
  u=readfloat(fw,fr);
  hcmat1=readfloat(fw,fr);
  hcmat2=readfloat(fw,fr); 
  exfc=readfloat(fw,fr); 
  exmc=readfloat(fw,fr); 
  if (prodsys == 1) mtest=readfloat(fw,fr); 
    else readdes(fr); 
  pcmf=readfloat(fw,fr); 
  pff=readfloat(fw,fr);   
  fclose(fr);
  fprintf(fw, "\n\n");  
  if (exmc + mtest > 0.999999 || pcmf > 0.999999) pbf = 0;
    else pbf = 1;
  if (pcmf < 0.000001 && pff < 0.000001) pchf = 0;
    else pchf = 1; 
  if (feedlot == 0) pcmf = pff = pbf = 0;  
  if (feedlot == 0 && exmc + mtest < 0.999999) {
    if (prodsys == 1) nonsense9();
    if (prodsys > 1) nonsense10();
    goto END;
  } 
  if (pbf == 0 && pcmf < 0.000001 && exmc + mtest < 0.999999) {
    if (prodsys == 1) nonsense9();
    if (prodsys > 1) nonsense10();
    goto END;
  } 
  if (pcmf > 0.000001 && exmc + mtest > 0.999999) {
    pcmf = 0;
    if (pff < 0.000001) {
      feedlot = 0;
      fprintf(fw, "\n\n######################################################\n");
      fprintf(fw, "# W A R N I N G !                                    #\n");
      fprintf(fw, "# The option for fattening given in the parameter    #\n");
      fprintf(fw, "# file was changed to 0 as there are no animals      #\n");
      fprintf(fw, "# for fattening.                                     #\n");
      fprintf(fw, "######################################################\n\n\n");
    }
  }
  if (feedlot == 2 && rfi_f == 1 && pbf == 1) rfi_fa = 1;

  /* Reading input file INPUT06.TXT and writing its information to output file */
  n2 = 6;
  zz++;
  printf("Reading data from INPUT06.TXT\n"); 
  inp07(fw,n2,zz);
  fr = fopen("INPUT06.TXT", "r");
  readcom(fr);  
  /* Reading the input parameters */
  bwf=readfloat(fw,fr);
  bwm=readfloat(fw,fr);
  con_1=readfloat(fw,fr);
  w1conf=readfloat(fw,fr);
  w1conm=readfloat(fw,fr);
  con_2=readfloat(fw,fr);
  w2conf=readfloat(fw,fr);
  w2conm=readfloat(fw,fr);
  con_3=readfloat(fw,fr);
  w3conf=readfloat(fw,fr);  
  w3conm=readfloat(fw,fr);
  mwb=readfloat(fw,fr); 
  fclose(fr);
  fprintf(fw, "\n\n");  
  
if (prodsys <= 2) {  
    /* Reading input file INPUT13.TXT and writing its information to output file */
    n2 = 13;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT13.TXT\n");   
    fr = fopen("INPUT13.TXT", "r");
    readcom(fr);
    /* Reading the input parameters */
    adgh1s=readfloat(fw,fr);
    adgh2w=readfloat(fw,fr);
    adgh2s=readfloat(fw,fr);
    adgh3w=readfloat(fw,fr);
    adgh3s=readfloat(fw,fr);
    adgh4w=readfloat(fw,fr);
    whmin=readfloat(fw,fr);
    sigmawh=readfloat(fw,fr);
    dfrp=readfloat(fw,fr);
    sfrp=readfloat(fw,fr);
    phs=readfloat(fw,fr);
    nphs=readfloat(fw,fr);
    dayshc=readfloat(fw,fr);  
    dprfrep=readfloat(fw,fr);  
    aih=readfloat(fw,fr); 
    if (insh == 2) aih = 1; 
    drys[22]=readfloat(fw,fr);
    dryw[22]=readfloat(fw,fr);
    rfis[22]=readfloat(fw,fr);
    rfiw[22]=readfloat(fw,fr);
    eds[22]=readfloat(fw,fr);
    edw[22]=readfloat(fw,fr);
    pdids[22]=readfloat(fw,fr);
    pdidw[22]=readfloat(fw,fr); 
    prw[22]=readfloat(fw,fr);
    prs[22]=readfloat(fw,fr);
    straw[22]=readfloat(fw,fr);       
    dung[22]=readfloat(fw,fr);
    min[22]=readfloat(fw,fr);
    wat[22]=readfloat(fw,fr);
    costv[22]=readfloat(fw,fr);
    fixcrh=readfloat(fw,fr); 
    prrep=readfloat(fw,fr);
    prnphse=readfloat(fw,fr);
    prphse=readfloat(fw,fr);
    anphse1=readfloat(fw,fr);
    anphse2=readfloat(fw,fr);
    nphsold1=readfloat(fw,fr);
    nphsold2=readfloat(fw,fr);
    fclose(fr);
    fprintf(fw, "\n\n");  
    } /* End input file 13 - prodsys <= 2 */
  
  /* Reading input file INPUT08.TXT and writing its information to output file */
  n2 = 8;
  zz++;
  inp07(fw,n2,zz);
  printf("Reading data from INPUT08.TXT\n");
  fr = fopen("INPUT08.TXT", "r");
  readcom(fr);
  /* Reading the input parameters */
  if (pbf == 1) {
    adgwsm = readfloat(fw,fr);
    wbfat = readfloat(fw,fr);
    }
    else for (i = 1; i <= 2; i++) readdes(fr);
  dresb = readfloat(fw,fr);
  if (pcmf > 0.000001) dresc = readfloat(fw,fr);
    else readdes(fr);
  dresh = readfloat(fw,fr);
  if (pbf == 1) {
    kdresb = readfloat(fw,fr);
    nmcf = readfloat(fw,fr);
    dmcf = readfloat(fw,fr);
    wat[14] = readfloat(fw,fr);
    }
    else for (i = 1; i <= 4; i++) readdes(fr);
  if (feedlot > 0) {
    dungfi = readfloat(fw,fr);
    strawfi = readfloat(fw,fr);
    }
    else for (i = 1; i <= 2; i++) readdes(fr);
  if (pbf == 1) {
    dryf[14] = readfloat(fw,fr);
    rfi[14] = readfloat(fw,fr);
    edf[14] = readfloat(fw,fr);
    pdidf[14] = readfloat(fw,fr);
    prf[14] = readfloat(fw,fr);
    }
    else for (i = 1; i <= 5; i++) readdes(fr);
  losff = readfloat(fw,fr);
  prb = readfloat(fw,fr); 
  prh = readfloat(fw,fr);                     
  if (pbf == 1) kpr[14] = readfloat(fw,fr);
    else readdes(fr);
  if (feedlot > 0) {  
    costvfi = readfloat(fw,fr);
    fixcfi = readfloat(fw,fr);
    }
    else for (i = 1; i <= 2; i++) readdes(fr);
  p1 = readint(fw,fr);
  p2 = readint(fw,fr);
  if (pbf == 1) dotfatib = readfloat(fw,fr);
    else readdes(fr);
  fclose(fr);
  fprintf(fw, "\n\n");  

  if (feedlot == 2) {  
    /* Reading input file INPUT09.TXT and writing its information to output file */
    n2 = 9;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT09.TXT\n");
    /* Reading input file INPUT09.TXT */
    fr = fopen("INPUT09.TXT", "r");
    readcom(fr);
    /* Reading the input parameters */
    if (pcmf > 0.000001) {
      dgcxw = readfloat(fw,fr);
      dgcxs = readfloat(fw,fr);
      dgcxas = readfloat(fw,fr);
      }
    else for (i=1; i<=3; i++) readdes(fr);  
    if (pff > 0.000001) {
      dgfxw = readfloat(fw,fr);
      dgfxs = readfloat(fw,fr);
      dgfxas = readfloat(fw,fr);
      }
    else for (i=1; i<=3; i++) readdes(fr);    
    if (pcmf > 0.000001) wcxfat = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) whxfat = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) kdresc = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) kdresh = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) nccf = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) nfcf = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) dccf = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) dfcf = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) dryfx[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) dryfx[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) dryw[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) dryw[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) drys[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) drys[12] = readfloat(fw,fr);  
    else readdes(fr);
    if (pcmf > 0.000001) rfisc = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) rfisf = readfloat(fw,fr);  
    else readdes(fr);
    if (pcmf > 0.000001) rfiw[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) rfiw[12] = readfloat(fw,fr);  
    else readdes(fr);
    if (pcmf > 0.000001) rfis[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) rfis[12] = readfloat(fw,fr);  
    else readdes(fr);
    if (pcmf > 0.000001) edfx[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) edfx[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) eds[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) eds[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) edw[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) edw[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) pdidfx[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) pdidfx[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) pdids[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) pdids[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) pdidw[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) pdidw[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) pras[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) pras[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) prs[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) prs[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) prw[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) prw[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) prm[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) prm[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) min[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) min[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) wat[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) wat[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pchf == 1) {
      dungfx = readfloat(fw,fr);
      strawfx = readfloat(fw,fr);
      costvfx = readfloat(fw,fr);
      fixcfx = readfloat(fw,fr);
      }
    else for (i=1; i<=4; i++) readdes(fr);      
    if (pcmf > 0.000001) kpr[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) kpr[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pchf == 1) dotfatx = readfloat(fw,fr); 
    else readdes(fr);
    if (pcmf > 0.000001) prcs = readfloat(fw,fr);
    else readdes(fr);
    fclose(fr);
    fprintf(fw, "\n\n");  
    if (pff < 0.000001 && pbf == 1) dgfxw = adgwsm;  
    if (pff < 0.000001 && pbf == 0 && pcmf > 0.000001) dgfxw = dgcxw;  
    } /* End feedlot == 2 */ 

  if (feedlot == 1) {  
    /* Reading input file INPUT10.TXT and writing its information to output file */
    n2 = 10;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT10.TXT\n");
    /* Reading input file INPUT10.TXT */
    fr = fopen("INPUT10.TXT", "r");
    readcom(fr);
    /* Reading the input parameters */
    if (pcmf > 0.000001) adgwsc=readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) adgwsf=readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) wcfat=readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) whfat=readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) nccf = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) nfcf = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) kdresc = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) kdresh = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) dccf = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) dfcf = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) wat[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) wat[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) dryf[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) dryf[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) rfi[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) rfi[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) edf[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) edf[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) pdidf[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) pdidf[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) prf[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) prf[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) prcs = readfloat(fw,fr);
    else readdes(fr);
    if (pcmf > 0.000001) kpr[17] = readfloat(fw,fr);
    else readdes(fr);
    if (pff > 0.000001) kpr[12] = readfloat(fw,fr);
    else readdes(fr);
    if (pchf == 1) dotfati = readfloat(fw,fr);
    else readdes(fr);
    fclose(fr);
    fprintf(fw, "\n\n");  
    } /* End feedlot == 1 */ 
  if (feedlot == 1 && pff < 0.000001 && pbf == 1)
    adgwsf = adgwsm;   
  if (feedlot == 1 && pff < 0.000001 && pbf == 0 && pcmf > 0.000001)
    adgwsf = adgwsc;   

  if (prodsys == 1) {
    /* Reading input file INPUT05.TXT and writing its information to output file */
    n2 = 5;
    zz++;
    printf("Reading data from INPUT05.TXT\n");  
    inp07(fw,n2,zz);
    fr = fopen("INPUT05.TXT", "r");
    readcom(fr);
    adgbbt = readfloat(fw,fr);
    lengbt = readfloat(fw,fr);
    dtse = readfloat(fw,fr);
    msel = readfloat(fw,fr); 
    prtb = readfloat(fw,fr);
    prt = readfloat(fw,fr);
    prtse = readfloat(fw,fr);
    pdidtb = readfloat(fw,fr);
    pdidt = readfloat(fw,fr);
    pdidtse = readfloat(fw,fr);
    edtb = readfloat(fw,fr); 
    edt = readfloat(fw,fr);
    edtse = readfloat(fw,fr);  
    drytb = readfloat(fw,fr); 
    dryt = readfloat(fw,fr);
    drytse = readfloat(fw,fr); 
    readcom(fr);
    if (rfi_fa == 1) {
      rfitb = readfloat(fw,fr); 
      rfit = readfloat(fw,fr);
      rfits = readfloat(fw,fr); 
      }
    else for (i=1; i<=3; i++) readdes(fr);
    dung[10] = readfloat(fw,fr);
    straw[10] = readfloat(fw,fr);
    costv[10] = readfloat(fw,fr);
    fixcbt = readfloat(fw,fr);
    dottest = readfloat(fw,fr);    
    prbbsel = readfloat(fw,fr);
    fclose(fr);
    fprintf(fw, "\n\n");  
    } /* End prodsys == 1 */

  /* Reading input file INPUT04.TXT and writing its information to output file */
  n1 = 21;
  n2 = 4;
  zz++;
  printf("Reading data from INPUT04.TXT\n");
  /* Reading input file INPUT04.TXT and writing to results file */
  inp07(fw, n2, zz);
  fr = fopen("INPUT04.TXT", "r");
  readcom(fr);
  /* Reading the input parameters */
  if (prodsys > 1) {
    agebbse = readfloat(fw,fr);
    wbbse = readfloat(fw,fr);
    }
    else for (i=1; i<=2; i++) readdes(fr);
  lifebb = readfloat(fw,fr);  
  agebbm = readfloat(fw,fr);
  drys[10] = readfloat(fw,fr);
  dryw[10] = readfloat(fw,fr);
  readcom(fr);  
  if (rfi_cow == 1) {
    rfis[10] = readfloat(fw,fr);
    rfiw[10] = readfloat(fw,fr);
    }
  else for (i = 1; i <= 2; i++) readdes(fr);
  eds[10] = readfloat(fw,fr);
  edw[10] = readfloat(fw,fr);
  pdids[10] = readfloat(fw,fr);
  pdidw[10] = readfloat(fw,fr);
  prw[10] = readfloat(fw,fr);
  prs[10] = readfloat(fw,fr);
  min[10] = readfloat(fw,fr); 
  prm[10] = readfloat(fw,fr);
  strawbb = readfloat(fw,fr);  
  dungbb = readfloat(fw,fr);
  wat[10] = readfloat(fw,fr);
  prbb = readfloat(fw,fr);
  costvbb = readfloat(fw,fr);
  fixcbb = readfloat(fw,fr);
  prbbcull = readfloat(fw,fr);
  fclose(fr);
  fprintf(fw, "\n\n");  

  if (prodsys == 3) {
    /* Reading input file INPUT14.TXT and writing its information to output file */
    n2 = 14;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT14.TXT\n");
    fr = fopen("INPUT14.TXT", "r");
    readcom(fr);
    /* Reading the input parameters */
    agefrep=readfloat(fw,fr);
    wfrep = readfloat(fw,fr);
    dprfrep = readfloat(fw,fr); 
    dayshc = readfloat(fw,fr); 
    agecal = readfloat(fw,fr);
    wcacal[0] = readfloat(fw,fr);  
    wcacal[1] = readfloat(fw,fr);  
    dung[22] = readfloat(fw,fr);
    min[22] = readfloat(fw,fr);
    straw[22] = readfloat(fw,fr);
    wat[22] = readfloat(fw,fr);
    drys[22] = readfloat(fw,fr);
    dryw[22] = readfloat(fw,fr);
    rfis[22] = readfloat(fw,fr);
    rfiw[22] = readfloat(fw,fr);
    eds[22] = readfloat(fw,fr);
    edw[22] = readfloat(fw,fr);  
    pdids[22] = readfloat(fw,fr);
    pdidw[22] = readfloat(fw,fr); 
    prw[22] = readfloat(fw,fr);
    prs[22] = readfloat(fw,fr);
    prrep = readfloat(fw,fr);   
    fixcrh = readfloat(fw,fr);   
    costv[22] = readfloat(fw,fr);
    if (dprfrep < 0.000001) {
      aih = readfloat(fw,fr);
      if (insh == 2) aih = 1;
      }
    else readdes(fr);  
    fclose(fr);
    fprintf(fw, "\n\n");  
  } /* End prodsys == 3 */

  if (lactcur == 2) {
    /* Reading input file INPUT19.TXT and writing its information to output file */
    n2 = 19;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT19.TXT\n");
    fr = fopen("INPUT19.TXT", "r");
    readcom(fr);
    /* Reading the input parameters */
    mpm0=readfloat(fw,fr);
    pl=readfloat(fw,fr);
    fclose(fr);
    fprintf(fw, "\n\n");  
    } /* End lactcur == 2 */

  if (lactcur == 1) {
    /* Reading input file INPUT20.TXT and writing its information to output file */
    n2 = 20;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT20.TXT\n");
    fr = fopen("INPUT20.TXT", "r");
    readcom(fr);
    /* Reading the input parameters */
    a2 = readfloat(fw,fr);
    a3 = readfloat(fw,fr);
    a4 = readfloat(fw,fr);
    am = readfloat(fw,fr);
    b2 = readfloat(fw,fr);
    b3 = readfloat(fw,fr);
    b4 = readfloat(fw,fr);
    bm = readfloat(fw,fr);
    c2 = readfloat(fw,fr); 
    c3 = readfloat(fw,fr);
    c4 = readfloat(fw,fr);
    cm = readfloat(fw,fr);
    fclose(fr);
    fprintf(fw, "\n\n");  
    } /* End lactcur == 1 */

  /* Reading input file INPUT16.TXT and writing its information to output file */
  n2 = 16;
  zz++;
  inp07(fw,n2,zz);
  printf("Reading data from INPUT16.TXT\n");
  fr = fopen("INPUT16.TXT", "r");
  readcom(fr);
  /* Reading the input parameters */
  for (i1 = 1; i1 <= 4; i1++) {
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (i1 == 1 && (prodsys == 1 || pbf == 1)) fscanf(fr, "%f", &Pb[j][i]); 
	if (i1 == 2) fscanf(fr, "%f", &Pc[j][i]);
	if (i1 == 3 && (prodsys == 1 || pbf == 1)) fscanf(fr, "%f", &Prb[j][i]);
	if (i1 == 4) fscanf(fr, "%f", &Prc[j][i]);
        }
      }
    if (i1 == 2 || i1 == 4) {
      wrides(fr,fw); 
      fprintf(fw, "\n");
      }  
    if (i1 == 1 || i1 == 3) {
      if (prodsys > 1 && pbf < 0.000001) readdes(fr);
      else {
	wrides(fr,fw); 
	fprintf(fw, "\n");
	}
      }
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (i1 == 1 && (prodsys == 1 || pbf == 1)) 
	  fprintf(fw, "%9.3f", Pb[j][i]); 
	if (i1 == 2) fprintf(fw, "%9.3f", Pc[j][i]);
	if (i1 == 3 && (prodsys == 1 || pbf == 1)) 
	  fprintf(fw, "%9.3f", Prb[j][i]);
	if (i1 == 4) fprintf(fw, "%9.3f", Prc[j][i]);
        }
      fprintf(fw, "\n");	
      }    
    }
  fclose(fr);
  fprintf(fw, "\n\n");  

/* Reading input file INPUT17.TXT or INPUT18.TXT and writing its 
   information to output file */
  zz++;
  if (feedlot == 1 || feedlot == 0) n2 = 17;
  if (feedlot == 2) n2 = 18;
  inp07(fw,n2,zz);
  if (feedlot == 1 || feedlot == 0) printf("Reading data from INPUT17.TXT\n");
  if (feedlot == 2) printf("Reading data from INPUT18.TXT\n");
  if (feedlot == 1 || feedlot == 0) fr = fopen("INPUT17.TXT", "r");
  if (feedlot == 2) fr = fopen("INPUT18.TXT", "r");
  readcom(fr);
  /* Reading the input parameters */
  for (i1 = 1; i1 <= 4; i1++) {
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (i1 == 1) fscanf(fr, "%f", &Ph[j][i]); 
	if (i1 == 2 && pcmf > 0.000001) fscanf(fr, "%f", &Pcs[j][i]);
	if (i1 == 3) fscanf(fr, "%f", &Prh[j][i]);
	if (i1 == 4 && pcmf > 0.000001) fscanf(fr, "%f", &Prcs[j][i]);
        }
      }
    if (i1 == 1 || i1 == 3) {
      wrides(fr,fw); 
      fprintf(fw, "\n");
      }  
    if (i1 == 2 || i1 == 4) {
      if (pcmf < 0.000001) readdes(fr);
      else {
	wrides(fr,fw); 
	fprintf(fw, "\n");
	}
      }
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (i1 == 1) fprintf(fw, "%9.3f", Ph[j][i]); 
	if (i1 == 2 && pcmf > 0.000001) fprintf(fw, "%9.3f", Pcs[j][i]);
	if (i1 == 3) fprintf(fw, "%9.3f", Prh[j][i]);
	if (i1 == 4 && pcmf > 0.000001) fprintf(fw, "%9.3f", Prcs[j][i]);
        }
      if (i1 == 1 || i1 == 3) fprintf(fw, "\n");
      if (i1 == 2 && pcmf > 0.000001) fprintf(fw, "\n");
      if (i1 == 4 && pcmf > 0.000001) fprintf(fw, "\n");
      }    
    }
  fclose(fr);
  fprintf(fw, "\n\n");  

  /* Reading input file INPUT26.TXT and writing its information to output file */
  n2 = 26;
  zz++;
  inp07(fw,n2,zz);  
  printf("Reading data from INPUT26.TXT\n");
  fr = fopen("INPUT26.TXT", "r");
  readcom(fr);
  /* Reading the input parameters */
  acs = readfloat(fw,fr);
  acd = readfloat(fw,fr);
  n_sac = readfloat(fw,fr);
  l_inv = readfloat(fw,fr);
  for (i = 0; i < ACM; i++) { 
    for (j = 0; j < ACM; j++) PM[i][j] = 0;
    }
  i = 1;
  if (prodsys == 1) for (j = 1; j <=acs; j++) fscanf(fr, "%lf", &PM[i][j]);
  if (prodsys > 1) for (j = 1; j <=acs; j++) fscanf(fr, "%f", &aa1);
    wrides(fr,fw);
    for (j = 1; j <=acs; j++) fprintf(fw, "%7.4f", PM[i][j]);
  i = acs + 1;
  for (j = 1; j <=acs; j++) fscanf(fr, "%lf", &PM[i][j]);
    wrides(fr,fw);  
    for (j = 1; j <=acs; j++) fprintf(fw, "%7.4f", PM[i][j]);
  i = 1;
    if (prodsys == 1) for (j = acs+1; j <=acs+acd; j++) fscanf(fr, "%lf", &PM[i][j]);
    if (prodsys > 1) for (j = acs+1; j <=acs+acd; j++) fscanf(fr, "%f", &aa1);  
    wrides(fr,fw);    
    for (j = acs+1; j <=acs+acd; j++) fprintf(fw, "%7.4f", PM[i][j]);
  fclose(fr);
  fprintf(fw, "\n\n");  

  /* Reading input file INPUT34.TXT and writing its information to output file
     */
  printf("Reading data from INPUT34.TXT\n");
  fr = fopen("INPUT34.TXT", "r");
  n2 = 34;
  zz++;
  inp07(fw,n2,zz);
  fclose(fr); 
  fr = fopen("INPUT34.TXT", "r");  
  readcom(fr); 
  for (i = 1; i < 5; i++) flag[i] = readint(fw,fr);
  fprintf(fw, "\n\n");
  fclose(fr);

  /* Selecting traits for the calculation of economic weights.
     to[i] is set to zero for traits not considered. */
  /* - For the following traits, economic weights are never printed */
  to[14] = to[15] = to[16] = to[17] =
    to[19] = to[20] = to[21] = to[22] =
    to[24] = to[25] = 0;    
  /* - Omitting traits as consequence of selecting from pairs of traits */
  if (flag[1] == 6) to[26] = 1; else to[6] = 1;
  if (flag[2] == 7) to[27] = 1; else to[7] = 1;
  if (flag[3] == 8) to[28] = 1; else to[8] = 1;      
  if (flag[4] == 11) to[29] = 1; else to[11] = 1;
  if (feedlot == 0) to[9] = 1;
  if (prodsys == 3) to[4] = to[11] = to[12] = to[13] = to[29] = 1;
  if (rfi_h == 0 || prodsys == 3) to[30] = 1;
  if (rfi_fa == 0) to[31] = 1;
  if (rfi_fx == 0) to[32] = 1;
  if (rfi_cow == 0 || prodsys == 3) to[33] = 1;

  /* Writing file T.TXT with values flag[1] to flag[4] and to[30] to to[33] */
  if (zr == 1 && prodsys == 3) {  
    fw3 = fopen("T.TXT", "w");
    fprintf(fw3, "/* Data from Production System 3\n");
    fprintf(fw3, "   Structure of the file:\n   - flag[1] to flag[4] to be read as flag[4], flag[5], flag[6] and flag[3]\n");
    fprintf(fw3, "   - to[30] to to[33] to be read as to3[43], to3[44], to3[47] and to3[45] */\n");
    fprintf(fw3, "%d\n", flag[1]);
    fprintf(fw3, "%d\n", flag[2]);
    fprintf(fw3, "%d\n", flag[3]);
    fprintf(fw3, "%d\n", flag[4]);
    fprintf(fw3, "%d\n", to[30]);
    fprintf(fw3, "%d\n", to[31]);
    fprintf(fw3, "%d\n", to[32]);
    fprintf(fw3, "%d\n", to[33]);
    fclose(fw3);
    }
  /* delta_d and delta_m - indicators for direct and maternal traits */   
  for (i = 1; i < NT; i++) {
    if (to[i] == 2 && (tt[i] == 0 || tt[i] == 2)) delta_d[i] = 1;
    if (to[i] == 2 && tt[i] > 0) delta_m[i] = 1;
    }
  if (gstd == 2) {
    /* Reading input file INPUT35.TXT and writing its information to 
       output file */
    printf("Reading data from INPUT35.TXT\n");
    fr = fopen("INPUT35.TXT", "r");
    n2 = 35;
    zz++;
    inp07(fw,n2,zz);
    fclose(fr); 
    fr = fopen("INPUT35.TXT", "r");  
    readcom(fr); 
    for (i = 1; i < NT; i++) {
      if (to[i] > 0) {
	if (to[i] == 1) readdes(fr);
	else {
	  if (tt[i] == 2) {
	    fscanf(fr, "%f", &gstd_d[i]); 
	    fscanf(fr, "%f", &gstd_m[i]); 
	    wrides(fr,fw); 
	    fprintf(fw, "%12.4f %12.4f", gstd_d[i],gstd_m[i]);
	  }
 	  if (tt[i] == 0) {
	    fscanf(fr, "%f", &gstd_d[i]);
	    wrides(fr,fw); 
	    fprintf(fw, "%12.4f", gstd_d[i]);
	  } 
	  if (tt[i] == 1) {
	    fscanf(fr, "%f", &gstd_m[i]); 
	    wrides(fr,fw); 
            fprintf(fw, "%12.4f", gstd_m[i]);
	  }   
	}  
      }
    } 
    fprintf(fw, "\n\n");
    fclose(fr);
  }

  if (gstd == 3) {
    /* Reading input file INPUT36.TXT and writing its information to 
       output file */
    printf("Reading data from INPUT36.TXT\n");
    fr = fopen("INPUT36.TXT", "r");
    n2 = 36;
    zz++;
    inp07(fw,n2,zz);
    fclose(fr); 
    fr = fopen("INPUT36.TXT", "r");  
    readcom(fr);
    for (i = 1; i < NT; i++) {
      if (to[i] > 0) {
        if (to[i] == 1) readdes(fr);
        if (to[i] == 2) {
	  fscanf(fr, "%f", &gstd_d[i]);
	  wrides(fr,fw); 
	  fprintf(fw, "%12.4f", gstd_d[i]);
	}
      }
    }
    fprintf(fw, "\n\n");
    fclose(fr);  
  } 

  /* Test of parameters */
  if (exmc + mtest > 1.0001) {
    nonsense3();
    goto END;
  } 
  if (((exfc + pff + nphs + phs > 1.0001) || (exfc + pff + nphs + phs < 0.9999))
    && (prodsys <= 2)) {
    nonsense4();
    goto END;
  }
  if (((exfc + pff > 1.0001) || (exfc + pff < 0.9999)) && (prodsys == 3)) {
    nonsense4a();
    goto END;
  }

  /* Coefficients and further parameters */
  kcon2h = cr2nmh/crinh;
  kcon3h = cr3nmh/crinh;
  kcon2c = ecr2nmc/ecrinc;
  kcon3c = ecr3nmc/ecrinc; 
  kmcwhmin = whmin/mcw;
  if (prodsys <= 2) anphse = anphse1 * nphsold1 + anphse2 * nphsold2;

  /* Daily gain in beef cattle */
  printf("\nCalculating daily gain in beef cattle\n");
  kbwmf = bwm/bwf;
  adgcon1f = (w1conf - bwf)/con_1;
  adgcon1m = (w1conm - bwm)/con_1;
  kgcon1mf = adgcon1m/adgcon1f;
  adgcon2f = (w2conf - w1conf)/(con_2-con_1);
  adgcon2m= (w2conm - w1conm)/(con_2-con_1);
  kgcon2mf = adgcon2m/adgcon2f;
  adgcon3f = (w3conf - w2conf)/(con_3-con_2);
  adgcon3m = (w3conm - w2conm)/(con_3-con_2);
  kgcon3mf = adgcon3m/adgcon3f;
  kdresbh = dresb/dresh;
  kdresch = dresc/dresh;
  kdrescwh = drescw/dresh;
  if (feedlot == 1) {
    if (pbf == 1) kgainmf = adgwsm/adgwsf;
    if (pcmf > 0.000001) kgaincf = adgwsc/adgwsf;
    }
  if (feedlot == 2) {
    if (pff > 0.000001) {
      kdgfxws = dgfxs/dgfxw;
      kdgfxwas = dgfxas/dgfxw;
      }
    if (pcmf > 0.000001) kdgxwcf = dgcxw/dgfxw;
    if (pcmf > 0.000001) kdgxscf = dgcxs/dgfxw;
    if (pcmf > 0.000001) kdgxascf = dgcxas/dgfxw;
    if (pbf == 1) kgainmf = adgwsm/dgfxw;
    }     
  if (prodsys == 1) {  
    if (feedlot == 1) {
      if (pff > 0.000001) kslh = whfat/mcw;
      if (pcmf > 0.000001) kslc = wcfat/mcw;
      if (pbf == 1) kslb = wbfat/mcw;
      }  
    if (feedlot == 2) {
      if (pff > 0.000001) kslhx=whxfat/mcw;
      if (pcmf > 0.000001) kslcx=wcxfat/mcw;
      if (pbf == 1) kslb=wbfat/mcw;    
      }  
    kmwbc=mwb/mcw;
    }

Start:  
  /* Structure of the cow herd */
  if (trait == 0)
    printf("Calculating the structure of the cow herd\n");  
    ecr2nmc = ecrinc*kcon2c;
    ecr3nmc = ecrinc*kcon3c;
  for (i=0; i<LL; i++) {
    pclos[i] = pp[19+6*(i+1)];
    pcul[i] = pp[21+6*(i+1)];   
    clcm[i] = intcm*pclos[i]/365.0; 
    clmc[i] = pclos[i]-clcm[i];
    cculcm[i] = intcm*pcul[i]/365.0; 
    cculmc[i] = pcul[i] - cculcm[i];
    dysf[i] = dysm[i] = 0;
    for (j = dyscl - 1; j < DD; j++) {
      dysf[i] += dysff[j][i];
      dysm[i] += dysmm[j][i];    
      }
    dys[i] = (dysf[i]+dysm[i])/2.0;
    pcdys[i] = dys[i]*cmd;
    dysmat[i] = dys[i] - pcdys[i];
    if (i==LL-1) dysmat[i] = 0;
    cmat[i] = 1.0 - pcdys[i] - cculcm[i] - clcm[i];
    if (i==LL-1) cmat[i] = 0;
    if (insc == 1) {
      aa1 = dysmat[i]*pinmatd[i]*(ecrinc-crdys);
      aa2 = (cmat[i]-dysmat[i])*(pinmatnd[i])*ecrinc;
    }
    if (insc == 2) {
      aa1 = dysmat[i]*(ecrinc-crdys);
      aa2 = (cmat[i]-dysmat[i])*ecrinc;
    }
    cpin[i] = aa1 + aa2;
    aa3 = (dysmat[i]-aa1)*(ecr2nmc-crdys);
    aa4 = (cmat[i]-dysmat[i]-aa2)*ecr2nmc;
    cp2nm[i] = aa3 + aa4;
    aa5 = (dysmat[i]-aa1-aa3)*(ecr3nmc-crdys);
    aa6 = (cmat[i]-dysmat[i]-aa2-aa4)*ecr3nmc;
    cp3nm[i] = aa5 + aa6;
    cp[i] = cpin[i]+cp2nm[i]+cp3nm[i];
    if (cmat[i]>0) crcmp[i] = cp[i]/cmat[i];
    npc[i] = cmat[i]-cp[i];
    if (i==LL-1) npc[i] = 1-pcdys[i]-cculcm[i]-clcm[i];
    }
  /* Construction of matrix T for systems 1 to 5 */
  /* Preparation of data for matrix T */
  if (trait == 0)
    printf("  Constructing matrix T for systems 1 to 3\n");  
  pp[26] = pcdys[0];
  pp[29] = (npc[0])*(npcsp[0])*(1.0-clmc[0]-cculmc[0]);
  pp[30] = (cp[0])*(1.0-clmc[0]-cculmc[0]);
  pp[28] = 1.0-pp[25]-pp[26]-pp[27]-pp[29]-pp[30];
  for (i=1; i<LL; i++) { 
    pp[20+6*(i+1)] = pcdys[i];
    np[20+6*(i+1)] = 0;   
    }
  pncal[0] = 0;
  pcal[0] = 1;
  for (i=2; i<LL; i++) { 
    pncal[i-1] = pp[23+6*(i-1)]/(pp[23+6*(i-1)]+pp[24+6*(i-1)]);
    pcal[i-1] = 1 - pncal[i-1];
    np[23+6*i] = pncal[i-1]*(1-cp[i-1])*npcsn[i-1];
    pp[23+6*i] = pcal[i-1]*(1-cp[i-1])*npcsp[i-1];
    np[24+6*i] = pncal[i-1]*(1-cp[i-1])*(1-clmc[i-1]-cculmc[i-1]);
    pp[24+6*i] = pcal[i-1]*cp[i-1]*(1-clmc[i-1]-cculmc[i-1]);
    np[22+6*i] = 1-np[19+6*i]-np[20+6*i]-np[21+6*i]-np[23+6*i]-np[24+6*i];
    pp[22+6*i] = 1-pp[19+6*i]-pp[20+6*i]-pp[21+6*i]-pp[23+6*i]-pp[24+6*i];
    }
  i = LL;
    pncal[LL-1] = pp[23+6*(i-1)]/(pp[23+6*(i-1)]+pp[24+6*(i-1)]);
    pcal[LL-1] = 1 - pncal[LL-1];
    np[CC] = 1 - np[CC-1] - np[CC-2] - np[CC-3];
    pp[CC] = 1 - pp[CC-1] - pp[CC-2] - pp[CC-3];
  for (i1=0; i1<LL; i1++) {
    for (i2=1; i2<7; i2++) {
      pncalc[24+i1*6+i2] = pncal[i1];
      pcalc[24+i1*6+i2] = pcal[i1];
      if (i1 == LL-1 && i2 == 4) break; 
      } 
    }
  for (i=0; i<LL-1; i++) {
    pncalc[32+i*6] = 0;
    pcalc[32+i*6] = 1;
    }
  /* Filling matrix T */
  /* Setting all elements to 0 */
  for (i1=0; i1<T; i1++) {
    for (i2=0; i2<T; i2++) {
      t[i1][i2] = 0;
      } 
    }
  /* Filling columns 1 to 6 */
  for (i1=1; i1<5; i1++) {
    for (i2=1; i2<7; i2++) {
      for (i3=0; i3<LL; i3++) {
        t[6*i3+i1][i2] = (double) pp[24+i2];
	}
      }
    }  
  /* Filling columns 7 to TT */  
  for (i1=0; i1<LL-1; i1++) {
    for (i3=1; i3<7; i3++) {
      t[5+6*i1][(i1+1)*6+i3] = (double) np[24+(i1+1)*6+i3];
      t[6+6*i1][(i1+1)*6+i3] = (double) pp[24+(i1+1)*6+i3];
      if (i1 == LL-2 && i3 == 4) break; 
      }
    }  
  /* Testing the correctness of matrix T */
  for (i1=1; i1<=TT; i1++) {
    aa1 = 0;
    for (i2=1; i2<=TT; i2++) {
      aa1 = aa1 + t[i1][i2];
      }
    if (aa1 < 0.999999 || aa1 > 1.000001) {
      printf("Sum of elements of T is different from 1");
      printf("  %d %12.9f\n", i1, aa1); }
    }
  /* Calculating vector l2 by iteration */
  n = TT; /* Dimension of the vector l2 */
  /* Initial values of the elements of l2 */
    l2[0] = 0;
    l2[1] = 1;
    for (i = 2; i <= n; i++) {
      l2[i] = 0;
      }
  /* Starting the iteration */
    k = 0;
    a = 1.;
    for (i = 1; i <= n; i++) {
      l2_0[i] = 0;
      }
    while (a>.0000000001) {k++;
      if (k > 2000) break;
      sl2 = 0; /* Sum of elements of l2 */
      a1 = 0;
      for (i = 1; i <= n; i++) {
        for (j = 1; j <= n; j++) {
	  l2_0[i] = l2_0[i] + t[j][i] * l2[j];
	  }
	}            
      for (i = 1; i <= n; i++) {
        sl2 = sl2 + l2_0[i];
	}
      for (i = 1; i <= n; i++) {
        l2_0[i] = l2_0[i]/sl2;
	a1 += ((l2_0[i] - l2[i]) * (l2_0[i] - l2[i]));
	}
	a = a1/(double) n;
      for (i = 1; i <= n; i++) {
        l2[i] = l2_0[i];
	}	
      }  		
  /* Proportion of cows calving in individual reproductive cycles */
  l3[0] = 0;
  for (j = 1; j <= 6; j++) {
    l3[0] += l2[j];
    }  
  Ncal = l3[0];  
  for (i = 1; i < LL; i++) {
    l3[i] = l2[i*6];
    Ncal += l3[i];  
    }
  /* Proportion of cows in individual reproductive cycles */
  aa1 = 0;
  for (i = 0; i < LL; i++) {
    l4[i] = 0;
    }
  for (i = 1; i < LL; i++) {
    for (j = 1; j <= 6; j++) {
      l4[i-1] += l2[(i-1)*6 + j];
      }
    aa1 += l4[i-1];  
    }
  for (j = 1; j <= 4; j++) {
    l4[LL-1] += l2[(i-1)*6 + j];
    }  
    aa1 += l4[LL-1];
  /* Average cow losses */
  losc = 0;
  for (i = 1; i <= LL; i++) {
    losc += (pp[19+6*i] + pp[21+6*i])*l3[i-1];
    losc += (np[19+6*i] + np[21+6*i])*(l4[i-1] - l3[i-1]);
    }      

  /* Reproductive cycles of beef cattle */
  if (trait == 0)
    printf("Calculating parameters for reproductive cycles of beef cattle\n");
  cr2nmh = crinh * kcon2h;
  cr3nmh = crinh * kcon3h;  
  if (deai>dsmp) dconai = dsmp + (deai - dsmp)/2;
  if (deai<dsmp) dconai = dsmp + (365 + deai - dsmp)/2;
  if (denm2>dsnm2) dconnm2 = dsnm2 + (denm2 - dsnm2)/2;
  if (denm2<dsnm2) dconnm2 = dsnm2 + (365 + denm2 - dsnm2)/2;  
  if (denm3>dsnm3) dconnm3 = dsnm3 + (denm3 - dsnm3)/2;
  if (denm3<dsnm3) dconnm3 = dsnm3 + (365 + denm3 - dsnm3)/2;
  dcalai = dconai+lgpre;
  dcalnm2 = dconnm2+lgpre;
  dcalnm3=dconnm3+lgpre;
  if (dcalai>365) dcalai -= 365;
  if (dcalnm2>365) dcalnm2 -= 365;
  if (dcalnm3>365) dcalnm3 -= 365;
    for (i = 0; i < LL-1; i++) {
    pregaic[i] = cpin[i]/cp[i];
    preg2nmc[i] = cp2nm[i]/cp[i];
    preg3nmc[i]= 1 - pregaic[i] - preg2nmc[i];
    }
  aa1 = 0;
  aa2 = 0;
  aa3 = 0;
  aa4 = Ncal - l3[0];;
  for (i = 1; i < LL-1; i++) {
    aa1 += pregaic[i] * l3[i];
    aa2 += preg2nmc[i] * l3[i]; 
    aa3 += preg3nmc[i] * l3[i];
    }
  davmatc = (dconai*aa1+dconnm2*aa2+dconnm3*aa3)/aa4;  
  davcalc = davmatc + lgpre;
  intcmc = 365 + davmatc - davcalc;  
  aihc = crinh * aih;  
  crh1mp=aihc+(1-aihc)*cr2nmh+(1-aihc-(1-aihc)*cr2nmh)*cr3nmh;  
  if (prodsys <= 2) {
    pregaih = aihc/crh1mp;
    preg2nmh = (1-aihc)*cr2nmh/crh1mp;
    preg3nmh = (1-aihc-(1-aihc)*cr2nmh)*cr3nmh /crh1mp;
    davmath = dconai*pregaih+dconnm2*preg2nmh+dconnm3*preg3nmh;
    davcalh = davmath+lgpre;
    davcal  = (davcalh*l3[0] + davcalc*aa4)/Ncal;
    davmat =  (davmath*l3[0] + davmatc*aa4)/Ncal; 
    }
  if ((prodsys == 3) && (dprfrep > 0)) {
    davcal = davcalc;
    davmat = davmatc; 
    }
  if ((prodsys == 3) && (dprfrep == 0)) {
    pregaih = aihc/crh1mp;
    preg2nmh = (1-aihc)*cr2nmh/crh1mp;
    preg3nmh = (1-aihc-(1-aihc)*cr2nmh)*cr3nmh /crh1mp;
    davmath = dconai*pregaih+dconnm2*preg2nmh+dconnm3*preg3nmh;
    davcalh = davmath+lgpre;
    davcal  = (davcalh*l3[0] + davcalc*aa4)/Ncal;
    davmat =  (davmath*l3[0] + davmatc*aa4)/Ncal; 
    }
  if (davcal>365) davcal -= 365;
  if (davmat>365) davmat -= 365; 
  if (davcalc>365) davcalc -= 365;
  if (davmatc>365) davmatc -= 365;
  if (davcalh>365) davcalh -= 365;
  if (davmath>365) davmath -= 365;
  if (dw0>davcal)  agew = dw0 - davcal;  
  if (dw0<=davcal ) agew = 365 + dw0 - davcal;
  dwx = 365 - depas + dbpas;
  dsx = depas - dbpas;
  if (davcal > dbpas && davcal < depas) {
    nonsense11();
    goto END;
  } 

  /* Growth of beef cattle */
  if (trait == 0)
    printf("Calculating parameters for growth in beef cattle\n");
  if (agew >= con_2) {
    wwf = bwf + con_1*adgcon1f +(con_2-con_1)*adgcon2f + adgcon3f*(agew-con_2);
    wwm = bwf*kbwmf + con_1*kgcon1mf*adgcon1f + (con_2-con_1)*kgcon2mf*adgcon2f;
      wwm += kgcon3mf*adgcon3f*(agew-con_2);
    }
  if (agew < con_2) {
    wwf = bwf +con_1*adgcon1f + (agew-con_1)*adgcon2f;
    wwm = bwf*kbwmf + con_1*kgcon1mf*adgcon1f + (agew-con_1)*kgcon2mf*adgcon2f;
    }
  agedcw = agew/2.0;
  if ((con_2 > agedcw) && (agedcw >= con_1)) {
    wdcwf =  bwf + con_1*adgcon1f + (agedcw-con_1)*adgcon2f;
    wdcwm = bwf*kbwmf + con_1*kgcon1mf*adgcon1f + (agedcw-con_1)*kgcon2mf*adgcon2f;
    }
  if (agedcw < con_1) {
    wdcwf = bwf + agedcw*adgcon1f;
    wdcwm = bwf*kbwmf + agedcw*kgcon1mf*adgcon1f;
    }   
  dresc = dresh*kdresch;
  dresb = dresh*kdresbh; 
  if (feedlot == 1) {
    if (prodsys == 1) {
      if (pff > 0.000001) whfat = mcw*kslh;
      if (pcmf > 0.000001) wcfat = mcw*kslc;
      if (pbf == 1) wbfat = mcw*kslb;
      }
    if (pbf == 1) adgwsm = adgwsf*kgainmf;
    if (pcmf > 0.000001) adgwsc = adgwsf*kgaincf;
    if (pff > 0.000001) agesf = agew + (whfat - wwf)/adgwsf;
    if (pbf == 1) agesm = agew + (wbfat - wwm)/adgwsm;
    if (pcmf > 0.000001) agesc = agew + (wcfat - wwm)/adgwsc;
    if (pff > 0.000001) agedwsf = agew + (agesf-agew)/2.0;
    if (pbf == 1) agedwsm = agew + (agesm-agew)/2.0;
    if (pcmf > 0.000001) agedwsc = agew + (agesc-agew)/2.0;
    if (pff > 0.000001) wdwsf = wwf + adgwsf*(agedwsf-agew);
    if (pbf == 1) wdwsm = wwm + adgwsm*(agedwsm-agew);
    if (pcmf > 0.000001) wdwsc = wwm + adgwsc*(agedwsc-agew);
    if (pff > 0.000001) agecwsf = agew  + (agesf-agew)/2.0;
    if (pbf == 1) agecwsm = agew + (agesm-agew)/2.0;
    if (pcmf > 0.000001) agecwsc = agew + (agesc-agew)/2.0;
    if (pff > 0.000001) wcwsf = wwf + adgwsf*(agecwsf-agew);
    if (pbf == 1) wcwsm = wwm + adgwsm*(agecwsm -agew);
    if (pcmf > 0.000001) wcwsc = wwm + adgwsc*(agecwsc-agew);
    }
  if (feedlot == 2) {
    if (prodsys == 1) {
      if (pff > 0.000001) whxfat = mcw*kslhx;
      if (pcmf > 0.000001) wcxfat = mcw*kslcx;
      if (pbf == 1) wbfat = mcw*kslb;
      }
    if (pbf == 1) adgwsm = dgfxw*kgainmf;
    if (pbf == 1) agesm = (wbfat - wwm)/adgwsm + agew;
    if (pff > 0.000001) {
      dgfxs = dgfxw*kdgfxws;
      dgfxas = dgfxw*kdgfxwas;
      }
    if (pcmf > 0.000001) {
      dgcxw = dgfxw*kdgxwcf;
      dgcxs = dgfxw*kdgxscf;
      dgcxas = dgfxw*kdgxascf;
      }
    if (pff > 0.000001) {     
      wfxw = wwf + dwx*dgfxw;
      wfxs = wfxw + dsx*dgfxs;
      if (wfxs >= whxfat) {
	whxfat = wfxs;
	agesf = agew + dwx + dsx; }
      else {
	dasf = (whxfat - wfxs)/dgfxas;
	agesf = agew + dwx + dsx + dasf; }
      }
    if (pcmf > 0.000001) {
      wcxw = wwm + dwx*dgcxw;
      wcxs = wcxw + dsx*dgcxs;
      if (wcxs >= wcxfat) {
	wcxfat = wcxs;
	agesc = agew + dwx + dsx; }
      else {
	dasc = (wcxfat-wcxs)/dgcxas;
	agesc = agew + dwx + dsx + dasc; }
      }
    if (pff > 0.000001) agedwsf = agew  + dwx;
    if (pbf == 1) agedwsm = agew + (agesm-agew)/2.0;
    if (pcmf > 0.000001) agedwsc = agew + dwx;
    if (pff > 0.000001) wdwsf = wfxw;
    if (pbf == 1) wdwsm = wwm + adgwsm*(agedwsm-agew);
    if (pcmf > 0.000001) wdwsc = wcxw;
    if (pff > 0.000001) agecwsf = agew  + dwx;
    if (pbf == 1) agecwsm = agew + (agesm-agew)/2.0;
    if (pcmf > 0.000001) agecwsc = agew + dwx;
    if (pff > 0.000001) wcwsf = wfxw;
    if (pbf == 1) wcwsm = wwm + adgwsm*(agedwsm -agew);
    if (pcmf > 0.000001) wcwsc = wcxw;
    }  
  if (prodsys == 1) {
    agebbst = agew + (startbt-dw0);
    wbbst = wwm + adgcon3f*kgcon3mf*(agebbst-agew);
    agebbt = agebbst + lengbt;
    wbbt = wbbst + lengbt*adgbbt;
    mwb = mcw*kmwbc;
    agebbse = agebbt + dtse;
    adgtm = (mwb-wbbt)/(agebbm-agebbt);
    wbbse = wbbt + dtse*adgtm;
    }
  if (prodsys >= 2) {
    if (agebbm-agebbse > .0001) adgtm = (mwb-wbbse)/(agebbm-agebbse);
    }  
  if (prodsys <= 2) {
    if (davmath>davcalh) dcalmat = davmath-davcalh;
    if (davmath<=davcalh) dcalmat = 365+davmath -davcalh;
    if (davmath > dbpas) {
      if (davmath < depas) dmatpas = depas-davmath;
        else dmatpas = 0;
      }
      else dmatpas = depas-dbpas;
    if (davcalh<depas) dpascal = 365 - depas + davcalh;
    if (davcalh>=depas) dpascal = davcalh - depas;
    dpasmat = 365 - depas + davmath;
    if (davmath<dw0) agehmat1 = agew + 365 - dw0 + davmath;
    if (davmath>dw0) agehmat1 = agew + davmath - dw0;
    whmat1 = bwf + adgcon1f*con_1 + adgcon2f*(con_2-con_1) + adgcon3f*(agehmat1-con_2);
    ageh1cal = agehmat1+lgpre;
    if (davmath > dbpas) {
      if (davmath < depas) wh1cal=whmat1+dmatpas*adgh1s+dpascal*adgh2w;
	else  wh1cal=whmat1+(365-davmath+dbpas)*adgh2w
          +(depas-dbpas)*adgh2s+(davmath-depas)*adgh3w;
      }		     
      else wh1cal=whmat1+adgcon3f*(dbpas-davmath)+dmatpas*adgh1s+dpascal*adgh2w;
    agehmat2 = agehmat1 + 365;
    whmat2 = wh1cal +dcalmat*adgh2w ;
    ageh2cal = agehmat2+lgpre;
    if (davmath>dbpas) {
        if (davmath < depas) wh2cal = whmat2 + dmatpas*adgh2s + dpascal*adgh3w;
	   else  wh2cal=whmat2+(365-davmath+dbpas)*adgh3w
                 +(depas-dbpas)*adgh3s+(davmath-depas)*adgh4w;
	}		     
         else wh2cal=whmat2+adgh2w*(dbpas-davmath)+dmatpas*adgh2s
	      +dpascal*adgh3w;	
    agehmat3 = agehmat2 + 365;
    whmat3 = wh2cal +dcalmat*adgh3w;
    ageh3cal = agehmat3 + lgpre;
    if (davmath>dbpas) {
        if (davmath < depas) wh3cal = whmat3 + dmatpas*adgh3s + dpascal*adgh4w;
	   else  wh3cal=whmat3+(365-davmath+dbpas)*adgh4w
                 +(depas-dbpas)*adgh3s+(davmath-depas)*adgh4w;
	}		     
         else wh3cal = whmat3 +(dbpas-davmath)*adgh3w+dmatpas*adgh3s+dpascal*adgh4w;    
    if (wh3cal > mcw) wh3cal = mcw;
    whmin = kmcwhmin*mcw;
    aa1 = (whmin - whmat1)/sigmawh;
    if (aa1 < 0)  phmat2 = .5 - erf((-(double)aa1)/sqrt(2.))/2.0;
    if (aa1 >= 0) phmat2 = .5 + erf((double)aa1/sqrt(2.))/2.0;
    phmat1 = 1 - phmat2;
    }

  /* Structure of progeny */
  dysav = 0;
  l1[1] = 0;
  pf[1] = 0;
  pm[1] = 0;
  for (i = 0; i < LL; i++) {
    dysav = dysav + dys[i]*l3[i];
    deadc[i] = ab[i] + 0.5*(dysf[i]+dysm[i])*stcd[i];
      deadc[i] = deadc[i] +(1-0.5*(dysf[i]+dysm[i]))*stce[i];
    deadfc[i] = 0.5*(ab[i]+dysf[i]*stcd[i]+(1-dysf[i])*stce[i]);
    deadmc[i] = deadc[i] - deadfc[i];
    l1[1] = l1[1] + deadc[i]*l3[i];
    pf[1] = pf[1] + deadfc[i]*l3[i];
    }  
  if (trait == 2) {
    l1[1] = calfloss/(1 + kp21);
    pf[1] = l1[1]/(1 + kpm1);
    }
  pm[1] = l1[1] - pf[1];
  Nfcba = 0.5*Ncal - pf[1];
  Nmcba = 0.5*Ncal - pm[1];
  l1[2] = 0;
  pf[2] = 0;
  pm[2] = 0;
  sdcd = 0;
  sdce = 0;
  for (i = 0; i < LL; i++) {
    sdcd += dcd[i];
    sdce += dce[i];
    }  
  if (sdcd + sdce > 0.000001) {  
    for (i = 0; i < LL; i++) {
      dead48f[i] = (0.5 - deadfc[i])*(dysf[i]*dcd[i]+(1-dysf[i])*dce[i]);
      dead48m[i] = (0.5 - deadmc[i])*(dysm[i]*dcd[i]
	+ (1-dysm[i])*dce[i]);
      dead48[i] = dead48m[i] + dead48f[i];
      pf[2] = pf[2] + dead48f[i]*l3[i];    
      pm[2] = pm[2] + dead48m[i]*l3[i];
      l1[2] = pm[2] + pf[2];
      }
    if (trait == 2) {
      l1[2] = calfloss - l1[1];
      pf[2] = l1[2]/(1 + kpm2);
      pm[2] = l1[2] - pf[2];
      }
    }    
  Nfc48a = 0.5*Ncal - pf[1] - pf[2];
  Nmc48a = 0.5*Ncal - pm[1] - pm[2];
  losfw = Nfc48a*dcw;
  losmw = Nmc48a*dcw;
  calfloss = l1[1] + l1[2];
  l1[3] = losfw + losmw;
  Nfcw = 0.5*Ncal - pf[1] - pf[2] - losfw;
  Nmcw = 0.5*Ncal - pm[1] - pm[2] - losmw;
  l1[9] = Nmcw*exmc;
  if (prodsys == 1) {
    l1[10] = Nmcw*mtest*msel;
    l1[11] = Nmcw*mtest*(1-msel);
    }
  if (prodsys >= 2) {
    l1[10] = 0;
    l1[11] = 0;  
    }
  Nmcf = Nmcw - l1[9] - l1[10] - l1[11];
  Nmcfc = Nmcf*pcmf;
  Nmcfb = Nmcf*(1 - pcmf);
  if (pbf == 1) l1[4] = Nmcfb*dmcf;
  if (pcmf > 0.000001) l1[5] = Nmcfc*dccf;
  if (pbf == 1) l1[15] = Nmcfb*nmcf;
  if (pcmf > 0.000001) l1[16] = Nmcfc*nccf;
  if (pcmf > 0.000001) l1[17] = Nmcfc - l1[5] - l1[16];
  if (pbf == 1) l1[14] = Nmcfb - l1[4] - l1[15];
  if (prodsys <= 2) {
    conh1 = phmat1*crh1mp;
    h1mprp = phmat1*(1-crh1mp)*(1-hcmat1) + phmat2;
    h1mpf = 1 - conh1 - h1mprp;
    if (fabs(h1mpf) < 0.000001) h1mpf = 0;
    conh2 = h1mprp*crh1mp;
    h2mprp = (1-conh1-h1mpf-conh2)*(1-hcmat2);
    h2mpf = 1 - conh1 - h1mpf - conh2 - h2mprp;
    conh3 = h2mprp*crh1mp;
    crhmp = conh1 + conh2 + conh3;
    hmpf = 1-crhmp;
    h3mpf = hmpf - h1mpf - h2mpf;
    Nfmat = l3[0]/crhmp;
    Nfrp = Nfmat/(1 - dfrp - sfrp);
    l1[21] = 0;
    if (Nfrp > Nfcw) {
      l1[6] = l1[8] = l1[12] = l1[13] = l1[23] = l1[24] = 0;
      l1[22] = Nfcw * (1-dfrp) * (1-sfrp) * crhmp;
      l1[20] = l3[0] - l1[22];
      l1[7] = Nfcw * dfrp;
      if (dprfrep > 0.000001) {
        l1[18] = Nfcw * (1-dfrp) * sfrp;
        l1[19] = Nfcw * (1-dfrp) * (1-sfrp) * (1-crhmp);
        }
      if (dprfrep < 0.000001) {
        l1[19] = Nfcw * (1-dfrp) * (1-sfrp) * (1-crhmp) 
	  + (1 - crhmp) * l1[20] / crhmp;
        l1[18] = Nfcw * (1-dfrp) * sfrp;
        }
      }    
    if (Nfrp <= Nfcw) {
      l1[19] = Nfmat* hmpf;
      l1[20] = 0;
      Nfav = Nfcw - Nfrp;
      Nffa = Nfav * pff;
      l1[22] = l3[0];
      l1[23] = Nfav*nphs;
      l1[24] = Nfav*phs;
      l1[8] = Nfav * exfc;
      l1[6] = Nffa * dfcf;
      l1[13] = Nffa * nfcf;
      l1[12] = Nffa - l1[6] - l1[13];
      l1[7] = Nfrp * dfrp;
      l1[18] = Nfrp * sfrp;
      }
    phc1 = h1mpf/hmpf;
    phc2 = h2mpf/hmpf;
    phc3 = h3mpf/hmpf;
    php1 = conh1/crhmp;
    php2 = conh2/crhmp;
    php3 = conh3/crhmp; 
    } /* End prodsys <= 2 */
  if (prodsys == 3) {
    l1[7] = 0;
    l1[18] = 0;
    l1[20] = l3[0];
    if (dprfrep > 0.000001) l1[19] = 0;
    if (dprfrep < 0.000001) l1[19] = (1 - crh1mp) * l1[20] / crh1mp;
    l1[21] = 0;
    l1[22] = 0;
    l1[23] = 0;
    l1[24] = 0;
    Nffa = Nfcw * pff;
    l1[8] = Nfcw * exfc;
    l1[6] = Nffa * dfcf;
    l1[13] = Nffa * nfcf;
    l1[12] = Nffa - l1[6] - l1[13];
    } /* End prodsys == 3 */
  /* Vector l1 */
  suml1 = 0;
  for (i = 1; i <=24; i++) {
    suml1 += l1[i];
    }
  /* Checking the correctness of the calculation of vector l1 */
  if (prodsys < 3) {
    if (Nfrp <= Nfcw) aa1 = suml1 - Ncal;
    if (Nfrp > Nfcw && dprfrep > 0) aa1 = suml1 - Ncal - l1[20];
    if (Nfrp > Nfcw && dprfrep < 0.000001) aa1 = suml1 - Ncal - l1[20]
      - ((1 - crhmp) * l1[20] / crhmp);
    }
  if (prodsys == 3 && dprfrep < 0.000001) aa1 = suml1 - Ncal - l1[20] - l1[19];
  if (prodsys == 3 && dprfrep > 0) aa1 = suml1 - Ncal - l1[20];
  if (fabs(aa1) > 0.00001) {
    nonsense5();
    goto END;
    }
  for (i = 1; i <= TT; i++) {
    l1[i+24] = l2[i];
    suml1 = suml1 + l1[i+24]; 
    }
  if (prodsys <= 2) {
    hcon1mat = conh1/(conh1+conh2+conh3);
    hcon2mat = conh2/(conh1+conh2+conh3);
    hcon3mat = 1-hcon1mat-hcon2mat;
    whmat = whmat1*hcon1mat + whmat2*hcon2mat + whmat3*hcon3mat; 
    agehmat = agehmat1*hcon1mat + agehmat2*hcon2mat + agehmat3*hcon3mat;  
    agecal = ageh1cal*hcon1mat+ageh2cal*hcon2mat+ageh3cal*hcon3mat;
    whcal = wh1cal*hcon1mat+wh2cal*hcon2mat+wh3cal*hcon3mat;
    wcacal[0] = whcal;
    if (wcacal[0] > wcacal[1]) {
      nonsense7();
      goto End_EW;
      }
    wccal[0] = whcal + wpreg;
    adghcal = (whcal-wwf)/(agecal-agew);
    agedmh = agew+(agecal-agew)/2.0;
    whdmh = wwf+adghcal*(agedmh-agew);
    agehcmat1 = agehmat1 + dayshc;
    whcmat1 = whmat1 + adgh1s*dayshc;
    agehcmat2 = agehmat2 + dayshc;
    whcmat2 = whmat2 + adgh2s*dayshc;
    agehcmat3 = agehmat3 + dayshc;
    whcmat3 = whmat3 + adgh3s*dayshc;
    hcmat1p = h1mpf/(h1mpf+h2mpf+h3mpf);
    hcmat2p = h2mpf/(h1mpf+h2mpf+h3mpf);
    hcmat3p = 1 - hcmat1p - hcmat2p;
    agehcmat = agehcmat1*hcmat1p+agehcmat2*hcmat2p+agehcmat3*hcmat3p;
    whcmat = whcmat1*hcmat1p+whcmat2*hcmat2p+whcmat3*hcmat3p;
    aphse1 = agehmat1 + dprfrep;
    aphse2 = agehmat2 + dprfrep;
    aphse = (agehmat1*hcon1mat + agehmat2*hcon2mat)/(hcon1mat + hcon2mat) + dprfrep;
    /* aphse = agehmat + dprfrep; */
    wnphse = wwf + (anphse - agew)*(whmat - wwf)/(agehmat-agew);
    wphse = whmat + dprfrep*adghcal; /*without weight of foetus*/
    agefrep = aphse;
    } /* End prodsys <= 2 */
  if (prodsys == 3) whcal = wcacal[0];
  wccal[1] = wcacal[1] + wpreg;
  for (i=2; i<=LL-1; i++) {
    wcacal[i] = mcw;
    wccal[i] = wcacal[2] + wpreg;
    }
  ndaycd = lghrcyc/2.0;
  if (davcal<davmat) ndaydys = (davmat - davcal)/2.0;
  else ndaydys = (365+davmat - davcal)/2.0;
  ndaycc = lghrcyc/2.0;
  ndaycw = agew +(depas-dw0);
  for (i = 25; i <=30; i++) {
    if (i == 26) i++;
    adg[i] = (wcacal[1] - wcacal[0]) / lghrcyc;
    } 
  adg[26] = 0; 
  for (i = 31; i <= 36; i++) {
    if (i == 32) i++;
    adg[i] = (wcacal[2] - wcacal[1]) / lghrcyc;
    }
  adg[32] = 0;
  for (i = 37; i <= CC; i++) adg[i] = 0;
  for (i = 1; i <= LL; i++) {  
    d[19+6*i] = ndaycd;
    d[20+6*i] = ndaydys;
    d[21+6*i] = ndaycc;
    d[22+6*i] = agew;   
      }
  for (i=1; i<LL; i++) d[23+6*i] = d[24+6*i] = lghrcyc;   
  for (i=0; i<LL; i++) wcd[i] = wcacal[i] + adg[19+6*(i+1)]*d[19+6*(i+1)];
  for (i=0; i<LL; i++) wcdys[i] = wcacal[i] + adg[20+6*(i+1)]*d[20+6*(i+1)];
  for (i=0; i<LL; i++) wcc[i] = wcacal[i] + adg[21+6*(i+1)]*d[21+6*(i+1)];
  for (i=0; i<LL; i++) wccw[i] = wcacal[i] + adg[22+6*(i+1)]*d[22+6*(i+1)];
  
  /* Calculation of the average life time of cows */ 
  for (i = 1; i <= LL; i++) {
    life[19+6*i]=ndaycd + (i-1)*lghrcyc;
    life[20+6*i]=ndaydys + (i-1)*lghrcyc;
    life[21+6*i]=ndaycc + (i-1)*lghrcyc;
    life[22+6*i]=ndaycw + (i-1)*lghrcyc;
    }
  for (i = 1; i < LL; i++) life[23+6*i]=life[24+6*i]=0;
  avelifecy = 0;
  for (i = 1; i <= TT; i++) 
    avelifecy += l2[i]*life[24+i];
  avelifecy /= (365*l4[0]);
  avelifecc = 1/(l3[0]*Ncal);
  
  /* Calculating the parameters for the lactation curve */
  if (lactcur == 2) {
    if (trait == 0)
      printf("Calculating parameters for the lactation curve\n");
    mpm = (0.125*pl + 0.375)*mpm0;
    mp2 = k2*mpm/km;
    mp3 = k3*mpm/km;
    mp4 = k4*mpm/km;
    lmm = mpm + 40;
    lm2 = lmm + 10;
    lm3 = lmm - 10;
    lm4 = lmm - 5;
    a2 = (4 - 0.05*lm2)*mp2/k2;
    a3 = (6.65 - 0.11*lm3)*mp3/k3;
    a4 = (5.85 - 0.09*lm4)*mp4/k4;
    am = (5.3 - 0.075*lmm)*mpm/km;
    if (a2>0) b2 = (log(mp2) - log(a2))/(log(lm2 + 14)-1);
      else { 
	nonsense1();
	goto END; 
	}
    if (a3>0) b3 = (log(mp3) - log(a3))/(log(lm3 + 14)-1);
      else { 
	nonsense1();
	goto END; 
	}
    if (a4>0) b4 = (log(mp4) - log(a4))/(log(lm4 + 14)-1);
      else { 
	nonsense1();
	goto END; 
	}
    if (am>0) bm = (log(mpm) - log(am))/(log(lmm + 14)-1);
      else { 
	nonsense1();
	goto END; 
	}
    c2 = b2/(lm2 + 14);
    c3 = b3/(lm3 + 14);
    c4 = b4/(lm4 + 14);
    cm = bm/(lmm + 14);
    } /* End lactcur == 2 */

  /* Energy and protein requirements */
  /* Feed losses for  production system 1 - 5 */
  if (trait == 0)
    printf("Calculating parameters for energy and protein requirements\n");
  kff = 100 / (100 - losff);
  kfpa = 100 / (100 - losfpa);
  kfw = 100 / (100 - loswf);
  
  /* Energy and protein requirement per animal of categories 1 and 2 */  
  for (i=0; i<=GG; i++) {
    new[i] = nes[i] = pdiw[i] = pdis[i] = nes0[i] = pdis0[i] = 0;
    }
  for (i=0; i<=CC; i++) {
    sl_1[i] = sl_2[i] = sl_3[i] = 0;
    wl_1[i] = wl_2[i] = wl_3[i] = 0;
    }

  /* Energy and protein requirement per animal of categories 3, 8, 9 */  
  bw[8] = bwf;
  bw[9] = bwf * kbwmf;
  bw[3] = 0.5 * (bw[8]+bw[9]);
  adg[8] = (wwf - bwf) / agew;
  adg[9] = (wwm - bw[9]) / agew;
  adg[3] = (0.5 * (wdcwf + wdcwm) - bw[3]) / agedcw;
  if (davcal+agedcw > 365) {
    if (davcal+agedcw-365 <= dbpas) {
      ds[3] = 0;
      dw[3] = agedcw;
      }
      else {
       dw[3] = 365+ dbpas - davcal;
       ds[3] = agedcw - dw[3]; 
       } 
      }
    else {
      if (davcal+agedcw <= dbpas) {
        ds[3] = 0;
        dw[3] = agedcw;
        }
      else {
	dw[3] = dbpas - davcal;
	ds[3] = agedcw - dw[3]; 
        }	 
    }  
  if (davcal+agew > 365) {
    if (davcal+agew-365 <= dbpas) {
      ds[8] = ds[9] = 0;
      dw[8] = dw[9] = agew;
      }
      else {
       dw[8] = dw[9] = 365+ dbpas - davcal;
       ds[8] = ds[9] = agew - dw[8]; 
       } 
      }
    else {
      if (davcal+agew <= dbpas) {
        ds[8] = ds[9] = 0;
        dw[8] = dw[9] = agew;
        }
      else {
	dw[8] = dw[9] = dbpas - davcal;
	ds[8] = ds[9] = agew - dw[8]; 
        }	 
    }
  dsl[8] = ds[8];
  dsl[9] = ds[9];
  dsl[3] = ds[3];
  ww[3] = bw[3] + adg[3] * dw[3];
  ww[8] = bw[8] + adg[8] * dw[8];
  ww[9] = bw[9] + adg[9] * dw[9];
  for (j = 3; j <= 9; j++) {
    if (j == 4) j = 8;
    for (i = 1; i <= (int) dw[j]; i++)      
      new[j] += pow(bw[j] + i*adg[j], 0.75);      
    new[j] = 0.42*new[j] + dw[j]*(5.69*adg[j] + 1.75*adg[j]*adg[j] - 2.67);
    aa1 = pow(bw[j] + dw[j]*adg[j], 0.75);      
    new[j] += 0.42*aa1*(dw[j]-(int)dw[j]);      		  	
    }    
  for (j = 3; j <= 9; j++) {
    if (j == 4) j = 8;    
    for (i = 1; i <= (int) ds[j]; i++) 
      nes[j] += pow(ww[j] + i * adg[j], 0.75);
    nes[j] += (ds[j]-(int)ds[j])*pow(ww[j] + ds[j] * adg[j], 0.75);	      
    nes[j] *= 0.302 + 0.228 * adg[j];	
    }
  for (j = 3; j <= 9; j++) {
    if (j == 4) j = 8;    
    for (i = 1; i <= (int)dw[j]; i++) 
      pdiw[j] += pow(bw[j] + i * adg[j], 0.75);
    pdiw[j] += (dw[j]-(int)dw[j])* pow(bw[j] + dw[j] * adg[j], 0.75);
    pdiw[j] = 3.25*pdiw[j]+dw[j]*(274.48*adg[j]-16.53*adg[j]*adg[j]-8.88);
    }   
  for (j = 3; j <= 9; j++) { 
    if (j == 4) j = 8;
    for (i = 1; i <= (int)ds[j]; i++)
      pdis[j] += pow(ww[j] + i * adg[j], 0.75);
    pdis[j] += (ds[j]-(int)ds[j])* pow(ww[j] + ds[j] * adg[j], 0.75);  
    pdis[j] = (3.25 + 0.98*adg[j])*pdis[j] + ds[j]*220.5*adg[j];
    }       
  if (ageh1cal < 800) {
    aa2 = a2;
    aa3 = b2;
    aa4 = c2; }
    else {
      aa2 = a3;
      aa3 = b3;
      aa4 = c3;}
  for (j = 3; j <= 9; j++) { 
    if (j == 4) j = 8;
  for (i = 1; i <= (int)dw[j]; i++) 
    wl_1[j] += exp(-aa4 * (i + 14))*pow(i+14, aa3);
  wl_1[j] += (dw[j]-(int)dw[j])*exp(-aa4 * (dw[j] + 14))*pow(dw[j]+14, aa3);
  wl_1[j] *= aa2;
    }
  if (ageh1cal < 800) {
    aa2 = a3;
    aa3 = b3;
    aa4 = c3; }
    else {
      aa2 = a4;
      aa3 = b4;
      aa4 = c4;}
  for (j = 3; j <= 9; j++) { 
    if (j == 4) j = 8;
  for (i = 1; i <= (int)dw[j]; i++) 
    wl_2[j] += exp(-aa4 * (i + 14))*pow(i+14, aa3);
  wl_2[j] += (dw[j]-(int)dw[j])*exp(-aa4 * (dw[j] + 14))*pow(dw[j]+14, aa3);
  wl_2[j] *= aa2;
  for (i = 1; i <= (int)dw[j]; i++) 
    wl_3[j] += exp(-cm * (i + 14))*pow(i+14, bm);
  wl_3[j] += (dw[j]-(int)dw[j])*exp(-cm * (dw[j] + 14))*pow(dw[j]+14, bm);
  wl_3[j] = wl_3[j]*am;
  aa1 = wl_1[j] * l3[0];
  aa2 = wl_2[j] * l3[1];
  aa3 = Ncal - l3[0] - l3[1];
  aa4 = wl_3[j] * aa3;
  wl[j] = aa1 + aa2 + aa4;
  newl[j] = wl[j] * 1.94 * (fat / 4.0);
    }
  for (j = 3; j <= 9; j++){  
    if (j == 4) j = 8;    
    new[j] -= newl[j];
    if (new[j] < 0)
      new[j] = 0;
    }	
  if (ageh1cal < 800) {
    aa2 = a2;
    aa3 = b2;
    aa4 = c2; }
    else {
      aa2 = a3;
      aa3 = b3;
      aa4 = c3;} 
  for (j = 3; j <= 9; j++) {
    if (dsl[j] == 0) j++;
    if (j == 4) j = 8;    
    for (i = (int)dw[j]; i <= (int)(dw[j]+dsl[j]); i++) 
      sl_1[j] += exp(-aa4 * (i + 14))*pow(i+14, aa3);
    sl_1[j] -= (dw[j]-(int)dw[j])*exp(-aa4 * (dw[j] + 14))*pow(dw[j]+14, aa3);  
    sl_1[j] += (dw[j]+dsl[j]-(int)(dw[j]+dsl[j]))
      *exp(-aa4*(dw[j]+dsl[j]+14))*pow(dw[j]+dsl[j]+14,aa3);     
    sl_1[j] *= aa2;
    }
  if (ageh1cal < 800) {
    aa2 = a3;
    aa3 = b3;
    aa4 = c3; }
    else {
      aa2 = a4;
      aa3 = b4;
      aa4 = c4;}
  for (j = 3; j <= 9; j++) {
    if (dsl[j] == 0) j++;
    if (j == 4) j = 8;    
    for (i = (int)dw[j]; i <= (int)(dw[j]+dsl[j]); i++) 
      sl_2[j] += exp(-aa4 * (i + 14))*pow(i+14, aa3);
    sl_2[j] -= (dw[j]-(int)dw[j])*exp(-aa4 * (dw[j] + 14))*pow(dw[j]+14, aa3);  
    sl_2[j] += (dw[j]+dsl[j]-(int)(dw[j]+dsl[j]))
      *exp(-aa4*(dw[j]+dsl[j]+14))*pow(dw[j]+dsl[j]+14,aa3);     
    sl_2[j] *= aa2;
    }
  for (j = 3; j <= 9; j++) {
    if (dsl[j] == 0) j++;  
    if (j == 4) j = 8;    
    for (i = (int)dw[j]; i <= (int)(dw[j]+dsl[j]); i++) 
      sl_3[j] += exp(-cm * (i + 14))*pow(i+14, bm);
    sl_3[j] -= (dw[j]-(int)dw[j])*exp(-cm * (dw[j] + 14))*pow(dw[j]+14, bm);  
    sl_3[j] += (dw[j]+dsl[j]-(int)(dw[j]+dsl[j]))
      *exp(-cm*(dw[j]+dsl[j]+14))*pow(dw[j]+dsl[j]+14,bm);     
    sl_3[j] *= am;
    }
  for (j = 3; j <= 9; j++) {
    if (j == 4) j = 8;    
    aa1 = sl_1[j] * l3[0];
    aa2 = sl_2[j] * l3[1];
    aa3 = Ncal - l3[0] - l3[1];
    aa4 = sl_3[j] * aa3;
    sl[j] = aa1 + aa2 + aa4;
    }
  nesl[3] = sl[3] * 1.94 * (fat / 4.0);
  nesl[8] = sl[8] * 1.94 * (fat / 4.0);
  nesl[9] = sl[9] * 1.94 * (fat / 4.0);        
  for (j = 3; j <= 9; j++) { 
    if (j == 4) j = 8;    
    nes[j] -= nesl[j];
    if (nes[j] < 0)
      nes[j] = 0;
    }      
  for (j = 3; j <= 9; j++) {
    if (j == 4) j = 8;    
    pdiwl[j] = wl[j] * 20.5 * (fat / 4.0);
    pdiw[j] -= pdiwl[j];
    if (pdiw[j] < 0)
      pdiw[j] = 0;
    }
  for (j = 3; j <= 9; j++) {
    if (j == 4) j = 8;
    pdisl[j] = sl[j] * 20.5 * (fat / 4.0);      
    pdis[j] -= pdisl[j];
    if (pdis[j] < 0)
      pdis[j] = 0;
    } 
   /* End of energy and protein requirements of categories 3, 8, 9 */

  /* Setting zero of different variables */
  for (i=0; i<G; i++) {    
    new1[i] = pdiw1[i] = nes1[i] = pdis1[i] = 0;
    new2[i] = pdiw2[i] = nes2[i] = pdis2[i] = 0;
    new3[i] = pdiw3[i] = nes3[i] = pdis3[i] = 0;
    nesp[i] = pdisp[i] = 0;
    nepc[i] = newp[i] = 0;
    pdipc[i] = pdiwp[i] = 0;     
    costwt[i] = costm[i] = 0;
    }
  for (i=0; i<C; i++) {
    neas[i] = ne[i] = 0;
    pdi[i] = pdias[i] = 0;  
    }
  new4 = pdiw4 = 0;  

  /* Energy for categories 4, 14 and 15*/
  if (pbf == 1) {
    if (tech1 == 1) kt = ktb;
    if (tech1 == 2) kt = ktf;
    adg[4] = adg[14] = adg[15] = adgwsm;
    d[4] = agedwsm - agew;
    d[14] = agesm - agew;
    d[15] = agecwsm - agew;
    if (prodsys <= 2) {
      aa1 = 0.13;
      aa2 = 3.0;
      aa3 = 0.975;
      }
      else {
	aa1 = 0.16;
	aa2 = 2.5;
	aa3 = 0.85;
	}
    for (j = 4; j <= 15; j++) {
      if (j == 5) j = 14;
      for (i = 1; i <= (int)d[j]; i++)      
	ne[j] += pow(wwm + i*adg[j], 0.75);      
      ne[j] = (0.34*kt+aa1*adg[j])*ne[j] + d[j]*aa2*adg[j];
      ne[j] += (d[j]-(int)d[j])*(0.34*kt+aa1*adg[j])*pow(wwm + d[j]*adg[j], 0.75);
      }    
    for (j = 4; j <= 15; j++) {
      if (j == 5) j = 14;
      for (i = 1; i <= (int)d[j]; i++)      
	pdi[j] += pow(wwm + i*adg[j], 0.75);
      pdi[j] += (d[j]-(int)d[j])* pow(wwm + d[j] * adg[j], 0.75);            
      pdi[j] = (3.25+aa3*adg[j])*pdi[j] + d[j]*220*adg[j];		  	
      }    
    }
    
  /* Energy for categories 5, 16 and 17*/
  if (pcmf > 0.000001) {
    if (maturity == 1) {
      kce = 1.15;
      kcp = 0.9;
      }
    if (maturity == 2) {
      kce = 1.0;
      kcp = 1.0;
      }
    if (maturity == 3) {    
      kce = 0.85;
      kcp = 1.1;
      }
    d[5] = agedwsc - agew;
    d[16] = agecwsc - agew;
    d[17] = agesc - agew;
    if (feedlot == 1) {
      if (tech1 == 1) kt = ktb;
      if (tech1 == 2) kt = ktf;
      adg[5] = adg[16] = adg[17] = adgwsf * kgaincf;
      for (j = 5; j <= 17; j++) {
	if (j == 6) j = 16;
	for (i = 1; i <= (int)d[j]; i++)      
	  ne[j] += pow(wwm + i*adg[j], 0.75); 
	ne[j] += (d[j]-(int)d[j])*pow(wwm + d[j]*adg[j], 0.75); 	     
	ne[j] = (0.34*kt+0.275*adg[j])*ne[j]*kce;
	}    
      for (j = 5; j <= 17; j++) {
	if (j == 6) j = 16;
	for (i = 1; i <= (int)d[j]; i++)      
	  pdi[j] += pow(wwm + i*adg[j], 0.75);
	pdi[j] += (d[j]-(int)d[j])* pow(wwm + d[j] * adg[j], 0.75);            
	pdi[j] = kcp*((3.25+1.05*adg[j])*pdi[j] + d[j]*220*adg[j]);
	}    
      } /* End of feedlot 1 */
    if (feedlot == 2) {
      for (j = 5; j <= 17; j++) {
	if (j == 6) j = 16;
	for (i = 1; i <= (int) dwx; i++)      
	  new[j] = new[j] + pow(wwm + i*dgcxw, 0.75);
	new[j] += (dwx-(int)dwx)*pow(wwm + dwx*dgcxw, 0.75); 	     	      
	new[j] = (0.34*ktf+0.275*dgcxw)*new[j]*kce;
	}    
      for (j = 5; j <= 17; j++) {
	if (j == 6) j = 16;
	for (i = 1; i <= (int)dwx; i++)      
	  pdiw[j] += pow(wwm + i*dgcxw, 0.75);
	pdiw[j] += (dwx-(int)dwx)* pow(wwm + dwx * dgcxw, 0.75);            
	pdiw[j] = kcp*((3.25+1.05*dgcxw)*pdiw[j] + dwx*220*dgcxw);		  	
	}    
      nes[5] = nes[16] = 0;
      pdis[5] = pdis[16] = 0;
      neas[5] = neas[16] = 0;
      pdias[5] = pdias[16] = 0;
      for (i = 1; i <= (int) dsx; i++)      
	nes[17] += pow(wcxw + i*dgcxs, 0.75);
      nes[17] += (dsx-(int)dsx)*pow(wcxw + dsx*dgcxs, 0.75);        
      nes[17] = (0.34*ktp+0.275*dgcxs)*nes[17]*kce;
      for (i = 1; i <= (int)dsx; i++)
	pdis[17] += pow(wcxw + i * dgcxs, 0.75);
      pdis[17] += (dsx-(int)dsx)* pow(wcxw + dsx * dgcxs, 0.75);  
      pdis[17] = kcp*((3.25 + 1.05*dgcxs)*pdis[17] + dsx*220*dgcxs);
      if (wcxs < wcxfat) {    
	for (i = 1; i <= (int) dasc; i++)      
	  neas[17] += pow(wcxs + i*dgcxas, 0.75);      
	neas[17] += (dasc-(int)dasc)*pow(wcxs + dasc*dgcxas, 0.75);        	
	neas[17] = (0.34*ktf+0.275*dgcxas)*neas[17]*kce;
	for (i = 1; i <= (int)dasc; i++)
	  pdias[17] += pow(wcxs + i * dgcxas, 0.75);
	pdias[17] += (dasc-(int)dasc)* pow(wcxs + dasc * dgcxas, 0.75);  
	pdias[17] = kcp*((3.25 + 1.05*dgcxas)*pdias[17] + dasc*220*dgcxas);
	} 
      else
	neas[17] = pdias[17] = 0;  
      } /* End of feedlot 2 */
    } 
 
  /* Energy for categories 6, 12, 13 */  
  if (pff > 0.000001) { 
    if (maturity == 1) {
      khe = 1.3;
      khp = 0.8;
      }
    if (maturity == 2) {
      khe = 1.15;
      khp = 0.9;
      }
    if (maturity == 3) {
      khe = 1.0;
      khp = 1.0;
      }
    d[6] = agedwsf - agew;
    d[13] = agecwsf - agew;
    d[12] = agesf - agew;
    }

  if (feedlot == 1) {
    if (pff > 0.000001) {
      if (tech1 == 1) kt = ktb;
      if (tech1 == 2) kt = ktf;
      adg[6] = adg[12] = adg[13] = adgwsf;
      for (j = 6; j <= 13; j++) {
	if (j == 7) j = 12;
	for (i = 1; i <= (int)d[j]; i++) {
	  aa1 = pow(wwf+i*adg[j], 0.75);
	  aa2 = pow(wwf+i*adg[j], 1.3);
	  ne[j] += 0.348*kt*aa1 + 0.004*aa2;
	  }      
	ne[j] = khe*(5.584*adg[j]*adg[j]*d[j] + ne[j]);
 	  aa1 = pow(wwf+d[j]*adg[j], 0.75);
 	  aa2 = pow(wwf+d[j]*adg[j], 1.3);
 	  aa3 = 0.348*kt*aa1 + 0.004*aa2;
	ne[j] += (d[j]-(int)d[j])*khe*aa3;
	}    
      for (j = 6; j <= 13; j++) {
	if (j == 7) j = 12;
	for (i = 1; i <= (int)d[j]; i++)  
	  pdi[j] += 3.25*pow(wwf+i*adg[j], 0.75) + 0.147*(wwf+i*adg[j]);	     
	pdi[j] += (d[j]-(int)d[j])*(3.25*pow(wwf+d[j]*adg[j],0.75)+0.147*(wwf+d[j]*adg[j]));	     		
	pdi[j] = khp*(pdi[j]+(216.3*adg[j]-5)*d[j]);
	}    
      }
    }  /* End of feedlot 1 */

  if (feedlot == 2) { /* Start of feedlot 2 */
    if (pff > 0.000001) {
      for (j = 6; j <= 13; j++) {
	if (j == 7) j = 12;
	for (i = 1; i <= (int)dwx; i++)  {    
	  aa1 = pow(wwf+i*dgfxw, 0.75);
	  aa2 = pow(wwf+i*dgfxw, 1.3);
	  new[j] += 0.348*kt*aa1 + 0.004*aa2;       
	  }
	new[j] = khe*(5.584*dgfxw*dgfxw*dwx+new[j]);
 	  aa1 = pow(wwf+dwx*dgfxw, 0.75);
 	  aa2 = pow(wwf+dwx*dgfxw, 1.3);
 	  aa3 = 0.348*kt*aa1 + 0.004*aa2;
	new[j] += (dwx-(int)dwx)*khe*aa3;
	}
      for (j = 6; j <= 13; j++) {
	if (j == 7) j = 12;
	for (i = 1; i <= (int)dwx; i++)  
	  pdiw[j] += 3.25*pow(wwf+i*dgfxw, 0.75) + 0.147*(wwf+i*dgfxw);	     
	pdiw[j] += (dwx-(int)dwx)*(3.25*pow(wwf+dwx*dgfxw,0.75)+0.147*(wwf+dwx*dgfxw));	     		
	pdiw[j] = khp*(pdiw[j]+(216.3*dgfxw-5)*dwx);
	} 
      nes[6] = nes[13] = 0;
      pdis[6] = pdis[13] = 0;
      neas[6] = neas[13] = 0;
      pdias[6] = pdias[13] = 0;
      for (i = 1; i <= (int)dsx; i++) {
          aa1 = pow(wfxw+i*dgfxs, 0.75);
	  aa2 = pow(wfxw+i*dgfxs, 1.3);
	  nes[12] += 0.348*kt*aa1 + 0.004*aa2; ;      
	  }
	nes[12] = khe*(5.584*dgfxs*dgfxs*dsx+nes[12]);
 	  aa1 = pow(wfxw+dsx*dgfxs, 0.75);
 	  aa2 = pow(wfxw+dsx*dgfxs, 1.3);
 	  aa3 = 0.348*kt*aa1 + 0.004*aa2;
	nes[12] += (dsx-(int)dsx)*khe*aa3;
	for (i = 1; i <= (int)dsx; i++)  
	  pdis[12] += 3.25*pow(wfxw+i*dgfxs, 0.75) + 0.147*(wfxw+i*dgfxs);	     
	pdis[12] += (dsx-(int)dsx)*(3.25*pow(wfxw+dsx*dgfxs,0.75)+0.147*(wfxw+dsx*dgfxs));	     		
	pdis[12] = khp*(pdis[12]+(216.3*dgfxs-5)*dsx);
      if (wfxs < whxfat) {    
	for (i = 1; i <= (int)dasf; i++)  {
	  aa1 = pow(wfxs+i*dgfxas, 0.75);
	  aa2 = pow(wfxs+i*dgfxas, 1.3);
	  neas[12] += 0.348*kt*aa1 + 0.004*aa2; ;      
	  }
	neas[12] = khe*(5.584*dgfxas*dgfxas*dasf+neas[12]);
 	  aa1 = pow(wfxs+dasf*dgfxas, 0.75);
 	  aa2 = pow(wfxs+dasf*dgfxas, 1.3);
 	  aa3 = 0.348*kt*aa1 + 0.004*aa2;
	neas[12] += (dasf-(int)dasf)*khe*aa3;
	for (i = 1; i <= (int)dasf; i++)  
	  pdias[12] += 3.25*pow(wfxs+i*dgfxas, 0.75) + 0.147*(wfxs+i*dgfxas);	     
	pdias[12] += (dasf-(int)dasf)*(3.25*pow(wfxs+dasf*dgfxas,0.75)+0.147*(wfxs+dasf*dgfxas));	     		
	pdias[12] = khp*(pdias[12]+(216.3*dgfxas-5)*dasf);
	} 
      else
	neas[12] = pdias[12] = 0; 
    }
  } /* End of feedlot 2 */

  /* Energy for category 7 */  
  if (prodsys <= 2) {
    d[7] = agedmh - agew;
    for (i = 1; i <= (int)d[7]; i++)      
      ne[7] += pow(wwf + i*adghcal, 0.75);
    ne[7] += (d[7]-(int)d[7])*pow(wwf + d[7]*adghcal, 0.75);        
    ne[7] = (0.302*ktp+0.228*adghcal)*ne[7];
    for (i = 1; i <= (int)d[7]; i++)
      pdi[7] += pow(wwf + i * adghcal, 0.75);
    pdi[7] += (d[7]-(int)d[7])* pow(wwf + d[7] * adghcal, 0.75);  
    pdi[7] = (3.25 + 0.98*adghcal)*pdi[7] + d[7]*220.5*adghcal;
    new[7] = ne[7] / 3.0;
    nes[7] = ne[7] - new[7];
    pdiw[7] = pdi[7] / 3.0;
    pdis[7] = pdi[7] - pdiw[7];  
  }    

  /* Energy for category 19 - three groups are defined in this category: 
     19_1 = CC+1, 19_2 = CC+2, 19_3 = CC+3 */
  if (prodsys <= 2) {
    if (davcal >= depas) aa3 = davcal + agew - 365.0; /* date of weaning */
    if (davcal <= dbpas) aa3 = davcal + agew;    
    if (davcal <= dbpas) aa2 = agehcmat1 + davcal; /* date of ending category */
    else aa2 = agehcmat1 + davcal - 365.0; 
    if (aa3 <= depas) {
      if (aa2 <= depas) {
        ds0[CC+1] = aa2 - aa3; 
	dw1[CC+1] = 0;
	} 
      if (aa2 > depas) {
       ds0[CC+1] = depas - aa3;
       if (aa2 <= dbpas + 365.0) {
         dw1[CC+1] = aa2 - depas;
	 ds1[CC+1] = 0;
	 }
       if (aa2 > dbpas + 365.0) 
         dw1[CC+1] = dbpas + 365.0 - depas; 
       }
     }
    if (aa3 > depas) {
      ds0[CC+1] = 0;
      if (aa2 <= dbpas + 365) {
	dw1[CC+1] = aa2 - aa3;
	ds1[CC+1] = 0;
	} 
      if (aa2 > dbpas + 365) dw1[CC+1] = dbpas + 365 - aa3;
      }
    if (aa2 > dbpas + 365 && aa2 <= depas + 365) {
      ds1[CC+1] =  aa2 - (dbpas + 365);
      dw2[CC+1] = 0;
      }
    if (aa2 > depas + 365 && aa2 <= dbpas + 2*365) {
      ds1[CC+1] =  depas - dbpas;
      dw2[CC+1] = aa2 - (depas + 365);
      ds2[CC+1] = 0;
      }
    if (aa2 > dbpas + 2*365 && aa2 <= depas + 2*365) {
      ds1[CC+1] =  depas - dbpas;
      dw2[CC+1] = dbpas + 365 - depas;
      ds2[CC+1] = aa2 - (dbpas + 2*365);
      dw3[CC+1] = 0;
      }
    if (aa2 > depas + 2*365 && aa2 <= dbpas + 3*365) {
      ds1[CC+1] =  depas - dbpas;
      dw2[CC+1] = dbpas + 365 - depas;
      ds2[CC+1] = depas - dbpas;
      dw3[CC+1] = aa2 - (depas + 2*365);
      }
    if (aa2 > dbpas + 3*365 && aa2 <= depas + 3*365) {
      ds1[CC+1] =  depas - dbpas;
      dw2[CC+1] = dbpas + 365 - depas;
      ds2[CC+1] = depas - dbpas;
      dw3[CC+1] = dbpas + 365 - depas;
      ds3[CC+1] = aa2 - (dbpas + 3*365);
      dw4[CC+1] = 0;
      }
    if (aa2 > depas + 3*365) {
      ds1[CC+1] =  depas - dbpas;
      dw2[CC+1] = dbpas + 365 - depas;
      ds2[CC+1] = depas - dbpas;
      dw3[CC+1] = dbpas + 365 - depas;
      ds3[CC+1] = depas - dbpas;
      dw4[CC+1] = aa2 - (depas + 3*365);
      }	 	 	 	 
    adgs0[CC+1] = adgcon3f;
    adgs1[CC+1] = adgh1s;
    adgw1[CC+1] = adgcon3f;
    if (aa3 < depas) {
      ws0[CC+1] = wwf + adgs0[CC+1]* (depas-dw0);
      ww1[CC+1] = ws0[CC+1] + adgw1[CC+1]*dw1[CC+1];
      }
    else  ww1[CC+1] = wwf + adgw1[CC+1]*dw1[CC+1];
    if (aa3 < depas) {
      for (i = 1; i <= (int)ds0[CC+1]; i++)      
	nes0[CC+1] += pow(wwf + i*adgs0[CC+1], 0.75); 
      nes0[CC+1] += (ds0[CC+1]-(int)ds0[CC+1])*pow(wwf + ds0[CC+1]*adgs0[CC+1], 0.75);               
      nes0[CC+1] *= 0.302*ktf+0.228*adgs0[CC+1]; 
      for (i = 1; i <= (int)dw1[CC+1]; i++)
	new[CC+1] += pow(ws0[CC+1] + i*adgw1[CC+1], 0.75); 
      new[CC+1] += (dw1[CC+1]-(int)dw1[CC+1])*pow(ws0[CC+1] + dw1[CC+1]*adgw1[CC+1], 0.75); 
      new[CC+1] *= 0.302*ktf+0.228*adgw1[CC+1];	
      }    
    else {	
      for (i = 1; i <= (int)dw1[CC+1]; i++)      
	new[CC+1] += pow(wwf + i*adgw1[CC+1], 0.75); 
      new[CC+1] += (dw1[CC+1]-(int)dw1[CC+1])*pow(wwf + dw1[CC+1]*adgw1[CC+1], 0.75);               
      new[CC+1] *= 0.302*ktf+0.228*adgw1[CC+1];
      }
    if (aa3 < depas) {
      for (i = 1; i <= (int)ds0[CC+1]; i++)
	pdis0[CC+1] += pow(wwf + i * adgs0[CC+1], 0.75);
      pdis0[CC+1] += (ds0[CC+1]-(int)ds0[CC+1])* pow(wwf + ds0[CC+1] * adgs0[CC+1], 0.75);  
      pdis0[CC+1] = (3.25 + 0.98*adgs0[CC+1])*pdiw[CC+1] + ds0[CC+1]*220.5*adgs0[CC+1];
      for (i = 1; i <= (int)dw1[CC+1]; i++)      
	pdiw[CC+1] += pow(ws0[CC+1] + i * adgw1[CC+1], 0.75);
      pdiw[CC+1] += (dw1[CC+1]-(int)dw1[CC+1])* pow(ws0[CC+1] + dw1[CC+1] * adgw1[CC+1], 0.75);  
      pdiw[CC+1] = (3.25 + 0.98*adgw1[CC+1])*pdiw[CC+1] + dw1[CC+1]*220.5*adgw1[CC+1];
      }    
    else {		    
      for (i = 1; i <= (int)dw1[CC+1]; i++)
	pdiw[CC+1] += pow(wwf + i * adgw1[CC+1], 0.75);
      pdiw[CC+1] += (dw1[CC+1]-(int)dw1[CC+1])* pow(wwf + dw1[CC+1] * adgw1[CC+1], 0.75);  
      pdiw[CC+1] = (3.25 + 0.98*adgw1[CC+1])*pdiw[CC+1] + dw1[CC+1]*220.5*adgw1[CC+1];
      }
    if (ds1[CC+1] > 0) {
      for (i = 1; i <= (int)ds1[CC+1]; i++)      
        nes[CC+1] += pow(ww1[CC+1] + i*adgs1[CC+1], 0.75);    
      nes[CC+1] += (ds1[CC+1]-(int)ds1[CC+1])*pow(ww1[CC+1] + ds1[CC+1]*adgs1[CC+1], 0.75);      
      nes[CC+1] *= 0.302*ktp+0.228*adgs1[CC+1];
      for (i = 1; i <= (int)ds1[CC+1]; i++)
	pdis[CC+1] += pow(ww1[CC+1] + i * adgs1[CC+1], 0.75);
      pdis[CC+1] += (ds1[CC+1]-(int)ds1[CC+1])* pow(ww1[CC+1] + ds1[CC+1] * adgs1[CC+1], 0.75);  
      pdis[CC+1] = (3.25 + 0.98*adgs1[CC+1])*pdis[CC+1] + ds1[CC+1]*220.5*adgs1[CC+1];
      }
    nes[CC+1] += nes0[CC+1];
    pdis[CC+1] += pdis0[CC+1];  
    
 /* Category of heifers CC+2 */  
    if (davcal<= dbpas) aa2 = agehcmat2 + davcal; /*date of ending category */
    else aa2 = agehcmat2 + davcal - 365; 
    if (aa3 <= depas) {
      if (aa2 <= depas) {
        ds0[CC+2] = aa2 - aa3; 
	dw1[CC+2] = 0;
	} 
      if (aa2 > depas) {
       ds0[CC+2] = depas - aa3;
       if (aa2 <= dbpas + 365) {
         dw1[CC+2] = aa2 - depas;
	 ds1[CC+2] = 0;
	 }
       if (aa2 > dbpas + 365) 
         dw1[CC+2] = dbpas + 365 - depas; 
       }
     }
    if (aa3 > depas) {
      ds0[CC+2] = 0;
      if (aa2 <= dbpas + 365) {
	dw1[CC+2] = aa2 - aa3;
	ds1[CC+2] = 0;
	} 
      if (aa2 > dbpas + 365) dw1[CC+2] = dbpas + 365 - aa3;
      }
    if (aa2 > dbpas + 365 && aa2 <= depas + 365) {
      ds1[CC+2] =  aa2 - (dbpas + 365);
      dw2[CC+2] = 0;
      }
    if (aa2 > depas + 365 && aa2 <= dbpas + 2*365) {
      ds1[CC+2] =  depas - dbpas;
      dw2[CC+2] = aa2 - (depas + 365);
      ds2[CC+2] = 0;
      }
    if (aa2 > dbpas + 2*365 && aa2 <= depas + 2*365) {
      ds1[CC+2] =  depas - dbpas;
      dw2[CC+2] = dbpas + 365 - depas;
      ds2[CC+2] = aa2 - (dbpas + 2*365);
      dw3[CC+2] = 0;
      }
    if (aa2 > depas + 2*365 && aa2 <= dbpas + 3*365) {
      ds1[CC+2] =  depas - dbpas;
      dw2[CC+2] = dbpas + 365 - depas;
      ds2[CC+2] = depas - dbpas;
      dw3[CC+2] = aa2 - (depas + 2*365);
      }
    if (aa2 > dbpas + 3*365 && aa2 <= depas + 3*365) {
      ds1[CC+2] =  depas - dbpas;
      dw2[CC+2] = dbpas + 365 - depas;
      ds2[CC+2] = depas - dbpas;
      dw3[CC+2] = dbpas + 365 - depas;
      ds3[CC+2] = aa2 - (dbpas + 3*365);
      dw4[CC+2] = 0;
      }
    if (aa2 > depas + 3*365) {
      ds1[CC+2] =  depas - dbpas;
      dw2[CC+2] = dbpas + 365 - depas;
      ds2[CC+2] = depas - dbpas;
      dw3[CC+2] = dbpas + 365 - depas;
      ds3[CC+2] = depas - dbpas;
      dw4[CC+2] = aa2 - (depas + 3*365);
      }	 	 	 	 
    adgs0[CC+2] = adgcon3f;
    adgs1[CC+2] = adgh1s;
    adgs2[CC+2] = adgh2s;
    adgw1[CC+2] = adgcon3f;
    adgw2[CC+2] = adgh2w;
    if (aa3 < depas) {
      ws0[CC+2] = wwf + adgs0[CC+2]* (depas-dw0);
      ww1[CC+2] = ws0[CC+2] + adgw1[CC+2]*dw1[CC+2];
      }
    else  ww1[CC+2] = wwf + adgw1[CC+2]*dw1[CC+2];
    ws1[CC+2] = ww1[CC+2] + adgh1s * ds1[CC+2];
    ww2[CC+2] = ws1[CC+2] + adgh2w * dw2[CC+2];
    if (aa3<depas) {
      nes0[CC+2] = nes0[CC+1]; 
      for (i = 1; i <= (int)dw1[CC+2]; i++)      
	new1[CC+2] += pow(ws0[CC+2] + i*adgw1[CC+2], 0.75);      
      new1[CC+2] += (dw1[CC+2]-(int)dw1[CC+2])*pow(ws0[CC+2] + dw1[CC+2]*adgw1[CC+2], 0.75);
      new1[CC+2] *= 0.302*ktf+0.228*adgw1[CC+2];  
      }    
    else {
      for (i = 1; i <= (int)dw1[CC+2]; i++)      
	new1[CC+2] += pow(wwf + i*adgw1[CC+2], 0.75);      
      new1[CC+2] += (dw1[CC+2]-(int)dw1[CC+2])*pow(wwf + dw1[CC+2]*adgw1[CC+2], 0.75);
      new1[CC+2] *= 0.302*ktf+0.228*adgw1[CC+2];
      }
    if (aa3<depas) {      
      pdis0[CC+2] = pdis0[CC+1]; 
      for (i = 1; i <= (int)dw1[CC+2]; i++)
	pdiw1[CC+2] += pow(ws0[CC+2] + i * adgw1[CC+2], 0.75);
      pdiw1[CC+2] += (dw1[CC+2]-(int)dw1[CC+2])* pow(ws0[CC+2] + dw1[CC+2] * adgw1[CC+2], 0.75);  
      pdiw1[CC+2] = (3.25 + 0.98*adgw1[CC+2])*pdiw1[CC+2] + dw1[CC+2]*220.5*adgw1[CC+2];
      }
    else {  
      for (i = 1; i <= (int)dw1[CC+2]; i++)
	pdiw1[CC+2] += pow(wwf + i * adgw1[CC+2], 0.75);
      pdiw1[CC+2] += (dw1[CC+2]-(int)dw1[CC+2])* pow(wwf + dw1[CC+2] * adgw1[CC+2], 0.75);  
      pdiw1[CC+2] = (3.25 + 0.98*adgw1[CC+2])*pdiw1[CC+2] + dw1[CC+2]*220.5*adgw1[CC+2];
      }    
    for (i = 1; i <= (int)ds1[CC+2]; i++)      
      nes1[CC+2] += pow(ww1[CC+2] + i*adgs1[CC+2], 0.75);
    nes1[CC+2] += (ds1[CC+2]-(int)ds1[CC+2])*pow(ww1[CC+2] + ds1[CC+2]*adgs1[CC+2], 0.75); 
    nes1[CC+2] *= 0.302*ktp+0.228*adgs1[CC+2];
    for (i = 1; i <= (int)ds1[CC+2]; i++)
      pdis1[CC+2] += pow(ww1[CC+2] + i * adgs1[CC+2], 0.75);
    pdis1[CC+2] += (ds1[CC+2]-(int)ds1[CC+2])* pow(ww1[CC+2] + ds1[CC+2] * adgs1[CC+2], 0.75);  
    pdis1[CC+2] = (3.25 + 0.98*adgs1[CC+2])*pdis1[CC+2] + ds1[CC+2]*220.5*adgs1[CC+2];
    for (i = 1; i <= (int)dw2[CC+2]; i++)      
      new2[CC+2] += pow(ws1[CC+2] + i*adgw2[CC+2], 0.75);
    new2[CC+2] += (dw2[CC+2]-(int)dw2[CC+2])*pow(ws1[CC+2] + dw2[CC+2]*adgw2[CC+2], 0.75); 
    new2[CC+2] *= 0.302*ktf+0.228*adgw2[CC+2];
    for (i = 1; i <= (int)dw2[CC+2]; i++)
      pdiw2[CC+2] += pow(ws1[CC+2] + i * adgw2[CC+2], 0.75);
    pdiw2[CC+2] += (dw2[CC+2]-(int)dw2[CC+2])* pow(ws1[CC+2] + dw2[CC+2] * adgw2[CC+2], 0.75);  
    pdiw2[CC+2] = (3.25 + 0.98*adgw2[CC+2])*pdiw2[CC+2] + dw2[CC+2]*220.5*adgw2[CC+2];
    if (ds2[CC+2]>0) {  
      for (i = 1; i <= (int)ds2[CC+2]; i++)      
	nes2[CC+2] += pow(ww2[CC+2] + i*adgs2[CC+2], 0.75);
      nes2[CC+2] += (ds2[CC+2]-(int)ds2[CC+2])*pow(ww2[CC+2] + ds2[CC+2]*adgs2[CC+2], 0.75);   
      nes2[CC+2] *= 0.302*ktp+0.228*adgs2[CC+2];
      for (i = 1; i <= (int)ds2[CC+2]; i++)
	pdis2[CC+2] += pow(ww2[CC+2] + i * adgs2[CC+2], 0.75);
      pdis2[CC+2] += (ds2[CC+2]-(int)ds2[CC+2])* pow(ww2[CC+2] + ds2[CC+2] * adgs2[CC+2], 0.75);  
      pdis2[CC+2] = (3.25 + 0.98*adgs2[CC+2])*pdis2[CC+2] + ds2[CC+2]*220.5*adgs2[CC+2];
      }
    new[CC+2] = new1[CC+2] + new2[CC+2];
    pdiw[CC+2] = pdiw1[CC+2] + pdiw2[CC+2];
    nes[CC+2] = nes0[CC+2] + nes1[CC+2] + nes2[CC+2];
    pdis[CC+2] = pdis0[CC+2] + pdis1[CC+2] + pdis2[CC+2];

  /* Category of heifers CC+3 */
    if (davcal<= dbpas) aa2 = agehcmat3 + davcal; /*date of ending category */
    else aa2 = agehcmat3 + davcal - 365; 
    if (aa3 <= depas) {
      if (aa2 <= depas) {
        ds0[CC+3] = aa2 - aa3; 
	dw1[CC+3] = 0;
	} 
      if (aa2 > depas) {
       ds0[CC+3] = depas - aa3;
       if (aa2 <= dbpas + 365) {
         dw1[CC+3] = aa2 - depas;
	 ds1[CC+3] = 0;
	 }
       if (aa2 > dbpas + 365) 
         dw1[CC+3] = dbpas + 365 - depas; 
       }
     }
    if (aa3 > depas) {
      ds0[CC+3] = 0;
      if (aa2 <= dbpas + 365) {
	dw1[CC+3] = aa2 - aa3;
	ds1[CC+3] = 0;
	} 
      if (aa2 > dbpas + 365) dw1[CC+3] = dbpas + 365 - aa3;
      }
    if (aa2 > dbpas + 365 && aa2 <= depas + 365) {
      ds1[CC+3] =  aa2 - (dbpas + 365);
      dw2[CC+3] = 0;
      }
    if (aa2 > depas + 365 && aa2 <= dbpas + 2*365) {
      ds1[CC+3] =  depas - dbpas;
      dw2[CC+3] = aa2 - (depas + 365);
      ds2[CC+3] = 0;
      }
    if (aa2 > dbpas + 2*365 && aa2 <= depas + 2*365) {
      ds1[CC+3] =  depas - dbpas;
      dw2[CC+3] = dbpas + 365 - depas;
      ds2[CC+3] = aa2 - (dbpas + 2*365);
      dw3[CC+3] = 0;
      }
    if (aa2 > depas + 2*365 && aa2 <= dbpas + 3*365) {
      ds1[CC+3] =  depas - dbpas;
      dw2[CC+3] = dbpas + 365 - depas;
      ds2[CC+3] = depas - dbpas;
      dw3[CC+3] = aa2 - (depas + 2*365);
      }
    if (aa2 > dbpas + 3*365 && aa2 <= depas + 3*365) {
      ds1[CC+3] =  depas - dbpas;
      dw2[CC+3] = dbpas + 365 - depas;
      ds2[CC+3] = depas - dbpas;
      dw3[CC+3] = dbpas + 365 - depas;
      ds3[CC+3] = aa2 - (dbpas + 3*365);
      dw4[CC+3] = 0;
      }
    if (aa2 > depas + 3*365) {
      ds1[CC+3] =  depas - dbpas;
      dw2[CC+3] = dbpas + 365 - depas;
      ds2[CC+3] = depas - dbpas;
      dw3[CC+3] = dbpas + 365 - depas;
      ds3[CC+3] = depas - dbpas;
      dw4[CC+3] = aa2 - (depas + 3*365);
      }	 	 	 	 
    adgs0[CC+3] = adgcon3f;
    adgs1[CC+3] = adgh1s;
    adgw1[CC+3] = adgcon3f;
    if (aa3 < depas) {
      ws0[CC+3] = wwf + adgs0[CC+3]* (depas-dw0);
      ww1[CC+3] = ws0[CC+3] + adgw1[CC+3]*dw1[CC+3];
      }
    else  ww1[CC+3] = wwf + adgw1[CC+3]*dw1[CC+3];
    adgs2[CC+3] = adgs2[CC+2];
    adgw2[CC+3] = adgw2[CC+2];
    ws1[CC+3] = ws1[CC+2];
    ww2[CC+3] = ws1[CC+3] + adgh2w*dw2[CC+3];
    adgs2[CC+3] = adgh2s;
    adgw3[CC+3] = adgh3w;
    adgs3[CC+3] = adgh3s;
    ws2[CC+3] = ww2[CC+3] + adgh2s * ds2[CC+3];
    ww3[CC+3] = ws2[CC+3] + adgh3w * dw3[CC+3];
        nes0[CC+3] = nes0[CC+2];
    pdis0[CC+3] = pdis0[CC+2];
    new1[CC+3] = new1[CC+2];
    pdiw1[CC+3] = pdiw1[CC+2];
    nes1[CC+3] = nes1[CC+2];
    pdis1[CC+3] = pdis1[CC+2];
    for (i = 1; i <= (int)dw2[CC+3]; i++)      
      new2[CC+3] += pow(ws1[CC+3] + i*adgw2[CC+3], 0.75);
    new2[CC+3] += (dw2[CC+3]-(int)dw2[CC+3])*pow(ws1[CC+3] + dw2[CC+3]*adgw2[CC+3], 0.75);   
    new2[CC+3] *= 0.302*ktf+0.228*adgw2[CC+3];
    for (i = 1; i <= (int)dw2[CC+3]; i++)
      pdiw2[CC+3] += pow(ws1[CC+3] + i * adgw2[CC+3], 0.75);
    pdiw2[CC+3] += (dw2[CC+3]-(int)dw2[CC+3])* pow(ws1[CC+3] + dw2[CC+3] * adgw2[CC+3], 0.75);  
    pdiw2[CC+3] = (3.25 + 0.98*adgw2[CC+3])*pdiw2[CC+3] + dw2[CC+3]*220.5*adgw2[CC+3];        
    for (i = 1; i <= (int)ds2[CC+3]; i++)      
      nes2[CC+3] += pow(ww2[CC+3] + i*adgs2[CC+3], 0.75);
    nes2[CC+3] += (ds2[CC+3]-(int)ds2[CC+3])*pow(ww2[CC+3] + ds2[CC+3]*adgs2[CC+3], 0.75);   
    nes2[CC+3] *= 0.302*ktp+0.228*adgs2[CC+3];
    for (i = 1; i <= (int)ds2[CC+3]; i++)
      pdis2[CC+3] += pow(ww2[CC+3] + i * adgs2[CC+3], 0.75);
    pdis2[CC+3] += (ds2[CC+3]-(int)ds2[CC+3])* pow(ww2[CC+3] + ds2[CC+3] * adgs2[CC+3], 0.75);  
    pdis2[CC+3] = (3.25 + 0.98*adgs2[CC+3])*pdis2[CC+3] + ds2[CC+3]*220.5*adgs2[CC+3];
    for (i = 1; i <= (int)dw3[CC+3]; i++)      
      new3[CC+3] += pow(ws2[CC+3] + i*adgw3[CC+3], 0.75);
    new3[CC+3] += (dw3[CC+3]-(int)dw3[CC+3])*pow(ws2[CC+3] + dw3[CC+3]*adgw3[CC+3], 0.75);
    new3[CC+3] *= 0.302*ktf+0.228*adgw3[CC+3];
    for (i = 1; i <= (int)dw3[CC+3]; i++)
      pdiw3[CC+3] += pow(ws2[CC+3] + i * adgw3[CC+3], 0.75);
    pdiw3[CC+3] += (dw3[CC+3]-(int)dw3[CC+3])* pow(ws2[CC+3] + dw3[CC+3] * adgw3[CC+3], 0.75);  
    pdiw3[CC+3] = (3.25 + 0.98*adgw3[CC+3])*pdiw3[CC+3] + dw3[CC+3]*220.5*adgw3[CC+3];
    for (i = 1; i <= (int)ds3[CC+3]; i++)      
      nes3[CC+3] += pow(ww3[CC+3] + i*adgs3[CC+3], 0.75);
    nes3[CC+3] += (ds3[CC+3]-(int)ds3[CC+3])*pow(ww3[CC+3] + ds3[CC+3]*adgs3[CC+3], 0.75);   
    nes3[CC+3] *= 0.302*ktp+0.228*adgs3[CC+3];
    for (i = 1; i <= (int)ds3[CC+3]; i++)
      pdis3[CC+3] += pow(ww3[CC+3] + i * adgs3[CC+3], 0.75);
    pdis3[CC+3] += (ds3[CC+3]-(int)ds3[CC+3])* pow(ww3[CC+3] + ds3[CC+3] * adgs3[CC+3], 0.75);  
    pdis3[CC+3] = (3.25 + 0.98*adgs3[CC+3])*pdis3[CC+3] + ds3[CC+3]*220.5*adgs3[CC+3];
    new[CC+3] = new1[CC+3] + new2[CC+3] + new3[CC+3];
    pdiw[CC+3] = pdiw1[CC+3] + pdiw2[CC+3] + pdiw3[CC+3];
    nes[CC+3] = nes0[CC+3] + nes1[CC+3] + nes2[CC+3] + nes3[CC+3];
    pdis[CC+3] = pdis0[CC+3] + pdis1[CC+3] + pdis2[CC+3] + pdis3[CC+3];

    /* Energy and protein requirement fo category 19 */
    new[19] = phc1 * new[CC+1] + phc2 * new[CC+2] + phc3 * new[CC+3];
    pdiw[19] = phc1 * pdiw[CC+1] + phc2 * pdiw[CC+2] + phc3 * pdiw[CC+3];
    nes[19] = phc1 * nes[CC+1] + phc2 * nes[CC+2] + phc3 * nes[CC+3];
    pdis[19] = phc1 * pdis[CC+1] + phc2 * pdis[CC+2] + phc3 * pdis[CC+3];
  } /* End production systems 1 to 2 */

  /* Energy for category 22 - three groups are defined in this category: 
     22_1 = CC+4, 22_2 = CC+5, 22_3 = CC+6 */
  if (prodsys <= 2) { /* Start production systems 1 to 2 */
    if (davcal<= dbpas) aa2 = ageh1cal + davcal; /*date of ending category */
    else aa2 = ageh1cal + davcal - 365; 
    if (aa3 <= depas) {
      if (aa2 <= depas) {
        ds0[CC+4] = aa2 - aa3; 
	dw1[CC+4] = 0;
	} 
      if (aa2 > depas) {
       ds0[CC+4] = depas - aa3;
       if (aa2 <= dbpas + 365) {
         dw1[CC+4] = aa2 - depas;
	 ds1[CC+4] = 0;
	 }
       if (aa2 > dbpas + 365) 
         dw1[CC+4] = dbpas + 365 - depas; 
       }
     }
    if (aa3 > depas) {
      ds0[CC+4] = 0;
      if (aa2 <= dbpas + 365) {
	dw1[CC+4] = aa2 - aa3;
	ds1[CC+4] = 0;
	} 
      if (aa2 > dbpas + 365) dw1[CC+4] = dbpas + 365 - aa3;
      }
    if (aa2 > dbpas + 365 && aa2 <= depas + 365) {
      ds1[CC+4] =  aa2 - (dbpas + 365);
      dw2[CC+4] = 0;
      }
    if (aa2 > depas + 365 && aa2 <= dbpas + 2*365) {
      ds1[CC+4] =  depas - dbpas;
      dw2[CC+4] = aa2 - (depas + 365);
      ds2[CC+4] = 0;
      }
    if (aa2 > dbpas + 2*365 && aa2 <= depas + 2*365) {
      ds1[CC+4] =  depas - dbpas;
      dw2[CC+4] = dbpas + 365 - depas;
      ds2[CC+4] = aa2 - (dbpas + 2*365);
      dw3[CC+4] = 0;
      }
    if (aa2 > depas + 2*365 && aa2 <= dbpas + 3*365) {
      ds1[CC+4] =  depas - dbpas;
      dw2[CC+4] = dbpas + 365 - depas;
      ds2[CC+4] = depas - dbpas;
      dw3[CC+4] = aa2 - (depas + 2*365);
      }
    if (aa2 > dbpas + 3*365 && aa2 <= depas + 3*365) {
      ds1[CC+4] =  depas - dbpas;
      dw2[CC+4] = dbpas + 365 - depas;
      ds2[CC+4] = depas - dbpas;
      dw3[CC+4] = dbpas + 365 - depas;
      ds3[CC+4] = aa2 - (dbpas + 3*365);
      dw4[CC+4] = 0;
      }
    if (aa2 > depas + 3*365) {
      ds1[CC+4] =  depas - dbpas;
      dw2[CC+4] = dbpas + 365 - depas;
      ds2[CC+4] = depas - dbpas;
      dw3[CC+4] = dbpas + 365 - depas;
      ds3[CC+4] = depas - dbpas;
      dw4[CC+4] = aa2 - (depas + 3*365);
      }	 	 	 	 
    adgs0[CC+4] = adgcon3f;
    adgs1[CC+4] = adgh1s;
    adgw1[CC+4] = adgcon3f;
    if (aa3 < depas) {
      ws0[CC+4] = wwf + adgs0[CC+4]* (depas-dw0);
      ww1[CC+4] = ws0[CC+4] + adgw1[CC+4]*dw1[CC+4];
      }
    else  ww1[CC+4] = wwf + adgw1[CC+4]*dw1[CC+4];
    nes0[CC+4] = nes0[CC+2];
    pdis0[CC+4] = pdis0[CC+2];
    new1[CC+4] = new1[CC+2];
    pdiw1[CC+4] = pdiw1[CC+2];
    nes1[CC+4] = nes1[CC+2];
    pdis1[CC+4] = pdis1[CC+2];
    ws1[CC+4] = ws1[CC+2];
    adgw2[CC+4] = adgw2[CC+2];
    for (i = 1; i <= (int)dw2[CC+4]; i++)      
      new2[CC+4] += pow(ws1[CC+4] + i*adgw2[CC+4], 0.75);
    new2[CC+4] += (dw2[CC+4]-(int)dw2[CC+4])*pow(ws1[CC+4] +
      dw2[CC+4]*adgw2[CC+4], 0.75); 
    new2[CC+4] *= 0.302*ktf+0.228*adgw2[CC+4];
    for (i = 1; i <= (int)dw2[CC+4]; i++)
      pdiw2[CC+4] += pow(ws1[CC+4] + i * adgw2[CC+4], 0.75);
    pdiw2[CC+4] += (dw2[CC+4]-(int)dw2[CC+4])* pow(ws1[CC+4] + dw2[CC+4] *
      adgw2[CC+4], 0.75);  
    pdiw2[CC+4] = (3.25 + 0.98*adgw2[CC+4])*pdiw2[CC+4] +
      dw2[CC+4]*220.5*adgw2[CC+4];
    if (ds2[CC+4]>0) {  
      for (i = 1; i <= (int)ds2[CC+4]; i++)      
	nes2[CC+4] += pow(ww2[CC+4] + i*adgs2[CC+4], 0.75);
      nes2[CC+4] += (ds2[CC+4]-(int)ds2[CC+4])*pow(ww2[CC+4] + ds2[CC+4]
        *adgs2[CC+4], 0.75);   
      nes2[CC+4] *= 0.302*ktp + 0.228 * adgs2[CC+4];
      for (i = 1; i <= (int)ds2[CC+4]; i++)
	pdis2[CC+4] += pow(ww2[CC+4] + i * adgs2[CC+4], 0.75);
      pdis2[CC+4] += (ds2[CC+4]-(int)ds2[CC+4])* pow(ww2[CC+4] + ds2[CC+4] 
        * adgs2[CC+4], 0.75);  
      pdis2[CC+4] = (3.25 + 0.98*adgs2[CC+4])*pdis2[CC+4] +
        ds2[CC+4]*220.5*adgs2[CC+4];
      }
    new[CC+4] = new1[CC+4] + new2[CC+4];
    pdiw[CC+4] = pdiw1[CC+4] + pdiw2[CC+4];
    nes[CC+4] = nes0[CC+4]+nes1[CC+4]+nes2[CC+4];
    pdis[CC+4] = pdis0[CC+4]+pdis1[CC+4]+ pdis2[CC+4];

    ds0[CC+5] = ds0[CC+2];
    dw1[CC+5] = dw1[CC+3];
    ds1[CC+5] = ds1[CC+3];
    dw2[CC+5] = dw2[CC+3];
    ds2[CC+5] = ds2[CC+3];
    dw3[CC+5] = dw2[CC+4];  
    nes0[CC+5] = nes0[CC+2];
    pdis0[CC+5] =pdis0[CC+2];
    new1[CC+5] = new1[CC+3];
    pdiw1[CC+5] = pdiw1[CC+3];
    nes1[CC+5] = nes1[CC+3];
    pdis1[CC+5] = pdis1[CC+3];
    new2[CC+5] = new2[CC+3];
    pdiw2[CC+5] = pdiw2[CC+3];
    nes2[CC+5] = nes2[CC+3];
    pdis2[CC+5] = pdis2[CC+3];
    ws2[CC+5] = ws2[CC+3];
    adgw3[CC+5] = adgw3[CC+3];
    for (i = 1; i <= (int)dw3[CC+5]; i++)      
      new3[CC+5] += pow(ws2[CC+5] + i*adgw3[CC+5], 0.75);
    new3[CC+5] += (dw3[CC+5]-(int)dw3[CC+5])*pow(ws2[CC+5] + dw3[CC+5]*adgw3[CC+5], 0.75);
    new3[CC+5] *= 0.302*ktf+0.228*adgw3[CC+5];
    for (i = 1; i <= (int)dw3[CC+5]; i++)
      pdiw3[CC+5] += pow(ws2[CC+5] + i * adgw3[CC+5], 0.75);
    pdiw3[CC+5] += (dw3[CC+5]-(int)dw3[CC+5])* pow(ws2[CC+5] + dw3[CC+5] *
      adgw3[CC+5], 0.75);  
    pdiw3[CC+5] = (3.25 + 0.98*adgw3[CC+5])*pdiw3[CC+5] + 
      dw3[CC+5]*220.5*adgw3[CC+5];
    for (i = 1; i <= (int)ds3[CC+5]; i++)      
      nes3[CC+5] += pow(ww3[CC+5] + i*adgs3[CC+5], 0.75);
    nes3[CC+5] += (ds3[CC+5]-(int)ds3[CC+5])*pow(ww3[CC+5] +
      ds3[CC+5]*adgs3[CC+5], 0.75);   
    nes3[CC+5] *= 0.302*ktp+0.228*adgs3[CC+5];
    for (i = 1; i <= (int)ds3[CC+5]; i++)
      pdis3[CC+5] += pow(ww3[CC+5] + i * adgs3[CC+5], 0.75);
    pdis3[CC+5] += (ds3[CC+5]-(int)ds3[CC+5])* pow(ww3[CC+5] + ds3[CC+5] *
      adgs3[CC+5], 0.75);  
    pdis3[CC+5] = (3.25 + 0.98*adgs3[CC+5])*pdis3[CC+5] + 
      ds3[CC+5]*220.5*adgs3[CC+5];
    new[CC+5] = new1[CC+5] + new2[CC+5] + new3[CC+5];
    pdiw[CC+5] = pdiw1[CC+5] + pdiw2[CC+5] + pdiw3[CC+5];
    nes[CC+5] = nes0[CC+5]+nes1[CC+5] + nes2[CC+5] + nes3[CC+5];
    pdis[CC+5] = pdis0[CC+5]+pdis1[CC+5] + pdis2[CC+5]+ pdis3[CC+5];

    ds0[CC+6] = ds0[CC+3];
    dw1[CC+6] = dw1[CC+3];
    ds1[CC+6] = ds1[CC+3];
    dw2[CC+6] = dw2[CC+3];
    ds2[CC+6] = ds2[CC+3];
    ds3[CC+6] = ds2[CC+3];
    dw3[CC+6] = dw2[CC+4];
    nes0[CC+6] = nes0[CC+3];
    pdis0[CC+6] =pdis0[CC+3];    
    new1[CC+6] = new1[CC+3];
    pdiw1[CC+6] = pdiw1[CC+3];
    nes1[CC+6] = nes1[CC+3];
    pdis1[CC+6] = pdis1[CC+3];
    new2[CC+6] = new2[CC+3];
    pdiw2[CC+6] = pdiw2[CC+3];
    nes2[CC+6] = nes2[CC+3];
    pdis2[CC+6] = pdis2[CC+3];
    ws3 = ww3[CC+3]+ adgh3s*ds3[CC+6];
    ww3[CC+6] = ww3[CC+3];
    adgw3[CC+6] = adgw3[CC+3];    
    adgs3[CC+6] = adgs3[CC+3];
    ws3 = ww3[CC+6] + adgs3[CC+6] * ds3[CC+6];
    dw4[CC+6] = dw2[CC+4];
    for (i = 1; i <= (int)dw3[CC+6]; i++)      
      new3[CC+6] += pow(ws2[CC+6] + i*adgw3[CC+6], 0.75);
    new3[CC+6] += (dw3[CC+6]-(int)dw3[CC+6])*pow(ws2[CC+6] + dw3[CC+6]*adgw3[CC+6], 0.75);
    new3[CC+6] *= 0.302*ktf+0.228*adgw3[CC+6];
    for (i = 1; i <= (int)dw3[CC+6]; i++)
      pdiw3[CC+6] += pow(ws2[CC+6] + i * adgw3[CC+6], 0.75);
    pdiw3[CC+6] += (dw3[CC+6]-(int)dw3[CC+6])* pow(ws2[CC+6] + dw3[CC+6] * adgw3[CC+6], 0.75);  
    pdiw3[CC+6] = (3.25 + 0.98*adgw3[CC+6])*pdiw3[CC+6] + dw3[CC+6]*220.5*adgw3[CC+6];    
    for (i = 1; i <= (int)ds3[CC+6]; i++)      
      nes3[CC+6] += pow(ww3[CC+6] + i*adgs3[CC+6], 0.75);
    nes3[CC+6] += (ds3[CC+6]-(int)ds3[CC+6])*pow(ww3[CC+6] + ds3[CC+6]*adgs3[CC+6], 0.75);   
    nes3[CC+6] *= 0.302*ktp+0.228*adgs3[CC+6];
    for (i = 1; i <= (int)ds3[CC+6]; i++)
      pdis3[CC+6] += pow(ww3[CC+6] + i * adgs3[CC+6], 0.75);
    pdis3[CC+6] += (ds3[CC+6]-(int)ds3[CC+6])* pow(ww3[CC+6] + ds3[CC+6] * adgs3[CC+6], 0.75);  
    pdis3[CC+6] = (3.25 + 0.98*adgs3[CC+6])*pdis3[CC+6] + ds3[CC+6]*220.5*adgs3[CC+6];
    for (i = 1; i <= (int)dw4[CC+6]; i++)      
      new4 += pow(ws3 + i*adgw4, 0.75);
    new4 += (dw4[CC+6]-(int)dw4[CC+6])*pow(ws3 + dw4[CC+6]*adgw4, 0.75);
    new4 *= 0.302*ktf+0.228*adgw4;
    for (i = 1; i <= (int)dw4[CC+6]; i++)
      pdiw4 += pow(ws3 + i * adgw4, 0.75);
    pdiw4 += (dw4[CC+6]-(int)dw4[CC+6])* pow(ws3 + dw4[CC+6] * adgw4, 0.75);  
    pdiw4 = (3.25 + 0.98*adgw4)*pdiw4 + dw4[CC+6]*220.5*adgw4;
    new[CC+6] = new1[CC+6] + new2[CC+6] + new3[CC+6] + new4;
    pdiw[CC+6] = pdiw1[CC+6] + pdiw2[CC+6] + pdiw3[CC+6] + pdiw4;
    nes[CC+6] = nes0[CC+6] + nes1[CC+6] + nes2[CC+6] + nes3[CC+6];
    pdis[CC+6] = pdis0[CC+6] + pdis1[CC+6] + pdis2[CC+6] + pdis3[CC+6];

    /*Energy for pregnancy for category 22*/
    if (davmath>=depas) {
      dwp1[22] = 365+dbpas-davmath;
      if (davcalh > depas) {
        dsp[22]=depas-dbpas;
        dwp2[22]=davcalh-depas;
	}
      if (davcalh <= depas && davcalh > dbpas) {
        dsp[22]=davcalh-dbpas;
        dwp2[22]=0;
	}
    }   
    if (davmath < depas && davmath <= dbpas)  {
      dwp1[22] = dbpas-davmath;
      if (davcalh > depas && davcalh >= dbpas ) {
        dsp[22]=depas-dbpas;
        dwp2[22]=davcalh-depas;
	}
      if (davcalh < depas && davcalh <= dbpas) {
        dsp[22]=depas-dbpas;
        dwp2[22]= davcalh + 365 - depas;
	}
    }	
    if (davmath <= depas && davmath > dbpas)  {
      dwp1[22] = 0;
      if (davcalh > depas) {
        dsp[22]=depas-davmath;
        dwp2[22]=davcalh-depas;
	}
      if (davcalh <= depas && davcalh < dbpas) {
        dsp[22]=depas - davmath;
        dwp2[22]=davcalh + 365 - depas;
	}
    }	
    for (i = 1; i <= (int)(lgpre+.001); i++) {     
      nepc[22] += (0.4504 - 0.000766*i)*exp((0.03233-0.0000275*i)*i);
      if (i == (int)dwp1[22]) newp1[22] = nepc[22];
      if (i == (int)(dwp1[22]+dsp[22])) nesp[22] = nepc[22]; 
      if (i == (int)(dwp1[22]+dsp[22]+dwp2[22])) newp2[22] = nepc[22]; 
      }
    nepc[22] *= 0.0042*0.576*bw[3];
    newp1[22] *= 0.0042*0.576*bw[3];
    nesp[22]  *= 0.0042*0.576*bw[3];
    aa1 = (0.4504 -
           0.000766*(dwp1[22]+dsp[22]+dwp2[22]))*exp((0.03233-0.0000275
	   *(dwp1[22]+dsp[22]+dwp2[22]))*(dwp1[22]+dsp[22]+dwp2[22]));
    newp2[22] += aa1*((dwp1[22]+dsp[22]+dwp2[22]) 
              -(int)(dwp1[22]+dsp[22]+dwp2[22]));
    newp2[22] *= 0.0042*0.576*bw[3];
    newp2[22] -= nesp[22];
    nesp[22] -= newp1[22];
    newp[22] = newp1[22] + newp2[22];
    nesp[22] = nepc[22] - newp[22];
    for (i = 1; i <= (int)(lgpre+.001); i++) {     
      pdipc[22] += (0.00167-0.00000211*i)*exp((0.0278-0.0000176*i)*i);
      if (i == (int)dwp1[22]) pdiwp1[22] = pdipc[22];
      if (i == (int)(dwp1[22]+dsp[22])) pdisp[22] = pdipc[22]; 
      if (i == (int)(dwp1[22]+dsp[22]+dwp2[22])) pdiwp2[22] = pdipc[22]; 
      }
    pdipc[22] *= (1.64*6.25*bw[3]);
    pdiwp1[22] *= (1.64*6.25*bw[3]);
    pdisp[22] *= (1.64*6.25*bw[3]);            
    aa1 =(0.00167-0.00000211* 
         (dwp1[22]+dsp[22]+dwp2[22]))*exp((0.0278-0.0000176
	 *(dwp1[22]+dsp[22]+dwp2[22]))*(dwp1[22]+dsp[22]+dwp2[22]));
    pdiwp2[22] += aa1*((dwp1[22]+dsp[22]+dwp2[22]) 
              - (int)(dwp1[22]+dsp[22]+dwp2[22])); 
    pdiwp2[22] *= (1.64*6.25*bw[3]);
    pdiwp2[22] -= pdisp[22];
    pdisp[22] -= pdiwp1[22];
    pdiwp[22] = pdiwp1[22] + pdiwp2[22];
    pdisp[22] = pdipc[22] - pdiwp[22];
    new[22] = php1*new[CC+4] + php2*new[CC+5] + php3*new[CC+6] + newp[22];
    pdiw[22] = php1*pdiw[CC+4] + php2*pdiw[CC+5] + php3*pdiw[CC+6] + pdiwp[22];
    nes[22] = php1*nes[CC+4] + php2*nes[CC+5] + php3*nes[CC+6] + nesp[22];
    pdis[22] = php1*pdis[CC+4] + php2*pdis[CC+5] + php3*pdis[CC+6] + pdisp[22];
  } /* End of production systems 1 to 2 */


  /* Energy for category 23 - breeding heifers sold without mating - 
  two groups are defined in this category: 23_1 = CC+7, 23_2 = CC+8 */
  /* Category CC+7 */
  if (prodsys <= 2) {
    if (davcal<= dbpas) aa2 = anphse1 + davcal; /*date of ending category */
    else aa2 = anphse1 + davcal - 365; 
    if (aa3 <= depas) {
      if (aa2 <= depas) {
        ds0[CC+7] = aa2 - aa3; 
	dw1[CC+7] = 0;
	} 
      if (aa2 > depas) {
       ds0[CC+7] = depas - aa3;
       if (aa2 <= dbpas + 365) {
         dw1[CC+7] = aa2 - depas;
	 ds1[CC+7] = 0;
	 }
       if (aa2 > dbpas + 365) 
         dw1[CC+7] = dbpas + 365 - depas; 
       }
     }
    if (aa3 > depas) {
      ds0[CC+7] = 0;
      if (aa2 <= dbpas + 365) {
	dw1[CC+7] = aa2 - aa3;
	ds1[CC+7] = 0;
	} 
      if (aa2 > dbpas + 365) dw1[CC+7] = dbpas + 365 - aa3;
      }
    if (aa2 > dbpas + 365 && aa2 <= depas + 365) {
      ds1[CC+7] =  aa2 - (dbpas + 365);
      dw2[CC+7] = 0;
      }
    if (aa2 > depas + 365 && aa2 <= dbpas + 2*365) {
      ds1[CC+7] =  depas - dbpas;
      dw2[CC+7] = aa2 - (depas + 365);
      ds2[CC+7] = 0;
      }
    if (aa2 > dbpas + 2*365 && aa2 <= depas + 2*365) {
      ds1[CC+7] =  depas - dbpas;
      dw2[CC+7] = dbpas + 365 - depas;
      ds2[CC+7] = aa2 - (dbpas + 2*365);
      dw3[CC+7] = 0;
      }
    if (aa2 > depas + 2*365 && aa2 <= dbpas + 3*365) {
      ds1[CC+7] =  depas - dbpas;
      dw2[CC+7] = dbpas + 365 - depas;
      ds2[CC+7] = depas - dbpas;
      dw3[CC+7] = aa2 - (depas + 2*365);
      }
    if (aa2 > dbpas + 3*365 && aa2 <= depas + 3*365) {
      ds1[CC+7] =  depas - dbpas;
      dw2[CC+7] = dbpas + 365 - depas;
      ds2[CC+7] = depas - dbpas;
      dw3[CC+7] = dbpas + 365 - depas;
      ds3[CC+7] = aa2 - (dbpas + 3*365);
      dw4[CC+7] = 0;
      }
    if (aa2 > depas + 3*365) {
      ds1[CC+7] =  depas - dbpas;
      dw2[CC+7] = dbpas + 365 - depas;
      ds2[CC+7] = depas - dbpas;
      dw3[CC+7] = dbpas + 365 - depas;
      ds3[CC+7] = depas - dbpas;
      dw4[CC+7] = aa2 - (depas + 3*365);
      }	 	 	 	 
    adgs0[CC+7] = adgcon3f;
    adgs1[CC+7] = adgh1s;
    adgw1[CC+7] = adgcon3f;
    if (aa3 < depas) {
      ws0[CC+7] = wwf + adgs0[CC+7]* (depas-dw0);
      ww1[CC+7] = ws0[CC+7] + adgw1[CC+7]*dw1[CC+7];
      }
    else  ww1[CC+7] = wwf + adgw1[CC+7]*dw1[CC+7];
    if (aa3 < depas) {
      for (i = 1; i <= (int)ds0[CC+7]; i++)      
	nes0[CC+7] += pow(wwf + i*adgs0[CC+7], 0.75); 
      nes0[CC+7] += (ds0[CC+7]-(int)ds0[CC+7])*pow(wwf + ds0[CC+7]*adgs0[CC+7], 0.75);               
      nes0[CC+7] *= 0.302*ktf+0.228*adgs0[CC+7]; 
      for (i = 1; i <= (int)ds0[CC+7]; i++)
	pdis0[CC+7] += pow(wwf + i * adgs0[CC+7], 0.75);
      pdis0[CC+7] += (ds0[CC+7]-(int)ds0[CC+7])* pow(wwf + ds0[CC+7] * adgs0[CC+7], 0.75);  
      pdis0[CC+7] = (3.25 + 0.98*adgs0[CC+7])*pdiw[CC+7] + ds0[CC+7]*220.5*adgs0[CC+7];   
    }
    for (i = 1; i <= (int)dw1[CC+7]; i++)      
      new[CC+7] += pow(ws0[CC+7] + i*adgw1[CC+7], 0.75);      
    new[CC+7] += (dw1[CC+7]-(int)dw1[CC+7])*pow(ws0[CC+7] + dw1[CC+7]*adgw1[CC+7], 0.75);
    new[CC+7] *= 0.302*ktf+0.228*adgw1[CC+7];
    for (i = 1; i <= (int)dw1[CC+7]; i++)
      pdiw[CC+7] += pow(ws0[CC+7] + i * adgw1[CC+7], 0.75);
    pdiw[CC+7] += (dw1[CC+7]-(int)dw1[CC+7])* pow(ws0[CC+7] + dw1[CC+7] * adgw1[CC+7], 0.75);  
    pdiw[CC+7] = (3.25 + 0.98*adgw1[CC+7])*pdiw1[CC+7] + dw1[CC+7]*220.5*adgw1[CC+7];
    for (i = 1; i <= (int)ds1[CC+7]; i++)      
      nes[CC+7] += pow(ww1[CC+7] + i*adgs1[CC+7], 0.75);
    nes[CC+7] += (ds1[CC+7]-(int)ds1[CC+7])*pow(ww1[CC+7] + ds1[CC+7]*adgs1[CC+7], 0.75); 
    nes[CC+7] *= 0.302*ktp+0.228*adgs1[CC+7];
    for (i = 1; i <= (int)ds1[CC+7]; i++)
      pdis[CC+7] += pow(ww1[CC+7] + i * adgs1[CC+7], 0.75);
    pdis[CC+7] += (ds1[CC+7]-(int)ds1[CC+7])* pow(ww1[CC+7] + ds1[CC+7] * adgs1[CC+7], 0.75);  
    pdis[CC+7] = (3.25 + 0.98*adgs1[CC+7])*pdis1[CC+7] + ds1[CC+7]*220.5*adgs1[CC+7];
    nes[CC+7] += nes0[CC+7];
    pdis[CC+7] += pdis0[CC+7];

    /* Category CC+8 */
    if (davcal<= dbpas) aa2 = anphse2 + davcal; /*date of ending category */
    else aa2 = anphse2 + davcal - 365; 
    if (aa3 <= depas) {
      if (aa2 <= depas) {
        ds0[CC+8] = aa2 - aa3; 
	dw1[CC+8] = 0;
	} 
      if (aa2 > depas) {
       ds0[CC+8] = depas - aa3;
       if (aa2 <= dbpas + 365) {
         dw1[CC+8] = aa2 - depas;
	 ds1[CC+8] = 0;
	 }
       if (aa2 > dbpas + 365) 
         dw1[CC+8] = dbpas + 365 - depas; 
       }
     }
    if (aa3 > depas) {
      ds0[CC+8] = 0;
      if (aa2 <= dbpas + 365) {
	dw1[CC+8] = aa2 - aa3;
	ds1[CC+8] = 0;
	} 
      if (aa2 > dbpas + 365) dw1[CC+8] = dbpas + 365 - aa3;
      }
    if (aa2 > dbpas + 365 && aa2 <= depas + 365) {
      ds1[CC+8] =  aa2 - (dbpas + 365);
      dw2[CC+8] = 0;
      }
    if (aa2 > depas + 365 && aa2 <= dbpas + 2*365) {
      ds1[CC+8] =  depas - dbpas;
      dw2[CC+8] = aa2 - (depas + 365);
      ds2[CC+8] = 0;
      }
    if (aa2 > dbpas + 2*365 && aa2 <= depas + 2*365) {
      ds1[CC+8] =  depas - dbpas;
      dw2[CC+8] = dbpas + 365 - depas;
      ds2[CC+8] = aa2 - (dbpas + 2*365);
      dw3[CC+8] = 0;
      }
    if (aa2 > depas + 2*365 && aa2 <= dbpas + 3*365) {
      ds1[CC+8] =  depas - dbpas;
      dw2[CC+8] = dbpas + 365 - depas;
      ds2[CC+8] = depas - dbpas;
      dw3[CC+8] = aa2 - (depas + 2*365);
      }
    if (aa2 > dbpas + 3*365 && aa2 <= depas + 3*365) {
      ds1[CC+8] =  depas - dbpas;
      dw2[CC+8] = dbpas + 365 - depas;
      ds2[CC+8] = depas - dbpas;
      dw3[CC+8] = dbpas + 365 - depas;
      ds3[CC+8] = aa2 - (dbpas + 3*365);
      dw4[CC+8] = 0;
      }
    if (aa2 > depas + 3*365) {
      ds1[CC+8] =  depas - dbpas;
      dw2[CC+8] = dbpas + 365 - depas;
      ds2[CC+8] = depas - dbpas;
      dw3[CC+8] = dbpas + 365 - depas;
      ds3[CC+8] = depas - dbpas;
      dw4[CC+8] = aa2 - (depas + 3*365);
      }	 	 	 	 
    adgs0[CC+8] = adgcon3f;
    adgs1[CC+8] = adgh1s;
    adgw1[CC+8] = adgcon3f;
    adgs1[CC+8] = adgh1s;
    adgw2[CC+8] = adgh2w;
    adgs2[CC+8] = adgh2s;    
    if (aa3 < depas) {
      ws0[CC+8] = wwf + adgs0[CC+8]* (depas-dw0);
      ww1[CC+8] = ws0[CC+8] + adgw1[CC+8]*dw1[CC+8];
      }
    else  ww1[CC+8] = wwf + adgw1[CC+8]*dw1[CC+8];
    ws1[CC+8] = ww1[CC+8] + adgh1s * ds1[CC+8];
    ww2[CC+8] = ws1[CC+8] + adgh2w * dw2[CC+8];
    if (aa3<depas) {
      for (i = 1; i <= (int)ds0[CC+8]; i++)      
	nes0[CC+8] += pow(wwf + i*adgs0[CC+8], 0.75); 
      nes0[CC+8] += (ds0[CC+8]-(int)ds0[CC+8])*pow(wwf + ds0[CC+8]*adgs0[CC+8], 0.75);               
      nes0[CC+8] *= 0.302*ktf+0.228*adgs0[CC+8]; 
      }
      for (i = 1; i <= (int)dw1[CC+8]; i++)
	new[CC+8] += pow(ws0[CC+8] + i*adgw1[CC+8], 0.75); 
      new[CC+8] += (dw1[CC+8]-(int)dw1[CC+8])*pow(ws0[CC+8] + dw1[CC+8]*adgw1[CC+8], 0.75); 
      new[CC+8] *= 0.302*ktf+0.228*adgw1[CC+8];	
      }    
    else {	
      for (i = 1; i <= (int)dw1[CC+8]; i++)      
	new[CC+8] += pow(wwf + i*adgw1[CC+8], 0.75); 
      new[CC+8] += (dw1[CC+8]-(int)dw1[CC+8])*pow(wwf + dw1[CC+8]*adgw1[CC+8], 0.75);               
      new[CC+8] *= 0.302*ktf+0.228*adgw1[CC+8];
      }
    if (aa3<depas) {
      for (i = 1; i <= (int)ds0[CC+8]; i++)
	pdis0[CC+8] += pow(wwf + i * adgs0[CC+8], 0.75);
      pdis0[CC+8] += (ds0[CC+8]-(int)ds0[CC+8])* pow(wwf + ds0[CC+8] * adgs0[CC+8], 0.75);  
      pdis0[CC+8] = (3.25 + 0.98*adgs0[CC+8])*pdiw[CC+8] + ds0[CC+8]*220.5*adgs0[CC+8];

    for (i = 1; i <= (int)dw1[CC+8]; i++)      
      new1[CC+8] += pow(ws0[CC+8] + i*adgw1[CC+8], 0.75);      
    new1[CC+8] += (dw1[CC+8]-(int)dw1[CC+8])*pow(ws0[CC+8] + dw1[CC+8]*adgw1[CC+8], 0.75);
    new1[CC+8] *= 0.302*ktf+0.228*adgw1[CC+8];  
    for (i = 1; i <= (int)dw1[CC+8]; i++)
      pdiw1[CC+8] += pow(ws0[CC+8] + i * adgw1[CC+8], 0.75);
    pdiw1[CC+8] += (dw1[CC+8]-(int)dw1[CC+8])* pow(ws0[CC+8] + dw1[CC+8] * adgw1[CC+8], 0.75);  
    pdiw1[CC+8] = (3.25 + 0.98*adgw1[CC+8])*pdiw1[CC+8] + dw1[CC+8]*220.5*adgw1[CC+8];
    for (i = 1; i <= (int)ds1[CC+8]; i++)      
      nes1[CC+8] += pow(ww1[CC+8] + i*adgs1[CC+8], 0.75);
    nes1[CC+8] += (ds1[CC+8]-(int)ds1[CC+8])*pow(ww1[CC+8] + ds1[CC+8]*adgs1[CC+8], 0.75); 
    nes1[CC+8] *= 0.302*ktp+0.228*adgs1[CC+8];
    for (i = 1; i <= (int)ds1[CC+8]; i++)
      pdis1[CC+8] += pow(ww1[CC+8] + i * adgs1[CC+8], 0.75);
    pdis1[CC+8] += (ds1[CC+8]-(int)ds1[CC+8])* pow(ww1[CC+8] + ds1[CC+8] * adgs1[CC+8], 0.75);  
    pdis1[CC+8] = (3.25 + 0.98*adgs1[CC+8])*pdis1[CC+8] + ds1[CC+8]*220.5*adgs1[CC+8];
    for (i = 1; i <= (int)dw2[CC+8]; i++)      
      new2[CC+8] += pow(ws1[CC+8] + i*adgw2[CC+8], 0.75);
    new2[CC+8] += (dw2[CC+8]-(int)dw2[CC+8])*pow(ws1[CC+8] + dw2[CC+8]*adgw2[CC+8], 0.75); 
    new2[CC+8] *= 0.302*ktf+0.228*adgw2[CC+8];
    for (i = 1; i <= (int)dw2[CC+8]; i++)
      pdiw2[CC+8] += pow(ws1[CC+8] + i * adgw2[CC+8], 0.75);
    pdiw2[CC+8] += (dw2[CC+8]-(int)dw2[CC+8])* pow(ws1[CC+8] + dw2[CC+8] * adgw2[CC+8], 0.75);  
    pdiw2[CC+8] = (3.25 + 0.98*adgw2[CC+8])*pdiw2[CC+8] + dw2[CC+8]*220.5*adgw2[CC+8];
    if (ds2[CC+8]>0) {  
      for (i = 1; i <= (int)ds2[CC+8]; i++)      
	nes2[CC+8] += pow(ww2[CC+8] + i*adgs2[CC+8], 0.75);
      nes2[CC+8] += (ds2[CC+8]-(int)ds2[CC+8])*pow(ww2[CC+8] + ds2[CC+8]*adgs2[CC+8], 0.75);   
      nes2[CC+8] *= 0.302*ktp+0.228*adgs2[CC+8];
      for (i = 1; i <= (int)ds2[CC+8]; i++)
	pdis2[CC+8] += pow(ww2[CC+8] + i * adgs2[CC+8], 0.75);
      pdis2[CC+8] += (ds2[CC+8]-(int)ds2[CC+8])* pow(ww2[CC+8] + ds2[CC+8] * adgs2[CC+8], 0.75);  
      pdis2[CC+8] = (3.25 + 0.98*adgs2[CC+8])*pdis2[CC+8] + ds2[CC+8]*220.5*adgs2[CC+8];
      }
    new[CC+8] = new1[CC+8] + new2[CC+8];
    pdiw[CC+8] = pdiw1[CC+8] + pdiw2[CC+8];
    nes[CC+8] = nes0[CC+8] + nes1[CC+8] + nes2[CC+8];
    pdis[CC+8] = pdis0[CC+8] + pdis1[CC+8] + pdis2[CC+8];

    new[23] = new[CC+7] * nphsold1 + new[CC+8] * nphsold2;
    pdiw[23] = pdiw[CC+7] * nphsold1 + pdiw[CC+8] * nphsold2;
    nes[23] = nes[CC+7] * nphsold1 + nes[CC+8] * nphsold2;
    pdis[23] = pdis[CC+7] * nphsold1 + pdis[CC+8] * nphsold2;
  }  

  /* Energy for category 24 - breeding heifers sold pregnant
     after the first or second breeding season after their weaning - 
     two groups are defined in this category: 24_1 = CC+9, 24_2 = CC+10 */
  if (prodsys <= 2) {
    if (davcal<= dbpas) aa2 = aphse1 + davcal; /*date of ending category */
    else aa2 = aphse1 + davcal - 365; 
    if (aa3 <= depas) {
      if (aa2 <= depas) {
        ds0[CC+9] = aa2 - aa3; 
	dw1[CC+9] = 0;
	} 
      if (aa2 > depas) {
       ds0[CC+9] = depas - aa3;
       if (aa2 <= dbpas + 365) {
         dw1[CC+9] = aa2 - depas;
	 ds1[CC+9] = 0;
	 }
       if (aa2 > dbpas + 365) 
         dw1[CC+9] = dbpas + 365 - depas; 
       }
     }
    if (aa3 > depas) {
      ds0[CC+9] = 0;
      if (aa2 <= dbpas + 365) {
	dw1[CC+9] = aa2 - aa3;
	ds1[CC+9] = 0;
	} 
      if (aa2 > dbpas + 365) dw1[CC+9] = dbpas + 365 - aa3;
      }
    if (aa2 > dbpas + 365 && aa2 <= depas + 365) {
      ds1[CC+9] =  aa2 - (dbpas + 365);
      dw2[CC+9] = 0;
      ds2[CC+9] = 0;
      }
    if (aa2 > depas + 365 && aa2 <= dbpas + 2*365) {
      ds1[CC+9] =  depas - dbpas;
      dw2[CC+9] = aa2 - (depas + 365);
      ds2[CC+9] = 0;
      }
    if (aa2 > dbpas + 2*365 && aa2 <= depas + 2*365) {
      ds1[CC+9] =  depas - dbpas;
      dw2[CC+9] = dbpas + 365 - depas;
      ds2[CC+9] = aa2 - (dbpas + 2*365);
      dw3[CC+9] = 0;
      }
    if (aa2 > depas + 2*365 && aa2 <= dbpas + 3*365) {
      ds1[CC+9] =  depas - dbpas;
      dw2[CC+9] = dbpas + 365 - depas;
      ds2[CC+9] = depas - dbpas;
      dw3[CC+9] = aa2 - (depas + 2*365);
      }
    if (aa2 > dbpas + 3*365 && aa2 <= depas + 3*365) {
      ds1[CC+9] =  depas - dbpas;
      dw2[CC+9] = dbpas + 365 - depas;
      ds2[CC+9] = depas - dbpas;
      dw3[CC+9] = dbpas + 365 - depas;
      ds3[CC+9] = aa2 - (dbpas + 3*365);
      dw4[CC+9] = 0;
      }
    if (aa2 > depas + 3*365) {
      ds1[CC+9] =  depas - dbpas;
      dw2[CC+9] = dbpas + 365 - depas;
      ds2[CC+9] = depas - dbpas;
      dw3[CC+9] = dbpas + 365 - depas;
      ds3[CC+9] = depas - dbpas;
      dw4[CC+9] = aa2 - (depas + 3*365);
      }	 	 	 	 
    adgs0[CC+9] = adgcon3f;
    adgs1[CC+9] = adgh1s;
    adgw1[CC+9] = adgcon3f;
    adgs1[CC+10] = adgh1s;
    adgw2[CC+9] = adgw2[CC+10] = adgh2w;    
    adgs2[CC+9] = adgs2[CC+10] = adgh2s; 
    adgw3[CC+10] = adgh3w;
    adgs3[CC+10] = adgh3s;
    nes0[CC+9] = nes0[CC+10] = nes0[CC+2];
    pdis0[CC+9] = pdis0[CC+10] = pdis0[CC+2];
    if (aa3 < depas) {
      ws0[CC+9] = wwf + adgs0[CC+9]* (depas-dw0);
      ww1[CC+9] = ws0[CC+9] + adgw1[CC+9]*dw1[CC+9];
      }
    else  ww1[CC+9] = wwf + adgw1[CC+9]*dw1[CC+9];
    ws1[CC+9] = ws1[CC+2];
    ww2[CC+9] = ws1[CC+9] + adgh2w * dw2[CC+9];
    nes0[CC+9] = nes0[CC+2];
    pdis0[CC+9] = pdis0[CC+2];
    new1[CC+9] = new1[CC+2];
    pdiw1[CC+9] = pdiw1[CC+2];
    nes1[CC+9] = nes1[CC+2];
    pdis1[CC+9] = pdis1[CC+2];
    for (i = 1; i <= (int)dw2[CC+9]; i++)      
      new2[CC+9] += pow(ws1[CC+9] + i*adgw2[CC+9], 0.75);
    new2[CC+9] += (dw2[CC+9]-(int)dw2[CC+9])*pow(ws1[CC+9] + dw2[CC+9]*adgw2[CC+9], 0.75); 
    new2[CC+9] *= 0.302*ktf+0.228*adgw2[CC+9];
    for (i = 1; i <= (int)dw2[CC+9]; i++)
      pdiw2[CC+9] += pow(ws1[CC+9] + i * adgw2[CC+9], 0.75);
    pdiw2[CC+9] += (dw2[CC+9]-(int)dw2[CC+9])* pow(ws1[CC+9] + dw2[CC+9] * adgw2[CC+9], 0.75);  
    pdiw2[CC+9] = (3.25 + 0.98*adgw2[CC+9])*pdiw2[CC+9] + dw2[CC+9]*220.5*adgw2[CC+9];
    if (ds2[CC+9]>0) {  
      for (i = 1; i <= (int)ds2[CC+9]; i++)      
	nes2[CC+9] += pow(ww2[CC+9] + i*adgs2[CC+9], 0.75);
      nes2[CC+9] += (ds2[CC+9]-(int)ds2[CC+9])*pow(ww2[CC+9] + ds2[CC+9]*adgs2[CC+9], 0.75);   
      nes2[CC+9] *= 0.302*ktp+0.228*adgs2[CC+9];
      for (i = 1; i <= (int)ds2[CC+9]; i++)
	pdis2[CC+9] += pow(ww2[CC+9] + i * adgs2[CC+9], 0.75);
      pdis2[CC+9] += (ds2[CC+9]-(int)ds2[CC+9])* pow(ww2[CC+9] + ds2[CC+9] * adgs2[CC+9], 0.75);  
      pdis2[CC+9] = (3.25 + 0.98*adgs2[CC+9])*pdis2[CC+9] + ds2[CC+9]*220.5*adgs2[CC+9];
      }
    new[CC+9] = new1[CC+9] + new2[CC+9];
    pdiw[CC+9] = pdiw1[CC+9] + pdiw2[CC+9];
    nes[CC+9] = nes0[CC+9] + nes1[CC+9] + nes2[CC+9];
    pdis[CC+9] = pdis0[CC+9] + pdis1[CC+9] + pdis2[CC+9];
     
  /* Category CC+10 */
    ds0[CC+10] = ds0[CC+2];
    dw1[CC+10] = dw1[CC+3];
    ds1[CC+10] = ds1[CC+3];
    dw2[CC+10] = dw2[CC+3];
    ds2[CC+10] = ds2[CC+3];
    dw3[CC+10] = dw2[CC+4];
    ds3[CC+10] = ds3[CC+4];  
    nes0[CC+10] = nes0[CC+2];
    pdis0[CC+10] =pdis0[CC+2];
    new1[CC+10] = new1[CC+3];
    pdiw1[CC+10] = pdiw1[CC+3];
    nes1[CC+10] = nes1[CC+3];
    pdis1[CC+10] = pdis1[CC+3];
    new2[CC+10] = new2[CC+3];
    pdiw2[CC+10] = pdiw2[CC+3];
    nes2[CC+10] = nes2[CC+3];
    pdis2[CC+10] = pdis2[CC+3];
    ws2[CC+10] = ws2[CC+3];
    ww3[CC+10] = ws2[CC+10] + adgw3[CC+10]*dw3[CC+10];
    adgw3[CC+10] = adgw3[CC+3];  
    for (i = 1; i <= (int)dw3[CC+10]; i++)      
      new3[CC+10] += pow(ws2[CC+10] + i*adgw3[CC+10], 0.75);
    new3[CC+10] += (dw3[CC+10]-(int)dw3[CC+10])*pow(ws2[CC+10] + dw3[CC+10]*adgw3[CC+10], 0.75);
    new3[CC+10] *= 0.302*ktf+0.228*adgw3[CC+10];
    for (i = 1; i <= (int)dw3[CC+10]; i++)
      pdiw3[CC+10] += pow(ws2[CC+10] + i * adgw3[CC+10], 0.75);
    pdiw3[CC+10] += (dw3[CC+10]-(int)dw3[CC+10])* pow(ws2[CC+10] + dw3[CC+10] * adgw3[CC+10], 0.75);  
    pdiw3[CC+10] = (3.25 + 0.98*adgw3[CC+10])*pdiw3[CC+10] + dw3[CC+10]*220.5*adgw3[CC+10];
    for (i = 1; i <= (int)ds3[CC+10]; i++)      
      nes3[CC+10] += pow(ww3[CC+10] + i*adgs3[CC+10], 0.75);
    nes3[CC+10] += (ds3[CC+10]-(int)ds3[CC+10])*pow(ww3[CC+10] + ds3[CC+10]*adgs3[CC+10], 0.75);   
    nes3[CC+10] *= 0.302*ktp+0.228*adgs3[CC+10];
    for (i = 1; i <= (int)ds3[CC+10]; i++)
      pdis3[CC+10] += pow(ww3[CC+10] + i * adgs3[CC+10], 0.75);
    pdis3[CC+10] += (ds3[CC+10]-(int)ds3[CC+10])* pow(ww3[CC+10] + ds3[CC+10] * adgs3[CC+10], 0.75);  
    pdis3[CC+10] = (3.25 + 0.98*adgs3[CC+10])*pdis3[CC+10] + ds3[CC+10]*220.5*adgs3[CC+10];
    new[CC+10] = new1[CC+10] + new2[CC+10] + new3[CC+10];
    pdiw[CC+10] = pdiw1[CC+10] + pdiw2[CC+10] + pdiw3[CC+10];
    nes[CC+10] = nes0[CC+10] + nes1[CC+10] + nes2[CC+10] + nes3[CC+10];
    pdis[CC+10] = pdis0[CC+10] + pdis1[CC+10] + pdis2[CC+10] + pdis3[CC+10];
    
  /* Energy for pregnancy for category 24 - this energy is the same for both
     groups: 24_1 = CC+9, 24_2 = CC+10 */
    if (davmath>=depas) {
      dwp1[CC+9] = 365+dbpas-davmath;
      if (davmath+dprfrep > depas) {
        dsp[CC+9]=depas-dbpas;
        dwp2[CC+9]=davmath+dprfrep-depas;
	}
      if (davmath+dprfrep <= depas) {
        dsp[CC+9]=davmath+dprfrep-dbpas;
        dwp2[CC+9]=0;
	}
    }   
    if (davmath < depas && davmath <= dbpas)  {
      dwp1[CC+9] = dbpas-davmath;
      if (davmath+dprfrep > depas && davmath+dprfrep >= dbpas ) {
        dsp[CC+9]=depas-dbpas;
        dwp2[CC+9]=davmath+dprfrep-depas;
	}
      if (davmath+dprfrep < depas && davmath+dprfrep <= dbpas) {
        dsp[CC+9]=depas-dbpas;
        dwp2[CC+9]= davmath+dprfrep + 365 - depas;
	}
    }	
    if (davmath <= depas && davmath > dbpas)  {
      dwp1[CC+9] = 0;
      if (davmath+dprfrep > depas) {
        dsp[CC+9]=depas-davmath;
        dwp2[CC+9]=davmath+dprfrep-depas;
	}
      if (davmath+dprfrep <= depas) {
        dsp[CC+9]=davmath+dprfrep;
        dwp2[CC+9]=0;
	}
    }	
    for (i = 1; i <= (int)(dprfrep+.001); i++) {     
      nepc[CC+9] += (0.4504 - 0.000766*i)*exp((0.03233-0.0000275*i)*i);
      if (i == (int)dwp1[CC+9]) newp1[CC+9] = nepc[CC+9];
      if (i == (int)(dwp1[CC+9]+dsp[CC+9])) nesp[CC+9] = nepc[CC+9]; 
      if (i == (int)(dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9])) newp2[CC+9] = nepc[CC+9]; 
      }
    nepc[CC+9] *= 0.0042*0.576*bw[3];
    newp1[CC+9] *= 0.0042*0.576*bw[3];
    nesp[CC+9]  *= 0.0042*0.576*bw[3];
    aa1 = (0.4504 -
           0.000766*(dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9]))*exp((0.03233-0.0000275
	   *(dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9]))*(dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9]));
    newp2[CC+9] += aa1*((dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9]) 
              -(int)(dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9]));
    newp2[CC+9] *= 0.0042*0.576*bw[3];
    newp2[CC+9] -= nesp[CC+9];
    nesp[CC+9] -= newp1[CC+9];
    newp[CC+9] = newp1[CC+9] + newp2[CC+9];
    nesp[CC+9] = nepc[CC+9] - newp[CC+9];
    for (i = 1; i <= (int)(dprfrep+.001); i++) {     
      pdipc[CC+9] += (0.00167-0.00000211*i)*exp((0.0278-0.0000176*i)*i);
      if (i == (int)dwp1[CC+9]) pdiwp1[CC+9] = pdipc[CC+9];
      if (i == (int)(dwp1[CC+9]+dsp[CC+9])) pdisp[CC+9] = pdipc[CC+9]; 
      if (i == (int)(dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9])) pdiwp2[CC+9] = pdipc[CC+9]; 
      }
    pdipc[CC+9] *= (1.64*6.25*bw[3]);
    pdiwp1[CC+9] *= (1.64*6.25*bw[3]);
    pdisp[CC+9] *= (1.64*6.25*bw[3]);        
    aa1 =(0.00167-0.00000211* 
         (dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9]))*exp((0.0278-0.0000176
	 *(dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9]))*(dwp1[22]+dsp[22]+dwp2[22]));
    pdiwp2[CC+9] += aa1*((dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9]) 
              - (int)(dwp1[CC+9]+dsp[CC+9]+dwp2[CC+9])); 
    pdiwp2[CC+9] *= (1.64*6.25*bw[3]);	      
    pdiwp2[CC+9] -= pdisp[CC+9];
    pdisp[CC+9] -= pdiwp1[CC+9];
    pdiwp[CC+9] = pdiwp1[CC+9] + pdiwp2[CC+9];
    pdisp[CC+9] = pdipc[CC+9] - pdiwp[CC+9];
      new[CC+9] += newp[CC+9];
      nes[CC+9] += nesp[CC+9];    
      pdis[CC+9] += pdisp[CC+9];
      pdiw[CC+9] += pdiwp[CC+9];  
      new[CC+10]+= newp[CC+9]; 
      nes[CC+10] += nesp[CC+9];    
      pdis[CC+10] += pdisp[CC+9]; 
      pdiw[CC+10] += pdiwp[CC+9];        	       	 	
    new[24] = new[CC+9] * phmat1 + new[CC+10] * phmat2;
    nes[24] = nes[CC+9] * phmat1 + nes[CC+10] * phmat2; 
    pdiw[24] = pdiw[CC+9] * phmat1 + pdiw[CC+10] * phmat2;
    pdis[24] = pdis[CC+9] * phmat1 + pdis[CC+10] * phmat2;  
    }

  /* Energy for category 18 */
  if (prodsys <= 2) {
    if (davcal >= depas) aa3 = davcal + agew - 365.0; /*date of weaning*/
    if (davcal <= dbpas) aa3 = davcal + agew;    
    if (davcal <= dbpas) aa2 = agehmat1 + davcal; 
      /*date of ending category from year 0 */
      else aa2 = agehmat1 + davcal - 365.0; 
    if (aa2 <= dbpas+365) {
      if (aa3 <= depas) {
        ds0[18] = depas - aa3; 
        dw1[18] = aa2 - depas;
        } 
      if (aa3 > depas) {
        ds0[18] = 0; 
        dw1[18] = aa2 - aa3;
        }
      }
    if (aa2 > 365 + dbpas && aa2 <= depas + 365) {
      if (aa3 <= depas) ds0[18] = depas - aa3; 
      if (aa3 > depas) ds0[18] = 0; 
      dw1[18] = dbpas + 365 - depas;
      ds1[18] = aa2 - (dbpas + 365);
      }
    if (aa2 > depas + 365 && aa2 <= dbpas + 2*365) {
      if (aa3 <= depas) ds0[18] = depas - aa3; 
      if (aa3 > depas) ds0[18] = 0; 
      dw1[18] = dbpas + 365 - depas;
      ds1[18] = depas - dbpas;
      dw2[18] = aa2 - (depas + 365);
      }
    dw[18] = dw1[18] + dw2[18];
    adgs0[18] = adgcon3f;
    adgs1[18] = adgh1s;
    adgw1[18] = adgcon3f;
    adgw2[18] = adgh2w;
    if (aa3 <= depas) {
      ws0[18] = wwf + adgs0[18]* (depas-dw0);
      ww1[18] = ws0[18] + adgw1[18] * dw1[18];
      }
    else  ww1[18] = wwf + adgw1[18] * dw1[18];
    if (dw2[18] > 0.0000001) ws1[18] = ww1[18] + adgh1s * ds1[18];
    if (aa3 < depas) {
      for (i = 1; i <= (int)ds0[18]; i++)      
	nes0[18] += pow(wwf + i*adgs0[18], 0.75); 
      nes0[18] += (ds0[18]-(int)ds0[18])*pow(wwf + ds0[18]*adgs0[18], 0.75);
      nes0[18] *= 0.302*ktf+0.228*adgs0[18]; 
      for (i = 1; i <= (int)dw1[18]; i++)
	new1[18] += pow(ws0[18] + i*adgw1[18], 0.75); 
      new1[18] += (dw1[18]-(int)dw1[18])*pow(ws0[18] + dw1[18]*adgw1[18], 0.75);
      new1[18] *= 0.302*ktf+0.228*adgw1[18];	
      }    
    else {	
      for (i = 1; i <= (int)dw1[18]; i++)      
	new1[18] += pow(wwf + i*adgw1[18], 0.75); 
      new1[18] += (dw1[18]-(int)dw1[18])*pow(wwf + dw1[18]*adgw1[18], 0.75);
      new1[18] *= 0.302*ktf+0.228*adgw1[18];
      }
    if (aa3 < depas) {
      for (i = 1; i <= (int)ds0[18]; i++)
	pdis0[18] += pow(wwf + i * adgs0[18], 0.75);
      pdis0[18] += (ds0[18]-(int)ds0[18])* pow(wwf + ds0[18] * adgs0[18], 0.75);
      pdis0[18] = (3.25 + 0.98*adgs0[18])*pdiw[18] + ds0[18]*220.5*adgs0[18];
      for (i = 1; i <= (int)dw1[18]; i++)      
	pdiw1[18] += pow(ws0[18] + i * adgw1[18], 0.75);
      pdiw1[18] += (dw1[18]-(int)dw1[18])* pow(ws0[18] + dw1[18] 
        * adgw1[18], 0.75);  
      pdiw1[18] = (3.25 + 0.98*adgw1[18])*pdiw[18] + dw1[18]*220.5*adgw1[18];
      }    
    else {		    
      for (i = 1; i <= (int)dw1[18]; i++)
	pdiw1[18] += pow(wwf + i * adgw1[18], 0.75);
      pdiw1[18] += (dw1[18]-(int)dw1[18])* pow(wwf + dw1[18] * adgw1[18], 0.75);
      pdiw1[18] = (3.25 + 0.98*adgw1[18])*pdiw[18] + dw1[18]*220.5*adgw1[18];
      }
    if (ds1[18] > 0) {
      for (i = 1; i <= (int)ds1[18]; i++)      
        nes[18] += pow(ww1[18] + i*adgs1[18], 0.75);    
      nes[18] += (ds1[18]-(int)ds1[18])*pow(ww1[18] + ds1[18]*adgs1[18], 0.75); 
      nes[18] *= 0.302*ktp+0.228*adgs1[18];
      for (i = 1; i <= (int)ds1[18]; i++)
	pdis[18] += pow(ww1[18] + i * adgs1[18], 0.75);
      pdis[18] += (ds1[18]-(int)ds1[18])* pow(ww1[18] + ds1[18] 
        * adgs1[18], 0.75);  
      pdis[18] = (3.25 + 0.98*adgs1[18])*pdis[18] + ds1[18]*220.5*adgs1[18];
      }
    nes[18] += nes0[18];
    pdis[18] += pdis0[18];  
    if (dw2[18] > 0) {
    for (i = 1; i <= (int)dw2[18]; i++)      
      new2[18] += pow(ws1[18] + i*adgw2[18], 0.75);
    new2[18] += (dw2[18]-(int)dw2[18])*pow(ws1[18] + dw2[18]*adgw2[18], 0.75); 
    new2[18] *= 0.302*ktf+0.228*adgw2[18];
    for (i = 1; i <= (int)dw2[18]; i++)
      pdiw2[18] += pow(ws1[18] + i * adgw2[18], 0.75);
    pdiw2[18] += (dw2[18]-(int)dw2[18])* pow(ws1[18] + dw2[18] 
      * adgw2[18], 0.75);  
    pdiw2[18] = (3.25 + 0.98*adgw2[18])*pdiw2[18] + dw2[18]*220.5*adgw2[18];
    }
    new[18] += new1[18];
    pdiw[18] += pdiw1[18];  
  }

  /* Energy for category 20 */
  if (Nfrp - Nfcw > 0) i1 = 1;
    else i1 = 3;
  if (prodsys >= i1) {
    if (dprfrep > 0) d[20] = lgpre - dprfrep;
      else d[20] = agecal - agefrep;
    if (prodsys <= 2) {
      if (dprfrep > 0) wfrep = wphse;
        else wfrep = wnphse;
      adgfrep = (whcal - wfrep)/d[20];
      }
    if (prodsys == 3) adgfrep = (wcacal[0] - wfrep)/d[20];
    if (adgfrep > 1) {
      nonsense6();
      goto END;
      }
    if (prodsys == 3) {
      aa1 = 0.311;
      aa2 = 0.261;
    }  
    if (prodsys <= 2) {
      aa1 = 0.302;
      aa2 = 0.228;
    }  
    for (i = 1; i <= (int)d[20]; i++)      
      ne[20] += pow(wfrep + i*adgfrep, 0.75);
    ne[20] += (d[20] - (int)d[20])*pow(wfrep + d[20]*adgfrep, 0.75);        
    ne[20] *= aa1*ktf+aa2*adgfrep;
    for (i = 1; i <= (int)d[20]; i++)
      pdi[20] += pow(wfrep + i * adgfrep, 0.75);
    pdi[20] += (d[20]-(int)d[20])* pow(wfrep + d[20] * adgfrep, 0.75);  
    pdi[20] = (3.25 + 0.98*adgfrep)*pdi[20] + d[20]*220.5*adgfrep;
    if (dprfrep > lgpre) {
      nonsense2();
      goto END;
      }
    for (i = (int)(dprfrep+.001); i <= (int)(lgpre+.001); i++)
      nepc[20] = nepc[20] + (0.4504 - 0.000766*i)*exp((0.03233-0.0000275*i)*i);
    nepc[20] = (0.0042*0.576*bw[3]) * nepc[20];
    for (i = (int)(dprfrep+.001); i <= (int)(lgpre+.001); i++) 
      pdipc[20] = pdipc[20] + (0.00167-0.00000211*i)*exp((0.0278-0.0000176*i)*i);
    pdipc[20] = (6.25*bw[3]) * pdipc[20];  
    new[20] = (ne[20] + nepc[20])/2.0;
    pdiw[20] = (pdi[20] + pdipc[20])/2.0;
    nes[20] = (ne[20] + nepc[20])/2.0;
    pdis[20] = (pdi[20] + pdipc[20])/2.0;
    ne[20] += nepc[20];
    pdi[20] += pdipc[20];
  }
  
  /* Energy for category 19 */
  if (prodsys == 3) {
    if (dprfrep>0) new[19] = nes[19] = pdiw[19] = pdis[19] = 0; 
    else {
      d[19] = agecal-lgpre+dayshc-agefrep;
      whcmat = wfrep + d[19]*adgfrep;
      for (i = 1; i <= (int)d[19]; i++)      
	ne[19] += pow(wfrep + i*adgfrep, 0.75);      
      ne[19] += (d[19] - (int)d[19])*pow(whcmat, 0.75);        
      ne[19] *= aa1*ktf+aa2*adgfrep;
      for (i = 1; i <= (int)d[19]; i++)
	pdi[19] += pow(wfrep + i * adgfrep, 0.75);
      pdi[19] += (d[19]-(int)d[19])* pow(whcmat, 0.75);  
      pdi[19] = (3.25 + 0.98*adgfrep)*pdi[19] + d[19]*220.5*adgfrep;
      new[19] = ne[19]/2.0;
      pdiw[19] = pdi[19]/2.0;
      nes[19] = ne[19]/2.0;
      pdis[19] = pdi[19]/2.0;   
     }
   }
   
  /* Energy for cows (categories 25 to CC) */  
  for (i = 25; i <= CC; i++) newl[i] = nesl[i] = pdiwl[i] = pdisl[i] = 0;
  for (i = 25; i <=30; i++) ww[i] = wcacal[0] + 0.5*(adg[i]*d[i]);
  for (i = 31; i <= 36; i++) ww[i] = wcacal[1] + 0.5*(adg[i]*d[i]);
  for (i = 37; i <= CC; i++) ww[i] = mcw;
  if (davcalc<=dbpas) {
    for (i = 1; i <= LL; i++) {  
      dwl[19 + 6 * i] = dbpas - davcalc; 
      dwl[21 + 6 * i] = dbpas - davcalc; 
      dwl[22 + 6 * i] = dbpas - davcalc;
      if (i < LL) {
	dwl[23 + 6 * i] = dbpas - davcalc; 
	dwl[24 + 6 * i] = dbpas - davcalc;
	}
      dwl[20 + 6 * i] = ndaydys;
      dsl[19 + 6 * i] = lghrcyc / 2.0 - dwl[19 + 6 * i];
      dsl[21 + 6 * i] = lghrcyc / 2.0 - dwl[21 + 6 * i];
      dsl[22 + 6 * i] = dw0 - dbpas;
      if (i < LL) {
	dsl[23 + 6 * i] = dw0 - dbpas; 
	dsl[24 + 6 * i] = dw0 - dbpas;
	}
      dsl[20 + 6 *i] = dsd[20 + 6 *i] = 0;
      if (i < LL) {
	dsd[23 + 6 * i] = depas - dw0; 
	dsd[24 + 6 * i] = depas - dw0;
	}
      for (j = 19; j <= 22; j++) dsd[j + 6 *i] = 0;
      if (i < LL) {
	dwd[23 + 6 * i] = 365 - depas + davcalc; 
	dwd[24 + 6 * i] = 365 - depas + davcalc;
	}
       }  
      } 
  else {   
    for (i = 1; i <= LL; i++) {  
      dwl[19 + 6 * i] = 365 + dbpas - davcalc; 
      dwl[21 + 6 * i] = 365 + dbpas - davcalc; 
      dwl[22 + 6 * i] = 365 + dbpas - davcalc;
      if (i < LL) {
	dwl[23 + 6 * i] = 365 + dbpas - davcalc; 
	dwl[24 + 6 * i] = 365 + dbpas - davcalc;
	}
      dwl[20 + 6 * i] = ndaydys;
      if (dwl[19 + 6 * i]> lghrcyc/2.0) dwl[19 + 6 * i]= lghrcyc/2.0;
      if (dwl[21 + 6 * i]> lghrcyc/2.0) dwl[21 + 6 * i]= lghrcyc/2.0;
      dsl[19 + 6 * i] = lghrcyc / 2.0 - dwl[19 + 6 * i];
      dsl[21 + 6 * i] = lghrcyc / 2.0 - dwl[21 + 6 * i];
      if (dw0>dbpas) dsl[22 + 6 * i] = dw0 - dbpas;
      if (i < LL) {
	if (dw0>dbpas) dsl[23 + 6 * i] = dw0 - dbpas; 
	if (dw0>dbpas) dsl[24 + 6 * i] = dw0 - dbpas;
	}
      dsl[20 + 6 *i] = dsd[20 + 6 *i] = 0;
      if (i < LL) {
	if (dw0>dbpas && dw0<=depas) dsd[23 + 6 * i] = depas - dw0; 
	if (dw0>dbpas && dw0<=depas) dsd[24 + 6 * i] = depas - dw0;
	}
      for (j = 19; j <= 22; j++) dsd[j + 6 *i] = 0;
      if (i < LL) {
	dwd[23 + 6 * i] = davcalc - depas; 
	dwd[24 + 6 * i] = davcalc - depas;
	}
       }     
      }  
  for (i = 1; i <= LL; i++) {      
    for (j = 19; j <= 22; j++) {
      dwd[j + 6 *i] = 0;
      if (j <= 22) ds[j + 6 * i] = dsl[j + 6 * i];
      }
    if (i < LL) { 
      for (j = 23; j <=24; j++)
	ds[j + 6 * i] = depas - dbpas; 
      }
    }  
  for (i = 25; i <= CC; i++) {
    dw1[i] = dwl[i];
    dw2[i] = dwd[i];
    nemw[i] = ktf*0.293*pow(ww[i], 0.75)*(kbl*dwl[i]+kbd*dwd[i]);
    nems[i] = ktp*0.293*pow(ww[i], 0.75)*(kbl*dsl[i]+kbd*dsd[i]);
    negw[i] = 22*adg[i]*(dwl[i]+dw2[i]);
    negs[i] = 22*adg[i]*ds[i];
    }  
  if (agecal < 800) {
    aa1 = a2;
    aa2 = b2;
    aa3 = c2;
    }
    else {
      aa1 = a3;
      aa2 = b3;
      aa3 = c3;
      }     
  for (i = 25; i <= 30; i++) {
    for (j = 1; j <= (int)dwl[i]; j++) 
      newl[i] += pow(j+14, aa2)*exp(-aa3*(j+14));
      newl[i] += (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, aa2)*exp(-aa3*(dwl[i]+14));  
      newl[i] *= 3.13*0.25*fat*aa1;
    if (dsl[i] > 0) {    
    for (j = (int) (dwl[i]); j <= (int)(dwl[i]+dsl[i]); j++) 
      nesl[i] += pow(j+14, aa2)*exp(-aa3*(j+14));
      nesl[i] -= (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, aa2)*exp(-aa3*(dwl[i]+14));
      nesl[i] += (dwl[i]+dsl[i]-(int)(dwl[i]+dsl[i]))
              *pow(dwl[i]+dsl[i]+14, aa2)*exp(-aa3*(dwl[i]+dsl[i]+14));
      nesl[i] *= 3.13*0.25*fat*aa1;      
      }
    }    
  if (agecal < 800) {
    aa1 = a3;
    aa2 = b3;
    aa3 = c3;
    }
    else {
      aa1 = a4;
      aa2 = b4;
      aa3 = c4;   
      }         
  for (i = 31; i <= 36; i++) {
    for (j = 1; j <= (int)dwl[i]; j++) 
      newl[i] += pow(j+14, aa2)*exp(-aa3*(j+14));
    newl[i] += (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, aa2)*exp(-aa3*(dwl[i]+14));  
    newl[i] *= 3.13*0.25*fat*aa1;
    if (dsl[i] > 0) {    
    for (j = (int) (dwl[i]); j <= (int)(dwl[i]+dsl[i]); j++) 
      nesl[i] += pow(j+14, aa2)*exp(-aa3*(j+14));
    nesl[i] -= (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, aa2)*exp(-aa3*(dwl[i]+14));
    nesl[i] += (dwl[i]+dsl[i]-(int)(dwl[i]+dsl[i]))
      *pow(dwl[i]+dsl[i]+14, aa2)*exp(-aa3*(dwl[i]+dsl[i]+14));
    nesl[i] *= 3.13*0.25*fat*aa1;      
      }
    }    
  for (i = 37; i <= CC; i++) {
    for (j = 1; j <= (int)dwl[i]; j++) 
      newl[i] += pow(j+14, bm)*exp(-cm*(j+14));
    newl[i] += (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, bm)*exp(-cm*(dwl[i]+14));  
    newl[i] *= 3.13*0.25*fat*am;
    if (dsl[i] > 0) {    
    for (j = (int) (dwl[i]); j <= (int)(dwl[i]+dsl[i]); j++) 
      nesl[i] += pow(j+14, bm)*exp(-cm*(j+14));
    nesl[i] -= (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, bm)*exp(-cm*(dwl[i]+14));
    nesl[i] += (dwl[i]+dsl[i]-(int)(dwl[i]+dsl[i]))
      *pow(dwl[i]+dsl[i]+14, bm)*exp(-cm*(dwl[i]+dsl[i]+14));
    nesl[i] *= 3.13*0.25*fat*am;      
      }
    }    
  for (i = 25; i <= CC; i++) {
    pdimw[i] = 3.25*pow(ww[i], 0.75)*(dwl[i]+dwd[i]);
    pdims[i] = 3.25*pow(ww[i], 0.75)*(dsl[i]+dsd[i]);
    pdigw[i] = 230*adg[i]*(dw1[i]+dw2[i]);
    pdigs[i] = 230*adg[i]*ds[i];
    }       
  if (agecal < 800) {
    aa1 = a2;
    aa2 = b2;
    aa3 = c2;
    }
    else {
      aa1 = a3;
      aa2 = b3;
      aa3 = c3;
      }     
  for (i = 25; i <= 30; i++) {
    for (j = 1; j <= (int)dwl[i]; j++) 
      pdiwl[i] += pow(j+14, aa2)*exp(-aa3*(j+14));
    pdiwl[i] += (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, aa2)*exp(-aa3*(dwl[i]+14)); 
    pdiwl[i] *= 50*1.64*0.25*fat*aa1;
    if (dsl[i] > 0) {    
    for (j = (int) (dwl[i]); j <= (int)(dwl[i]+dsl[i]); j++) 
      pdisl[i] += pow(j+14, aa2)*exp(-aa3*(j+14));
    pdisl[i] -= (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, aa2)*exp(-aa3*(dwl[i]+14));
    pdisl[i] += (dwl[i]+dsl[i]-(int)(dwl[i]+dsl[i]))
      *pow(dwl[i]+dsl[i]+14, aa2)*exp(-aa3*(dwl[i]+dsl[i]+14));
    pdisl[i] *= 50*1.64*0.25*fat*aa1;      
      }
    }    
  if (agecal < 800) {
    aa1 = a3;
    aa2 = b3;
    aa3 = c3;
    }
    else {
      aa1 = a4;
      aa2 = b4;
      aa3 = c4;
      }     
  for (i = 31; i <= 36; i++) {
    for (j = 1; j <= (int)dwl[i]; j++) 
      pdiwl[i] += pow(j+14, aa2)*exp(-aa3*(j+14));
    pdiwl[i] += (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, aa2)*exp(-aa3*(dwl[i]+14));  
    pdiwl[i] *= 50*1.64*0.25*fat*aa1;
    if (dsl[i] > 0) {    
    for (j = (int) (dwl[i]); j <= (int)(dwl[i]+dsl[i]); j++) 
      pdisl[i] += pow(j+14, aa2)*exp(-aa3*(j+14));
    pdisl[i] -= (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, aa2)*exp(-aa3*(dwl[i]+14));
    pdisl[i] += (dwl[i]+dsl[i]-(int)(dwl[i]+dsl[i]))
      *pow(dwl[i]+dsl[i]+14, aa2)*exp(-aa3*(dwl[i]+dsl[i]+14));
    pdisl[i] *= 50*1.64*0.25*fat*aa1;      
      }
    }    
  for (i = 37; i <= CC; i++) {
    for (j = 1; j <= (int)dwl[i]; j++) 
      pdiwl[i] += pow(j+14, bm)*exp(-cm*(j+14));
    pdiwl[i] += (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, bm)*exp(-cm*(dwl[i]+14));  
    pdiwl[i] *= 50*1.64*0.25*fat*am;
    if (dsl[i] > 0) {    
    for (j = (int) (dwl[i]); j <= (int)(dwl[i]+dsl[i]); j++) 
      pdisl[i] += pow(j+14, bm)*exp(-cm*(j+14));
    pdisl[i] -= (dwl[i]-(int)dwl[i])*pow(dwl[i]+14, bm)*exp(-cm*(dwl[i]+14));
    pdisl[i] += (dwl[i]+dsl[i]-(int)(dwl[i]+dsl[i]))
      *pow(dwl[i]+dsl[i]+14, bm)*exp(-cm*(dwl[i]+dsl[i]+14));
    pdisl[i] *= 50*1.64*0.25*fat*am;      
      }
    }    

    /*Energy for pregnancy for category [24+6*i], i = 1 to LL-1*/
  for (j = 1; j < LL; j++) {
    if (davmatc>=depas) {
      dwp1[24+6*j] = 365+dbpas-davmatc;
      if (davcalc > depas) {
        dsp[24+6*j]=depas-dbpas;
        dwp2[24+6*j]=davcalc-depas;
	}
      if (davcalc <= depas && davcalc > dbpas) {
        dsp[24+6*j]=davcalc-dbpas;
        dwp2[24+6*j]=0;
	}
    }   
    if (davmatc < depas && davmatc <= dbpas)  {
      dwp1[24+6*j] = dbpas-davmatc;
      if (davcalc > depas && davcalc >= dbpas ) {
        dsp[24+6*j]=depas-dbpas;
        dwp2[24+6*j]=davcalc-depas;
	}
      if (davcalc < depas && davcalc <= dbpas) {
        dsp[24+6*j]=depas-dbpas;
        dwp2[24+6*j]= davcalc + 365 - depas;
	}
    }	
    if (davmatc <= depas && davmatc > dbpas)  {
      dwp1[24+6*j] = 0;
      if (davcalc > depas) {
        dsp[24+6*j]=depas-davmatc;
        dwp2[24+6*j]=davcalc-depas;
	}
      if (davcalc <= depas && davcalc < dbpas) {
        dsp[24+6*j]=depas-davmatc;
        dwp2[24+6*j]= davcalc + 365 - depas;
	}
    }	
  }         
  for (j = 1; j < LL; j++) {
    for (i = 1; i <= (int)(lgpre+.001); i++) {     
      nepc[24+6*j] += (0.4504 - 0.000766*i)*exp((0.03233-0.0000275*i)*i);
      if (i == (int)dwp1[24+6*j]) newp1[24+6*j] = nepc[24+6*j];
      if (i == (int)(dwp1[24+6*j]+dsp[24+6*j])) nesp[24+6*j] = nepc[24+6*j]; 
      if (i == (int)(dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j])) newp2[24+6*j] = nepc[24+6*j]; 
      }
    nepc[24+6*j] *= 0.0042*0.576*bw[3];
    newp1[24+6*j] *= 0.0042*0.576*bw[3];
    nesp[24+6*j]  *= 0.0042*0.576*bw[3];
    aa1 = (0.4504 -
           0.000766*(dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j]))*exp((0.03233-0.0000275
	   *(dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j]))*(dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j]));
    newp2[24+6*j] += aa1*((dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j]) 
              -(int)(dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j]));
    newp2[24+6*j] *= 0.0042*0.576*bw[3];
    newp2[24+6*j] -= nesp[24+6*j];
    nesp[24+6*j] -= newp1[24+6*j];
    newp[24+6*j] = newp1[24+6*j] + newp2[24+6*j];
    nesp[24+6*j] = nepc[24+6*j] - newp[24+6*j];
    for (i = 1; i <= (int)(lgpre+.001); i++) {     
      pdipc[24+6*j] += (0.00167-0.00000211*i)*exp((0.0278-0.0000176*i)*i);
      if (i == (int)dwp1[24+6*j]) pdiwp1[24+6*j] = pdipc[24+6*j];
      if (i == (int)(dwp1[24+6*j]+dsp[24+6*j])) pdisp[24+6*j] = pdipc[24+6*j]; 
      if (i == (int)(dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j])) pdiwp2[24+6*j] = pdipc[24+6*j]; 
      }
    pdipc[24+6*j] = (1.64*6.25*bw[3]) * pdipc[24+6*j];
    aa1 =(0.00167-0.00000211* 
         (dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j]))*exp((0.0278-0.0000176
	 *(dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j]))*dsp[24+6*j]);
    pdisp[24+6*j] += aa1*((dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j]) 
              - (int)(dwp1[24+6*j]+dsp[24+6*j]+dwp2[24+6*j])); 
    pdiwp2[24+6*j] *= (1.64*6.25*bw[3]);
    pdiwp2[24+6*j] -= pdisp[24+6*j];
    pdisp[24+6*j] -= pdiwp1[24+6*j];
    pdiwp[24+6*j] = pdiwp1[24+6*j] + pdiwp2[24+6*j];
    pdisp[24+6*j] = pdipc[24+6*j] - pdiwp[24+6*j];
    }

/* Total energy and protein requirement in winter and summer for cow categories*/    
  for (i = 1; i <= LL; i++) {
    newp[19+6*i] = newp[21+6*i] = newp[24+6*i]/3.0;
    nesp[20+6*i] = nepc[20+6*i] = newp[20+6*i] = 0;
    nesp[22+6*i] = nepc[22+6*i] = newp[22+6*i] = 0;
    pdiwp[19+6*i] = pdiwp[21+6*i] = pdiwp[24+6*i]/3.0;
    pdisp[20+6*i] = pdipc[20+6*i] = pdiwp[20+6*i] = 0;
    pdisp[22+6*i] = pdipc[22+6*i] = pdiwp[22+6*i] = 0;
    if (i < LL) {
      nesp[23+6*i] = nepc[23+6*i] = newp[23+6*i] = 0;
      pdisp[23+6*i] = pdipc[23+6*i] = pdiwp[23+6*i] = 0;
      }
    }
  for (i = 25; i <= CC; i++) {      
    newncal[i] = nemw[i] + negw[i] + newp[i];
    newcal[i] = nemw[i] + negw[i] + newl[i] + newp[i];
    new[i] = newncal[i]*pncalc[i] + newcal[i]*pcalc[i];
    nesncal[i] = nems[i] + negs[i] + nesp[i];
    nescal[i] = nems[i] + negs[i] + nesl[i] + nesp[i];
    nes[i] = nesncal[i]*pncalc[i] + nescal[i]*pcalc[i];
    pdiwncal[i] = pdimw[i] + pdigw[i] + pdiwp[i];
    pdiwcal[i] = pdimw[i] + pdigw[i] + pdiwl[i] + pdiwp[i];
    pdiw[i] = pdiwncal[i]*pncalc[i] + pdiwcal[i]*pcalc[i];
    pdisncal[i] = pdims[i] + pdigs[i] + pdisp[i];
    pdiscal[i] = pdims[i] + pdigs[i] + pdisl[i] + pdisp[i];
    pdis[i] = pdisncal[i]*pncalc[i] + pdiscal[i]*pcalc[i];     
    }
  /* End categories 25 to CC */
    
  /* Energy for category 10 */
  if (prodsys == 1) {
    dst = agebbst - agew;
    dt = agebbt - agebbst;
    adgwt = adgbbt;
    adgst = adgcon3f * kgcon3mf; 
    nebt = net = netse = 0;
    pditb = pdit = pditse = 0;
    for (i = 1; i <= (int)dst; i++)
      nebt += pow(wwm + i * adgst, 0.75);
    nebt += (dst-(int)dst)*pow(wwm + dst * adgst, 0.75);  
    nebt *= (0.34 * ktf + 0.13 * adgst); 
    nebt += dst * (3.0 * adgst); 
    if (tech1 == 1)
      kt = ktb;
    else 
      kt = ktf;
    for (i = 1; i <= (int)dt; i++)
      net += pow(wbbst + i * adgwt, 0.75);
    net += (dt-(int)dt)*pow(wbbst + dt * adgwt, 0.75);
    net *= (0.34 * kt + 0.13 * adgwt); 
    net += dt * (3.0 * adgwt);
    for (i = 1; i <= (int)dtse; i++)
      netse += pow(wbbt + i * adgtm, 0.75);
    netse += (dtse-(int)dtse)*pow(wbbt + dtse * adgtm, 0.75);
    netse *= (0.34 * kt + 0.13 * adgtm); 
    netse += dtse * (3.0 * adgtm);
    for (i = 1; i <= (int)dst; i++)
      pditb += pow(wwm + i * adgst, 0.75);
    pditb += (dst-(int)dst)*pow(wwm + dst * adgst, 0.75);  
    pditb *= (3.25 + 0.975 * adgst); 
    pditb += dst * (220 * adgst);
    for (i = 1; i <= (int)dt; i++)
      pdit += pow(wbbst + i * adgwt, 0.75);
    pdit += (dt-(int)dt)*pow(wbbst + dt * adgwt, 0.75);        
    pdit *= (3.25 + 0.975 * adgwt); 
    pdit += dt * (220 * adgwt);
    for (i = 1; i <= (int)dtse; i++)
      pditse += pow(wbbt + i * adgtm, 0.75);
    pditse += (dtse-(int)dtse)*pow(wbbt + dtse * adgtm, 0.75);        
    pditse *= (3.25 + 0.975 * adgtm); 
    pditse += dtse * (220 * adgtm);
    dm = agebbm - agebbse;
    dslg = lghrcyc*lifebb - dm;
    agebbcull = agebbse + dm + dslg;
    dbb = dm + dslg;
  } /* End prodsys 1 */

  if (prodsys >=2) {
    dm = agebbm - agebbse;
    dslg = lghrcyc*lifebb - dm;
    agebbcull = agebbse + dm + dslg;
    adgtm = (mwb - wbbse) / dm;
    dbb = dm + dslg;
  }
  
  nebbm = 0;
  for (i = 1; i <= (int)dm; i++)
    nebbm += pow(wbbse + i * adgtm, 0.75);
  nebbm += (dm-(int)dm)*pow(wbbse + dm * adgtm, 0.75);
  nebbm *= (0.34 * ktp + 0.13 * adgtm); 
  nebbm += dm * (3.0 * adgtm);
  nebbsl = dslg * (14.35 + 0.044 * mwb);
  nebbw = 0.5 * (nebbm + nebbsl);
  nebbs = 0.5 * (nebbm + nebbsl);
  pdibbm = 0;
  for (i = 1; i <= (int)dm; i++)
    pdibbm += pow(wbbse + i * adgtm, 0.75);
  pdibbm += (dm-(int)dm)*pow(wbbse + i * adgtm, 0.75);
  pdibbm *= (3.25 + 0.975 * adgtm); 
  pdibbm += dm * (220 * adgtm);
  pdibbsl = dslg * (153 + 0.511 * mwb);
  pdibbw = 0.5 * (pdibbm + pdibbsl);
  pdibbs = 0.5 * (pdibbm + pdibbsl); 

  for (i = 1; i <= CC; i++) {
    if (ne[i] < .000001) ne[i] = new[i] + nes[i];
    if (pdi[i] < .000001) pdi[i] = pdiw[i] + pdis[i];
    }

  /* Fresh feed matter, minerals, water requirement */
  d[3] = agedcw;
  d[8] = d[9] = agew;
  if (prodsys <= 2) {
    d[18] = agehmat1 - agew;
    d[19] = agehcmat1*phc1 + agehcmat2*phc2 + agehcmat3*phc3 + dayshc - agew;
    d[22] = agecal - agew;
    if (nphs > 0) d[23] = anphse - agew;
    else d[23] = 0;
    if (phs >0) d[24] = aphse - agew;
    else d[24] = 0;
    }
  if (prodsys == 3) {
    d[18] = d[22] = d[23] = d[24] = 0;
    } 
  if (pbf == 1) edf[4] = edf[15] = edf[14];
  if (feedlot == 1) {
    if (pcmf > 0.000001) edf[5] = edf[16] = edf[17];
    if (pff > 0.000001) edf[6] = edf[13] = edf[12];
    }
  if (feedlot == 2) {
    if (pcmf > 0.000001) edfx[5] = edfx[16] = edfx[17];
    if (pff > 0.000001) edfx[6] = edfx[13] = edfx[12];
    if (pcmf > 0.000001) edw[5] = edw[16] = edw[17];
    if (pff > 0.000001) edw[6] = edw[13] = edw[12];
    }
  edw[7] = edw[18] = edw[19] = edw[20] = edw[23] = edw[24] = edw[22];
  edw[3] = edw[9] = edw[8];
  for (i = 26; i <= CC; i++) {
    edw[i] = edw[25];
    }
  if (feedlot == 2) {  
    if (pcmf > 0.000001) eds[5] = eds[16] = eds[17];
    if (pff > 0.000001) eds[6] = eds[13] = eds[12];
    }
  eds[7] = eds[18] = eds[19] = eds[20] = eds[23] = eds[24] = eds[22];
  eds[3] = eds[9] = eds[8];
  for (i = 26; i <= CC; i++) {
    eds[i] = eds[25];
    }
  if (pbf == 1) dryf[4] = dryf[15] = dryf[14];
  if (feedlot == 1) {
    if (pcmf > 0.000001) dryf[5] = dryf[16] = dryf[17];
    if (pff > 0.000001) dryf[6] = dryf[13] = dryf[12];
    }
  if (feedlot == 2) {
    if (pcmf > 0.000001) dryfx[5] = dryfx[16] = dryfx[17];
    if (pff > 0.000001) dryfx[6] = dryfx[13] = dryfx[12];
    }
  dryw[7] = dryw[18] = dryw[19] = dryw[20] = dryw[23] = dryw[24] = dryw[22];
  dryw[3] = dryw[9] = dryw[8];
  for (i = 26; i <= CC; i++) {
    dryw[i] = dryw[25];
    }
  if (feedlot == 2) {
    if (pcmf > 0.000001) drys[5] = drys[16] = drys[17];
    if (pff > 0.000001) drys[6] = drys[13] = drys[12];
    if (pcmf > 0.000001) dryw[5] = dryw[16] = dryw[17];
    if (pff > 0.000001) dryw[6] = dryw[13] = dryw[12];
    }
  drys[7] = drys[18] = drys[19] = drys[20] = drys[23] = drys[24] = drys[22];
  drys[3] = drys[9] = drys[8];
  for (i = 26; i <= CC; i++) {
    drys[i] = drys[25];
    }
  if (pbf == 1) pdidf[4] = pdidf[15] = pdidf[14];
  if (feedlot == 1) {    
    if (pcmf > 0.000001) pdidf[5] = pdidf[16] = pdidf[17];
    if (pff > 0.000001) pdidf[6] = pdidf[13] = pdidf[12];
    }
  if (feedlot == 2) {
    if (pcmf > 0.000001) pdidfx[5] = pdidfx[16] = pdidfx[17];
    if (pff > 0.000001) pdidfx[6] = pdidfx[13] = pdidfx[12];
    if (pcmf > 0.000001) pdidw[5] = pdidw[16] = pdidw[17];
    if (pff > 0.000001) pdidw[6] = pdidw[13] = pdidw[12];
    }
  pdidw[7] = pdidw[18] = pdidw[19] = pdidw[20] = pdidw[23] = pdidw[24] = pdidw[22];
  pdidw[3] = pdidw[9] = pdidw[8];
  for (i = 26; i <= CC; i++) {
    pdidw[i] = pdidw[25];
    }
  if (feedlot == 2) {
    if (pcmf > 0.000001) pdids[5] = pdids[16] = pdids[17];
    if (pff > 0.000001) pdids[6] = pdids[13] = pdids[12];
    }
  pdids[7] = pdids[18] = pdids[19] = pdids[20] = pdids[23] = pdids[24] = pdids[22];
  pdids[3] = pdids[9] = pdids[8];
  for (i = 26; i <= CC; i++) {
    pdids[i] = pdids[25];
    }

  if (pcmf > 0.000001) prw[5] = prw[16] = prw[17];
  if (pff > 0.000001) prw[6] = prw[13] = prw[12];
  prw[7] = prw[22];
  for (i = 18; i<=24; i++) 
    prw[i] = prw[22]; 
  for (i = 26; i <= CC; i++) 
    prw[i] = prw[25];
  prw[3] = prw[9] = prw[8];      
  if (pcmf > 0.000001) prs[5] = prs[16] = prs[17];
  if (pff > 0.000001) prs[6] = prs[13] = prs[12];
  prs[7] = prs[22];
  for (i = 18; i<=24; i++) 
    prs[i] = prs[22]; 
  for (i = 26; i <= CC; i++) 
    prs[i] = prs[25];
  prs[3] = prs[9] = prs[8];            
  if (pbf == 1) prf[4] = prf[15] = prf[14];
  if (pcmf > 0.000001) prf[5] = prf[16] = prf[17];
  if (pff > 0.000001) prf[6] = prf[13] = prf[12];
  if (pcmf > 0.000001) pras[5] = pras[16] = pras[17];
  if (pff > 0.000001) pras[6] = pras[13] = pras[12];

  /* Minerals */
  min[1] = min[2] = min[3] = min[8] = min[9] = min[4] = min[15] = min[14] = 0;
  min[7] = min[22];
  for (i = 18; i<=24; i++) 
    min[i] = min[22]; 
  for (i = 26; i <= CC; i++) 
    min[i] = min[25];
  if (feedlot == 1)
    min[5] = min[16] = min[17] = min[6] = min[13] = min[12] = 0;
    else {
      if (pff > 0.000001) min[6] = min[13] = min[12];
      if (pcmf > 0.000001) min[5] = min[16] = min[17];
      }
  /* Water */
  wat[1] = wat[2] = wat[3] = wat[8] = wat[9] = 0;
  if (pbf == 1) wat[4] = wat[15] = wat[14];
  if (pcmf > 0.000001) wat[5] = wat[16] = wat[17];
  if (pff > 0.000001) wat[6] = wat[13] = wat[12];
  wat[7] = wat[22];
  for(i = 18; i<= 24; i++) {
    wat[i] = wat[22];
    }
  for(i = 26; i <= CC; i++) {
    wat[i] = wat[25];
    }

  prm[4] = prm[15] = prm[14] = 0;
  prm[7] = prm[22];
  for (i = 18; i<= 24; i++) {
    prm[i] = prm[22];
    }  
  for (i = 26; i <= CC; i++) {
    prm[i] = prm[25];
    }  
  if (feedlot == 1)
    prm[5] = prm[16] = prm[17] = prm[6] = prm[13] = prm[12] = 0;
    else {
      if (pff > 0.000001) prm[6] = prm[13] = prm[12];
      if (pcmf > 0.000001) prm[5] = prm[16] = prm[17];
      }

  /* Costs for nutrition */
  for (i = 3; i <= CC; i++) {
    if (i == 10) i = 12; 
    costm[i] = min[i] * prm[i] * d[i];
    costwt[i] = wat[i] * prwt * d[i];
    }
  /* Total period for which the residual feed intake of category i in summer 
     and winter period or in fattening is defined */
  for (i = 3; i <= GG; i++) { 
    if (i == 4) i = 8;
    if (i == 10) i = 18;
    if (i == 19) i = 25;    
    if (ds[i] < 0.0000001) ds[i] = ds0[i]+ds1[i]+ds2[i]+ds3[i];
    if (dw[i] < 0.0000001) dw[i] = dw1[i]+dw2[i]+dw3[i]+dw4[i];
    }
  dw[7] = d[7]/3.0;
  ds[7] = d[7] - dw[7];
  dw[10] = ds[10] = 0.5 * dbb;
  if (l1[20] > 0.00000001) dw[20] = ds[20] = 0.5 * d[20];
  /*Average summer and winter periods for categories 19, 22, 23 and 24 */
  if (prodsys == 3) dw[19] = ds[19] = 0.5 * d[19];
  if (prodsys < 3) {  
    dw[19] = phc1 * dw[CC+1] + phc2 * dw[CC+2] + phc3 * dw[CC+3];
    dw[22] = php1*dw[CC+4] + php2*dw[CC+5] + php3*dw[CC+6];
    dw[23] = dw[CC+7] * nphsold1 + dw[CC+8] * nphsold2;
    dw[24] = dw[CC+9] * phmat1 + dw[CC+10] * phmat2;
    ds[19] = phc1 * ds[CC+1] + phc2 * ds[CC+2] + phc3 * ds[CC+3];
    ds[22] = php1*ds[CC+4] + php2*ds[CC+5] + php3*ds[CC+6];
    ds[23] = ds[CC+7] * nphsold1 + ds[CC+8] * nphsold2;
    ds[24] = ds[CC+9] * phmat1 + ds[CC+10] * phmat2;
    }
  if (feedlot == 2) {
    if (pff > 0.000001) {
      ds[12] = dsx;
      dw[6] = dw[12] = dw[13] = dwx;
      }
    if (pcmf > 0.000001) {
      ds[17] = dsx;
      dw[5] = dw[16] = dw[17] = dwx;
      }
    }
  /* Defining rfi for all animal categories on the basis of the 
     input parameters for rfi */
  for (i = 26; i <= CC; i++) {
    rfis[i] = rfis[25];
    rfiw[i] = rfiw[25];
  }
  if (feedlot == 2) {
    if (pff > 0.000001) { 
      rfis[6] = rfis[13] = rfis[12];
      rfiw[6] = rfiw[13] = rfiw[12];
    }
    if (pcmf > 0.000001) {
      rfis[5] = rfis[16] = rfis[17];
      rfiw[5] = rfiw[16] = rfiw[17];
    }
    if (pbf > 0.000001) rfi[4] = rfi[15] = rfi[14];
   }
  if (feedlot == 1) {
    if (pbf > 0.000001) rfi[4] = rfi[15] = rfi[14];
    if (pff > 0.000001) rfi[6] = rfi[13] = rfi[12];
    if (pcmf > 0.000001) rfi[5] = rfi[16] = rfi[17];
    }
  rfis[7] = rfis[18] = rfis[19] = rfis[22] = rfis[23] 
    = rfis[24] = rfis[22];
  rfiw[7] = rfiw[18] = rfiw[19] = rfiw[22] = rfiw[23] 
    = rfiw[24] = rfiw[22];
  if (l1[20] > 0.000001) {
    rfis[20] = rfis[22];
    rfiw[20] = rfiw[22];
    }
  /* Calculation of the total and average dry matter intake for all 
     categories of cows and progeny with winter and summer feeding periods
     including extensive fattening */      
  for (i = 1; i <= CC; i++) { 
    if (i == 4 && feedlot == 2) i = 5;
    if (i == 4 && feedlot != 2) i = 7;    
    if (i == 5 && pcmf < 0.000001) i = 6;
    if (i == 6 && pff < 0.000001) i = 7;
    if (i == 10 && feedlot == 2) i = 12;
    if (i == 10 && feedlot != 2) i = 18;       
    if (i == 12 && pff < 0.000001) i = 14;
    if (i == 14 && feedlot == 2) i = 16;
    if (i == 14 && pbf == 0) i = 16;
    if (i == 16 && pcmf < 0.000001) i = 18;
    /* Winter feeding */
    if (edw[i]*dryw[i] > 0)
      fwe[i] = new[i] / (edw[i] * dryw[i]);
      else fwe[i] = 0;
    if (pdidw[i]*dryw[i] > 0)
      fwpdi[i] = pdiw[i] / (pdidw[i] * dryw[i]);
      else fwpdi[i] = 0;
    if (edw[i] > 0) tdrywe[i] = new[i] / edw[i];
      else tdrywe[i] = 0;
    if (pdidw[i] > 0) tdrywpdi[i] = pdiw[i] / pdidw[i];
      else tdrywpdi[i] = 0;
    /* Total predicted dry matter intake in all winter periods for category i */
    if (feedcost == 1) tdryw[i] = maxi(tdrywe[i], tdrywpdi[i]);
    if (feedcost == 2) tdryw[i] = tdrywe[i];
    /*Predicted daily average dry matter intake*/
    if (dw[i] > 0) ddryw[i] = tdryw[i]/dw[i];
      else ddryw[i] = 0;
    /* Actual daily dry matter intake */
    addryw[i] = ddryw[i] + rfiw[i];
    /* Total actual dry matter intake in all winter periods for category i */ 
    atdryw[i] = addryw[i] * dw[i];
    /* Fresh feed intake without wasting */
    if (dryw[i] > 0) fw0[i] = atdryw[i] / dryw[i]; 
    /* Cost for winter feeding including wasting */
    costfw[i] = prw[i] * fw0[i] * kfw;
    /* Summer feeding */
    if (eds[i]*drys[i] > 0)      
      fse[i] = nes[i] / (eds[i] * drys[i]);
      else fse[i] = 0;
    if (pdids[i]*drys[i] > 0)      	
      fspdi[i] = pdis[i] / (pdids[i] * drys[i]);
      else fspdi[i] = 0;
    if (eds[i] > 0)
      tdryse[i] = nes[i] / eds[i];
      else tdryse[i] = 0;
    if (pdids[i] > 0)
      tdryspdi[i] = pdis[i] / pdids[i];
      else tdryspdi[i] = 0;
    if (feedcost == 1) tdrys[i] = maxi(tdryse[i], tdryspdi[i]);
    if (feedcost == 2) tdrys[i] = tdryse[i];
    /* Predicted daily average dry matter intake */
    if (ds[i] > 0) ddrys[i] = tdrys[i]/ds[i];
      else ddrys[i] = 0;
    /* Actual daily DMI */
    addrys[i] = ddrys[i] + rfis[i]; 
    /* Total actual dry matter intake in all summer periods for category i */
    atdrys[i] = addrys[i] * ds[i];
    /* Fresh feed intake without wasting*/
    if (drys[i] > 0) fs[i] = atdrys[i] / drys[i];
    /* Cost for summer feeding including wasting */    
    costfs[i] = prs[i] * fs[i] * kfpa;
    }
  /* Intensive fattening */    
  for (i = 4; i <= 17; i++) {
    if (i == 4 && pbf == 0) i = 5;
    if (i == 5 && feedlot == 2) i = 14;
    if (i == 5 && pcmf < 0.000001) i = 6;
    if (i == 6 && pff < 0.000001) i = 14;
    if (i == 7) i = 12;
    if (i == 12 && pff < 0.000001) i = 14;
    if (i == 14 && pbf == 0) i = 16;
    if (i == 16 && feedlot == 2) break;
    if (edf[i]*dryf[i] > 0)     
      fe[i] = ne[i] / (edf[i] * dryf[i]);
      else fe[i] = 0;
    fpdi[i] = pdi[i] / (pdidf[i] * dryf[i]);
    /* Total dry matter intak of category i in fattening */
      /* predicted on the basis of energy requirement */
    if (edf[i] > 0)     
      tdrye[i] = ne[i] / edf[i]; 
      else tdrye[i] = 0;         
      /* predicted on the basis of protein requirement */  
    if (pdidf[i] > 0)   
      tdrypdi[i] = pdi[i] / pdidf[i];  
      else tdrypdi[i] = 0;    
    if (feedcost == 1) tdry[i] = maxi(tdrye[i], tdrypdi[i]);
    if (feedcost == 2) tdry[i] = tdrye[i];
    /* Predicted daily average dry matter intake */
    if (d[i] > 0) ddry[i] = tdry[i]/d[i];
      else ddry[i] = 0;
    /* Actual daily DMI */
    addry[i] = ddry[i] + rfi[i]; 
    /* Total actual dry matter intake for category i */
    atdry[i] = addry[i] * d[i];
    /* Fresh feed intake without feed wasting*/
    if (dryf[i] > 0) f[i] = atdry[i] / dryf[i];  
    /* Cost for feed including wasting */ 
    costff[i] = prf[i] * f[i] * kff;            
    }

  /* Last part of extensive fattening (after pasture period) */
  if (feedlot == 2) {
    if (pcmf > 0.000001) {
      /* Castrates */
      if (edfx[17] > 0.000001 && dryfx[17] > 0.00001)
        fase[17] = neas[17] / (edfx[17] * dryfx[17]);
      if (pdidfx[17] > 0.000001 && dryfx[17] > 0.00001)
        faspdi[17] = pdias[17] / (pdidfx[17] * dryfx[17]);
      if (edfx[17] > 0.000001)
        tdryfase[17] = neas[17] / edfx[17];
      if (pdidfx[17] > 0.000001)
        tdryfaspdi[17] = pdias[17] / pdidfx[17];	
      if (feedcost == 1) tdryfas[17] = maxi(tdryfase[17], tdryfaspdi[17]);
      if (feedcost == 2) tdryfas[17] = tdryfase[17];
      /* Predicted daily average dry matter intake */
      if (dasc > 0) ddryfas[17] = tdryfas[17]/dasc;
        else ddryfas[17] = 0;
      /* Actual daily dry matter intake */
      addryfas[17] = ddryfas[17]; 
      if (dasc > 0) addryfas[17] += rfisc; 
      /*Total actual dry matter intake for category i*/ 
      atdryfas[17] = addryfas[17] * dasc;
      /* Fresh feed intake without feed wasting */
      if (dryfx[17] > 0.00001) fas[17] = atdryfas[17] / dryfx[17];
      /* Cost for feed including wasting */ 
      costfas[17] = pras[17] * fas[17] * kfw;
      }
    if (pff > 0.000001) { 
      /* Heifers */
      if (edfx[12] > 0.000001 && dryfx[12] > 0.00001)
        fase[12] = neas[12] / (edfx[12] * dryfx[12]);
      if (pdidfx[12] > 0.000001 && dryfx[12] > 0.00001)
        faspdi[12] = pdias[12] / (pdidfx[12] * dryfx[12]);
      if (edfx[12] > 0.000001)
        tdryfase[12] = neas[12] / edfx[12];
      if (pdidfx[12] > 0.000001)
        tdryfaspdi[12] = pdias[12] / pdidfx[12];	
      if (feedcost == 1) tdryfas[12] = maxi(tdryfase[12], tdryfaspdi[12]);
      if (feedcost == 2) tdryfas[12] = tdryfase[12];
      /* Predicted daily average dry matter intake */
      if (dasf > 0) ddryfas[12] = tdryfas[12]/dasf;
        else ddryfas[12] = 0;
      /* Actual daily dry matter intake */
      addryfas[12] = ddryfas[12]; 
      if (dasf > 0) addryfas[12] += rfisc; 
      /* Total actual dry matter intake for category i */ 
      atdryfas[12] = addryfas[12] * dasf;
      /* Fresh feed intake without feed wasting */
      if (dryfx[12] > 0.00001) fas[12] = atdryfas[12] / dryfx[12];
      /* Cost for feed including wasting */ 
      costfas[12] = pras[12] * fas[12] * kfw;
      }	
    } /* End of feedlot 2 */
    
  for (i = 1; i <= CC; i++) {
    if (i == 4) i = 8;
    if (i == 10) i = 25;
    costf[i] = costfw[i] + costfs[i] + costwt[i] + costm[i];        
    }
  for (i = 4; i <= 17; i++) {
    if (i == 4 && pbf == 0) i = 5; 
    if (i == 5 && feedlot != 1) i = 14;
    if (i == 5 && pcmf < 0.000001) i = 14;
    if (i == 6) i = 14;
    if (i == 14 && pbf == 0) i = 16;
    if (i == 16 && feedlot != 1) break;
    if (i == 16 && pcmf < 0.000001) break;
    costf[i] = costff[i] + costwt[i] + costm[i] + costf[9];
    }
  if (feedlot == 2) {
    if (pcmf > 0.000001) {  
      for (i = 5; i <= 17; i++) {
	if (i == 6) i = 16;
	costf[i] = costfw[i] + costfs[i] + costfas[i] + costwt[i];
	  costf[i] = costf[i] + costm[i] + costf[9];
	}  
      }
    }
  if (pff > 0.000001) {
    for (i = 6; i <= 13; i++) {
      if (i == 7) i = 12;
      if (feedlot == 1) 	
	costf[i] = costff[i] + costwt[i] + costm[i] + costf[8];
      if (feedlot == 2)
	costf[i] = costfw[i] + costfs[i] + costfas[i] + costwt[i];
	  costf[i] = costf[i] + costm[i] + costf[8];	
      }
    }
  costf[20] = costfw[20] + costfs[20] + costwt[20] + costm[20];

  /* Breeding bulls for natural mating */
  if (edw[10] > 0.000001 && dryw[10] > 0.00001) 
    fbbwe = (nebbw/edw[10])/dryw[10]; 
  if (pdidw[10] > 0.000001 && dryw[10] > 0.00001)   
    fbbwpdi = (pdibbw /pdidw[10])/dryw[10];
  if (edw[10] > 0.000001) tdrybbwe = nebbw / edw[10]; 
  if (pdidw[10] > 0.000001)   tdrybbwpdi = pdibbw / pdidw[10];
  if (feedcost == 1) tdrybbw = maxi(tdrybbwe, tdrybbwpdi);
  if (feedcost == 2) tdrybbw = tdrybbwe;
  if (eds[10] > 0.000001 && drys[10] > 0.00001)  
    fbbse = nebbs / (eds[10] * drys[10]);
  if (pdids[10] > 0.000001 && drys[10] > 0.00001) 
    fbbspdi = pdibbs / (pdids[10] * drys[10]);
  if (eds[10] > 0.000001)  tdrybbse = nebbs / eds[10];
  if (pdids[10] > 0.000001) tdrybbspdi = pdibbs / pdids[10];
  if (feedcost == 1) tdrybbs = maxi(tdrybbse, tdrybbspdi);
  if (feedcost == 2) tdrybbs = tdrybbse;
  /* Predicted daily average dry matter intake in summer and winter periods */
  if (dw[10] > 0) ddrybbw = tdrybbw/dw[10]; 
    else ddrybbw = 0;
  if (ds[10] > 0) ddrybbs = tdrybbs/ds[10];
    else ddrybbs = 0;
  /* Actual daily dry matter intake */
  addrybbw = ddrybbw + rfiw[10]; 
  addrybbs = ddrybbs + rfis[10]; 
  /* Total actual dry matter intake in winter and summer periods 
     for breeding bulls */ 
  atdrybbw = addrybbw * dw[10];
  atdrybbs = addrybbs * ds[10];
  if (dryw[10] > 0.00001) fbbw = atdrybbw / dryw[10]; 
  if (drys[10] > 0.00001) fbbs = atdrybbs / drys[10]; 
  costfbbw = prw[10] * fbbw * kfw;
  costfbbs = prs[10] * fbbs * kfpa;
  costwtbb = wat[10] * prwt * (agebbcull-agebbse);
  costmbb = min[10] * prm[10] * (agebbcull-agebbse);
  costfbb = costfbbw + costfbbs + costwtbb + costmbb; 

  /* Bulls in performance test */
  if (prodsys == 1) {
    d[11] = agebbt - agew;
    edw[11] = edw[10];
    eds[11] = eds[10];
    dryw[11] = dryw[10];
    drys[11] = drys[10];
    pdidw[11] = pdidw[10];
    pdids[11] = pdids[10];
    min[11] = min[10];
    prm[11] = prm[10];
    if (edtb > 0.000001 && drytb > 0.00001)
      ftbe = (nebt/edtb)/drytb;
    if (pdidtb > 0.000001 && drytb > 0.00001)
      ftbpdi = pditb / (pdidtb * drytb);
    if (edtb > 0.000001) tdrytbe = nebt / edtb; 
    if (pdidtb > 0.000001) tdrytbpdi = pditb / pdidtb;
    if (feedcost == 1) tdrytb = maxi(tdrytbe, tdrytbpdi);
    if (feedcost == 2) tdrytb = tdrytbe;
    if (edt > 0.000001 && dryt > 0.00001) fte = net / (edt * dryt);
    if (pdidt > 0.000001 && dryt > 0.00001) ftpdi = pdit / (pdidt * dryt);
    if (edt > 0.000001) tdryte = net / edt;
    if (pdidt > 0.000001) tdrytpdi = pdit / pdidt;
    if (feedcost == 1) tdryt = maxi(tdryte, tdrytpdi);
    if (feedcost == 2) tdryt = tdryte;
    if (edtse > 0.000001 && drytse > 0.00001) 
      ftse = netse / (edtse * drytse);
    if (pdidtse > 0.000001 && drytse > 0.00001) 
      ftsepdi = pditse / (pdidtse * drytse);
    if (edtse > 0.000001) tdrytse = netse / edtse;
    if (pdidtse > 0.000001) tdrytspdi = pditse / pdidtse;
    if (feedcost == 1) tdryts = maxi(tdrytse, tdrytspdi);
    if (feedcost == 2) tdryts = tdrytse;
    /* Predicted daily average dry matter intake in the periods before test, 
       in test and after test */
    if (dst > 0) ddrytb = tdrytb/dst; 
      else ddrytb = 0;  
    if (dt > 0) ddryt = tdryt/dt;
      else ddryt = 0;  
    if (dtse > 0) ddryts = tdryts/dtse;
      else ddryts = 0;  
    /* Actual daily dry matter intake */
    addrytb = ddrytb + rfitb; 
    addryt = ddryt + rfit; 
    addrytse = ddryts + rfits; 
    /* Total actual dry matter intake of bulls before, in and after 
       performance test */ 
    atdrytb = addrytb * dst;
    atdryt = addryt * dt;
    atdrytse = addrytse * dtse;
    if (drytb > 0.00001) ftb = atdrytb / drytb;
    if (dryt > 0.00001) ft = atdryt / dryt;
    if (drytse > 0.00001) fts = atdrytse / drytse;
    costftse = prtse * fts * kfw;
    costftb = prtb * ftb * kfw;
    costft = prt * ft * kff;
    costwt[10] = wat[10] * prwt * (agebbse - agew);
    costm[10] = 0;
    costf[10] = costftb + costft + costftse + costwt[10];
      costf[10] = costf[10] + costm[10] + costf[9];
    costwt[11] = wat[10] * prwt * d[11];
    costm[11] = 0;
    costf[11] = costftb + costft + costwt[11] + costm[11] + costf[9];
  } /* End of production system 1 */
  
  if (prodsys <= 2) {
    for (i = 7; i <= 24; i++) {
      if (i == 8) i = 18;
      if (i == 20) i = 22;
      costf[i] = costfw[i] + costfs[i] + costwt[i] + costm[i] + costf[8];
    }  
  }
  
  if (prodsys == 3) {
    for (i = 7; i <= 24; i++) {
      if (i == 8) i = 18;
      if (i == 20) i = 22;
      costf[i] = 0;
    }  
    if (dprfrep == 0) 
      costf[19] = costfw[19] + costfs[19] + costwt[19] + costm[19];
  }
/*  pasture = 0;
  for (i = 1; i <= CC; i++) pasture += fs[i]*l1[i];
  if (l1[8] == 0) pasture += fs[8]*(l1[6]+l1[12]+l1[13]);
  if (l1[9] == 0) pasture += fs[9]*(l1[4]+l1[5]+l1[14]+l1[15]+l1[16]+l1[17]);
  pasture *= kfpa*drys[25]/dryhayha; */
 
  /* Other costs */
  if (trait == 0) printf("Calculating costs\n");  
  aic = 0;
  if (insc == 1) {
    for (i = 0; i < LL-1; i++)  
      aic += l4[i]*(dysmat[i]*pinmatd[i] + (cmat[i]-dysmat[i])*pinmatnd[i]);
    }
  for (i = 0; i <= CC; i++) 
    costvet[i] = costh[i] = costo[i] = costfix[i] = 0;
  if (pcmf > 0.000001) costo[5] = costdf;
  if (pff > 0.000001) costo[6] = costdf;
  if (pcmf > 0.000001) {
    for (i = 5; i <= 17; i++) {
      if (i == 6) i = 17;
      if (feedlot == 2) {
	dcostw[i] = dwx;
	if (i == 17) dcostw[i] += dasc;
	}  	  
      if (feedlot == 1) {
	costh[i] = (strawfi * prst - dungfi * prdg)*d[i];
	costfix[i] = fixcfi * d[i];
	costvet[i] = costvfi;
	}
      if (feedlot == 2) {
	costh[i] = (strawfx * prst - dungfx * prdg)*dcostw[i];
	costfix[i] = fixcfx * d[i];
	costvet[i] = costvfx;
	}
      }    
    }
  if (pff > 0.000001) {
    for (i = 6; i <= 13; i++) {
      if (i == 7) i = 12;
      if (feedlot == 2) {
	dcostw[i] = dwx;
	if (i == 12) dcostw[i] += dasf;
	}  	  
      if (feedlot == 1) {
	costh[i] = (strawfi * prst - dungfi * prdg)*d[i];
	costfix[i] = fixcfi * d[i];
	costvet[i] = costvfi;
	}
      if (feedlot == 2) {
	costh[i] = (strawfx * prst - dungfx * prdg)*dcostw[i];
	costfix[i] = fixcfx * d[i];
	costvet[i] = costvfx;
	}
      }    
    }    
  if (pbf == 1) {
    costo[4] = costdf;
    costvet[4] = costvet[14] = costvet[15] = costvfi;
    for (i = 4; i <= 15; i++) {
      if (i == 5) i = 14;
      costh[i] = (strawfi * prst - dungfi * prdg)*d[i];
      costfix[i] = fixcfi * d[i];
      } 
    }
  costhbb = (strawbb*prst - dungbb*prdg)*lifebb*dwx;
  if (fabs(costhbb) < 0.000001) costhbb = 0;
  costvbbt = costvbb*lifebb;
  fixcbbt = fixcbb*lifebb*lghrcyc;
  costbb = costfbb + costhbb + costvbbt + fixcbbt;
  costbb -= mwb*dresb*prbbcull/lifebb;
  costi = (prbb + costbb)/(cowb*lifebb);
  if (insc == 1) costimc = aic*(prai + nr*prair) + (1-aic)*costi;
  if (insc == 2) costimc = costi;
  for (i = 1; i <= LL-1; i++) {
    dcostw[24+6*i] = dw1[24+6*i]+dw2[24+6*i];
    costh[24+6*i] = (straw[30]*prst - dung[30]*prdg)*dcostw[24+6*i];
    costvet[24+6*i] = costv[30];
    costo[24+6*i] = costimc;
    costfix[24+6*i] = fixcc*lghrcyc;
    }
  for (i = 1; i <= LL; i++) {
    dcostw[19+6*i] = dw1[19+6*i]+dw2[19+6*i];
    costh[19+6*i] = (straw[30]*prst - dung[30]*prdg)* dcostw[19+6*i];
    costvet[19+6*i] = costvet[30]/2.0;
    costo[19+6*i] = costimc + costdc;
    costfix[19+6*i] = fixcc*lghrcyc/2.0;
    dcostw[21+6*i] = dw1[21+6*i]+dw2[21+6*i];
    costh[21+6*i] = (straw[30]*prst - dung[30]*prdg)* dcostw[21+6*i];
    costvet[21+6*i] = costvet[30]/2.0;
    costo[21+6*i] = costimc;
    costfix[21+6*i] = fixcc*lghrcyc/2.0;
    costh[22+6*i] = costh[27];
    costvet[22+6*i] = costvet[30];
    costo[22+6*i] = costimc;
    costfix[22+6*i] = fixcc*agew;
    }  
  for (i = 1; i <= LL-1; i++) {
    costh[23+6*i] = costh[30];
    costvet[23+6*i] = costvet[30]/2.0;
    costo[23+6*i] = costimc;
    costfix[23+6*i] = costfix[30];
    }

  if (prodsys == 1) {
    d[10] = agebbse - agebbst;
    costh[10] = (straw[10]*prst - dung[10]*prdg)*d[10];
    costvet[10] = costv[10];
    costfix[10] = fixcbt*d[10];
    costh[11] = (straw[10]*prst - dung[10]*prdg)*d[11];
    costvet[11] = costv[10]/2.0;
    costfix[11] = fixcbt*d[11];
    }
  if (prodsys <= 2 || (prodsys == 3 && dprfrep == 0)) {
    if (insh == 1) costimh = aih*(prai + nr*prair) + (1-aih)*costi;
    if (insh == 2) costimh = costi;
    }
  if (prodsys <= 2) {
    dcostw[22] = php1*(dw1[CC+4] + dw2[CC+4]);
      dcostw[22] += php2*(dw1[CC+5] + dw2[CC+5] + dw3[CC+5]);
      dcostw[22] += php3*(dw1[CC+6] + dw2[CC+6] + dw3[CC+6] + dw4[CC+6]);
    d[22] = agecal - agew;
    costh[22] = (straw[22]*prst - dung[22]*prdg)*dcostw[22];
    costvet[22] = costv[22];
    costo[22] =  costimh;
    costfix[22] = fixcrh*d[22];
    dcostw[18] = dw[18];
    costh[18] = (straw[22]*prst - dung[22]*prdg)*dcostw[18];
    costvet[18] = costv[22]/2.0;
    costfix[18] = fixcrh*d[18];
    dcostw[23] = phmat1*dw1[CC+7] + phmat2*(dw1[CC+7] + dw2[CC+8]);
    costh[23] = (straw[22]*prst - dung[22]*prdg)*dcostw[23];
    costvet[23] = costv[22];
    costfix[23] = fixcrh*d[23];
    dcostw[24] = phmat1*dw1[CC+1] + phmat2*(dw1[CC+1] + dw2[CC+4]);
    costh[24] = (straw[22]*prst - dung[22]*prdg)*dcostw[24];
    costvet[24] = costv[22]/2.0;
    costo[24] = costimh;
    costfix[24] = fixcrh*d[24];
    costh[19] =  costh[24];
    costvet[19] = costv[22]/2.0;
    costo[19] = costimh;
    costfix[19] = fixcrh*d[19];
    dcostw[7] = dcostw[22]/2.0;
    costh[7] = (straw[22]*prst - dung[22]*prdg)*dcostw[7];
    costvet[7] = costv[22]/2.0;
    costo[7] = 0.5*costimh + costdf;
    costfix[7] = fixcrh*d[7];
    }

   if (prodsys == 3) {
     dcostw[20] = d[20]/2.0;
     costh[20] = (straw[22]*prst - dung[22]*prdg)*dcostw[20];
     costvet[20] = d[20]*costv[22]/(agecal-agew);
     costfix[20] = fixcrh*d[20] + prrep*wfrep;
     if (dprfrep == 0) {
       costo[20] = costo[19] = costimh;
       dcostw[19] = d[19]/2.0;
       costh[19] = (straw[22]*prst - dung[22]*prdg)*dcostw[19];
       costvet[19] = d[19]*costv[22]/(agecal-agew);
       costfix[19] = fixcrh*d[19] + prrep*wfrep;
       }
     }
   
  if (prodsys <= 2) {
    if (Nfcw >= Nfrp) goto End20;
    dcostw[20] = dcostw[22];
    costvet[20] = costv[22]/3.0;
    costh[20] = (straw[22]*prst - dung[22]*prdg)*dcostw[20];
    costfix[20] = fixcrh*d[20] + prrep*wfrep;
    }
End20:

  for (i = 1; i <= CC; i++) {
    if (i == 4 && pbf == 0) i = 5;
    if (i == 5 && pcmf < 0.000001) i = 6;
    if (i == 6 && pff < 0.000001) i = 7;
    if (i == 12 && pff < 0.000001) i = 14;
    if (i == 14 && pbf == 0) i = 16;
    if (i == 16 && pcmf < 0.000001) i = 18;
    if (l1[i] > 0.000001 || i == 8 || i == 9) 
      cost[i] = costf[i] + costh[i] + costvet[i] + costo[i] + costfix[i];
    }
  dysscoreav = 0;
  for (j = 0; j < DD; j++) {
    dysscore[j] = 0;
    for (i = 0; i < LL; i++) 
      dysscore[j] += .5*(dysff[j][i]+dysmm[j][i])*l3[i];        
    dysscoreav += (j + 1)*dysscore[j];
    } 
  costdysc = 0;  
  for (j = 0; j < DD; j++)       
    costdysc += (costlab*labdys[j]+vetdys[j])*dysscore[j];
  costdys = costdysc*Ncal;

  costvetc = costhc = costoc = costfixc = costfc = costc = 0;
  for (i = 25; i <= CC; i++) {  
    costvetc += l1[i]*costvet[i];
    costhc += l1[i]*costh[i];
    costoc += l1[i]*costo[i];
    costfixc += l1[i]*costfix[i];
    costfc += l1[i]*costf[i];
    costc += l1[i]*cost[i];
    }
    costc += costdys;

  /* Calculation of revenues */
  if (trait == 0) printf("Calculating revenues\n"); 
  pr[12] = pr[14] = pr[17] = pr[18] = pr[19] = pr[29] = 0;
  for (i = 0; i < p1; i++) {
    for (j = 0; j < p2; j++) {
      if (pff > 0.000001) pr[12] = pr[12] + Prh[i][j]*Ph[i][j];
      pr[14] = pr[14] + Prb[i][j]*Pb[i][j];
      if (pcmf > 0.000001) pr[17] = pr[17] + Prcs[i][j]*Pcs[i][j];
      pr[18] = pr[18] + Prh[i][j]*Ph[i][j];
      pr[29] = pr[29] + Prc[i][j]*Pc[i][j]; 
      }
    }
  if (pff > 0.000001) pr[12] = pr[12]*prh/100;
  pr[14] = pr[14]*prb/100;
  pr[11] = pr[14];
  if (pbf == 0) pr[14] = 0;
  if (pcmf > 0.000001) pr[17] = pr[17]*prcs/100;
  pr[18] = pr[18]*prh/100;
  pr[19] = pr[18];
  pr[29] = pr[29]*prc/100;
  for (i = 1; i <= CC; i++) rev[i] = 0;
  rev[8] = pr[8]*wwf;
  rev[9] = pr[9]*wwm;
  rev[10] = prbbsel;
  rev[11] = wbbt*dresb*pr[11];
  if (pff > 0.000001) { 
    if (feedlot == 1) rev[12] = whfat*dresh*pr[12];
    if (feedlot == 2) rev[12] = whxfat*dresh*pr[12];
    rev[13] = wcwsf*dresh*kdresh*pr[12]*kpr[12];
    }
  if (pbf == 1) {
    rev[14] = wbfat*dresb*pr[14];
    rev[15] = wcwsm*dresb*kdresb*pr[14]*kpr[14];
    }
  if (feedlot == 1 && pcmf > 0.000001) rev[17] = wcfat*dresc*pr[17];
  if (feedlot == 2 && pcmf > 0.000001) rev[17] = wcxfat*dresc*pr[17];  
  if (pcmf > 0.000001) rev[16] = wcwsc*dresc*kdresc*pr[17]*kpr[17];
  rev[18] = whmat1*dresh*pr[18];
  rev[19] = whcmat*dresh*pr[19];
  rev[23] = prnphse*wnphse;
  rev[24] = prphse*(wphse+wpreg/2.0);
  for (i = 1; i <= LL; i++) {
    rev[20+6*i] = wcdys[i-1]*drescw*pr[29]*kpr[29];
    rev[21+6*i] = wcc[i-1]*drescw*pr[29]*kpr[29];
    rev[22+6*i] = wccw[i-1]*drescw*pr[29]; 
    }
  /* End revenues */
  
  /* Calculating Numbers of discounted expressions */
  if (trait == 0)
    printf("Calculating number of discounted expressions\n");  
  for (i = 1; i <= CC; i++) tr[i] = 0;
  if(rev[8] > 0.000001) tr[8] = agew/365.0;
  if(rev[9] > 0.000001) tr[9] = agew/365.0;
  if(rev[10] > 0.000001) tr[10] = agebbse/365.0;
  if(rev[11] > 0.000001) tr[11] = agebbt/365.0;
  if(rev[12] > 0.000001) tr[12] = agesf/365.0;
  if(rev[13] > 0.000001) tr[13] = agecwsf/365.0;
  if(rev[14] > 0.000001) tr[14] = agesm/365.0;
  if(rev[15] > 0.000001) tr[15] = agecwsm/365.0;
  if(rev[16] > 0.000001) tr[16] = agecwsc/365.0;
  if(rev[17] > 0.000001) tr[17] = agesc/365.0;
  if(rev[18] > 0.000001) tr[18] = agehmat1/365.0;
  if(prodsys != 3 && rev[19] > 0.000001) tr[19] = agehcmat/365.0;
  if(prodsys == 3 && rev[19] > 0.000001) tr[19] = (lgpre - dayshc)/(-365.0);
  if(rev[23] > 0.000001) tr[23] = anphse/365.0;
  if(rev[24] > 0.000001) tr[24] = aphse/365.0;
  for (i = 1; i <= LL; i++) {
    if(rev[20+6*i] > 0.000001) tr[20+6*i] = ndaydys/365.0;
    if(rev[21+6*i] > 0.000001) tr[21+6*i] = ndaycc/365.0;
    if(rev[22+6*i] > 0.000001) tr[22+6*i] = ndaycw/365.0;
    }
  aa1 = 1/(1 + u);
  for (i = 1; i <= CC; i++) {
    qr[i] = pow(aa1, tr[i]);
    if(rev[i] > 0) NDEr[i] = l1[i]*qr[i];
    }  
  for (i = 1; i <= CC; i++) tc[i] = 0;
  if(cost[3] > 0.000001) tc[3] = agedcw/(365*2);
  if(cost[4] > 0.000001) tc[4] = agedwsm/(365*2);
  if(cost[5] > 0.000001 && pcmf > 0.000001) tc[5] = agedwsc/(365*2);
  if(cost[6] > 0.000001) tc[6] = agedwsf/(365*2);	
  if(cost[7] > 0.000001) tc[7] = agedmh/(365*2);
  if(cost[8] > 0.000001) tc[8] = agew/(365*2);
  if(cost[9] > 0.000001) tc[9] = agew/(365*2);
  if(cost[10] > 0.000001) tc[10] = agebbse/(365*2);
  if(cost[11] > 0.000001) tc[11] = agebbt/(365*2);
  if(cost[12] > 0.000001) tc[12] = agesf/(365*2);
  if(cost[13] > 0.000001) tc[13] = agecwsf/(365*2);
  if(cost[14] > 0.000001) tc[14] = agesm/(365*2);
  if(cost[15] > 0.000001) tc[15] = agecwsm/(365*2);
  if(cost[16] > 0.000001 && pcmf > 0.000001) tc[16] = agecwsc/(365*2);
  if(cost[17] > 0.000001 && pcmf > 0.000001) tc[17] = agesc/(365*2);
  if(cost[18] > 0.000001) tc[18] = agehmat1/(365*2);
  if(prodsys != 3 && cost[19] > 0.000001) tc[19] = agehcmat/(365*2);
  if(prodsys == 3 && cost[19] > 0.000001) tc[19] = d[19]/(-365);
  if(cost[20] > 0.000001) tc[20] = d[20]/(-365);
  if(cost[22] > 0.000001) tc[22] = agecal/(365*2);
  if(cost[23] > 0.000001) tc[23] = anphse/(365*2);
  if(cost[24] > 0.000001) tc[24] = aphse/(365*2);
  for (i = 1; i <= LL; i++) {
    if(cost[19+6*i] > 0.000001) tc[19+6*i] = ndaycd/(365*2);
    if(cost[20+6*i] > 0.000001) tc[20+6*i] = ndaydys/(365*2);
    if(cost[21+6*i] > 0.000001) tc[21+6*i] = ndaycc/(365*2);
    if(cost[22+6*i] > 0.000001) tc[22+6*i] = ndaycw/(365*2);
    if (i == LL) break;
    if(cost[23+6*i] > 0.000001) tc[23+6*i] = lghrcyc/(365*2);
    if(cost[24+6*i] > 0.000001) tc[24+6*i] = lghrcyc/(365*2);
    }
  for (i = 1; i <= CC; i++) {
    qc[i] = pow(aa1, tc[i]);
    if(cost[i] > 0) NDEc[i] = l1[i]*qc[i];
    }  
  NDEdys = 1;
  /* End Number of discounted expressions */  

  /* Calculating profit */
  if (trait == 0) printf("Calculating profit\n");
  Trev = Tcost = Tprof = 0;
  for (i = 1; i <= CC; i++) {
    Trev = Trev + rev[i]*NDEr[i];
    Tcost = Tcost + cost[i]*NDEc[i];
    }
  Tcost = Tcost + costdys*NDEdys;
  ncows = 0;
  for (i = 1; i < LL + 1; i++) 
    ncows +=  l2[4 + 6*(i-1)];
  if (feedlot == 1) aa1 = dotfati;
  if (feedlot == 2) aa1 = dotfatx;
  dot = herdbook*dotcowh + (Nfcw + Nmcw)*dotcalf + l1[9]*dotexpm + dotcowo;
    dot += (l1[10] + l1[11])*dt*dottest + dotcows*ncows +
           (l1[14]+l1[15])*dotfatib + aa1*(l1[12] + l1[13]+ l1[16] + l1[17]);
  Tprof = Trev - Tcost + dot;
  profitab = 100*(Trev-Tcost)/Tcost;
  profitabd = 100*Tprof/Tcost;
  
  /* Calculation of several coefficients */
  if (trait == 0 && zr==1) {
    kp21 = l1[2]/l1[1];
    kpm1 = pm[1]/pf[1];
    if (pf[2] > 0.00000001) kpm2 = pm[2]/pf[2];
  }

  /* Gene flow */
  if (trait == 0) {
  printf("Calculating gene flow\n");
  /* Completition of matrix PM */
  for (i = 2; i <=acs; i++) PM[i][i-1] = 1;
  for (j = 1; j <=acs; j++) PM[acs+acd+1][j] = PM[acs+1][j];
  for (j = acs +acd +1 - LL; j <= acs +acd; j++)
    PM[acs+1][j] = PM[acs+acd+1][j] = (double)(l3[j+LL-acs-acd-1]/(2*Ncal));
  if (prodsys == 3) for (j = 1; j <=acs+acd; j++) PM[acs+1][j] = 0;  
  for (i = acs + 2; i <= acs + acd; i++) PM[i][i-1] = 1; 
  for (i = 0; i < acs+acd+2; i++) m_gf0[i] = m_gf[i] = m_sum[i] = 0;
  if (gene_flow == 1) m_gf0[n_sac] = 1;
  if (gene_flow == 2) m_gf0[acs+n_sac] = 1;
  for (i1 = 1; i1 <= l_inv; i1++) {
    for (i = 1; i <= acs+acd+1; i++) {
      for (j = 1; j <= acs+acd+1; j++) 
        m_gf[i] += PM[i][j]*m_gf0[j];  
      }
    for (i = 1; i <= acs+acd+1; i++) { 
      m_gf0[i] = m_gf[i]; 
      m_sum[i] += m_gf0[i]/pow(u+1,i1); 
      m_gf[i] = 0;  
      }
    }
  for (i = 0; i < acs+acd+2; i++) hd[i] = hm[i] = 0;
  hd[acs+acd+1] = 1;
  for (i = acs +acd + 1 - LL; i <= acs + acd; i++) 
    hm[i] = (double)(l3[i+LL-acs-acd-1]/Ncal);
  NDEd = NDEm = 0;
  for (i = 1; i <= acs+acd+1; i++) {
    NDEd += hd[i]*m_sum[i];
    NDEm += hm[i]*m_sum[i];
    }  
  }

  /* Calculation of economic values */
  if (trait == 0) {
    printf("Calculating economic values (This will take some time)\n"); 
    for (i = 0; i < NT; i++)
      ew[i] = ew0[i] = ew_d[i]= ew_m[i] = 0;
    }
  /* Trait: mature weight of cows */
  if (trait == 0) {
    trait = 4;
    tvm = mcw;
    }
  if (trait == 4 && zr == 1) {
    mcw = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 4 && zr == 2) {
    Tprofh = Tprof;
    mcw = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 4 && zr == 3) {
    Tprofl = Tprof;
    ew0[trait] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    mcw = tvh;
    zr++;
    goto Start;
  }
  if (trait == 4 && zr == 4) {
    Tprofh = Tprof;
    mcw = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 4 && zr == 5) {
    Tprofl = Tprof;
    ew[trait] = (Tprofh - Tprofl)/(tvh - tvl);
    mcw = tvm;
    zr++;
    goto Start;
  }

  /* Trait: losses of calves from 48 hours after calving till weaning */
  if (trait == 4 && zr == 6) {
    trait = 3;
    tvm = dcw;
    }
  if (trait == 3 && zr == 6) {
    dcw = tvh = 1.01*tvm;
    if (tvm < 0.000001) dcw = tvh = 0.02;
    zr++;
    goto Start;
    }
  if (trait == 3 && zr == 7) {
    Tprofh = Tprof;
    dcw = tvl = 0.99*tvm;
    if (tvm < 0.000001) dcw = tvl = 0;
    zr++;
    goto Start;
  }
  if (trait == 3 && zr == 8) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    dcw = tvh;
    if (tvm < 0.000001) dcw = tvh = 0.01;
    zr++;
    goto Start;
  }
  if (trait == 3 && zr == 9) {
    Tprofh = Tprof;
    dcw = tvl;
    if (tvm < 0.000001) dcw = tvl = 0;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 3 && zr == 10) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    dcw = tvm;
    zr++;
    goto Start;
  }

  /* Trait: birthweight of calves */
  if (trait == 3 && zr == 11) {
    trait = 5;
    tvm = bwf;
    }
  if (trait == 5 && zr == 11) {
    bwf = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 5 && zr == 12) {
    Tprofh = Tprof;
    bwf = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 5 && zr == 13) {
    Tprofl = Tprof;
    ew0[trait] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    bwf = tvh;
    zr++;
    goto Start;
  }
  if (trait == 5 && zr == 14) {
    Tprofh = Tprof;
    bwf = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 5 && zr == 15) {
    Tprofl = Tprof;
    ew[trait] = (Tprofh - Tprofl)/(tvh - tvl);
    bwf = tvm;
    zr++;
    goto Start;
  }

  /* Trait: losses of calves at calving */
  if (trait == 5 && zr == 16) {
    trait = 2;
    tvm = calfloss;
    }
  if (trait == 2 && zr == 16) {
    calfloss = tvh = 1.01*tvm;
    if (tvm < 0.000001) calfloss = tvh = 0.02;
    zr++;
    goto Start;
    }
  if (trait == 2 && zr == 17) {
    Tprofh = Tprof;
    calfloss = tvl = 0.99*tvm;
    if (tvm < 0.000001) calfloss = tvl = 0;
    zr++;
    goto Start;
  }
  if (trait == 2 && zr == 18) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    calfloss = tvh;
    if (tvm < 0.000001) calfloss = tvh = 0.01;
    zr++;
    goto Start;
  }
  if (trait == 2 && zr == 19) {
    Tprofh = Tprof;
    calfloss = tvl;
    if (tvm < 0.000001) calfloss = tvl = 0;    
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 2 && zr == 20) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    calfloss = tvm;
    zr++;
    goto Start;
  }

  /* Trait: average daily gain from birth to 1st weighing */
  if (trait == 2 && zr == 21) {
    trait = 6;
    tvm = adgcon1f;
    }
  if (trait == 6 && zr == 21) {
    adgcon1f = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 6 && zr == 22) {
    Tprofh = Tprof;
    adgcon1f = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 6 && zr == 23) {
    Tprofl = Tprof;
    ew0[trait] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgcon1f = tvh;
    zr++;
    goto Start;
  }
  if (trait == 6 && zr == 24) {
    Tprofh = Tprof;
    adgcon1f = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 6 && zr == 25) {
    Tprofl = Tprof;
    ew[trait] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
    adgcon1f = tvm;
    zr++;
    goto Start;
  }

  /* Trait: average daily gain from 1st to 2nd weighing */
  if (trait == 6 && zr == 26) {
    trait = 7;
    tvm = adgcon2f;
    }
  if (trait == 7 && zr == 26) {
    adgcon2f = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 7 && zr == 27) {
    Tprofh = Tprof;
    adgcon2f = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 7 && zr == 28) {
    Tprofl = Tprof;
    ew0[trait] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgcon2f = tvh;
    zr++;
    goto Start;
  }
  if (trait == 7 && zr == 29) {
    Tprofh = Tprof;
    adgcon2f = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 7 && zr == 30) {
    Tprofl = Tprof;
    ew[trait] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
    adgcon2f = tvm;
    zr++;
    goto Start;
  } 

  /* Trait: average daily gain from 2nd to 3rd weighing */
  if (trait == 7 && zr == 31) {
    trait = 8;
    tvm = adgcon3f;
    }
  if (trait == 8 && zr == 31) {
    adgcon3f = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 8 && zr == 32) {
    Tprofh = Tprof;
    adgcon3f = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 8 && zr == 33) {
    Tprofl = Tprof;
    ew0[trait] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgcon3f = tvh;
    zr++;
    goto Start;
  }
  if (trait == 8 && zr == 34) {
    Tprofh = Tprof;
    adgcon3f = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 8 && zr == 35) {
    Tprofl = Tprof;
    ew[trait] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
    adgcon3f = tvm;
    zr++;
    goto Start;
  } 

  /* Trait: average daily gain in fattening */
  if (trait == 8 && zr == 36 && feedlot == 0) {
    trait = 9;
    zr = 41;
    }
  if (trait == 8 && zr == 36) {
    trait = 9;
    if (feedlot == 1) tvm = adgwsf;
    if (feedlot == 2) tvm = dgfxw;
    }
  if (trait == 9 && zr == 36) {
    if (feedlot == 1) adgwsf = tvh = 1.01*tvm;
    if (feedlot == 2) dgfxw = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 9 && zr == 37) {
    Tprofh = Tprof;
    if (feedlot == 1) adgwsf = tvl = 0.99*tvm;
    if (feedlot == 2) dgfxw = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 9 && zr == 38) {
    Tprofl = Tprof;
    ew0[trait] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    if (feedlot == 1) adgwsf = tvh;
    if (feedlot == 2) dgfxw = tvh;
    zr++;
    goto Start;
  }
  if (trait == 9 && zr == 39) {
    Tprofh = Tprof;
    if (feedlot == 1) adgwsf = tvl;
    if (feedlot == 2) dgfxw = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 9 && zr == 40) {
    Tprofl = Tprof;
    ew[trait] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
    if (feedlot == 1) adgwsf = tvm;
    if (feedlot == 2) dgfxw = tvm;
    zr++;
    goto Start;
  } 

  /* Trait: dressing percentage */
  if (trait == 9 && zr == 41) {
    trait = 10;
    tvm = dresh;
    }
  if (trait == 10 && zr == 41) {
    dresh = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 10 && zr == 42) {
    Tprofh = Tprof;
    dresh = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 10 && zr == 43) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    dresh = tvh;
    zr++;
    goto Start;
  }
  if (trait == 10 && zr == 44) {
    Tprofh = Tprof;
    dresh = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 10 && zr == 45) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    dresh = tvm;
    zr++;
    goto Start;
  } 

  /* Trait: conception rate of heifers */
  if (trait == 10 && zr == 46) {
    trait = 12;
    tvm = crinh;
    }
  if (trait == 12 && zr == 46) {
    crinh = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 12 && zr == 47) {
    Tprofh = Tprof;
    crinh = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 12 && zr == 48) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    crinh = tvh;
    zr++;
    goto Start;
  }
  if (trait == 12 && zr == 49) {
    Tprofh = Tprof;
    crinh = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 12 && zr == 50) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    crinh = tvm;
    zr++;
    goto Start;
  } 

  /* Trait: conception rate of cows */
  if (trait == 12 && zr == 51) {
    trait = 13;
    tvm = ecrinc;
    }
  if (trait == 13 && zr == 51) {
    ecrinc = tvh = 1.01*tvm;
    zr++;
    goto Start;
    }
  if (trait == 13 && zr == 52) {
    Tprofh = Tprof;
    ecrinc = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (trait == 13 && zr == 53) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    ecrinc = tvh;
    zr++;
    goto Start;
  }
  if (trait == 13 && zr == 54) {
    Tprofh = Tprof;
    ecrinc = tvl;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 13 && zr == 55) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    ecrinc = tvm;
    zr++;
    goto Start;
  } 

  /* Trait: fleshiness for cows */
  if (prodsys <= 2) {
    if (trait == 13 && zr == 56) {
      trait = 14;
      /* Saving the original values of matrix Pc */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  Pc0[j][i] = (double)Pc[j][i];
	  }
	} 
      /* Frequencies of fleshiness classes summed over fat covering classes 
	 and cumulative frequencies */
      for (j = 0; j < p1; j++) {
	Pcfl[j] = Pcfld[j] = 0; 
	for (i = 0; i < p2; i++) {
	  Pc[j][i] /= 100;
	  Pcfl[j] += Pc[j][i];
	}  
	if (j==0) Pcfld[j] = Pcfl[j];
	if (j>0) Pcfld[j] = Pcfld[j-1] + Pcfl[j]; 
	}
      /* Threshold values for classes of fleshiness */
      for (j = 0; j < p1-1; j++) {
	Pcflqm[j] = probit(Pcfld[j]); 
	} 
      /* Mean class for fleshiness */
      Pcflmc = 0;
      for (j = 0; j < p1; j++) {
	Pcflmc += (j+1)*Pcfl[j]; 
	} 	
      tvm = Pcflmcc = Pcflmc;      
      }

    if (trait == 14 && zr == 56) {
      /* Shifting the distribution to the left */
      for (j = 0; j < p1-1; j++) {
	Pcflql[j] = Pcflqm[j] - 0.1; 
	} 
      /* Values of the cumulative normal distribution for the shifted 
         distribution */
      for (j = 0; j < p1-1; j++) {
	Pcfldl[j] = normdis(Pcflql[j]); 
	} 
      Pcfldl[p1-1] = 1;
      Pcfll[0] = Pcfldl[0];
      for (j = 0; j < p1; j++) {
	Pcfll[j+1] = Pcfldl[j+1] - Pcfldl[j];
	} 
      /* New matrix Pc for shifted distribution */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (Pcfl[j] == 0) Pc[j][i] = 0;      
	    else Pc[j][i] = Pcfll[j]*Pc0[j][i]/Pcfl[j]; 
	  }
	}  
      /* Mean class for fleshiness */
      Pcflmc = 0;
      for (j = 0; j < p1; j++) {
	Pcflmc += (j+1)*Pcfll[j]; 
	} 
      tvh = Pcflmc;
      zr++;
      goto Start; 
      }

    if (trait == 14 && zr == 57) {
      Tprofh = Tprof;
      /* Shifting the distribution to the right */
      for (j = 0; j < p1-1; j++) {
	Pcflqr[j] = Pcflqm[j] + 0.1; 
	} 
      /* Values of the cumulative normal distribution for the shifted 
         distribution */
      for (j = 0; j < p1-1; j++) {
	Pcfldr[j] = normdis(Pcflqr[j]); 
	} 
      Pcfldr[p1-1] = 1;
      Pcflr[0] = Pcfldr[0];
      for (j = 0; j < p1; j++) {
	Pcflr[j+1] = Pcfldr[j+1] - Pcfldr[j];
	} 
      /* New matrix Pc for shifted distribution */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (Pcfl[j] == 0) Pc[j][i] = 0;      
	    else Pc[j][i] = Pcflr[j]*Pc0[j][i]/Pcfl[j]; 
	  }
	}  
      /* Mean class for fleshiness */
      Pcflmc = 0;
      for (j = 0; j < p1; j++) {
	Pcflmc += (j+1)*Pcflr[j]; 
	} 
      tvl = Pcflmc;
      zr++;
      goto Start;
    }

    if (trait == 14 && zr == 58) {
      Tprofl = Tprof;
      ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      /* Shifting the distribution to the left */
      for (j = 0; j < p1-1; j++) {
	Pcflql[j] = Pcflqm[j] - 0.05; 
	} 
      /* Values of the cumulative normal distribution for the shifted 
         distribution */
      for (j = 0; j < p1-1; j++) {
	Pcfldl[j] = normdis(Pcflql[j]); 
	} 
      Pcfldl[p1-1] = 1;
      Pcfll[0] = Pcfldl[0];
      for (j = 0; j < p1; j++) {
	Pcfll[j+1] = Pcfldl[j+1] - Pcfldl[j];
	} 
      /* New matrix Pc for shifted distribution */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (Pcfl[j] == 0) Pc[j][i] = 0;      
	    else Pc[j][i] = Pcfll[j]*Pc0[j][i]/Pcfl[j]; 
	  }
	}  
      /* Mean class for fleshiness */
      Pcflmc = 0;
      for (j = 0; j < p1; j++) {
	Pcflmc += (j+1)*Pcfll[j]; 
	} 
      tvh = Pcflmc;
      zr++;
      goto Start; 
      }

    if (trait == 14 && zr == 59) {
      Tprofh = Tprof;
      /* Shifting the distribution to the right */
      for (j = 0; j < p1-1; j++) {
	Pcflqr[j] = Pcflqm[j] + 0.05; 
	} 
      /* Values of the cumulative normal distribution for the shifted 
         distribution */
      for (j = 0; j < p1-1; j++) {
	Pcfldr[j] = normdis(Pcflqr[j]); 
	} 
      Pcfldr[p1-1] = 1;
      Pcflr[0] = Pcfldr[0];
      for (j = 0; j < p1; j++) {
	Pcflr[j+1] = Pcfldr[j+1] - Pcfldr[j];
	} 
      /* New matrix Pc for shifted distribution */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (Pcfl[j] == 0) Pc[j][i] = 0;      
	    else Pc[j][i] = Pcflr[j]*Pc0[j][i]/Pcfl[j]; 
	  }
	}  
      /* Mean class for fleshiness */
      Pcflmc = 0;
      for (j = 0; j < p1; j++) {
	Pcflmc += (j+1)*Pcflr[j]; 
	} 
      tvl = Pcflmc;
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }

    if (trait == 14 && zr == 60) {
      Tprofl = Tprof;
      ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  Pc[j][i] = Pc0[j][i];
	  }
	} 
      zr++;
      goto Start;
    } 
  }

  if (trait == 13 && zr == 56 && prodsys == 3) {
    trait = 14;
    zr = 61;
    }

  /* Trait: fleshiness for bulls */
  if (trait == 14 && zr == 61) {
    trait = 15;
    /* Saving the original values of matrix Pb */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pc0[j][i] = (double)Pb[j][i];
	}
      } 
    /* Frequencies of fleshiness classes summed over fat covering classes 
       and cumulative frequencies */
    for (j = 0; j < p1; j++) {
      Pcfl[j] = Pcfld[j] = 0; 
      for (i = 0; i < p2; i++) {
	Pb[j][i] /= 100;
	Pcfl[j] += Pb[j][i];
      }  
      if (j==0) Pcfld[j] = Pcfl[j];
      if (j>0) Pcfld[j] = Pcfld[j-1] + Pcfl[j]; 
      }
    /* Threshold values for classes of fleshiness */
    for (j = 0; j < p1-1; j++) {
      Pcflqm[j] = probit(Pcfld[j]); 
      } 
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfl[j]; 
      } 
    tvm = Pcflmcb = Pcflmc;
    }

  if (trait == 15 && zr == 61) {
    /* Shifting the distribution to the left */
    for (j = 0; j < p1-1; j++) {
      Pcflql[j] = Pcflqm[j] - 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldl[j] = normdis(Pcflql[j]); 
      } 
    Pcfldl[p1-1] = 1;
    Pcfll[0] = Pcfldl[0];
    for (j = 0; j < p1; j++) {
      Pcfll[j+1] = Pcfldl[j+1] - Pcfldl[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Pb[j][i] = 0;      
	  else Pb[j][i] = Pcfll[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfll[j]; 
      } 
    tvh = Pcflmc;
    zr++;
    goto Start; 
    }

  if (trait == 15 && zr == 62) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < p1-1; j++) {
      Pcflqr[j] = Pcflqm[j] + 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldr[j] = normdis(Pcflqr[j]); 
      } 
    Pcfldr[p1-1] = 1;
    Pcflr[0] = Pcfldr[0];
    for (j = 0; j < p1; j++) {
      Pcflr[j+1] = Pcfldr[j+1] - Pcfldr[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Pb[j][i] = 0;      
	  else Pb[j][i] = Pcflr[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcflr[j]; 
      } 
    tvl = Pcflmc;
    zr++;
    goto Start;
  }

  if (trait == 15 && zr == 63) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    /* Shifting the distribution to the left */
    for (j = 0; j < p1-1; j++) {
      Pcflql[j] = Pcflqm[j] - 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldl[j] = normdis(Pcflql[j]); 
      } 
    Pcfldl[p1-1] = 1;
    Pcfll[0] = Pcfldl[0];
    for (j = 0; j < p1; j++) {
      Pcfll[j+1] = Pcfldl[j+1] - Pcfldl[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Pb[j][i] = 0;      
	  else Pb[j][i] = Pcfll[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfll[j]; 
      } 
    tvh = Pcflmc;
    zr++;
    goto Start; 
    }

  if (trait == 15 && zr == 64) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < p1-1; j++) {
      Pcflqr[j] = Pcflqm[j] + 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldr[j] = normdis(Pcflqr[j]); 
      } 
    Pcfldr[p1-1] = 1;
    Pcflr[0] = Pcfldr[0];
    for (j = 0; j < p1; j++) {
      Pcflr[j+1] = Pcfldr[j+1] - Pcfldr[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Pb[j][i] = 0;      
	  else Pb[j][i] = Pcflr[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcflr[j]; 
      } 
    tvl = Pcflmc;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }

  if (trait == 15 && zr == 65) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pb[j][i] = Pc0[j][i];
	}
      } 
    zr++;
    goto Start;
  } 

  /* Trait: fleshiness for heifers */
  if (trait == 15 && zr == 66) {
    trait = 16;
    /* Saving the original values of matrix Pc */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pc0[j][i] = (double)Ph[j][i];
	}
      } 
    /* Frequencies of fleshiness classes summed over fat covering classes 
       and cumulative frequencies */
    for (j = 0; j < p1; j++) {
      Pcfl[j] = Pcfld[j] = 0; 
      for (i = 0; i < p2; i++) {
	Ph[j][i] /= 100;
	Pcfl[j] += Ph[j][i];
      }  
      if (j==0) Pcfld[j] = Pcfl[j];
      if (j>0) Pcfld[j] = Pcfld[j-1] + Pcfl[j]; 
      }
    /* Threshold values for classes of fleshiness */
    for (j = 0; j < p1-1; j++) {
      Pcflqm[j] = probit(Pcfld[j]); 
      } 
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfl[j]; 
      } 
    tvm = Pcflmch = Pcflmc;
    }

  if (trait == 16 && zr == 66) {
    /* Shifting the distribution to the left */
    for (j = 0; j < p1-1; j++) {
      Pcflql[j] = Pcflqm[j] - 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldl[j] = normdis(Pcflql[j]); 
      } 
    Pcfldl[p1-1] = 1;
    Pcfll[0] = Pcfldl[0];
    for (j = 0; j < p1; j++) {
      Pcfll[j+1] = Pcfldl[j+1] - Pcfldl[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Ph[j][i] = 0;      
	  else Ph[j][i] = Pcfll[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfll[j]; 
      } 
    tvh = Pcflmc;
    zr++;
    goto Start; 
    }

  if (trait == 16 && zr == 67) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < p1-1; j++) {
      Pcflqr[j] = Pcflqm[j] + 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldr[j] = normdis(Pcflqr[j]); 
      } 
    Pcfldr[p1-1] = 1;
    Pcflr[0] = Pcfldr[0];
    for (j = 0; j < p1; j++) {
      Pcflr[j+1] = Pcfldr[j+1] - Pcfldr[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Ph[j][i] = 0;      
	  else Ph[j][i] = Pcflr[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcflr[j]; 
      } 
    tvl = Pcflmc;
    zr++;
    goto Start;
  }

  if (trait == 16 && zr == 68) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    /* Shifting the distribution to the left */
    for (j = 0; j < p1-1; j++) {
      Pcflql[j] = Pcflqm[j] - 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldl[j] = normdis(Pcflql[j]); 
      } 
    Pcfldl[p1-1] = 1;
    Pcfll[0] = Pcfldl[0];
    for (j = 0; j < p1; j++) {
      Pcfll[j+1] = Pcfldl[j+1] - Pcfldl[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Ph[j][i] = 0;      
	  else Ph[j][i] = Pcfll[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfll[j]; 
      } 
    tvh = Pcflmc;
    zr++;
    goto Start; 
    }

  if (trait == 16 && zr == 69) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < p1-1; j++) {
      Pcflqr[j] = Pcflqm[j] + 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldr[j] = normdis(Pcflqr[j]); 
      } 
    Pcfldr[p1-1] = 1;
    Pcflr[0] = Pcfldr[0];
    for (j = 0; j < p1; j++) {
      Pcflr[j+1] = Pcfldr[j+1] - Pcfldr[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Ph[j][i] = 0;      
	  else Ph[j][i] = Pcflr[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcflr[j]; 
      } 
    tvl = Pcflmc;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }

  if (trait == 16 && zr == 70) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Ph[j][i] = Pc0[j][i];
	}
      } 
    zr++;
    goto Start;
  } 

  /* Trait: fleshiness for castrates */
  if (trait == 16 && zr == 71 && pcmf < 0.000001) {
    trait = 18;
    zr = 76;
    }
  if (trait == 16 && zr == 71 && pcmf > 0.000001) {
    trait = 17;
    /* Saving the original values of matrix Pc */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pc0[j][i] = (double)Pcs[j][i];
	}
      } 
    /* Frequencies of fleshiness classes summed over fat covering classes 
       and cumulative frequencies */
    for (j = 0; j < p1; j++) {
      Pcfl[j] = Pcfld[j] = 0; 
      for (i = 0; i < p2; i++) {
	Pcs[j][i] /= 100;
	Pcfl[j] += Pcs[j][i];
      }  
      if (j==0) Pcfld[j] = Pcfl[j];
      if (j>0) Pcfld[j] = Pcfld[j-1] + Pcfl[j]; 
      }
    /* Threshold values for classes of fleshiness */
    for (j = 0; j < p1-1; j++) {
      Pcflqm[j] = probit(Pcfld[j]); 
      } 
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfl[j]; 
      } 
    tvm = Pcflmcca = Pcflmc;
    }

  if (trait == 17 && zr == 71) {
    /* Shifting the distribution to the left */
    for (j = 0; j < p1-1; j++) {
      Pcflql[j] = Pcflqm[j] - 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldl[j] = normdis(Pcflql[j]); 
      } 
    Pcfldl[p1-1] = 1;
    Pcfll[0] = Pcfldl[0];
    for (j = 0; j < p1; j++) {
      Pcfll[j+1] = Pcfldl[j+1] - Pcfldl[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Pcs[j][i] = 0;      
	  else Pcs[j][i] = Pcfll[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfll[j]; 
      } 
    tvh = Pcflmc;
    zr++;
    goto Start; 
    }

  if (trait == 17 && zr == 72) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < p1-1; j++) {
      Pcflqr[j] = Pcflqm[j] + 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldr[j] = normdis(Pcflqr[j]); 
      } 
    Pcfldr[p1-1] = 1;
    Pcflr[0] = Pcfldr[0];
    for (j = 0; j < p1; j++) {
      Pcflr[j+1] = Pcfldr[j+1] - Pcfldr[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Pcs[j][i] = 0;      
	  else Pcs[j][i] = Pcflr[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcflr[j]; 
      } 
    tvl = Pcflmc;
    zr++;
    goto Start;
  }

  if (trait == 17 && zr == 73) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    /* Shifting the distribution to the left */
    for (j = 0; j < p1-1; j++) {
      Pcflql[j] = Pcflqm[j] - 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldl[j] = normdis(Pcflql[j]); 
      } 
    Pcfldl[p1-1] = 1;
    Pcfll[0] = Pcfldl[0];
    for (j = 0; j < p1; j++) {
      Pcfll[j+1] = Pcfldl[j+1] - Pcfldl[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Pcs[j][i] = 0;      
	  else Pcs[j][i] = Pcfll[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcfll[j]; 
      } 
    tvh = Pcflmc;
    zr++;
    goto Start; 
    }

  if (trait == 17 && zr == 74) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < p1-1; j++) {
      Pcflqr[j] = Pcflqm[j] + 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < p1-1; j++) {
      Pcfldr[j] = normdis(Pcflqr[j]); 
      } 
    Pcfldr[p1-1] = 1;
    Pcflr[0] = Pcfldr[0];
    for (j = 0; j < p1; j++) {
      Pcflr[j+1] = Pcfldr[j+1] - Pcfldr[j];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfl[j] == 0) Pcs[j][i] = 0;      
	  else Pcs[j][i] = Pcflr[j]*Pc0[j][i]/Pcfl[j]; 
	}
      }  
    /* Mean class for fleshiness */
    Pcflmc = 0;
    for (j = 0; j < p1; j++) {
      Pcflmc += (j+1)*Pcflr[j]; 
      } 
    tvl = Pcflmc;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }

  if (trait == 17 && zr == 75) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pcs[j][i] = Pc0[j][i];
	}
      } 
    zr++;
    goto Start;
  } 

  /* Trait: fleshiness summed over all categories */
  if (trait == 17 && zr == 76) trait = 18;
  if (trait == 18 && zr == 76) {
    ew[trait] = ew0[trait] = 0;
    for (i = 14; i <= 17; i++) {
      if (i == 17 && pcmf < 0.000001) break;
      ew[trait] += ew[i];     
      ew0[trait] += ew0[i];
      }      
    }

  /* Trait: fat covering for cows */
  if (prodsys <= 2) {
    if (trait == 18 && zr == 76) {
      trait = 19;
      /* Saving the original values of matrix Pc */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  Pc0[j][i] = (double)Pc[j][i];
	  }
	} 
      /* Frequencies of fat covering classes summed over fleshiness classes 
	 and cumulative frequencies */
      for (i = 0; i < p2; i++) {
	Pcfc[i] = Pcfcd[i] = 0; 
	for (j = 0; j < p1; j++) {
	  Pc[j][i] /= 100;
	  Pcfc[i] += Pc[j][i];
	}  
	if (i == 0) Pcfcd[i] = Pcfc[i];
	if (i>0) Pcfcd[i] = Pcfcd[i-1] + Pcfc[i]; 
	}
      /* Threshold values for classes of fat covering */
      for (i = 0; i < p2-1; i++) {
	Pcfcqm[i] = probit(Pcfcd[i]); 
	} 
      /* Mean class for fat covering */
      Pcfcmc = 0;
      for (i = 0; i < p2; i++) {
	Pcfcmc += (i+1)*Pcfc[i]; 
	} 
      tvm = Pcfcmcc = Pcfcmc;
      }
    if (trait == 19 && zr == 76) {
      /* Shifting the distribution to the left */
      for (i = 0; i < p2-1; i++) {
	Pcfcql[i] = Pcfcqm[i] - 0.1; 
	} 
      /* Values of the cumulative normal distribution for the shifted 
         distribution */
      for (i = 0; i < p2-1; i++) {
	Pcfcdl[i] = normdis(Pcfcql[i]); 
	} 
      Pcfcdl[p2-1] = 1;
      Pcfcl[0] = Pcfcdl[0];
      for (i = 0; i < p2; i++) {
	Pcfcl[i+1] = Pcfcdl[i+1] - Pcfcdl[i];
	} 
      /* New matrix Pc for shifted distribution */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (Pcfc[i] == 0) Pc[j][i] = 0;      
	    else Pc[j][i] = Pcfcl[i]*Pc0[j][i]/Pcfc[i]; 
	  }
	}  
      /* Mean class for fat covering */
      Pcfcmc = 0;
      for (i = 0; i < p2; i++) {
	Pcfcmc += (i+1)*Pcfcl[i]; 
	} 
      tvh = Pcfcmc;
      zr++;
      goto Start; 
      }

    if (trait == 19 && zr == 77) {
      Tprofh = Tprof;
      /* Shifting the distribution to the right */
      for (i = 0; i < p2-1; i++) {
	Pcfcqr[i] = Pcfcqm[i] + 0.1; 
	} 
      /* Values of the cumulative normal distribution for the shifted 
         distribution */
      for (i = 0; i < p2-1; i++) {
	Pcfcdr[i] = normdis(Pcfcqr[i]); 
	} 
      Pcfcdr[p2-1] = 1;
      Pcfcr[0] = Pcfcdr[0];
      for (i = 0; i < p2; i++) {
	Pcfcr[i+1] = Pcfcdr[i+1] - Pcfcdr[i];
	} 
      /* New matrix Pc for shifted distribution */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (Pcfc[i] == 0) Pc[j][i] = 0;      
	    else Pc[j][i] = Pcfcr[i]*Pc0[j][i]/Pcfc[i]; 
	  }
	}  
      /* Mean class for fat covering */
      Pcfcmc = 0;
      for (i = 0; i < p2; i++) {
	Pcfcmc += (i+1)*Pcfcr[i]; 
	} 
      tvl = Pcfcmc;
      zr++;
      goto Start;
    }

    if (trait == 19 && zr == 78) {
      Tprofl = Tprof;
      ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      /* Shifting the distribution to the left */
      for (i = 0; i < p2-1; i++) {
	Pcfcql[i] = Pcfcqm[i] - 0.05; 
	} 
      /* Values of the cumulative normal distribution for the shifted 
         distribution */
      for (i = 0; i < p2-1; i++) {
	Pcfcdl[i] = normdis(Pcfcql[i]); 
	} 
      Pcfcdl[p2-1] = 1;
      Pcfcl[0] = Pcfcdl[0];
      for (i = 0; i < p2; i++) {
	Pcfcl[i+1] = Pcfcdl[i+1] - Pcfcdl[i];
	} 
      /* New matrix Pc for shifted distribution */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (Pcfc[i] == 0) Pc[j][i] = 0;      
	    else Pc[j][i] = Pcfcl[i]*Pc0[j][i]/Pcfc[i]; 
	  }
	}  
      /* Mean class for fat covering */
      Pcfcmc = 0;
      for (i = 0; i < p2; i++) {
	Pcfcmc += (i+1)*Pcfcl[i]; 
	} 
      tvh = Pcfcmc;
      zr++;
      goto Start; 
      }

    if (trait == 19 && zr == 79) {
      Tprofh = Tprof;
      /* Shifting the distribution to the right */
      for (i = 0; i < p2-1; i++) {
	Pcfcqr[i] = Pcfcqm[i] + 0.05; 
	} 
      /* Values of the cumulative normal distribution for the shifted 
         distribution */
      for (i = 0; i < p2-1; i++) {
	Pcfcdr[i] = normdis(Pcfcqr[i]); 
	} 
      Pcfcdr[p2-1] = 1;
      Pcfcr[0] = Pcfcdr[0];
      for (i = 0; i < p2; i++) {
	Pcfcr[i+1] = Pcfcdr[i+1] - Pcfcdr[i];
	} 
      /* New matrix Pc for shifted distribution */
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (Pcfc[i] == 0) Pc[j][i] = 0;      
	    else Pc[j][i] = Pcfcr[i]*Pc0[j][i]/Pcfc[i]; 
	  }
	}  
      /* Mean class for fat covering */
      Pcfcmc = 0;
      for (i = 0; i < p2; i++) {
	Pcfcmc += (i+1)*Pcfcr[i]; 
	} 
      tvl = Pcfcmc;
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }

    if (trait == 19 && zr == 80) {
      Tprofl = Tprof;
      ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  Pc[j][i] = Pc0[j][i];
	  }
	} 
      zr++;
      goto Start;
    } 
  }  

  if (trait == 18 && zr == 76 && prodsys == 3) {
    trait = 19;
    zr = 81;
    }

  /* Trait: fat covering for bulls */
  if (trait == 19 && zr == 81) {
    trait = 20;
    /* Saving the original values of matrix Pc */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pc0[j][i] = (double)Pb[j][i];
	}
      } 
    /* Frequencies of fat covering classes summed over fleshiness classes 
       and cumulative frequencies */
    for (i = 0; i < p2; i++) {
      Pcfc[i] = Pcfcd[i] = 0; 
      for (j = 0; j < p1; j++) {
	Pb[j][i] /= 100;
	Pcfc[i] += Pb[j][i];
      }  
      if (i == 0) Pcfcd[i] = Pcfc[i];
      if (i>0) Pcfcd[i] = Pcfcd[i-1] + Pcfc[i]; 
      }
    /* Threshold values for classes of fat covering */
    for (i = 0; i < p2-1; i++) {
      Pcfcqm[i] = probit(Pcfcd[i]); 
      } 
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfc[i]; 
      } 
    tvm = Pcfcmcb = Pcfcmc;
    }
  if (trait == 20 && zr == 81) {
    /* Shifting the distribution to the left */
    for (i = 0; i < p2-1; i++) {
      Pcfcql[i] = Pcfcqm[i] - 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdl[i] = normdis(Pcfcql[i]); 
      } 
    Pcfcdl[p2-1] = 1;
    Pcfcl[0] = Pcfcdl[0];
    for (i = 0; i < p2; i++) {
      Pcfcl[i+1] = Pcfcdl[i+1] - Pcfcdl[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Pb[j][i] = 0;      
	  else Pb[j][i] = Pcfcl[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcl[i]; 
      } 
    tvh = Pcfcmc;
    zr++;
    goto Start; 
    }

  if (trait == 20 && zr == 82) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (i = 0; i < p2-1; i++) {
      Pcfcqr[i] = Pcfcqm[i] + 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdr[i] = normdis(Pcfcqr[i]); 
      } 
    Pcfcdr[p2-1] = 1;
    Pcfcr[0] = Pcfcdr[0];
    for (i = 0; i < p2; i++) {
      Pcfcr[i+1] = Pcfcdr[i+1] - Pcfcdr[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Pb[j][i] = 0;      
	  else Pb[j][i] = Pcfcr[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcr[i]; 
      } 
    tvl = Pcfcmc;
    zr++;
    goto Start;
  }

  if (trait == 20 && zr == 83) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    /* Shifting the distribution to the left */
    for (i = 0; i < p2-1; i++) {
      Pcfcql[i] = Pcfcqm[i] - 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdl[i] = normdis(Pcfcql[i]); 
      } 
    Pcfcdl[p2-1] = 1;
    Pcfcl[0] = Pcfcdl[0];
    for (i = 0; i < p2; i++) {
      Pcfcl[i+1] = Pcfcdl[i+1] - Pcfcdl[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Pb[j][i] = 0;      
	  else Pb[j][i] = Pcfcl[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcl[i]; 
      } 
    tvh = Pcfcmc;
    zr++;
    goto Start; 
    }

  if (trait == 20 && zr == 84) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (i = 0; i < p2-1; i++) {
      Pcfcqr[i] = Pcfcqm[i] + 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdr[i] = normdis(Pcfcqr[i]); 
      } 
    Pcfcdr[p2-1] = 1;
    Pcfcr[0] = Pcfcdr[0];
    for (i = 0; i < p2; i++) {
      Pcfcr[i+1] = Pcfcdr[i+1] - Pcfcdr[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Pb[j][i] = 0;      
	  else Pb[j][i] = Pcfcr[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcr[i]; 
      } 
    tvl = Pcfcmc;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }

  if (trait == 20 && zr == 85) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pb[j][i] = Pc0[j][i];
	}
      } 
    zr++;
    goto Start;
  } 

  /* Trait: fat covering for heifers */
  if (trait == 20 && zr == 86) {
    trait = 21;
    /* Saving the original values of matrix Pc */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pc0[j][i] = (double)Ph[j][i];
	}
      } 
    /* Frequencies of fat covering classes summed over fleshiness classes 
       and cumulative frequencies */
    for (i = 0; i < p2; i++) {
      Pcfc[i] = Pcfcd[i] = 0; 
      for (j = 0; j < p1; j++) {
	Ph[j][i] /= 100;
	Pcfc[i] += Ph[j][i];
      }  
      if (i == 0) Pcfcd[i] = Pcfc[i];
      if (i>0) Pcfcd[i] = Pcfcd[i-1] + Pcfc[i]; 
      }
    /* Threshold values for classes of fat covering */
    for (i = 0; i < p2-1; i++) {
      Pcfcqm[i] = probit(Pcfcd[i]); 
      } 
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfc[i]; 
      } 
    tvm = Pcfcmch = Pcfcmc;
    }
  if (trait == 21 && zr == 86) {
    /* Shifting the distribution to the left */
    for (i = 0; i < p2-1; i++) {
      Pcfcql[i] = Pcfcqm[i] - 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdl[i] = normdis(Pcfcql[i]); 
      } 
    Pcfcdl[p2-1] = 1;
    Pcfcl[0] = Pcfcdl[0];
    for (i = 0; i < p2; i++) {
      Pcfcl[i+1] = Pcfcdl[i+1] - Pcfcdl[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Ph[j][i] = 0;      
	  else Ph[j][i] = Pcfcl[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcl[i]; 
      } 
    tvh = Pcfcmc;
    zr++;
    goto Start; 
    }

  if (trait == 21 && zr == 87) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (i = 0; i < p2-1; i++) {
      Pcfcqr[i] = Pcfcqm[i] + 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdr[i] = normdis(Pcfcqr[i]); 
      } 
    Pcfcdr[p2-1] = 1;
    Pcfcr[0] = Pcfcdr[0];
    for (i = 0; i < p2; i++) {
      Pcfcr[i+1] = Pcfcdr[i+1] - Pcfcdr[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Ph[j][i] = 0;      
	  else Ph[j][i] = Pcfcr[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcr[i]; 
      } 
    tvl = Pcfcmc;
    zr++;
    goto Start;
  }

  if (trait == 21 && zr == 88) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    /* Shifting the distribution to the left */
    for (i = 0; i < p2-1; i++) {
      Pcfcql[i] = Pcfcqm[i] - 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdl[i] = normdis(Pcfcql[i]); 
      } 
    Pcfcdl[p2-1] = 1;
    Pcfcl[0] = Pcfcdl[0];
    for (i = 0; i < p2; i++) {
      Pcfcl[i+1] = Pcfcdl[i+1] - Pcfcdl[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Ph[j][i] = 0;      
	  else Ph[j][i] = Pcfcl[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcl[i]; 
      } 
    tvh = Pcfcmc;
    zr++;
    goto Start; 
    }

  if (trait == 21 && zr == 89) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (i = 0; i < p2-1; i++) {
      Pcfcqr[i] = Pcfcqm[i] + 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdr[i] = normdis(Pcfcqr[i]); 
      } 
    Pcfcdr[p2-1] = 1;
    Pcfcr[0] = Pcfcdr[0];
    for (i = 0; i < p2; i++) {
      Pcfcr[i+1] = Pcfcdr[i+1] - Pcfcdr[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Ph[j][i] = 0;      
	  else Ph[j][i] = Pcfcr[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcr[i]; 
      } 
    tvl = Pcfcmc;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }

  if (trait == 21 && zr == 90) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Ph[j][i] = Pc0[j][i];
	}
      } 
    zr++;
    goto Start;
  } 

  /* Trait: fat covering for castrates */
  if (trait == 21 && zr == 91 && pcmf < 0.000001) {
    trait = 23;
    zr = 96;
    }
  if (trait == 21 && zr == 91 && pcmf > 0.000001) {
    trait = 22;
    /* Saving the original values of matrix Pc */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pc0[j][i] = (double)Pcs[j][i];
	}
      } 
    /* Frequencies of fat covering classes summed over fleshiness classes 
       and cumulative frequencies */
    for (i = 0; i < p2; i++) {
      Pcfc[i] = Pcfcd[i] = 0; 
      for (j = 0; j < p1; j++) {
	Pcs[j][i] /= 100;
	Pcfc[i] += Pcs[j][i];
      }  
      if (i == 0) Pcfcd[i] = Pcfc[i];
      if (i>0) Pcfcd[i] = Pcfcd[i-1] + Pcfc[i]; 
      }
    /* Threshold values for classes of fat covering */
    for (i = 0; i < p2-1; i++) {
      Pcfcqm[i] = probit(Pcfcd[i]); 
      } 
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfc[i]; 
      } 
    tvm = Pcfcmcca = Pcfcmc;
    }
  if (trait == 22 && zr == 91) {
    /* Shifting the distribution to the left */
    for (i = 0; i < p2-1; i++) {
      Pcfcql[i] = Pcfcqm[i] - 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdl[i] = normdis(Pcfcql[i]); 
      } 
    Pcfcdl[p2-1] = 1;
    Pcfcl[0] = Pcfcdl[0];
    for (i = 0; i < p2; i++) {
      Pcfcl[i+1] = Pcfcdl[i+1] - Pcfcdl[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Pcs[j][i] = 0;      
	  else Pcs[j][i] = Pcfcl[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcl[i]; 
      } 
    tvh = Pcfcmc;
    zr++;
    goto Start; 
    }

  if (trait == 22 && zr == 92) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (i = 0; i < p2-1; i++) {
      Pcfcqr[i] = Pcfcqm[i] + 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdr[i] = normdis(Pcfcqr[i]); 
      } 
    Pcfcdr[p2-1] = 1;
    Pcfcr[0] = Pcfcdr[0];
    for (i = 0; i < p2; i++) {
      Pcfcr[i+1] = Pcfcdr[i+1] - Pcfcdr[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Pcs[j][i] = 0;      
	  else Pcs[j][i] = Pcfcr[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcr[i]; 
      } 
    tvl = Pcfcmc;
    zr++;
    goto Start;
  }

  if (trait == 22 && zr == 93) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    /* Shifting the distribution to the left */
    for (i = 0; i < p2-1; i++) {
      Pcfcql[i] = Pcfcqm[i] - 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdl[i] = normdis(Pcfcql[i]); 
      } 
    Pcfcdl[p2-1] = 1;
    Pcfcl[0] = Pcfcdl[0];
    for (i = 0; i < p2; i++) {
      Pcfcl[i+1] = Pcfcdl[i+1] - Pcfcdl[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Pcs[j][i] = 0;      
	  else Pcs[j][i] = Pcfcl[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcl[i]; 
      } 
    tvh = Pcfcmc;
    zr++;
    goto Start; 
    }

  if (trait == 22 && zr == 94) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (i = 0; i < p2-1; i++) {
      Pcfcqr[i] = Pcfcqm[i] + 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (i = 0; i < p2-1; i++) {
      Pcfcdr[i] = normdis(Pcfcqr[i]); 
      } 
    Pcfcdr[p2-1] = 1;
    Pcfcr[0] = Pcfcdr[0];
    for (i = 0; i < p2; i++) {
      Pcfcr[i+1] = Pcfcdr[i+1] - Pcfcdr[i];
      } 
    /* New matrix Pc for shifted distribution */
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (Pcfc[i] == 0) Pcs[j][i] = 0;      
	  else Pcs[j][i] = Pcfcr[i]*Pc0[j][i]/Pcfc[i]; 
	}
      }  
    /* Mean class for fat covering */
    Pcfcmc = 0;
    for (i = 0; i < p2; i++) {
      Pcfcmc += (i+1)*Pcfcr[i]; 
      } 
    tvl = Pcfcmc;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }

  if (trait == 22 && zr == 95) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	Pcs[j][i] = Pc0[j][i];
	}
      } 
    zr++;
    goto Start;
  } 

  /* Trait: fat covering summed over all categories */
  if (trait == 22 && zr == 96) trait = 23;
  if (trait == 23 && zr == 96) {
    ew[trait] = ew0[trait] = 0;
    for (i = 19; i <= 22; i++) {
      if (i == 22 && pcmf < 0.000001) break;
      ew[trait] += ew[i];     
      ew0[trait] += ew0[i];
      }      
    }

  /* Trait: Cow losses */
  if (trait == 23 && zr == 96) {
    trait = 11;
    tvm = losc;
    for (i = 1; i <= LL; i++) {
      zzlosc[i] = pp[19+6*i];
      zzlosc[i+LL] = pp[21+6*i];
      zzlosc[i+2*LL] = np[19+6*i];
      zzlosc[i+3*LL] = np[21+6*i];
      }
    }
  if (trait == 11 && zr == 96) {
    for (i = 1; i <= LL; i++) {
      pp[19+6*i] = 1.01 * zzlosc[i];
      pp[21+6*i] = 1.01 * zzlosc[i+LL];
      np[19+6*i] = 1.01 * zzlosc[i+2*LL];
      np[21+6*i] = 1.01 * zzlosc[i+3*LL];
      }
    zr++;
    goto Start;
    }
  if (trait == 11 && zr == 97) {
    Tprofh = Tprof;
    tvh = losc;
    avh = avelifecy;
    for (i = 1; i <= LL; i++) {
      pp[19+6*i] = 0.99 * zzlosc[i];
      pp[21+6*i] = 0.99 * zzlosc[i+LL];
      np[19+6*i] = 0.99 * zzlosc[i+2*LL];
      np[21+6*i] = 0.99 * zzlosc[i+3*LL];
      }
    zr++;
    goto Start;
  }
  if (trait == 11 && zr == 98) {
    Tprofl = Tprof;
    tvl = losc;
    avl = avelifecy;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    ew0[29] = (Tprofh - Tprofl)/(avh - avl);
    for (i = 1; i <= LL; i++) {
      pp[19+6*i] = 1.005 * zzlosc[i];
      pp[21+6*i] = 1.005 * zzlosc[i+LL];
      np[19+6*i] = 1.005 * zzlosc[i+2*LL];
      np[21+6*i] = 1.005 * zzlosc[i+3*LL];
      }
    zr++;
    goto Start;
  }
  if (trait == 11 && zr == 99) {
    Tprofh = Tprof;
    tvh = losc;
    avh = avelifecy;
    for (i = 1; i <= LL; i++) {
      pp[19+6*i] = 0.995 * zzlosc[i];
      pp[21+6*i] = 0.995 * zzlosc[i+LL];
      np[19+6*i] = 0.995 * zzlosc[i+2*LL];
      np[21+6*i] = 0.995 * zzlosc[i+3*LL];
      }
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }
  if (trait == 11 && zr == 100) {
    Tprofl = Tprof;
    tvl = losc;
    avl = avelifecy;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    ew[29] = (Tprofh - Tprofl)/(avh - avl);
    for (i = 1; i <= LL; i++) {
      pp[19+6*i] = zzlosc[i];
      pp[21+6*i] = zzlosc[i+LL];
      np[19+6*i] = zzlosc[i+2*LL];
      np[21+6*i] = zzlosc[i+3*LL];
      }
    zr++;
    goto Start;
  } 

  /* Trait: calving performance - female calves */
  if (trait == 11 && zr == 101) {
    trait = 24;
    /* Saving the original values of matrix dysff */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	dysff0[j][i] = (double)dysff[j][i];
	}
      } 
    /* Frequencies of calving performance classes summed over lactations 
       and cumulative frequencies */
    for (j = 0; j < DD; j++) {
      dysffl[j] = dysffld[j] = 0; 
      for (i = 0; i < LL; i++) {	    
	dysffl[j] += (double) (dysff[j][i]*l3[i]);
      }  
      if (j==0) dysffld[j] = dysffl[j];
      if (j>0) dysffld[j] = dysffld[j-1] + dysffl[j]; 
      }
    /* Threshold values for classes of calving performance */
    for (j = 0; j < DD-1; j++) {
      dysfflqm[j] = probit(dysffld[j]); 
      } 
    /* Mean class for calving performance */
    dysfflmc = 0;
    for (j = 0; j < DD; j++) {
      dysfflmc += (j+1)*dysffl[j]; 
      } 
    tvm = dysfflmc;
    }

  if (trait == 24 && zr == 101) {
    /* Shifting the distribution to the left */
    for (j = 0; j < DD-1; j++) {
      dysfflql[j] = dysfflqm[j] - 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < DD-1; j++) {
      dysffldl[j] = normdis(dysfflql[j]); 
      } 
    dysffldl[DD-1] = 1;
    for (j = 0; j < DD; j++) {
      } 
    dysffll[0] = dysffldl[0];
    for (j = 0; j < DD - 1; j++) {
      dysffll[j+1] = dysffldl[j+1] - dysffldl[j];
      } 
    /* New matrix dysff for shifted distribution */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	if (dysffl[j] == 0) dysff[j][i] = 0;      
	  else dysff[j][i] = dysffll[j]*dysff0[j][i]/dysffl[j]; 
	}
      }  
    /* Mean class for calving performance */
    dysfflmc = 0;
    for (j = 0; j < DD; j++) {
      dysfflmc += (j+1)*dysffll[j]; 
      } 
    tvh = dysfflmc;
    zr++;
    goto Start; 
    }

  if (trait == 24 && zr == 102) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < DD-1; j++) {
      dysfflqr[j] = dysfflqm[j] + 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < DD-1; j++) {
      dysffldr[j] = normdis(dysfflqr[j]); 
      } 
    dysffldr[DD-1] = 1;
    dysfflr[0] = dysffldr[0];
    for (j = 0; j < DD - 1; j++) {
      dysfflr[j+1] = dysffldr[j+1] - dysffldr[j];
      } 
    /* New matrix dysff for shifted distribution */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	if (dysffl[j] == 0) dysff[j][i] = 0;      
	  else dysff[j][i] = dysfflr[j]*dysff0[j][i]/dysffl[j]; 
	}
      }  
    /* Mean class for calving performance */
    dysfflmc = 0;
    for (j = 0; j < DD; j++) {
      dysfflmc += (j+1)*dysfflr[j]; 
      } 
    tvl = dysfflmc;
    zr++;
    goto Start;
  }

  if (trait == 24 && zr == 103) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    /* Shifting the distribution to the left */
    for (j = 0; j < DD-1; j++) {
      dysfflql[j] = dysfflqm[j] - 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < DD-1; j++) {
      dysffldl[j] = normdis(dysfflql[j]); 
      } 
    dysffldl[DD-1] = 1;
    dysffll[0] = dysffldl[0];
    for (j = 0; j < DD - 1; j++) {
      dysffll[j+1] = dysffldl[j+1] - dysffldl[j];
      } 
    /* New matrix dysff for shifted distribution */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	if (dysffl[j] == 0) dysff[j][i] = 0;      
	  else dysff[j][i] = dysffll[j]*dysff0[j][i]/dysffl[j]; 
	}
      }  
    /* Mean class for calving performance */
    dysfflmc = 0;
    for (j = 0; j < DD; j++) {
      dysfflmc += (j+1)*dysffll[j]; 
      } 
    tvh = dysfflmc;
    zr++;
    goto Start; 
    }


  if (trait == 24 && zr == 104) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < DD-1; j++) {
      dysfflqr[j] = dysfflqm[j] + 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < DD-1; j++) {
      dysffldr[j] = normdis(dysfflqr[j]); 
      } 
    dysffldr[DD-1] = 1;
    dysfflr[0] = dysffldr[0];
    for (j = 0; j < DD - 1; j++) {
      dysfflr[j+1] = dysffldr[j+1] - dysffldr[j];
      } 
    /* New matrix dysff for shifted distribution */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	if (dysffl[j] == 0) dysff[j][i] = 0;      
	  else dysff[j][i] = dysfflr[j]*dysff0[j][i]/dysffl[j]; 
	}
      }  
    /* Mean class for calving performance */
    dysfflmc = 0;
    for (j = 0; j < DD; j++) {
      dysfflmc += (j+1)*dysfflr[j]; 
      } 
    tvl = dysfflmc;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }

  if (trait == 24 && zr == 105) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	dysff[j][i] = dysff0[j][i];
	}
      } 
    zr++;
    goto Start;
  } 

  /* Trait: calving performance - male calves */
  if (trait == 24 && zr == 106) {
    trait = 25;
    /* Saving the original values of matrix dysmm */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	dysmm0[j][i] = (double)dysmm[j][i];
	}
      } 
    /* Frequencies of calving performance classes summed over lactations 
       and cumulative frequencies */
    for (j = 0; j < DD; j++) {
      dysmml[j] = dysmmld[j] = 0; 
      for (i = 0; i < LL; i++) {	    
	dysmml[j] += (double) (dysmm[j][i]*l3[i]);
      }  
      if (j==0) dysmmld[j] = dysmml[j];
      if (j>0) dysmmld[j] = dysmmld[j-1] + dysmml[j]; 
      }
    /* Threshold values for classes of calving performance */
    for (j = 0; j < DD-1; j++) {
      dysmmlqm[j] = probit(dysmmld[j]); 
      } 
    /* Mean class for calving performance */
    dysmmlmc = 0;
    for (j = 0; j < DD; j++) {
      dysmmlmc += (j+1)*dysmml[j]; 
      } 
    tvm = dysmmlmc;
    }

  if (trait == 25 && zr == 106) {
    /* Shifting the distribution to the left */
    for (j = 0; j < DD-1; j++) {
      dysmmlql[j] = dysmmlqm[j] - 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < DD-1; j++) {
      dysmmldl[j] = normdis(dysmmlql[j]); 
      } 
    dysmmldl[DD-1] = 1;
    dysmmll[0] = dysmmldl[0];
    for (j = 0; j < DD - 1; j++) {
      dysmmll[j+1] = dysmmldl[j+1] - dysmmldl[j];
      } 
    /* New matrix dysmm for shifted distribution */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	if (dysmml[j] == 0) dysmm[j][i] = 0;      
	  else dysmm[j][i] = dysmmll[j]*dysmm0[j][i]/dysmml[j]; 
	}
      }  
    /* Mean class for calving performance */
    dysmmlmc = 0;
    for (j = 0; j < DD; j++) {
      dysmmlmc += (j+1)*dysmmll[j]; 
      } 
    tvh = dysmmlmc;
    zr++;
    goto Start; 
    }

  if (trait == 25 && zr == 107) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < DD-1; j++) {
      dysmmlqr[j] = dysmmlqm[j] + 0.1; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < DD-1; j++) {
      dysmmldr[j] = normdis(dysmmlqr[j]); 
      } 
    dysmmldr[DD-1] = 1;
    dysmmlr[0] = dysmmldr[0];
    for (j = 0; j < DD - 1; j++) {
      dysmmlr[j+1] = dysmmldr[j+1] - dysmmldr[j];
      } 
    /* New matrix dysmm for shifted distribution */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	if (dysmml[j] == 0) dysmm[j][i] = 0;      
	  else dysmm[j][i] = dysmmlr[j]*dysmm0[j][i]/dysmml[j]; 
	}
      }  
    /* Mean class for calving performance */
    dysmmlmc = 0;
    for (j = 0; j < DD; j++) {
      dysmmlmc += (j+1)*dysmmlr[j]; 
      } 
    tvl = dysmmlmc;
    zr++;
    goto Start;
  }

  if (trait == 25 && zr == 108) {
    Tprofl = Tprof;
    ew0[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    /* Shifting the distribution to the left */
    for (j = 0; j < DD-1; j++) {
      dysmmlql[j] = dysmmlqm[j] - 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < DD-1; j++) {
      dysmmldl[j] = normdis(dysmmlql[j]); 
      } 
    dysmmldl[DD-1] = 1;
    dysmmll[0] = dysmmldl[0];
    for (j = 0; j < DD - 1; j++) {
      dysmmll[j+1] = dysmmldl[j+1] - dysmmldl[j];
      } 
    /* New matrix dysmm for shifted distribution */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	if (dysmml[j] == 0) dysmm[j][i] = 0;      
	  else dysmm[j][i] = dysmmll[j]*dysmm0[j][i]/dysmml[j]; 
	}
      }  
    /* Mean class for calving performance */
    dysmmlmc = 0;
    for (j = 0; j < DD; j++) {
      dysmmlmc += (j+1)*dysmmll[j]; 
      } 
    tvh = dysmmlmc;
    zr++;
    goto Start; 
    }


  if (trait == 25 && zr == 109) {
    Tprofh = Tprof;
    /* Shifting the distribution to the right */
    for (j = 0; j < DD-1; j++) {
      dysmmlqr[j] = dysmmlqm[j] + 0.05; 
      } 
    /* Values of the cumulative normal distribution for the shifted 
       distribution */
    for (j = 0; j < DD-1; j++) {
      dysmmldr[j] = normdis(dysmmlqr[j]); 
      } 
    dysmmldr[DD-1] = 1;
    dysmmlr[0] = dysmmldr[0];
    for (j = 0; j < DD - 1; j++) {
      dysmmlr[j+1] = dysmmldr[j+1] - dysmmldr[j];
      } 
    /* New matrix dysmm for shifted distribution */
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	if (dysmml[j] == 0) dysmm[j][i] = 0;      
	  else dysmm[j][i] = dysmmlr[j]*dysmm0[j][i]/dysmml[j]; 
	}
      }  
    /* Mean class for calving performance */
    dysmmlmc = 0;
    for (j = 0; j < DD; j++) {
      dysmmlmc += (j+1)*dysmmlr[j]; 
      } 
    tvl = dysmmlmc;
    zr++;
    printf("  Run #%4d\n", zr);
    goto Start;
  }

  if (trait == 25 && zr == 110) {
    Tprofl = Tprof;
    ew[trait] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) {
	dysmm[j][i] = dysmm0[j][i];
	}
      } 
    zr++;
    goto Start;
  } 

  /* Trait: calving performance summed over both sexes */
  if (trait == 25 && zr == 111) trait = 1;
  if (trait == 1 && zr == 111) {
    ew[trait] = ew[24]+ew[25];
    ew0[trait] = ew0[24]+ew0[25];
    zr++;
    }      

  /* Traits: weight at 1st, 2nd and 3rd weighing */  
  if (zr == 112) {
    ew[26] = ew[6]*1000/con_1;
    ew[27] = ew[7]*1000/(con_2-con_1);
    ew[28] = ew[8]*1000/(con_3-con_2);
    ew0[26] = ew0[6]*1000/con_1;
    ew0[27] = ew0[7]*1000/(con_2-con_1);
    ew0[28] = ew0[8]*1000/(con_3-con_2);
    zr++;
    }   
  
  if ((zr > 112 && zr < 118) && rfi_h == 1) {
    /* Trait: dry matter intake of heifers */
    if (zr == 113) {
      trait = 30;
      tvm = rfis[22];
      tvma = rfiw[22];
      rfis[22] = tvh = tvm + 0.1;
      rfiw[22] = tvha = tvma + 0.1;
      zr++;
      goto Start;
      }
    if (trait == 30 && zr == 114) {
      Tprofh = Tprof;
      rfis[22] = tvl = tvm - 0.1;
      rfiw[22] = tvla = tvma - 0.1;
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }
    if (trait == 30 && zr == 115) {
      Tprofl = Tprof;
      ew0[trait] = (Tprofh - Tprofl)/(tvh - tvl);
      tvh = tvm + 0.05;
      tvha = tvma + 0.05;
      tvl = tvm - 0.05;
      tvla = tvma - 0.05;
      rfis[22] = tvh;
      rfiw[22] = tvha;
      zr++;
      goto Start;
    }
    if (trait == 30 && zr == 116) {
      Tprofh = Tprof;
      rfis[22] = tvl;
      rfiw[22] = tvla;
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }
    if (trait == 30 && zr == 117) {
      Tprofl = Tprof;
      ew[trait] = (Tprofh - Tprofl)/(tvh - tvl);
      rfis[22] = tvm;
      rfiw[22] = tvma;
      zr++;
      goto Start;
    }
  }
  if (zr < 118) zr = 118;

  if ((zr > 117 && zr < 123) && rfi_fa == 1) {
    /* Trait: dry matter intake in intensive fattening */
    if (zr == 118) {
      trait = 31;
      tvm =  rfi[14];
      tvma = rfi[12];
      tvmb = rfi[17];
      tvmc = rfit;
      tvmd = rfitb;
      tvme = rfits;
      rfi[14] = tvh = tvm + 0.1;
      rfi[12] = tvha = tvma + 0.1;
      rfi[17] = tvhb = tvmb + 0.1;
      rfit  = tvhc = tvmc + 0.1;
      rfitb = tvhd = tvmd + 0.1;
      rfits = tvhe = tvme + 0.1;
      zr++;
      goto Start;
      }
    if (trait == 31 && zr == 119) {
      Tprofh = Tprof;
      rfi[14] = tvl = tvm - 0.1;
      rfi[12] = tvla = tvma - 0.1;
      rfi[17] = tvlb = tvmb - 0.1;
      rfit  = tvlc = tvmc - 0.1;
      rfitb = tvld = tvmd - 0.1;
      rfits = tvle = tvme - 0.1;      
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }
    if (trait == 31 && zr == 120) {
      Tprofl = Tprof;
      ew0[trait] = (Tprofh - Tprofl)/(tvh - tvl);
      tvh = tvm + 0.05;
      tvha = tvma + 0.05;
      tvhb = tvmb + 0.05;
      tvhc = tvmc + 0.05;
      tvhd = tvmd + 0.05;
      tvhe = tvme + 0.05;
      tvl = tvm - 0.05;
      tvla = tvma - 0.05;
      tvlb = tvmb - 0.05;
      tvlc = tvmc - 0.05;
      tvld = tvmd - 0.05;
      tvle = tvme - 0.05;                        
      rfi[14] = tvh;
      rfi[12] = tvha;
      rfi[17] = tvhb;
      rfit  = tvhc; 
      rfitb = tvhd; 
      rfits = tvhe; 
      zr++;
      goto Start;
    }
    if (trait == 31 && zr == 121) {
      Tprofh = Tprof;
      rfi[14] = tvl;
      rfi[12] = tvla;
      rfi[17] = tvlb;
      rfit  = tvlc; 
      rfitb = tvld; 
      rfits = tvle; 
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }
    if (trait == 31 && zr == 122) {
      Tprofl = Tprof;
      ew[trait] = (Tprofh - Tprofl)/(tvh - tvl);
      rfi[14] = tvm;
      rfi[12] = tvma;
      rfi[17] = tvmb;
      rfit  = tvmc;
      rfitb = tvmd;
      rfits = tvme;
      zr++;
      goto Start;
    }
  }
  if (zr < 123) zr = 123;

  if ((zr > 122 && zr < 128) && rfi_fx == 1) {
    /* Trait: dry matter intake in extensive fattening */
    if (zr == 123) {
      trait = 32;
      tvm =  rfisf;
      tvma = rfisc;
      tvmb = rfis[12];
      tvmc = rfit;
      tvmd = rfiw[12] ;
      tvme = rfiw[17];
      rfisf = tvh = tvm + 0.1;
      rfisc = tvha = tvma + 0.1;
      rfis[12] = tvhb = tvmb + 0.1;
      rfis[17] = tvhc = tvmc + 0.1;
      rfiw[12] = tvhd = tvmd + 0.1;
      rfiw[17] = tvhe = tvme + 0.1;
      zr++;
      goto Start;
      }
    if (trait == 32 && zr == 124) {
      Tprofh = Tprof;
      rfisf = tvl = tvm - 0.1;
      rfisc = tvla = tvma - 0.1;
      rfis[12] = tvlb = tvmb - 0.1;
      rfis[17] = tvlc = tvmc - 0.1;
      rfiw[12] = tvld = tvmd - 0.1;
      rfiw[17] = tvle = tvme - 0.1;      
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }
    if (trait == 32 && zr == 125) {
      Tprofl = Tprof;
      ew0[trait] = (Tprofh - Tprofl)/(tvh - tvl);
      tvh = tvm + 0.05;
      tvha = tvma + 0.05;
      tvhb = tvmb + 0.05;
      tvhc = tvmc + 0.05;
      tvhd = tvmd + 0.05;
      tvhe = tvme + 0.05;
      tvl = tvm - 0.05;
      tvla = tvma - 0.05;
      tvlb = tvmb - 0.05;
      tvlc = tvmc - 0.05;
      tvld = tvmd - 0.05;
      tvle = tvme - 0.05;                        
      rfisf = tvh;
      rfisc = tvha;
      rfis[12] = tvhb;
      rfis[17] = tvhc; 
      rfiw[12] = tvhd; 
      rfiw[17] = tvhe; 
      zr++;
      goto Start;
    }
    if (trait == 32 && zr == 126) {
      Tprofh = Tprof;
      rfisf = tvl;
      rfisc = tvla;
      rfis[12] = tvlb;
      rfis[17] = tvlc; 
      rfiw[12] = tvld; 
      rfiw[17] = tvle; 
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }
    if (trait == 32 && zr == 127) {
      Tprofl = Tprof;
      ew[trait] = (Tprofh - Tprofl)/(tvh - tvl);
      rfisf = tvm;
      rfisc = tvma;
      rfis[12] = tvmb;
      rfis[17] = tvmc;
      rfiw[12] = tvmd;
      rfiw[17] = tvme;
      zr++;
      goto Start;
    }
  }
  if (zr < 128) zr = 128;

  if ((zr > 127 && zr < 133) && rfi_cow == 1) {
    /* Trait: dry matter intake of adult animals */
    if (zr == 128) {
      trait = 33;
      tvm =  rfis[25];
      tvma = rfis[10];
      tvmb = rfiw[25];
      tvmc = rfiw[10];
      rfis[25] = tvh = tvm + 0.1;
      rfis[10] = tvha = tvma + 0.1;
      rfiw[25] = tvhb = tvmb + 0.1;
      rfis[17] = tvhc = tvmc + 0.1;
      zr++;
      goto Start;
      }
    if (trait == 33 && zr == 129) {
      Tprofh = Tprof;
      rfis[25] = tvl = tvm - 0.1;
      rfis[10] = tvla = tvma - 0.1;
      rfiw[25] = tvlb = tvmb - 0.1;
      rfis[17] = tvlc = tvmc - 0.1;
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }
    if (trait == 33 && zr == 130) {
      Tprofl = Tprof;
      ew0[trait] = (Tprofh - Tprofl)/(tvh - tvl);
      tvh = tvm + 0.05;
      tvha = tvma + 0.05;
      tvhb = tvmb + 0.05;
      tvhc = tvmc + 0.05;
      tvl = tvm - 0.05;
      tvla = tvma - 0.05;
      tvlb = tvmb - 0.05;
      tvlc = tvmc - 0.05;
      rfis[25] = tvh;
      rfis[10] = tvha;
      rfiw[25] = tvhb;
      rfis[17] = tvhc; 
      zr++;
      goto Start;
    }
    if (trait == 33 && zr == 131) {
      Tprofh = Tprof;
      rfis[25] = tvl;
      rfis[10] = tvla;
      rfiw[25] = tvlb;
      rfis[17] = tvlc; 
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
    }
    if (trait == 33 && zr == 132) {
      Tprofl = Tprof;
      ew[trait] = (Tprofh - Tprofl)/(tvh - tvl);
      rfis[25] = tvm;
      rfis[10] = tvma;
      rfiw[25] = tvmb;
      rfis[17] = tvmc;
      zr++;
      goto Start;
    }
  }
  if (zr < 133) zr = 133;

  if (zr == 133) {
    for (i = 1; i < NT; i++) ewdiff[i] = 0;  
    for (i = 1; i < NT; i++) {
      if (fabs(ew[i]) > 0.000001) ewdiff[i] = 100*(ew0[i]-ew[i])/ew[i];
     }
   }
     
End_EW: /* End of calculation of economic values */ 

  /* Calculation of economic weights for direct and maternal traits */
  if (zr == 133) {
    for (i = 1; i < NT; i++) {
      if (i == 14) i = 18;
      if (i == 19) i = 23;
      if (i == 24) i = 26;
      if (tt[i] == 0 || tt[i] == 2) ew_d[i] = NDEd * ew[i];
      if (tt[i] > 0) ew_m[i] = NDEm * ew[i];
    }  
  }

  /* Relative economic weights */
  if (zr == 133) {
    if (gstd == 2) {
      ewsum_d = ewsum_m = 0;
      for (i = 1; i < NT; i++) {
	if (delta_d[i] == 1) {
	  ewst_d[i] = ew_d[i] * gstd_d[i];
	  ewsum_d += fabs(ewst_d[i]);  
	  }  
	if (delta_m[i] == 1) {
	  ewst_m[i] = ew_m[i] * gstd_m[i];  
	  ewsum_m += fabs(ewst_m[i]);
	  }  
	}  
      ewsum = ewsum_d + ewsum_m;
      for (i = 1; i < NT; i++) {
	if (delta_d[i] == 1) { 
	  ewr_dd[i] = 100 * fabs(ewst_d[i]) / ewsum_d;
	  ewr_da[i] = 100 * fabs(ewst_d[i]) / ewsum;
	}  
	if (delta_m[i] == 1 && ewsum_m > 0.000001) { 
	  ewr_mm[i] = 100 * fabs(ewst_m[i]) / ewsum_m;
	  ewr_ma[i] = 100 * fabs(ewst_m[i]) / ewsum;
	}  
      }  
    }

    /* Relative marginal economic values for pure-bred dairy cattle */
    if (gstd == 3) {
      ewsum = 0;
      for (i = 1; i < NT; i++) {
	if (to[i] == 2) {
	  ewst_d[i] = ew[i] * gstd_d[i];
	  ewsum += fabs(ewst_d[i]);  
	}  
      }  
      for (i = 1; i < NT; i++) {
	if (to[i] == 2) 
	  ewr_dd[i] = 100 * fabs(ewst_d[i]) / ewsum;
      }  
    }
  }   

  /* Calculation of further derived values for output */
  if (zr == 133) {
  /* Calculation of further variables for economic analyses */
  /* Cost per cow and year in the cow herds (include cows and replacement heifers,
     without additional costs for calves till weaning) corrected for revenues
     from yearly culled cows and heifers */
    costcowy = 0;
    for (i = 1; i <= CC; i++) {  
      if (i == 4) i = 7;
      if (i == 8) i = 18;
      if (i == 23) i = 25;
      costcowy += l1[i]*(cost[i] - rev[i]);
      }
      costcowy +=costdys;
  /* Cost in the cow herd per weaned calf and per kg live weight of weaned
     calves*/
    costcw = costcowy/(Nmcw+Nfcw-Nfrp);
    costcwf = costcw + cost[8];
    costcwm = costcw + cost[9];
    costcwfkg = costcwf/wwf;
    costcwmkg = costcwm/wwm;   
  /* Average cost in fattening per slaughtered bull, heifer or castrate
     (that were reaching the given slaughter weight, without costs for purchased 
     weaned calf for fattening) */
    if (l1[14]>0.000001) {
      costfatb =(cost[14]*l1[14]+cost[4]*l1[4]+(cost[15]-rev[15])*l1[15])/
	l1[14]-cost[9];
        costfatbkg = costfatb/(wbfat*dresb);    
      }
    if (l1[12]>0.000001) {
      costfath =(cost[12]*l1[12]+cost[6]*l1[6]+(cost[13]-rev[13])*l1[13])/
	l1[12]-cost[8];
      if (feedlot == 1) costfathkg = costfath/(whfat*dresh);
      if (feedlot == 2) costfathkg = costfath/(whxfat*dresh);
      }
    if (l1[17]>0.000001) {     
      costfatc =(cost[17]*l1[17]+cost[5]*l1[5]+(cost[16]-rev[16])*l1[16])/
	l1[17]-cost[9];
      if (feedlot == 1) costfatckg = costfatc/(wcfat*dresc);
      if (feedlot == 2) costfatckg = costfatc/(wcxfat*dresc); 
      }
  /* Average cost per breeding heifers (before mating and pregnant) sold to other
     systems and per kg live weight of these heifers*/
    if (l1[23]>0.000001) {     
      costhnpr = cost[23] + costcw;
      costhnprkg = costhnpr/wnphse;
      }
    if (l1[24]>0.000001) {     
      costhpr = cost[24] + costcw;
      costhprkg = costhpr/(wphse + wpreg/2.0); 
      }
  } /* End of Part 19 */
  
  /* Writing results to results file */
  if (zr == 133) { printf("Writing results to output file\n");
  
    /* 3 Results, 3.1 Structure of the cow herd */
    for (i = 1; i <=5; i++) outputrw(fr2, fw);
    fprintf(fw, "\nNumber of iterations: %d", k);
    for (i = 1; i <=4; i++) outputrw(fr2, fw);         

    /* 3.1.1 Printing vector l2 to output file */
    fprintf(fw, "\n  Category %3d: %8.4f\n", 25, l2[1]);
    for (i = 2; i <= TT; i++) { 
      fprintf(fw, "  Category %3d: %8.4f\n", i+24, l2[i]);
      }

    /* 3.1.2 */  
    for (i = 1; i <=2; i++) outputrw(fr2, fw);  
    aa1 = l4[0];  
    fprintf(fw, "\nReproductive cycle %2d: %8.4f\n", 1, l4[0]);             
    for (i = 1; i < LL; i++) { 
      fprintf(fw, "Reproductive cycle %2d: %8.4f\n", i+1, l4[i]);
      aa1 += l4[i];
      }
    fprintf(fw, "Sum: %8.4f\n", aa1);
    outputrw(fr2, fw);  
    fprintf(fw, "%8.2f", avelifecy);
    outputrw(fr2, fw);  
    fprintf(fw, "%8.2f\n", avelifecc);

    /* 3.2 Reproduction characteristics of the herd */
    for (i = 1; i <=3; i++) outputrw(fr2, fw);  
    fprintf(fw, "%8.2f\n", crh1mp);
    outputrw(fr2, fw);  
    fprintf(fw, "\n  Reproductive cycle %2d: %8.4f\n", 1, crcmp[0]);             
    for (i = 1; i < LL-1; i++) { 
      fprintf(fw, "  Reproductive cycle %2d: %8.4f\n", i+1, crcmp[i]);    
      }
    outputrw(fr2, fw);
    dfdsjf(fw, (int)(davcal+.5));
    fprintf(fw," (days from January 1st: %d))", (int)(davcal+.5));
    outputrw(fr2, fw);
    dfdsjf(fw, (int)(davmat+.5));
    fprintf(fw," (days from January 1st: %d)", (int)(davmat+.5));
    outputrw(fr2, fw);
    fprintf(fw, "%d", (int)(intcmc+.5));        
    outputrw(fr2, fw);
    fprintf(fw, "%7.4f\n", dysav);        

    /* 3.3 Growth ... reproductive cycles 1 to 3 */ 
    for (i = 1; i <=4; i++) outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f", wcacal[0], wcacal[1], wcacal[2]);        
    outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f", wcc[0], wcc[1], wcc[2]);
    outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f", wcd[0], wcd[1], wcd[2]);
    outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f\n", wccw[0], wccw[1], wccw[2]);

    /* 3.4. Characteristics of progeny */
    /* 3.4.1. Structure of the progeny */
    for (i = 1; i <=5; i++) outputrw(fr2, fw);    
    fprintf(fw, "\n  Category %2d: %8.4f\n", 1, l1[1]);
    for (i = 2; i <= 24; i++) { 
      fprintf(fw, "  Category %2d: %8.4f\n", i, l1[i]);
      }
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Ncal);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", suml1);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nfcba);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nmcba);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nfc48a);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nmc48a);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", losfw); 
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", losmw);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nfcw);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nmcw);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nmcf);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nmcfc);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nmcfb);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nfmat);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nfrp);
    outputrw(fr2, fw);
    if (prodsys <= 2) fprintf(fw, "%6.3f", Nfav);
    if (prodsys == 3) fprintf(fw, "%6.3f", Nfcw);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", l1[8]);
    outputrw(fr2, fw);
    fprintf(fw, "%6.3f", Nffa);
    if (prodsys <= 2) {
      outputrw(fr2, fw);
      fprintf(fw, "%6.3f", l1[23]);
      outputrw(fr2, fw);
      fprintf(fw, "%6.3f", l1[24]);
    }
    else for (i = 1; i <= 2; i++) outputr(fr2);

    /* 3.4.2 Growth characteristics for calves */
    for (i = 1; i <=4; i++) outputrw(fr2, fw);        
    fprintf(fw, "%7.3f", adgcon1f);
    outputrw(fr2, fw);        
    fprintf(fw, "%7.3f", adgcon1m);
    outputrw(fr2, fw);        
    fprintf(fw, "%7.3f", adgcon2f);
    outputrw(fr2, fw);        
    fprintf(fw, "%7.3f", adgcon2m);
    outputrw(fr2, fw);        
    fprintf(fw, "%7.3f", adgcon3f);
    outputrw(fr2, fw);        
    fprintf(fw, "%7.3f", adgcon3m);
    outputrw(fr2, fw);        
    fprintf(fw, "%6.0f", agew);
    outputrw(fr2, fw);        
    fprintf(fw, "%6.0f", agedcw);
    outputrw(fr2, fw);        
    fprintf(fw, "%6.1f", wwf);
    outputrw(fr2, fw);        
    fprintf(fw, "%6.1f", wwm);
    outputrw(fr2, fw);        
    fprintf(fw, "%6.1f", wdcwf);
    outputrw(fr2, fw);        
    fprintf(fw, "%6.1f", wdcwm);

    /* 3.4.3 Reproduction and growth of replacement heifers */
    if (l1[22] > 0.000001) {
      for (i = 1; i <=4; i++) outputrw(fr2, fw);        
      fprintf(fw, "%7.3f", phmat1);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.3f", phmat2);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.3f", crhmp);
      outputrw(fr2, fw);        
      fprintf(fw, "\n  %7.3f %7.3f %7.3f", php1, php2, php3);
      outputrw(fr2, fw);        
      fprintf(fw, "\n  %7.0f %7.0f %7.0f", agehmat1, agehmat2, agehmat3);
      outputrw(fr2, fw);        
      fprintf(fw, "\n  %7.1f %7.1f %7.1f", whmat1, whmat2, whmat3);
      outputrw(fr2, fw);        
      fprintf(fw, "\n  %7.0f %7.0f %7.0f", ageh1cal, ageh2cal, ageh3cal);
      outputrw(fr2, fw);        
      fprintf(fw, "\n  %7.1f %7.1f %7.1f", wh1cal, wh2cal, wh3cal);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agehmat);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", whmat);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agecal);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", whcal);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agehcmat);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", whcmat);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agedmh);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", whdmh);
      }
    else for (i = 1; i <= 19; i++) outputr(fr2);
    if (l1[23] > 0.000001) {  
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wnphse);
      }
    else outputr(fr2);
    if (l1[24] > 0.000001) {       
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wphse);
      }
    else outputr(fr2);

    /* 3.4.4 Feedlot of progeny */
    if (l1[12]>0 || l1[14]>0 || l1[17]>0) {
      for (i = 1; i <=3; i++) outputrw(fr2, fw);
      }
      else {
        for (i = 1; i <=3; i++) outputr(fr2);
	}
    if (l1[12]>0) {
      outputrw(fr2, fw); 
      fprintf(fw, "%7.0f", agesf);
      }
      else outputr(fr2);  
    if (l1[14]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agesm);
      }
      else outputr(fr2);  
    if (l1[17]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agesc);
      }
      else outputr(fr2);  
    if (l1[12]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agedwsf);
      }
      else outputr(fr2);  
    if (l1[12]>0) { 
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wdwsf);
      }
      else outputr(fr2);  
    if (l1[14]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agedwsm);
      }
      else outputr(fr2);  
    if (l1[14]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wdwsm);
      }
      else outputr(fr2);  
    if (l1[17]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agedwsc);
      }
      else outputr(fr2);  
    if (l1[17]>0) { 
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wdwsc);
      }
      else outputr(fr2);  
    if (l1[12]>0) { 
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agecwsf);
      }
      else outputr(fr2);  
    if (l1[12]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wcwsf);
      }
      else outputr(fr2);  
    if (l1[14]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agecwsm);
      }
      else outputr(fr2);  
    if (l1[14]>0) { 
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wcwsm);
      }
      else outputr(fr2);  
    if (l1[17]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agecwsc);
      }
      else outputr(fr2);  
    if (l1[17]>0) {
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wcwsc);
      }
      else outputr(fr2);  

    /* 3.4.5 Rearing of breeding bulls - only for production system 1*/ 
    if (prodsys == 1) {
      for (i = 1; i <=4; i++) outputrw(fr2, fw);        
      fprintf(fw, "%7.0f", agebbst);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wbbst); 
      outputrw(fr2, fw);
      fprintf(fw, "%7.0f", agebbt);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wbbt); 
      outputrw(fr2, fw);
      fprintf(fw, "%7.0f", agebbse);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.1f", wbbse);
      outputrw(fr2, fw);        
      fprintf(fw, "%7.3f", adgtm);
      }
    if (prodsys > 1) {
      for (i = 1; i <=10; i++) outputr(fr2);              
    }

    /* 3.5 Nutrition costs */
    /*3.5.1. Calves died from 48 hours after calving till weaning 
             (category 3)*/
    for (i = 1; i <=7; i++) outputrw(fr2, fw);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", d[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", sl[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", wl[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", nesl[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", newl[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", nes[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", new[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", ne[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", pdisl[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", pdiwl[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", pdis[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", pdiw[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", pdi[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", atdrys[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.3f", addrys[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", atdryw[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.3f", addryw[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", fs[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", fw0[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", costfs[3]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", costfw[3]);

    /* 3.5.2. Fattened bulls (categories 4, 15 and 14) */
    if (l1[4] > 0.000001 || l1[14] > 0.000001 || l1[15] > 0.000001) { 
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "\n %8.1f %8.1f %8.1f", d[4], d[15], d[14]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %8.1f %8.1f %8.1f", ne[4], ne[15], ne[14]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %8.0f %8.0f %8.0f", pdi[4], pdi[15], pdi[14]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %8.1f %8.1f %8.1f", costwt[4], costwt[15], costwt[14]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %10.1f %10.1f %10.1f", atdry[4], atdry[15], atdry[14]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %10.3f %10.3f %10.3f", addry[4], addry[15], addry[14]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %8.1f %8.1f %8.1f", f[4], f[15], f[14]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %8.0f %8.0f %8.0f", costff[4], costff[15], costff[14]);
      }
    else {
      for (i = 1; i <= 10; i++) outputr(fr2);
      }  

    /* 3.5.3. Fattened castrates (categories 5, 16 and 17) */
    if (l1[5] > 0.000001 || l1[16] > 0.000001 || l1[17] > 0.000001) {
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "\n %9.1f %9.1f %9.1f", d[5], d[16], d[17]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %9.1f %9.1f %9.1f", costwt[5], costwt[16], costwt[17]);
      if (feedlot == 1) { 
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", ne[5], ne[16], ne[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", pdi[5], pdi[16], pdi[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.1f %10.1f %10.1f", atdry[5], atdry[16], atdry[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.3f %10.3f %10.3f", addry[5], addry[16], addry[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", f[5], f[16], f[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", costff[5], costff[16], costff[17]);
	for (i = 1; i<= 19; i++) outputr(fr2);  
	} 
      if (feedlot == 2) {
	for (i = 1; i<= 6; i++) outputr(fr2);  
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", new[5], new[16], new[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", nes[5], nes[16], nes[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n         -         - %9.1f", neas[17]);		
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", pdiw[5], pdiw[16], pdiw[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", pdis[5], pdis[16], pdis[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n         -         - %9.0f", pdias[17]);		
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.1f %10.1f %10.1f", 
	  atdryw[5], atdryw[16], atdryw[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.3f %10.3f %10.3f", 
	  addryw[5], addryw[16], addryw[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.1f %10.1f %10.1f", 
	  atdrys[5], atdrys[16], atdrys[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.3f %10.3f %10.3f", 
	  addrys[5], addrys[16], addrys[17]);  
	outputrw(fr2, fw);
	fprintf(fw, "\n          -          - %10.1f", atdryfas[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n          -          - %10.3f", addryfas[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", fs[5], fs[16], fs[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", fw0[5], fw0[16], fw0[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n         -         - %9.1f", fas[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", costfw[5], costfw[16], costfw[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", costfs[5], costfs[16], costfs[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n         -         - %9.0f", costfas[17]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", costm[5], costm[16], costm[17]);
	}
      }
    else {
      for (i = 1; i <= 29; i++) outputr(fr2);
      }  

    /* 3.5.4. Fattened heifers (categories 6, 13 and 12) */
    if (l1[6] > 0.000001 || l1[12] > 0.000001 || l1[13] > 0.000001) { 
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "\n %9.1f %9.1f %9.1f", d[6], d[13], d[12]);
      outputrw(fr2, fw);
      fprintf(fw, "\n %9.1f %9.1f %9.1f", costwt[6], costwt[13], costwt[12]);
      if (feedlot == 1) {
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", ne[6], ne[13], ne[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", pdi[6], pdi[13], pdi[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.1f %10.1f %10.1f", atdry[6], atdry[13], atdry[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.3f %10.3f %10.3f", addry[6], addry[13], addry[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", f[6], f[13], f[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", costff[6], costff[13], costff[12]);
	for (i =1; i<= 19; i++) outputr(fr2);  
	}
      if (feedlot == 2) {
	for (i = 1; i<= 6; i++) outputr(fr2);  
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", new[6], new[13], new[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", nes[6], nes[13], nes[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n         -         - %9.1f", neas[12]);		
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", pdiw[6], pdiw[13], pdiw[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.0f %9.0f %9.0f", pdis[6], pdis[13], pdis[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n         -         - %9.0f", pdias[12]);		
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.1f %10.1f %10.1f", 
	  atdryw[6], atdryw[13], atdryw[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.3f %10.3f %10.3f", 
	  addryw[6], addryw[13], addryw[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.1f %10.1f %10.1f", 
	  atdrys[6], atdrys[13], atdrys[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %10.3f %10.3f %10.3f", 
	  addrys[6], addrys[13], addrys[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n          -          - %10.1f", atdryfas[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n          -          - %10.3f", addryfas[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", fw0[5], fw0[16], fw0[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", fs[5], fs[16], fs[12]);	
	outputrw(fr2, fw);
	fprintf(fw, "\n         -         - %9.1f", fas[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", costfw[6], costfw[13], costfw[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", costfs[6], costfs[13], costfs[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n         -         - %9.1f", costfas[12]);
	outputrw(fr2, fw);
	fprintf(fw, "\n %9.1f %9.1f %9.1f", costm[6], costm[13], costm[12]);
	}
      }
    else {
      for (i = 1; i <= 29; i++) outputr(fr2);
      }  
      	
    /* 3.5.5. Heifers for replacement died between weaning and calving 
             (category 7) */
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    fprintf(fw, "%7.1f", d[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", nes[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", new[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", ne[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", pdis[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", pdiw[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", pdi[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", atdrys[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.3f", addrys[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", atdryw[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.3f", addryw[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", fs[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", fw0[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", costfs[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.1f", costfw[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", costm[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%7.1f", costwt[7]);

    /*3.5.6. Female (category 8 - first number) and male 
             (category 9 - second number) calves sold at 
	     weaning for export */
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", d[8], d[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", sl[8], sl[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", wl[8], wl[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", nesl[8], nesl[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", newl[8], newl[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", nes[8], nes[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", new[8], new[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", ne[8], ne[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f", pdisl[8], pdisl[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f", pdiwl[8], pdiwl[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f", pdis[8], pdis[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f", pdiw[8], pdiw[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f", pdi[8], pdi[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %10.1f %10.1f", atdrys[8], atdrys[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %10.3f %10.3f", addrys[8], addrys[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %10.1f %10.1f", atdryw[8], atdryw[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %10.3f %10.3f", addryw[8], addryw[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", fs[8], fs[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", fw0[8], fw0[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", costfs[8], costfs[9]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f", costfw[8], costfw[9]);

    /*3.5.7. Male calves tested on stations, selected as breeding bulls 
             and sold to the herd for natural mating or to AI stations 
	     (category 10)*/  
    if (prodsys == 1) {
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%7.3f", adgwt);
      outputrw(fr2, fw);
      fprintf(fw, "%7.3f", adgtm);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", nebt);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", net);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", netse);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pditb);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdit);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pditse);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdrytb);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addrytb);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdryt);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addryt);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdrytse);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addrytse);
      outputrw(fr2, fw);
      fprintf(fw, "%7.1f", ftb);
      outputrw(fr2, fw);
      fprintf(fw, "%7.1f", ft);
      outputrw(fr2, fw);
      fprintf(fw, "%7.1f", fts);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", costftb);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", costft);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", costftse);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", costwt[10]);
      }
    if (prodsys != 1) {
      for (i = 1; i<= 23; i++) outputr(fr2);
      }

    /* 3.5.8. Bulls in the herds used for natural mating 
              (from purchase to culling) */
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    fprintf(fw, "%9.0f", nebbs);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", nebbw);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", pdibbs);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", pdibbw);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", atdrybbs);
    outputrw(fr2, fw);
    fprintf(fw, "%10.3f", addrybbs);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", atdrybbw);
    outputrw(fr2, fw);
    fprintf(fw, "%10.3f", addrybbw);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", fbbs);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", fbbw);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", costfbbs);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", costfbbw);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", costmbb);
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", costwtbb);

    /* 3.5.9. Male calves tested on stations, negatively selected after 
              the test and slaughtered (category 11) */      
    if (l1[11] > 0.000001) {  
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%7.1f", d[11]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", nebt);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", net);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pditb);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdit);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdrytb);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addrytb);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdryt);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addryt);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", costftb);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", costft);
      outputrw(fr2, fw);
      fprintf(fw, "%7.1f", costwt[11]);
      }
    else {
      for (i = 1; i <= 14; i++) outputr(fr2);
      }  

    /* 3.5.10. Replacement heifers negatively selected before first mating 
               and slaughtered (category 18) */
    if (l1[18] > 0.000001) {	      
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%7.1f", d[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", nes[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", new[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", ne[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdis[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdiw[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdrys[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addrys[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdryw[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addryw[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", fs[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", fw0[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costfs[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costfw[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%7.1f", costm[18]);
      outputrw(fr2, fw);
      fprintf(fw, "%7.1f", costwt[18]);
      }
    else {
      for (i = 1; i <= 19; i++) outputr(fr2);
      }  

    /* 3.5.11. Replacement heifers slaughtered after mating because of 
               no pregnancy (category 19) */   
    if (l1[19] > 0.000001) {	       
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%7.1f", d[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", nes[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", new[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", ne[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdis[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdiw[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdrys[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addrys[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdryw[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addryw[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", fs[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", fw0[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costfs[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costfw[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costm[19]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[19]);
      }
    else {
      for (i = 1; i <= 19; i++) outputr(fr2);
      }  

    /* 3.5.12. Purchased female replacement (category 20) */
    if (Nfrp > Nfcw || prodsys == 3) {
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%7.1f", d[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.1f", nepc[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdipc[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", nes[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", new[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", ne[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdis[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdiw[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdrys[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addrys[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdryw[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addryw[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", fs[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", fw0[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costfs[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costfw[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%7.1f", costm[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%7.1f", costwt[20]);        
      }
    if (prodsys <= 2 && Nfrp < Nfcw) {
      for (i =1; i<= 21; i++) outputr(fr2);
      }

    /*3.5.13. Replacement heifers entering the first reproductive cycle 
              (category 22) */
    if (l1[22] > 0.000001) {	      
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%7.1f", d[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", nepc[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdipc[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", nes[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", new[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", ne[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdis[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdiw[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdrys[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addrys[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.1f", atdryw[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", addryw[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", fs[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", fw0[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", costfs[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", costfw[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costm[22]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[22]);
      }
    else {
      for (i = 1; i <= 21; i++) outputr(fr2);
      }  

    /*3.5.14. Breeding heifers sold before mating (category 23) and breeding
    heifers sold pregnant (category 24), respectively*/
    if (l1[23] > 0.000001 || l1[24] > 0.000001) {    
      for (i = 1; i<= 3; i++) outputrw(fr2, fw);
      print23(l1[23], l1[24], d[23], d[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], nes[23], nes[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], new[23], new[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], ne[23], ne[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], pdis[23], pdis[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], pdiw[23], pdiw[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], pdi[23], pdi[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], atdrys[23], atdrys[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], addrys[23], addrys[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], atdryw[23], atdryw[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], addryw[23], addryw[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], fs[23], fs[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], fw0[23], fw0[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], costfs[23], costfs[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], costfw[23], costfw[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], costm[23], costm[24], fw);
      outputrw(fr2, fw);
      print23(l1[23], l1[24], costwt[23], costwt[24], fw);
      }
    else {
      for (i = 1; i <= 19; i++) outputr(fr2);
      }  

    /* 3.5.15. Cows on reproductive cycle 1 */
    for (i = 1; i<= 5; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      d[25], d[26], d[27], d[28], d[29], d[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      nes[25], nes[26], nes[27], nes[28], nes[29], nes[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      new[25], new[26], new[27], new[28], new[29], new[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      ne[25], ne[26], ne[27], ne[28], ne[29], ne[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdis[25], pdis[26], pdis[27], pdis[28], pdis[29], pdis[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdiw[25], pdiw[26], pdiw[27], pdiw[28], pdiw[29], pdiw[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdi[25], pdi[26], pdi[27], pdi[28], pdi[29], pdi[30]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      atdrys[25], atdrys[26], atdrys[27], atdrys[28], atdrys[29], atdrys[30]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f", 
      addrys[25], addrys[26], addrys[27], addrys[28], addrys[29], addrys[30]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      atdryw[25], atdryw[26], atdryw[27], atdryw[28], atdryw[29], atdryw[30]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f", 
      addryw[25], addryw[26], addryw[27], addryw[28], addryw[29], addryw[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      fs[25], fs[26], fs[27], fs[28], fs[29], fs[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      fw0[25], fw0[26], fw0[27], fw0[28], fw0[29], fw0[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costfs[25], costfs[26], costfs[27], costfs[28], costfs[29], costfs[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costfw[25], costfw[26], costfw[27], costfw[28], costfw[29], costfw[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costm[25], costm[26], costm[27], costm[28], costm[29], costm[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costwt[25], costwt[26], costwt[27], costwt[28], costwt[29], costwt[30]);

    /*3.5.16. Cows on reproductive cycle 2 */ 
    for (i = 1; i<= 5; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      d[31], d[32], d[33], d[34], d[35], d[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      nes[31], nes[32], nes[33], nes[34], nes[35], nes[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      new[31], new[32], new[33], new[34], new[35], new[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      ne[31], ne[32], ne[33], ne[34], ne[35], ne[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdis[31], pdis[32], pdis[33], pdis[34], pdis[35], pdis[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdiw[31], pdiw[32], pdiw[33], pdiw[34], pdiw[35], pdiw[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdi[31], pdi[32], pdi[33], pdi[34], pdi[35], pdi[36]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      atdrys[31], atdrys[32], atdrys[33], atdrys[34], atdrys[35], atdrys[36]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f", 
      addrys[31], addrys[32], addrys[33], addrys[34], addrys[35], addrys[36]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      atdryw[31], atdryw[32], atdryw[33], atdryw[34], atdryw[35], atdryw[36]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f", 
      addryw[31], addryw[32], addryw[33], addryw[34], addryw[35], addryw[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      fs[31], fs[32], fs[33], fs[34], fs[35], fs[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      fw0[31], fw0[32], fw0[33], fw0[34], fw0[35], fw0[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costfs[31], costfs[32], costfs[33], costfs[34], costfs[35], costfs[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costfw[31], costfw[32], costfw[33], costfw[34], costfw[35], costfw[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costm[31], costm[32], costm[33], costm[34], costm[35], costm[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costwt[31], costwt[32], costwt[33], costwt[34], costwt[35], costwt[36]);

    /* 3.5.17. Cows on reproductive cycle 3 */ 
    for (i = 1; i<= 5; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      d[37], d[38], d[39], d[40], d[41], d[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      nes[37], nes[38], nes[39], nes[40], nes[41], nes[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      new[37], new[38], new[39], new[40], new[41], new[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      ne[37], ne[38], ne[39], ne[40], ne[41], ne[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdis[37], pdis[38], pdis[39], pdis[40], pdis[41], pdis[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdiw[37], pdiw[38], pdiw[39], pdiw[40], pdiw[41], pdiw[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f %9.0f", 
      pdi[37], pdi[38], pdi[39], pdi[40], pdi[41], pdi[42]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      atdrys[37], atdrys[38], atdrys[39], atdrys[40], atdrys[41], atdrys[42]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f", 
      addrys[37], addrys[38], addrys[39], addrys[40], addrys[41], addrys[42]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      atdryw[37], atdryw[38], atdryw[39], atdryw[40], atdryw[41], atdryw[42]);
    outputrw(fr2, fw);  
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f", 
      addryw[37], addryw[38], addryw[39], addryw[40], addryw[41], addryw[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      fs[37], fs[38], fs[39], fs[40], fs[41], fs[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      fw0[37], fw0[38], fw0[39], fw0[40], fw0[41], fw0[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costfs[37], costfs[38], costfs[39], costfs[40], costfs[41], costfs[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costfw[37], costfw[38], costfw[39], costfw[40], costfw[41], costfw[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costm[37], costm[38], costm[39], costm[40], costm[41], costm[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f %9.1f", 
      costwt[37], costwt[38], costwt[39], costwt[40], costwt[41], costwt[42]);

    /* 3.5.18. Cows on reproductive cycles 4 to LL */
    for (i =1; i<= 3; i++) outputrw(fr2, fw);

    /* 3.5.19. Total costs for nutrition (sum of the feed, water and mineral
               costs) for progeny of categories 1 to 24 */
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    if (l1[1] > 0.000001) fprintf(fw, "\n  Category %2d: %9.1f\n", 1, costf[1]);
    for (i = 2; i <= 24; i++) { 
      if (l1[i] > 0.000001) fprintf(fw, "  Category %2d: %9.1f\n", i, costf[i]);
      }

    /* 3.5.20. Total costs for nutrition (sum of the feed, water and mineral 
               costs) for cows on reproductive cycle 1 (categories 25 to 30)*/
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    if (l1[25] > 0.000001) fprintf(fw, "\n  Category %2d: %9.1f\n", 25, costf[25]);
      else  fprintf(fw, "\n"); 
    for (i = 26; i <= 30; i++) { 
      if (l1[i] > 0.000001) fprintf(fw, "  Category %2d: %9.1f\n", i, costf[i]);
      }

    /* 3.5.21. Total costs for nutrition (sum of the feed, water and mineral 
               costs) for cows on reproductive cycle 2 (categories 31 to 36)*/
    for (i = 1; i<= 2; i++) outputrw(fr2, fw);
    if (l1[31] > 0.000001) fprintf(fw, "\n  Category %2d: %9.1f\n", 31, costf[31]);
      else  fprintf(fw, "\n"); 
    for (i = 32; i <= 36; i++) { 
      if (l1[i] > 0.000001) fprintf(fw, "  Category %2d: %9.1f\n", i, costf[i]);
      }

    /* 3.5.22. Total costs for nutrition (sum of the feed, water and mineral
               costs) for cows on reproductive cycle 3 (categories 38 to 42)*/
    for (i = 1; i<= 2; i++) outputrw(fr2, fw);
    if (l1[37] > 0.000001) fprintf(fw, "\n  Category %2d: %9.1f\n", 37, costf[37]);
      else  fprintf(fw, "\n"); 
    for (i = 38; i <= 42; i++) { 
      if (l1[i] > 0.000001) fprintf(fw, "  Category %2d: %9.1f\n", i, costf[i]);
      }

    /* 3.5.23. Total costs for nutrition (sum of the feed, water and mineral 
               costs) for cows on reproductive cycle 4 to LL */ 
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    
    /* 3.5.24. Miscellaneous */
    outputrw(fr2, fw);
    /* fprintf(fw, "%8.3f", pasture); */
    if (Pcfcmcb > 0.000001) {
      outputrw(fr2, fw);
      fprintf(fw, "%8.3f", Pcfcmcb);
      }
    else outputr(fr2);    
    if (Pcfcmcc > 0.000001) {      
      outputrw(fr2, fw);
      fprintf(fw, "%8.3f", Pcfcmcc);
      }
    else outputr(fr2);    
    if (pcmf > 0.000001) {
      outputrw(fr2, fw);
      fprintf(fw, "%8.3f", Pcfcmcca);
      }
    else outputr(fr2);    
    if (Pcfcmch > 0.000001) {
      outputrw(fr2, fw);
      fprintf(fw, "%8.3f", Pcfcmch);
      }
    else outputr(fr2);    
    if (Pcflmcb > 0.000001) {      
      outputrw(fr2, fw);
      fprintf(fw, "%8.3f", Pcflmcb);
      }
    else outputr(fr2);    
    if (Pcflmcc > 0.000001) {      
      outputrw(fr2, fw);
      fprintf(fw, "%8.3f", Pcflmcc);
      }
    else outputr(fr2);    
    if (pcmf > 0.000001) {
      outputrw(fr2, fw);
      fprintf(fw, "%8.3f", Pcflmcca);
      }
    else outputr(fr2);          
    if (Pcflmch > 0.000001) {
      outputrw(fr2, fw);
      fprintf(fw, "%8.3f", Pcflmch);
      }
    else outputr(fr2);    
    outputrw(fr2, fw);
    fprintf(fw, "%8.3f", dysscoreav);
         
    /* 3.6. Other costs and total cost per animal in each category */
    for (i = 1; i <= 6; i++) outputrw(fr2, fw);
    for (i = 4; i <= CC; i++)  
      if (l1[i] > 0.000001) 
        fprintf(fw, "\n  Category %3d %10.1f %9.1f %9.1f %9.1f %9.1f %9.1f", i,
	costvet[i], costh[i], costo[i], costfix[i], costf[i], cost[i]);
    outputrw(fr2, fw);
    fprintf(fw, "\n               %10.1f %9.1f %9.1f %9.1f %9.1f %9.1f",
      costvetc, costhc, costoc, costfixc, costfc, costc);    	
    for (i = 1; i<= 2; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %15.1f %10.1f %10.1f %10.1f", costvbbt, costhbb, fixcbbt, costbb);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costimc);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costimh);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costdysc);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costdys);
    
    /* 3.7. Several costs expressed in a different way */
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    fprintf(fw, "%10.0f", costcowy);
    outputrw(fr2, fw);
    fprintf(fw, "%10.0f", costcw);
    outputrw(fr2, fw);
    fprintf(fw, "%10.0f", costcwf);
    outputrw(fr2, fw);
    fprintf(fw, "%10.2f", costcwfkg);
    outputrw(fr2, fw);
    fprintf(fw, "%10.0f", costcwm);
    outputrw(fr2, fw);
    fprintf(fw, "%10.2f", costcwmkg);
    if (l1[14]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.0f", costfatb);
	}
    if (l1[12]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.0f", costfath);
	}
    if (l1[17]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.0f", costfatc);
        }
    if (l1[14]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.2f", costfatbkg);
	}
    if (l1[12]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.2f", costfathkg);
	}
    if (l1[17]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.2f", costfatckg);
        }
    if (l1[23]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.0f", costhnpr);
	}
    if (l1[24]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.0f", costhpr);
        }
    if (l1[23]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.2f", costhnprkg);
	}
    if (l1[24]<0.000001) outputr(fr2);
      else {outputrw(fr2, fw);
        fprintf(fw, "%10.2f", costhprkg);
        }
	

    /* 3.8. Revenues */
    for (i = 1; i<= 4; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %5.1f %10.1f %10.1f %8.1f", pr[12], pr[14], pr[17], pr[29]);
    outputrw(fr2, fw);
    for (i = 1; i <= CC; i++)  
      if (l1[i] > 0.000001) fprintf(fw, "\n  Category %3d %15.1f", i, rev[i]);

    /* 3.9. Number of discounted expressions for revenues and costs */
    for (i = 1; i<= 2; i++) outputrw(fr2, fw);
    for (i = 1; i <= CC; i++)  
      if (l1[i] > 0.000001)
        fprintf(fw, "\n  Category %2d %15.5f %15.5f", i, NDEr[i], NDEc[i]); 
    outputrw(fr2, fw);
    fprintf(fw, "%8.3f", NDEdys);
    outputrw(fr2, fw);
    fprintf(fw, "%8.3f", NDEd);
    outputrw(fr2, fw);
    fprintf(fw, "%8.3f", NDEm);

    /* 3.10. Profit */
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    fprintf(fw, "%10.1f", Trev);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", dot);      
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", Tcost);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", Tprof);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", profitab);     
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", profitabd);     

    /* 3.11. Marginal economic  values */
    outputrw(fr2, fw);
    for (i = 1; i < NT; i++) {
      if (to[i] > 0) {      
	if (to[i] == 2) {
          outputrw(fr2, fw);
          fprintf(fw, "%9.3f", ew[i]);
        }
	else outputr(fr2);
      }
    }
    /* 3.12. Economic weights */      
    outputrw(fr2, fw);
    for (i = 1; i < NT; i++) {
      if (to[i] > 0) {      
	if (to[i] == 2) {
          if (fabs(ew_d[i]) < 0.000001 && fabs(ew_m[i]) < 0.000001)
	    outputr(fr2);  	    
	  else {
	    outputrw(fr2, fw);
            if (tt[i] == 0)
              fprintf(fw, "\n%12.4f         -", ew_d[i]);
	    if (tt[i] == 1) 
              fprintf(fw, "\n      -      %12.4f", ew_m[i]);
	    if (tt[i] == 2) {
	      if (fabs(ew_d[i]) > 0.000001 && fabs(ew_m[i]) > 0.000001)	    
                fprintf(fw, "\n%12.4f %12.4f", ew_d[i], ew_m[i]);      
	      if (fabs(ew_d[i]) > 0.000001 && fabs(ew_m[i]) < 0.000001)	    
	        fprintf(fw, "\n%12.4f         -", ew_d[i]);
      	      if (fabs(ew_d[i]) < 0.000001 && fabs(ew_m[i]) > 0.000001)
	      	fprintf(fw, "\n      -      %12.4f", ew_m[i]);
	    }  
          }
	}
	else outputr(fr2);
      }
    }

    /* 3.13. Relative economic weights */
    if (gstd == 2) {
      outputrw(fr2, fw);
      for (i = 1; i < NT; i++) {
        if (to[i] > 0) {
	  if (to[i] == 1) outputr(fr2);
	  else {
	    outputrw(fr2, fw);
	    if (tt[i] == 2 && prodsys != 3) 
              fprintf(fw, "                                      %10.3f       %10.3f\n",
		 ewr_dd[i], ewr_mm[i]);
	    if (tt[i] == 0  || (tt[i] == 2 && prodsys == 3)) 
              fprintf(fw, "                                      %10.3f             -\n",
		 ewr_dd[i]);
	    if (tt[i] == 1) 
              fprintf(fw, "                                            -          %10.3f\n",
		 ewr_mm[i]);
	  }
	}
      }
    if (prodsys != 3) {
      outputrw(fr2, fw);
      outputr(fr2);
      }
    if (prodsys == 3) {
        outputr(fr2);
	outputrw(fr2, fw);
      }      
    }  
    else for (i = 1; i <= 26; i++) outputr(fr2);
    
    if (gstd == 2 && prodsys != 3) {
      outputrw(fr2, fw);
      for (i = 1; i < NT; i++) {
        if (to[i] > 0) {
	  if (to[i] == 1) outputr(fr2);
	  else {
	    outputrw(fr2, fw);
	    if (tt[i] == 2) 
              fprintf(fw, "                                      %10.3f       %10.3f\n",
		 ewr_da[i], ewr_ma[i]);
	    if (tt[i] == 0) 
              fprintf(fw, "                                      %10.3f             -\n",
		 ewr_da[i]);
	    if (tt[i] == 1) 
              fprintf(fw, "                                            -          %10.3f\n",
		 ewr_ma[i]);
	  }
	}
      }
    outputrw(fr2, fw);
    fprintf(fw, "                                   %10.3f       %10.3f",
        100 * ewsum_d / ewsum, 100 * ewsum_m / ewsum);
    outputrw(fr2, fw);
    }  
    else for (i = 1; i <= 26; i++) outputr(fr2);

    /* 3.13. Relative marginal economic weights */
    if (gstd == 3) {
      outputrw(fr2, fw);
      for (i = 1; i < NT; i++) {
        if (to[i] > 0) {
	  if (to[i] == 1) outputr(fr2);
	  else {
	    outputrw(fr2, fw);
	    fprintf(fw, "                                        %7.3f",
	      ewr_dd[i]);
	  }
	}
      }
    outputrw(fr2, fw);                    
    }  
    else for (i = 1; i <= 25; i++) outputr(fr2);
      
    outputrw(fr2,fw);
    fclose(fw);
    fclose(fr2);
    zr++;
    }

  /* Printabc: Printing data to CHECK for checking the calulation */
  if (zr == 134) {
    fw2 = fopen("CHECK", "w");
    fprintf(fw2, "a2 = %12.4f\n", a2);
    fprintf(fw2, "a3 = %12.4f\n", a3);
    fprintf(fw2, "a4 = %12.4f\n", a4);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(ab[i])>.000001) fprintf(fw2, "ab[%d] = %14.4f\n", i, ab[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "acd = %d\n", acd);
    fprintf(fw2, "acs = %d\n", acs);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(addry[i])>.000001) 
        fprintf(fw2, "addry[%d] = %14.4f\n", i, addry[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "addrybbs = %10.4f\n", addrybbs);
    fprintf(fw2, "addrybbw = %10.4f\n", addrybbw);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(addryfas[i])>.000001) 
        fprintf(fw2, "addryfas[%d] = %14.4f\n", i, addryfas[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(addrys[i])>.000001) 
        fprintf(fw2, "addrys[%d] = %14.4f\n", i, addrys[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "addryt = %10.4f\n", addryt);
    fprintf(fw2, "addrytb = %10.4f\n", addrytb);
    fprintf(fw2, "addrytse = %10.4f\n", addrytse);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(addryw[i])>.000001) 
        fprintf(fw2, "addryw[%d] = %14.4f\n", i, addryw[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(adg[i])>.000001) fprintf(fw2, "adg[%d] = %14.4f\n", i, adg[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "adgbbt = %12.4f\n", adgbbt);
    fprintf(fw2, "adgcon1f = %12.4f\n", adgcon1f);
    fprintf(fw2, "adgcon1m = %12.4f\n", adgcon1m);
    fprintf(fw2, "adgcon2f = %12.4f\n", adgcon2f);
    fprintf(fw2, "adgcon2m = %12.4f\n", adgcon2m);
    fprintf(fw2, "adgcon3f = %12.4f\n", adgcon3f);
    fprintf(fw2, "adgcon3m = %12.4f\n", adgcon3m);
    fprintf(fw2, "adgfrep = %12.4f\n", adgfrep);
    fprintf(fw2, "adgh1s = %12.4f\n", adgh1s);
    fprintf(fw2, "adgh2s = %12.4f\n", adgh2s);
    fprintf(fw2, "adgh2w = %12.4f\n", adgh2w);
    fprintf(fw2, "adgh3s = %12.4f\n", adgh3s);
    fprintf(fw2, "adgh3w = %12.4f\n", adgh3w);
    fprintf(fw2, "adgh4w = %12.4f\n", adgh4w);
    fprintf(fw2, "adghcal = %12.4f\n", adghcal);
    fprintf(fw2, "adgtm = %12.4f\n", adgtm);
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(adgs0[i])>.000001) fprintf(fw2, "adgs0[%d] = %14.4f\n", i, adgs0[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(adgs1[i])>.000001) fprintf(fw2, "adgs1[%d] = %14.4f\n", i, adgs1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(adgs2[i])>.000001) fprintf(fw2, "adgs2[%d] = %14.4f\n", i, adgs2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(adgs3[i])>.000001) fprintf(fw2, "adgs3[%d] = %14.4f\n", i, adgs3[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "adgst = %12.4f\n", adgst);
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(adgw[i])>.000001) fprintf(fw2, "adgw[%d] = %14.4f\n", i, adgw[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(adgw1[i])>.000001) fprintf(fw2, "adgw1[%d] = %14.4f\n", i, adgw1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(adgw2[i])>.000001) fprintf(fw2, "adgw2[%d] = %14.4f\n", i, adgw2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(adgw3[i])>.000001) fprintf(fw2, "adgw3[%d] = %14.4f\n", i, adgw3[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "adgw4 = %12.4f\n", adgw4);
    if (pcmf > 0.000001) fprintf(fw2, "adgwsc = %12.4f\n", adgwsc);
    fprintf(fw2, "adgwsf = %12.4f\n", adgwsf);
    fprintf(fw2, "adgwsm = %12.4f\n", adgwsm);
    fprintf(fw2, "adgwt = %12.4f\n", adgwt);
    fprintf(fw2, "agebbcull = %12.4f\n", agebbcull);
    fprintf(fw2, "agebbm = %12.4f\n", agebbm);
    fprintf(fw2, "agebbse = %12.4f\n", agebbse);
    fprintf(fw2, "agebbst = %12.4f\n", agebbst);
    fprintf(fw2, "agebbt = %12.4f\n", agebbt);
    fprintf(fw2, "agecal = %12.4f\n", agecal);
    if (pcmf > 0.000001) fprintf(fw2, "agecwsc = %12.4f\n", agecwsc);
    fprintf(fw2, "agecwsf = %12.4f\n", agecwsf);
    fprintf(fw2, "agecwsm = %12.4f\n", agecwsm);
    fprintf(fw2, "agedcw = %12.4f\n", agedcw);
    fprintf(fw2, "agedmh = %12.4f\n", agedmh);
    if (pcmf > 0.000001) fprintf(fw2, "agedwsc = %12.4f\n", agedwsc);
    fprintf(fw2, "agedwsf = %12.4f\n", agedwsf);
    fprintf(fw2, "agedwsm = %12.4f\n", agedwsm);
    fprintf(fw2, "agefrep = %12.4f\n", agefrep);
    fprintf(fw2, "ageh1cal = %12.4f\n", ageh1cal);
    fprintf(fw2, "ageh2cal = %12.4f\n", ageh2cal);
    fprintf(fw2, "ageh3cal = %12.4f\n", ageh3cal);    
    fprintf(fw2, "agehcmat = %12.4f\n", agehcmat);
    fprintf(fw2, "agehcmat1 = %12.4f\n", agehcmat1);
    fprintf(fw2, "agehcmat2 = %12.4f\n", agehcmat2);
    fprintf(fw2, "agehcmat3 = %12.4f\n", agehcmat3);
    fprintf(fw2, "agehmat = %12.4f\n", agehmat);
    fprintf(fw2, "agehmat1 = %12.4f\n", agehmat1);
    fprintf(fw2, "agehmat2 = %12.4f\n", agehmat2);
    fprintf(fw2, "agehmat3 = %12.4f\n", agehmat3);
    if (pcmf > 0.000001) fprintf(fw2, "agesc = %12.4f\n", agesc);
    fprintf(fw2, "agesf = %12.4f\n", agesf);
    fprintf(fw2, "agesm = %12.4f\n", agesm);
    fprintf(fw2, "agew = %12.4f\n", agew);
    fprintf(fw2, "aic = %12.4f\n", aic);
    fprintf(fw2, "aih = %12.4f\n", aih);
    fprintf(fw2, "aihc = %12.4f\n", aihc);
    fprintf(fw2, "am = %12.4f\n", am);
    fprintf(fw2, "anphse = %12.4f\n", anphse);
    fprintf(fw2, "anphse1 = %12.4f\n", anphse1);
    fprintf(fw2, "anphse2 = %12.4f\n", anphse2);
    fprintf(fw2, "aphse = %12.4f\n", aphse);
    fprintf(fw2, "aphse1 = %12.4f\n", aphse1);
    fprintf(fw2, "aphse2 = %12.4f\n", aphse2);
    fprintf(fw2, "\n"); 
    for (i=1; i<=CC; i++) {
      if (fabs(atdry[i])>.000001) 
        fprintf(fw2, "atdry[%d] = %14.4f\n", i, atdry[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "atdrybbs = %10.4f\n", atdrybbs);
    fprintf(fw2, "atdrybbw = %10.4f\n", atdrybbw);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(atdryfas[i])>.000001) 
        fprintf(fw2, "atdryfas[%d] = %14.4f\n", i, atdryfas[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(atdrys[i])>.000001) 
        fprintf(fw2, "atdrys[%d] = %14.4f\n", i, atdrys[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "atdryt = %10.4f\n", atdryt);
    fprintf(fw2, "atdrytb = %10.4f\n", atdrytb);
    fprintf(fw2, "atdrytse = %10.4f\n", atdrytse);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(atdryw[i])>.000001) 
        fprintf(fw2, "atdryw[%d] = %14.4f\n", i, atdryw[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "avelifecc = %12.4f\n", avelifecc);
    fprintf(fw2, "avelifecy = %12.4f\n", avelifecy);
    fprintf(fw2, "\n");
    fprintf(fw2, "b2 = %12.4f\n", b2);
    fprintf(fw2, "b3 = %12.4f\n", b3);
    fprintf(fw2, "b4 = %12.4f\n", b4);
    fprintf(fw2, "bm = %12.4f\n", bm);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(bw[i])>.000001) fprintf(fw2, "bw[%d] = %14.4f\n", i, bw[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "bwf = %12.4f\n", bwf);
    fprintf(fw2, "bwm = %12.4f\n", bwm);
    fprintf(fw2, "\n");
    fprintf(fw2, "c2 = %12.4f\n", c2);
    fprintf(fw2, "c3 = %12.4f\n", c3);
    fprintf(fw2, "c4 = %12.4f\n", c4);
    fprintf(fw2, "calfloss = %12.4f\n", calfloss);
    fprintf(fw2, "CC = %d\n", CC);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(cculcm[i])>.000001) fprintf(fw2, "cculcm[%d] = %14.4f\n", i,
      cculcm[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(cculmc[i])>.000001) fprintf(fw2, "cculmc[%d] = %14.4f\n", i,
      cculmc[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(clcm[i])>.000001) fprintf(fw2, "clcm[%d] = %14.4f\n", i, clcm[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(clmc[i])>.000001) fprintf(fw2, "clmc[%d] = %14.4f\n", i, clmc[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "cm = %12.4f\n", cm);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(cmat[i])>.000001) fprintf(fw2, "cmat[%d] = %14.4f\n", i, cmat[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "cmd = %12.4f\n", cmd);
    fprintf(fw2, "con_1 = %12.4f\n", con_1);
    fprintf(fw2, "con_2 = %12.4f\n", con_2);
    fprintf(fw2, "con_3 = %12.4f\n", con_3);
    fprintf(fw2, "conh1 = %12.4f\n", conh1);
    fprintf(fw2, "conh2 = %12.4f\n", conh2);
    fprintf(fw2, "conh3 = %12.4f\n", conh3);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(cost[i])>.000001) fprintf(fw2, "cost[%d] = %14.4f\n", i, cost[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "costbb = %12.4f\n", costbb);
    fprintf(fw2, "costc = %12.2f\n", costc);
    fprintf(fw2, "costcowy = %12.4f\n", costcowy);
    fprintf(fw2, "costcw = %12.4f\n", costcw);
    fprintf(fw2, "costcwf = %12.4f\n", costcwf);
    fprintf(fw2, "costcwm = %12.4f\n", costcwm);  
    fprintf(fw2, "costcwfkg = %12.4f\n", costcwfkg);
    fprintf(fw2, "costcwmkg = %12.4f\n", costcwmkg);
    fprintf(fw2, "costdc = %12.4f\n", costdc);
    fprintf(fw2, "costdf = %12.4f\n", costdf);
    fprintf(fw2, "costdys = %12.4f\n", costdys);
    fprintf(fw2, "costdysc = %12.4f\n", costdysc);
    fprintf(fw2, "\n");        
    for (i=1; i<=CC; i++) {
      if (fabs(costf[i])>.000001) fprintf(fw2, "costf[%d] = %14.4f\n", i, costf[i]);
      }
    fprintf(fw2, "\n");        
    for (i=1; i<=CC; i++) {
      if (fabs(costfas[i])>.000001) fprintf(fw2, "costfas[%d] = %14.4f\n", i, costfas[i]);
      }
    fprintf(fw2, "\n");        
    if (l1[14]) fprintf(fw2, "costfatb = %12.4f\n", costfatb);  
    if (l1[14]) fprintf(fw2, "costfatbkg = %12.4f\n", costfatbkg);  
    if (l1[17]) fprintf(fw2, "costfatc = %12.4f\n", costfatc);  
    if (l1[17]) fprintf(fw2, "costfatckg = %12.4f\n", costfatckg);  
    if (l1[12]) fprintf(fw2, "costfath = %12.4f\n", costfath);  
    if (l1[12]) fprintf(fw2, "costfathkg = %12.4f\n", costfathkg);      
    fprintf(fw2, "costfbb = %12.4f\n", costfbb);
    fprintf(fw2, "costfbbs = %12.4f\n", costfbbs);
    fprintf(fw2, "costfbbw = %12.4f\n", costfbbw);
    fprintf(fw2, "costfc = %12.2f\n", costfc);
    fprintf(fw2, "\n");        
    for (i=1; i<=CC; i++) {
      if (fabs(costff[i])>.000001) fprintf(fw2, "costff[%d] = %14.4f\n", i, costff[i]);
      }
    fprintf(fw2, "\n");        
    for (i=1; i<=CC; i++) {
      if (fabs(costfix[i])>.000001) fprintf(fw2, "costfix[%d] = %14.4f\n", i, costfix[i]);
      }
    fprintf(fw2, "\n");            
    fprintf(fw2, "costfixc = %12.2f\n", costfixc);
    fprintf(fw2, "\n");            
    for (i=1; i<=CC; i++) {
      if (fabs(costfs[i])>.000001) fprintf(fw2, "costfs[%d] = %14.4f\n", i, costfs[i]);
      }
    fprintf(fw2, "\n");            
    fprintf(fw2, "costft = %12.4f\n", costft);
    fprintf(fw2, "costftb = %12.4f\n", costftb);
    fprintf(fw2, "costftse = %12.4f\n", costftse);
    fprintf(fw2, "\n");            
    for (i=1; i<=CC; i++) {
      if (fabs(costfw[i])>.000001) fprintf(fw2, "costfw[%d] = %14.4f\n", i, costfw[i]);
      }
    fprintf(fw2, "\n");            
    for (i=1; i<=CC; i++) {
      if (fabs(costh[i])>.000001) fprintf(fw2, "costh[%d] = %14.4f\n", i, costh[i]);
      }
    fprintf(fw2, "\n");            
    fprintf(fw2, "costhbb = %12.4f\n", costhbb);
    fprintf(fw2, "costhc = %12.2f\n", costhc);
    if (l1[23]) fprintf(fw2, "costhnpr = %12.4f\n", costhnpr);      
    if (l1[23]) fprintf(fw2, "costhnprkg = %12.4f\n", costhnprkg);      
    if (l1[24]) fprintf(fw2, "costhpr = %12.4f\n", costhpr); 
    if (l1[24]) fprintf(fw2, "costhprkg = %12.4f\n", costhprkg);          
    fprintf(fw2, "costi = %12.4f\n", costi);
    fprintf(fw2, "costimc = %12.4f\n", costimc);
    fprintf(fw2, "costimh = %12.4f\n", costimh);
    fprintf(fw2, "costlab = %12.4f\n", costlab);
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(costm[i])>.000001) fprintf(fw2, "costm[%d] = %14.4f\n", i, costm[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "costmbb = %12.4f\n", costmbb);
    fprintf(fw2, "\n");            
    for (i=1; i<=CC; i++) {
      if (fabs(costo[i])>.000001) fprintf(fw2, "costo[%d] = %14.4f\n", i, costo[i]);
      }
    fprintf(fw2, "\n");                
    fprintf(fw2, "costoc = %12.2f\n", costoc);
    fprintf(fw2, "\n");                
    for (i=1; i<=CC; i++) {
      if (fabs(costv[i])>.000001) fprintf(fw2, "costv[%d] = %14.4f\n", i, costv[i]);
      }
    fprintf(fw2, "\n");                
    fprintf(fw2, "costvbb = %12.4f\n", costvbb);
    fprintf(fw2, "costvbbt = %12.4f\n", costvbbt);
    fprintf(fw2, "\n");                
    for (i=1; i<=CC; i++) {
      if (fabs(costvet[i])>.000001) fprintf(fw2, "costvet[%d] = %14.4f\n", i, costvet[i]);
      }
    fprintf(fw2, "\n");                
    fprintf(fw2, "costvetc = %12.2f\n", costvetc);    
    fprintf(fw2, "costvfi = %12.4f\n", costvfi);
    fprintf(fw2, "costvfx = %12.4f\n", costvfx);
    fprintf(fw2, "\n");        
    for (i=1; i<=GG; i++) {
      if (fabs(costwt[i])>.000001) fprintf(fw2, "costwt[%d] = %14.4f\n", i, costwt[i]);
      }
    fprintf(fw2, "\n");                
    fprintf(fw2, "costwtbb = %12.4f\n", costwtbb);
    fprintf(fw2, "cowb = %12.4f\n", cowb);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(cp[i])>.000001) fprintf(fw2, "cp[%d] = %14.4f\n", i, cp[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(cp2nm[i])>.000001) fprintf(fw2, "cp2nm[%d] = %14.4f\n", i, cp2nm[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(cp3nm[i])>.000001) fprintf(fw2, "cp3nm[%d] = %14.4f\n", i, cp3nm[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(cpin[i])>.000001) fprintf(fw2, "cpin[%d] = %14.4f\n", i, cpin[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "cr2nmh = %12.4f\n", cr2nmh);
    fprintf(fw2, "cr3nmh = %12.4f\n", cr3nmh);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(crcmp[i])>.000001) fprintf(fw2, "crcmp[%d] = %14.4f\n", i, crcmp[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "crdys = %12.4f\n", crdys);
    fprintf(fw2, "crh1mp = %12.4f\n", crh1mp);
    fprintf(fw2, "crhmp = %12.4f\n", crhmp);
    fprintf(fw2, "crinh = %12.4f\n", crinh);
    fprintf(fw2, "\n");
    fprintf(fw2, "D = %d\n", D);
    for (i=1; i<=GG; i++) {
      if (fabs(d[i])>.000001) fprintf(fw2, "d[%d] = %14.4f\n", i, d[i]);
      }
    fprintf(fw2, "\n");            
    if (pcmf > 0.000001) fprintf(fw2, "dasc = %12.4f\n", dasc);
    fprintf(fw2, "dasf = %12.4f\n", dasf);
    fprintf(fw2, "davcal = %12.4f\n", davcal);
    fprintf(fw2, "davcalc = %12.4f\n", davcalc);
    fprintf(fw2, "davcalh = %12.4f\n", davcalh);
    fprintf(fw2, "davmat = %12.4f\n", davmat);
    fprintf(fw2, "davmatc = %12.4f\n", davmatc);
    fprintf(fw2, "davmath = %12.4f\n", davmath);
    fprintf(fw2, "dayshc = %12.4f\n", dayshc);
    fprintf(fw2, "dbb = %12.4f\n", dbb);
    fprintf(fw2, "dbpas = %d\n", dbpas);    
    fprintf(fw2, "dcalai = %12.4f\n", dcalai);
    fprintf(fw2, "dcalmat = %12.4f\n", dcalmat);
    fprintf(fw2, "dcalnm2 = %12.4f\n", dcalnm2);
    fprintf(fw2, "dcalnm3 = %12.4f\n", dcalnm3);
    if (pcmf > 0.000001) fprintf(fw2, "dccf = %12.4f\n", dccf);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(dcd[i])>.000001) fprintf(fw2, "dcd[%d] = %14.4f\n", i, dcd[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(dce[i])>.000001) fprintf(fw2, "dce[%d] = %14.4f\n", i, dce[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "dconai = %12.4f\n", dconai);
    fprintf(fw2, "dconnm2 = %12.4f\n", dconnm2);
    fprintf(fw2, "dconnm3 = %12.4f\n", dconnm3);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(dcostw[i])>.000001) fprintf(fw2, "dcostw[%d] = %14.4f\n", i, dcostw[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "dcw = %12.4f\n", dcw);
    fprintf(fw2, "DD = %d\n", DD);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(ddry[i])>.000001) 
        fprintf(fw2, "ddry[%d] = %14.4f\n", i, ddry[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "ddrybbs = %10.4f\n", ddrybbs);
    fprintf(fw2, "ddrybbw = %10.4f\n", ddrybbw);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(ddryfas[i])>.000001) 
        fprintf(fw2, "ddryfas[%d] = %14.4f\n", i, ddryfas[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(ddrys[i])>.000001) 
        fprintf(fw2, "ddrys[%d] = %14.4f\n", i, ddrys[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "ddryt = %10.4f\n", ddryt);
    fprintf(fw2, "ddrytb = %10.4f\n", ddrytb);
    fprintf(fw2, "ddryts = %10.4f\n", ddryts);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(ddryw[i])>.000001) 
        fprintf(fw2, "ddryw[%d] = %14.4f\n", i, ddryw[i]);
      }
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(dead48f[i])>.000001) fprintf(fw2, "dead48f[%d] = %14.4f\n", i,
      dead48f[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(dead48[i])>.000001) fprintf(fw2, "dead48[%d] = %14.4f\n", i,
      dead48[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(dead48m[i])>.000001) fprintf(fw2, "dead48m[%d] = %14.4f\n", i,
      dead48m[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(deadc[i])>.000001) fprintf(fw2, "deadc[%d] = %14.4f\n", i, deadc[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(deadfc[i])>.000001) fprintf(fw2, "deadfc[%d] = %14.4f\n", i,
      deadfc[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(deadmc[i])>.000001) fprintf(fw2, "deadmc[%d] = %14.4f\n", i,
      deadmc[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "deai = %d\n", deai);
    fprintf(fw2, "\n");      
    for (i = 1; i < NT; i++) 
      fprintf(fw2, "delta_d[%d] = %3d\n", i, delta_d[i]);
    fprintf(fw2, "\n");      
    for (i = 1; i < NT; i++) 
      fprintf(fw2, "delta_m[%d] = %3d\n", i, delta_m[i]);
    fprintf(fw2, "\n");      
    fprintf(fw2, "denm2 = %d\n", denm2);
    fprintf(fw2, "denm3 = %d\n", denm3);
    fprintf(fw2, "depas = %d\n", depas);
    fprintf(fw2, "dfcf = %12.4f\n", dfcf);
    fprintf(fw2, "dfrp = %12.4f\n", dfrp);
    if (pcmf > 0.000001) {
      fprintf(fw2, "dgcxas = %12.4f\n", dgcxas);
      fprintf(fw2, "dgcxs = %12.4f\n", dgcxs);
      fprintf(fw2, "dgcxw = %12.4f\n", dgcxw);
      }
    fprintf(fw2, "dgfxas = %12.4f\n", dgfxas);
    fprintf(fw2, "dgfxs = %12.4f\n", dgfxs);
    fprintf(fw2, "dgfxw = %12.4f\n", dgfxw);
    fprintf(fw2, "dm = %12.4f\n", dm);
    fprintf(fw2, "dmatpas = %12.4f\n", dmatpas);
    fprintf(fw2, "dmcf = %12.4f\n", dmcf);
    fprintf(fw2, "dot = %12.4f\n", dot);
    fprintf(fw2, "dotcalf = %12.2f\n", dotcalf);
    fprintf(fw2, "dotcowh = %12.2f\n", dotcowh);
    fprintf(fw2, "dotcowo = %12.2f\n", dotcowo);
    fprintf(fw2, "dotcows = %12.2f\n", dotcows);    
    fprintf(fw2, "dotexpm = %12.2f\n", dotexpm);
    fprintf(fw2, "dotfati = %12.2f\n", dotfati);
    fprintf(fw2, "dotfatib = %12.2f\n", dotfatib);
    fprintf(fw2, "dotfatx = %12.2f\n", dotfatx);
    fprintf(fw2, "dottest = %12.2f\n", dottest);
    fprintf(fw2, "dpascal = %12.4f\n", dpascal);
    fprintf(fw2, "dpasmat = %12.4f\n", dpasmat);
    fprintf(fw2, "dprfrep = %12.4f\n", dprfrep);
    fprintf(fw2, "dresb = %12.4f\n", dresb);
    if (pcmf > 0.000001) fprintf(fw2, "dresc = %12.4f\n", dresc);
    fprintf(fw2, "drescw = %12.4f\n", drescw);
    fprintf(fw2, "dresh = %12.4f\n", dresh);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(dryf[i])>.000001) fprintf(fw2, "dryf[%d] = %14.4f\n", i, dryf[i]);
      }
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(dryfx[i])>.000001) fprintf(fw2, "dryfx[%d] = %14.4f\n", i, dryfx[i]);
      }
    fprintf(fw2, "\n");    
    fprintf(fw2, "dryhayha = %12.4f\n", dryhayha);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(drys[i])>.000001) fprintf(fw2, "drys[%d] = %14.4f\n", i, drys[i]);
      }
    fprintf(fw2, "\n");    
    fprintf(fw2, "dryt = %12.4f\n", dryt);
    fprintf(fw2, "drytb = %12.4f\n", drytb);
    fprintf(fw2, "drytse = %12.4f\n", drytse);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(dryw[i])>.000001) fprintf(fw2, "dryw[%d] = %14.4f\n", i, dryw[i]);
      }
    fprintf(fw2, "\n"); 
    for (i=1; i<=GG; i++) {
      if (fabs(ds[i])>.000001) fprintf(fw2, "ds[%d] = %14.4f\n", i, ds[i]);
      }
    fprintf(fw2, "\n"); 
    for (i=1; i<=GG; i++) {
      if (fabs(ds0[i])>.000001) fprintf(fw2, "ds0[%d] = %14.4f\n", i, ds0[i]);
      }
    fprintf(fw2, "\n");             
    for (i=1; i<=GG; i++) {
      if (fabs(ds1[i])>.000001) fprintf(fw2, "ds1[%d] = %14.4f\n", i, ds1[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=GG; i++) {
      if (fabs(ds2[i])>.000001) fprintf(fw2, "ds2[%d] = %14.4f\n", i, ds2[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=GG; i++) {
      if (fabs(ds3[i])>.000001) fprintf(fw2, "ds3[%d] = %14.4f\n", i, ds3[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=CC; i++) {
      if (fabs(dsd[i])>.000001) fprintf(fw2, "dsd[%d] = %14.4f\n", i, dsd[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(dsl[i])>.000001) fprintf(fw2, "dsl[%d] = %14.4f\n", i, dsl[i]);
      }
    fprintf(fw2, "\n");       
    fprintf(fw2, "dslg = %12.4f\n", dslg);
    fprintf(fw2, "dsmp = %d\n", dsmp);
    fprintf(fw2, "dsnm2 = %d\n", dsnm2);
    fprintf(fw2, "dsnm3 = %d\n", dsnm3);
    fprintf(fw2, "\n");       
    for (i=1; i<=GG; i++) {
      if (fabs(dsp[i])>.000001) fprintf(fw2, "dsp[%d] = %14.4f\n", i, dsp[i]);
      }
    fprintf(fw2, "\n");       
    fprintf(fw2, "dst = %12.4f\n", dst);
    fprintf(fw2, "dsx = %12.4f\n", dsx);
    fprintf(fw2, "dt = %12.4f\n", dt);
    fprintf(fw2, "dtse = %12.4f\n", dtse);
    fprintf(fw2, "\n");       
    for (i=1; i<=CC; i++) {
      if (fabs(dung[i])>.000001) fprintf(fw2, "dung[%d] = %14.4f\n", i, dung[i]);
      }
    fprintf(fw2, "\n");               
    fprintf(fw2, "dungbb = %12.4f\n", dungbb);
    fprintf(fw2, "dungfi = %12.4f\n", dungfi);
    fprintf(fw2, "dungfx = %12.4f\n", dungfx);
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(dw[i])>.000001) fprintf(fw2, "dw[%d] = %14.4f\n", i, dw[i]);
      }
    fprintf(fw2, "\n");    
    fprintf(fw2, "dw0 = %d\n", dw0);
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(dw1[i])>.000001) fprintf(fw2, "dw1[%d] = %14.4f\n", i, dw1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(dw2[i])>.000001) fprintf(fw2, "dw2[%d] = %14.4f\n", i, dw2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(dw3[i])>.000001) fprintf(fw2, "dw3[%d] = %14.4f\n", i, dw3[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(dw4[i])>.000001) fprintf(fw2, "dw4[%d] = %14.4f\n", i, dw4[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(dwd[i])>.000001) fprintf(fw2, "dwd[%d] = %14.4f\n", i, dwd[i]);
      }
    fprintf(fw2, "\n");           
    for (i=1; i<=CC; i++) {
      if (fabs(dwl[i])>.000001) fprintf(fw2, "dwl[%d] = %14.4f\n", i, dwl[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=GG; i++) {
      if (fabs(dwp1[i])>.000001) fprintf(fw2, "dwp1[%d] = %14.4f\n", i, dwp1[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=GG; i++) {
      if (fabs(dwp2[i])>.000001) fprintf(fw2, "dwp2[%d] = %14.4f\n", i, dwp2[i]);
      }
    fprintf(fw2, "\n");           
    fprintf(fw2, "dwx = %12.4f\n", dwx);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(dys[i])>.000001) fprintf(fw2, "dys[%d] = %14.4f\n", i, dys[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "dysav = %12.4f\n", dysav);
    fprintf(fw2, "dyscl = %d\n", dyscl);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(dysf[i])>.000001) fprintf(fw2, "dysf[%d] = %14.4f\n", i, dysf[i]);
      }
    fprintf(fw2, "\n"); 
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) 
	fprintf(fw2, "dysff[%d][%d] = %12.6f\n", j, i, dysff[j][i]);
      }
    fprintf(fw2, "\n");       
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) 
	fprintf(fw2, "dysff0[%d][%d] = %12.6f\n", j, i, dysff0[j][i]);
      }
    fprintf(fw2, "\n"); 
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysffl[%d] = %14.6f\n", j, dysffl[j]);
    fprintf(fw2, "\n");       
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysffld[%d] = %14.6f\n", j, dysffld[j]);
    fprintf(fw2, "\n");       
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysffldl[%d] = %14.6f\n", j, dysffldl[j]);
    fprintf(fw2, "\n");       
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysffldr[%d] = %14.6f\n", j, dysffldr[j]);
    fprintf(fw2, "\n");       
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysffll[%d] = %14.6f\n", j, dysffll[j]);
    fprintf(fw2, "\n");       
    fprintf(fw2, "dysfflmc = %12.4f\n", dysfflmc);
    fprintf(fw2, "\n");
    for (j=0; j<DD-1; j++)
      fprintf(fw2, "dysfflql[%d] = %14.6f\n", j, dysfflql[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD-1; j++)
      fprintf(fw2, "dysfflqm[%d] = %14.6f\n", j, dysfflqm[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD-1; j++)
      fprintf(fw2, "dysfflqr[%d] = %14.6f\n", j, dysfflqr[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysfflr[%d] = %14.6f\n", j, dysfflr[j]);
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(dysm[i])>.000001) fprintf(fw2, "dysm[%d] = %14.4f\n", i, dysm[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(dysmat[i])>.000001) fprintf(fw2, "dysmat[%d] = %14.4f\n", i,
      dysmat[i]);
      }
    fprintf(fw2, "\n");      
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) 
	fprintf(fw2, "dysmm[%d][%d] = %12.6f\n", j, i, dysmm[j][i]);
      }
    fprintf(fw2, "\n");     
    for (j = 0; j < DD; j++) {
      for (i = 0; i < LL; i++) 
	fprintf(fw2, "dysmm0[%d][%d] = %12.6f\n", j, i, dysmm0[j][i]);
      }
    fprintf(fw2, "\n");  
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysmml[%d] = %14.6f\n", j, dysmml[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysmmld[%d] = %14.6f\n", j, dysmmld[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD-1; j++)
      fprintf(fw2, "dysmmldl[%d] = %14.6f\n", j, dysmmldl[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysmmldr[%d] = %14.6f\n", j, dysmmldr[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysmmll[%d] = %14.6f\n", j, dysmmll[j]);
    fprintf(fw2, "\n");      
    fprintf(fw2, "dysmmlmc = %12.4f\n", dysmmlmc);    
    fprintf(fw2, "\n");
    for (j=0; j<DD-1; j++)
      fprintf(fw2, "dysmmlql[%d] = %14.6f\n", j, dysmmlql[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD-1; j++)
      fprintf(fw2, "dysmmlqm[%d] = %14.6f\n", j, dysmmlqm[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD-1; j++)
      fprintf(fw2, "dysmmlqr[%d] = %14.6f\n", j, dysmmlqr[j]);
    fprintf(fw2, "\n");      
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysmmlr[%d] = %14.6f\n", j, dysmmlr[j]);
    fprintf(fw2, "\n");
    for (j=0; j<DD; j++)
      fprintf(fw2, "dysscore[%d] = %14.6f\n", j, dysscore[j]);
    fprintf(fw2, "\n");          
    fprintf(fw2, "dysscoreav = %12.4f\n", dysscoreav);
    fprintf(fw2, "\n");    
    fprintf(fw2, "ecr2nmc = %12.4f\n", ecr2nmc);
    fprintf(fw2, "ecr3nmc = %12.4f\n", ecr3nmc);
    fprintf(fw2, "ecrinc = %12.4f\n", ecrinc);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(edf[i])>.000001) fprintf(fw2, "edf[%d] = %14.4f\n", i, edf[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(edfx[i])>.000001) fprintf(fw2, "edfx[%d] = %14.4f\n", i, edfx[i]);
      }
    fprintf(fw2, "\n");   
    for (i=1; i<=CC; i++) {
      if (fabs(eds[i])>.000001) fprintf(fw2, "eds[%d] = %14.4f\n", i, eds[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "edt = %12.4f\n", edt);
    fprintf(fw2, "edtb = %12.4f\n", edtb);
    fprintf(fw2, "edtse = %12.4f\n", edtse);
    fprintf(fw2, "\n");   
    for (i=1; i<=CC; i++) {
      if (fabs(edw[i])>.000001) fprintf(fw2, "edw[%d] = %14.4f\n", i, edw[i]);
      }
    fprintf(fw2, "\n"); 
    for (i=1; i<NT; i++)
      fprintf(fw2, "ew[%d] = %12.4f\n", i, ew[i]);
    fprintf(fw2, "\n");       
    for (i=1; i<NT; i++)
      fprintf(fw2, "ew0[%d] = %12.4f\n", i, ew0[i]);
    fprintf(fw2, "\n");       
    for (i=1; i<NT; i++)
      if (fabs(ew_d[i]) > 0.000001 && (tt[i] == 0 || tt[i] == 2))
        fprintf(fw2, "ew_d[%d] = %12.4f\n", i, ew_d[i]);
    fprintf(fw2, "\n");       
    for (i=1; i<NT; i++)
      fprintf(fw2, "ewdiff[%d] = %12.4f\n", i, ewdiff[i]);
    fprintf(fw2, "\n");       
    for (i=1; i<NT; i++)
      if (fabs(ew_m[i]) > 0.000001 && tt[i] > 0)
        fprintf(fw2, "ew_m[%d] = %12.4f\n", i, ew_m[i]);
    fprintf(fw2, "\n"); 
    for (i = 1; i < NT; i++) 
      if (fabs(ewr_da[i]) > .000001) 
        fprintf(fw2, "ewr_da[%d] = %10.4f\n", i, ewr_da[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewr_dd[i]) > .000001) 
        fprintf(fw2, "ewr_dd[%d] = %10.4f\n", i, ewr_dd[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewr_ma[i]) > .000001) 
        fprintf(fw2, "ewr_ma[%d] = %10.4f\n", i, ewr_ma[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewr_mm[i]) > .000001) 
        fprintf(fw2, "ewr_mm[%d] = %10.4f\n", i, ewr_mm[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewst_d[i]) > .000001) 
        fprintf(fw2, "ewst_d[%d] = %10.4f\n", i, ewst_d[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewst_m[i]) > .000001) 
        fprintf(fw2, "ewst_m[%d] = %10.4f\n", i, ewst_m[i]);     
    fprintf(fw2, "ewsum = %f\n",ewsum);
    fprintf(fw2, "ewsum_d = %f\n",ewsum_d);
    fprintf(fw2, "ewsum_m = %f\n",ewsum_m);    
    fprintf(fw2, "exfc = %12.4f\n", exfc);
    fprintf(fw2, "exmc = %12.4f\n", exmc);
    fprintf(fw2, "\n");   
    for (i=1; i<=CC; i++) {
      if (fabs(f[i])>.000001) fprintf(fw2, "f[%d] = %14.4f\n", i, f[i]);
      }
    fprintf(fw2, "\n");   
    for (i=1; i<=CC; i++) {
      if (fabs(fas[i])>.000001) fprintf(fw2, "fas[%d] = %14.4f\n", i, fas[i]);
      }
    fprintf(fw2, "\n");         
    for (i=1; i<=CC; i++) {
      if (fabs(fase[i])>.000001) fprintf(fw2, "fase[%d] = %14.4f\n", i, fase[i]);
      }
    fprintf(fw2, "\n");         
    for (i=1; i<=CC; i++) {
      if (fabs(faspdi[i])>.000001) 
        fprintf(fw2, "faspdi[%d] = %14.4f\n", i, faspdi[i]);
      }
    fprintf(fw2, "\n");   
    fprintf(fw2, "fat = %12.4f\n", fat);
    fprintf(fw2, "fbbs = %12.4f\n", fbbs);
    fprintf(fw2, "fbbse = %12.4f\n", fbbse);
    fprintf(fw2, "fbbspdi = %12.4f\n", fbbspdi);
    fprintf(fw2, "fbbw = %12.4f\n", fbbw);
    fprintf(fw2, "fbbwe = %12.4f\n", fbbwe);
    fprintf(fw2, "fbbwpdi = %12.4f\n", fbbwpdi);
    fprintf(fw2, "\n");   
    for (i=1; i<=CC; i++) {
      if (fabs(fe[i])>.000001) fprintf(fw2, "fe[%d] = %14.4f\n", i, fe[i]);
      }
    fprintf(fw2, "\n");           
    fprintf(fw2, "feedcost = %d\n", feedcost);
    fprintf(fw2, "feedlot = %d\n", feedlot);
    fprintf(fw2, "fixcbb = %12.4f\n", fixcbb);
    fprintf(fw2, "fixcbbt = %12.4f\n", fixcbbt);
    fprintf(fw2, "fixcbt = %12.4f\n", fixcbt);
    fprintf(fw2, "fixcc = %12.4f\n", fixcc);
    fprintf(fw2, "fixcfi = %12.4f\n", fixcfi);
    fprintf(fw2, "fixcfx = %12.4f\n", fixcfx);
    fprintf(fw2, "fixcrh = %12.4f\n", fixcrh);
    for (i = 1; i < 5; i++) fprintf(fw2, "flag[%d] = %d\n", i, flag[i]);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(fpdi[i])>.000001) fprintf(fw2, "fpdi[%d] = %14.4f\n", i, fpdi[i]);
      }
    fprintf(fw2, "\n");        
    for (i=1; i<=CC; i++) {
      if (fabs(fs[i])>.000001) fprintf(fw2, "fs[%d] = %14.4f\n", i, fs[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=CC; i++) {
      if (fabs(fse[i])>.000001) fprintf(fw2, "fse[%d] = %14.4f\n", i, fse[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=CC; i++) {
      if (fabs(fspdi[i])>.000001) fprintf(fw2, "fspdi[%d] = %14.4f\n", i, fspdi[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "ft = %12.4f\n", ft);
    fprintf(fw2, "ftb = %12.4f\n", ftb);
    fprintf(fw2, "ftbe = %12.4f\n", ftbe);
    fprintf(fw2, "ftbpdi = %12.4f\n", ftbpdi);
    fprintf(fw2, "fte = %12.4f\n", fte);
    fprintf(fw2, "ftpdi = %12.4f\n", ftpdi);
    fprintf(fw2, "fts = %12.4f\n", fts);
    fprintf(fw2, "ftse = %12.4f\n", ftse);
    fprintf(fw2, "ftsepdi = %12.4f\n", ftsepdi);
    fprintf(fw2, "\n");        
    for (i=1; i<=CC; i++) {
      if (fabs(fw0[i])>.000001) fprintf(fw2, "fw0[%d] = %14.4f\n", i, fw0[i]);
      }
    fprintf(fw2, "\n");                   
    for (i=1; i<=CC; i++) {
      if (fabs(fwe[i])>.000001) fprintf(fw2, "fwe[%d] = %14.4f\n", i, fwe[i]);
      }
    fprintf(fw2, "\n");                      
    for (i=1; i<=CC; i++) {
      if (fabs(fwpdi[i])>.000001) fprintf(fw2, "fwpdi[%d] = %14.4f\n", i, fwpdi[i]);
      }
    fprintf(fw2, "\n");                
    fprintf(fw2, "gene_flow = %d\n", gene_flow);
    fprintf(fw2, "GG = %d\n", GG); 
    fprintf(fw2, "gstd = %d\n", gstd); 
    if (gstd == 2) {
      for (i = 1; i < NT; i++) 
	if (to[i] == 2 && (tt[i] == 0 || tt[i] == 2)) 
          fprintf(fw2, "gstd_d[%d] = %10.4f\n", i, gstd_d[i]);
    }
    if (gstd == 3) {
      for (i = 1; i < NT; i++) 
	if (to[i] == 2) 
          fprintf(fw2, "gstd_d[%d] = %10.4f\n", i, gstd_d[i]);
    }
    if (gstd > 1) {    
      for (i = 1; i < NT; i++) 
	if (to[i] == 2 && tt[i] > 0) 
          fprintf(fw2, "gstd_m[%d] = %10.4f\n", i, gstd_m[i]);
    }          
    fprintf(fw2, "\n");                          
    fprintf(fw2, "h1mpf = %12.4f\n", h1mpf);
    fprintf(fw2, "h1mprp = %12.4f\n", h1mprp);
    fprintf(fw2, "h2mpf = %12.4f\n", h2mpf);
    fprintf(fw2, "h2mprp = %12.4f\n", h2mprp);
    fprintf(fw2, "h3mpf = %12.4f\n", h3mpf);
    fprintf(fw2, "hcmat1 = %12.4f\n", hcmat1);
    fprintf(fw2, "hcmat1p = %12.4f\n", hcmat1p);
    fprintf(fw2, "hcmat2 = %12.4f\n", hcmat2);
    fprintf(fw2, "hcmat2p = %12.4f\n", hcmat2p);
    fprintf(fw2, "hcmat3p = %12.4f\n", hcmat3p);
    fprintf(fw2, "hcon1mat = %12.4f\n", hcon1mat);
    fprintf(fw2, "hcon2mat = %12.4f\n", hcon2mat);
    fprintf(fw2, "hcon3mat = %12.4f\n", hcon3mat);
    fprintf(fw2, "\n");
    for (i=1; i<=acs+acd+1; i++) {
      if (fabs(hd[i])>.000001) fprintf(fw2, "hd[%d] = %12.6f\n", i, hd[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "herdbook = %12.4f\n", herdbook);
    fprintf(fw2, "\n");
    for (i=1; i<=acs+acd+1; i++) {
      if (fabs(hm[i])>.000001) fprintf(fw2, "hm[%d] = %12.6f\n", i, hm[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "hmpf = %12.4f\n", hmpf);
    fprintf(fw2, "\n");                    
    fprintf(fw2, "insc = %d\n", insc);
    fprintf(fw2, "insh = %d\n", insh);
    fprintf(fw2, "intcm = %12.4f\n", intcm);
    fprintf(fw2, "intcmc = %12.4f\n", intcmc);
    fprintf(fw2, "\n");                    
    fprintf(fw2, "k2 = %12.4f\n", k2);
    fprintf(fw2, "k3 = %12.4f\n", k3);
    fprintf(fw2, "k4 = %12.4f\n", k4);
    fprintf(fw2, "kbd = %12.4f\n", kbd);
    fprintf(fw2, "kbl = %12.4f\n", kbl);
    fprintf(fw2, "kbwmf = %12.4f\n", kbwmf);
    if (pcmf > 0.000001) fprintf(fw2, "kce = %12.4f\n", kce);
    fprintf(fw2, "kcon2c = %12.4f\n", kcon2c);
    fprintf(fw2, "kcon2h = %12.4f\n", kcon2h);
    fprintf(fw2, "kcon3c = %12.4f\n", kcon3c);
    fprintf(fw2, "kcon3h = %12.4f\n", kcon3h);
    if (pcmf > 0.000001) fprintf(fw2, "kcp = %12.4f\n", kcp);
    fprintf(fw2, "kdgfxwas = %12.4f\n", kdgfxwas);
    fprintf(fw2, "kdgfxws = %12.4f\n", kdgfxws);
    if (pcmf > 0.000001) {
      fprintf(fw2, "kdgxascf = %12.4f\n", kdgxascf);
      fprintf(fw2, "kdgxscf = %12.4f\n", kdgxscf);
      fprintf(fw2, "kdgxwcf = %12.4f\n", kdgxwcf);
      }
    fprintf(fw2, "kdresb = %12.4f\n", kdresb);
    fprintf(fw2, "kdresbh = %12.4f\n", kdresbh);
    fprintf(fw2, "kdresc = %12.4f\n", kdresc);
    if (pcmf > 0.000001) fprintf(fw2, "kdresch = %12.4f\n", kdresch);
    fprintf(fw2, "kdrescwh = %12.4f\n", kdrescwh);
    fprintf(fw2, "kdresh = %12.4f\n", kdresh);
    fprintf(fw2, "kff = %12.4f\n", kff);
    fprintf(fw2, "kfpa = %12.4f\n", kfpa);
    fprintf(fw2, "kfw = %12.4f\n", kfw);
    if (pcmf > 0.000001) fprintf(fw2, "kgaincf = %12.4f\n", kgaincf);
    fprintf(fw2, "kgainmf = %12.4f\n", kgainmf);
    fprintf(fw2, "kgcon1mf = %12.4f\n", kgcon1mf);
    fprintf(fw2, "kgcon2mf = %12.4f\n", kgcon2mf);
    fprintf(fw2, "kgcon3mf = %12.4f\n", kgcon3mf);
    fprintf(fw2, "khe = %12.4f\n", khe);
    fprintf(fw2, "khp = %12.4f\n", khp);
    fprintf(fw2, "km = %12.4f\n", km);
    fprintf(fw2, "kmcwhmin = %12.4f\n", kmcwhmin);
    fprintf(fw2, "kmwbc = %12.4f\n", kmwbc);
    fprintf(fw2, "kp21 = %12.4f\n", kp21);
    fprintf(fw2, "kpm1 = %12.4f\n", kpm1);
    fprintf(fw2, "kpm2 = %12.4f\n", kpm2);
    fprintf(fw2, "\n");                
    for (i=1; i<=CC; i++) {
      if (fabs(kpr[i])>.000001) fprintf(fw2, "kpr[%d] = %14.4f\n", i, kpr[i]);
      }
    fprintf(fw2, "\n");                        
    fprintf(fw2, "kslb = %12.4f\n", kslb);
    if (pcmf > 0.000001) fprintf(fw2, "kslc = %12.4f\n", kslc);
    if (pcmf > 0.000001) fprintf(fw2, "kslcx = %12.4f\n", kslcx);
    fprintf(fw2, "kslh = %12.4f\n", kslh);
    fprintf(fw2, "kslhx = %12.4f\n", kslhx);
    fprintf(fw2, "kt = %12.4f\n", kt);
    fprintf(fw2, "ktb = %12.4f\n", ktb);
    fprintf(fw2, "ktf = %12.4f\n", ktf);
    fprintf(fw2, "ktp = %12.4f\n", ktp);
    fprintf(fw2, "\n");    
    fprintf(fw2, "l_inv = %d\n", l_inv);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(l1[i])>.000001) fprintf(fw2, "l1[%d] = %14.4f\n", i, l1[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=TT; i++)
      if (fabs(l2[i])>.000001) fprintf(fw2, "l2[%d] = %12.6f\n", i, l2[i]);
    fprintf(fw2, "\n");      
    for (i=1; i<=TT; i++)
      if (fabs(l2_0[i])>.000001) fprintf(fw2, "l2_0[%d] = %12.6f\n", i, l2_0[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(l3[i])>.000001) fprintf(fw2, "l3[%d] = %14.6f\n", i, l3[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(l4[i])>.000001) fprintf(fw2, "l4[%d] = %14.6f\n", i, l4[i]);
      }
    fprintf(fw2, "\n");
    for (j=0; j<DD; j++)
      fprintf(fw2, "labdys[%d] = %14.6f\n", j, labdys[j]);
    fprintf(fw2, "\n");      
    fprintf(fw2, "lactcur = %d\n", lactcur);        
    fprintf(fw2, "lengbt = %12.6f\n", lengbt);
    fprintf(fw2, "lghrcyc = %12.6f\n", lghrcyc);
    fprintf(fw2, "lgpre = %12.6f\n", lgpre);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(life[i])>.000001) fprintf(fw2, "life[%d] = %14.4f\n", i, life[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "lifebb = %12.6f\n", lifebb);
    fprintf(fw2, "LL = %d\n", LL);    
    fprintf(fw2, "lm2 = %12.6f\n", lm2);
    fprintf(fw2, "lm3 = %12.6f\n", lm3);
    fprintf(fw2, "lm4 = %12.6f\n", lm4);
    fprintf(fw2, "lmm = %12.6f\n", lmm);
    fprintf(fw2, "losc = %12.6f\n", losc);
    fprintf(fw2, "losff = %12.6f\n", losff);
    fprintf(fw2, "losfpa = %12.6f\n", losfpa);
    fprintf(fw2, "losfw = %12.6f\n", losfw);
    fprintf(fw2, "losmw = %12.6f\n", losmw);
    fprintf(fw2, "loswf = %12.6f\n", loswf);
    fprintf(fw2, "\n");    
    for (i=1; i<=acs+acd+1; i++) {
      if (fabs(m_gf[i])>.000001) fprintf(fw2, "m_gf[%d] = %12.6f\n", i, m_gf[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=acs+acd+1; i++) {
      if (fabs(m_gf0[i])>.000001) fprintf(fw2, "m_gf0[%d] = %12.6f\n", i, m_gf0[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=acs+acd+1; i++) {
      if (fabs(m_sum[i])>.000001) fprintf(fw2, "m_sum[%d] = %12.6f\n", i, m_sum[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "maturity = %d\n", maturity);    
    fprintf(fw2, "mcw = %12.6f\n", mcw);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(min[i])>.000001) fprintf(fw2, "min[%d] = %14.4f\n", i, min[i]);
      }
    fprintf(fw2, "\n");                
    fprintf(fw2, "mp2 = %12.6f\n", mp2);
    fprintf(fw2, "mp3 = %12.6f\n", mp3);
    fprintf(fw2, "mp4 = %12.6f\n", mp4);
    fprintf(fw2, "mpm = %12.6f\n", mpm);
    fprintf(fw2, "mpm0 = %12.6f\n", mpm0);
    fprintf(fw2, "msel = %12.6f\n", msel);
    fprintf(fw2, "mtest = %12.6f\n", mtest);
    fprintf(fw2, "mwb = %12.6f\n", mwb);
    fprintf(fw2, "\n");    
    fprintf(fw2, "n = %d\n", n);
    fprintf(fw2, "n_sac = %d\n", n_sac);        
    fprintf(fw2, "Ncal = %12.4f\n", Ncal);    
    if (pcmf > 0.000001) fprintf(fw2, "nccf = %12.6f\n", nccf);
    fprintf(fw2, "ncows = %12.6f\n", ncows);
    fprintf(fw2, "ndaycc = %12.6f\n", ndaycc);
    fprintf(fw2, "ndaycd = %12.6f\n", ndaycd);
    fprintf(fw2, "ndaycw = %12.6f\n", ndaycw);
    fprintf(fw2, "ndaydys = %12.6f\n", ndaydys);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(NDEc[i])>.000001) fprintf(fw2, "NDEc[%d] = %14.4f\n", i, NDEc[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "NDEd = %12.4f\n", NDEd);
    fprintf(fw2, "NDEdys = %12.6f\n", NDEdys);
    fprintf(fw2, "NDEm = %12.4f\n", NDEm); 
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(NDEr[i])>.000001) fprintf(fw2, "NDEr[%d] = %14.4f\n", i, NDEr[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(ne[i])>.000001) fprintf(fw2, "ne[%d] = %14.4f\n", i, ne[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(neas[i])>.000001) fprintf(fw2, "neas[%d] = %14.4f\n", i, neas[i]);
      }
    fprintf(fw2, "\n");            
    fprintf(fw2, "nebbm = %12.6f\n", nebbm);
    fprintf(fw2, "nebbs = %12.6f\n", nebbs);
    fprintf(fw2, "nebbsl = %12.6f\n", nebbsl);
    fprintf(fw2, "nebbw = %12.6f\n", nebbw);
    fprintf(fw2, "nebt = %12.6f\n", nebt);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(negs[i])>.000001) fprintf(fw2, "negs[%d] = %14.4f\n", i, negs[i]);
      }
    fprintf(fw2, "\n");  
    for (i=1; i<=CC; i++) {
      if (fabs(negw[i])>.000001) fprintf(fw2, "negw[%d] = %14.4f\n", i, negw[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(nems[i])>.000001) fprintf(fw2, "nems[%d] = %14.4f\n", i, nems[i]);
      }
    fprintf(fw2, "\n");  
    for (i=1; i<=CC; i++) {
      if (fabs(nemw[i])>.000001) fprintf(fw2, "nemw[%d] = %14.4f\n", i, nemw[i]);
      }
    fprintf(fw2, "\n"); 
    for (i=1; i<=GG; i++) {
      if (fabs(nepc[i])>.000001) fprintf(fw2, "nepc[%d] = %14.4f\n", i, nepc[i]);
      }
    fprintf(fw2, "\n");    
    for (i=1; i<=GG; i++) {
      if (fabs(nes[i])>.000001) fprintf(fw2, "nes[%d] = %14.4f\n", i, nes[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(nes0[i])>.000001) fprintf(fw2, "nes0[%d] = %14.4f\n", i, nes0[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(nes1[i])>.000001) fprintf(fw2, "nes1[%d] = %14.4f\n", i, nes1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(nes2[i])>.000001) fprintf(fw2, "nes2[%d] = %14.4f\n", i, nes2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(nes3[i])>.000001) fprintf(fw2, "nes3[%d] = %14.4f\n", i, nes3[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(nescal[i])>.000001) fprintf(fw2, "nescal[%d] = %14.4f\n", i, nescal[i]);
      }
    fprintf(fw2, "\n");           
    for (i=1; i<=CC; i++) {
      if (fabs(nesl[i])>.000001) fprintf(fw2, "nesl[%d] = %14.4f\n", i, nesl[i]);
      }
    fprintf(fw2, "\n");           
    for (i=1; i<=CC; i++) {
      if (fabs(nesncal[i])>.000001) fprintf(fw2, "nesncal[%d] = %14.4f\n", i, nesncal[i]);
      }
    fprintf(fw2, "\n"); 
    for (i=1; i<=GG; i++) {
      if (fabs(nesp[i])>.000001) fprintf(fw2, "nesp[%d] = %14.4f\n", i, nesp[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "net = %12.6f\n", net);
    fprintf(fw2, "netse = %12.6f\n", netse);
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(new[i])>.000001) fprintf(fw2, "new[%d] = %14.4f\n", i, new[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(new1[i])>.000001) fprintf(fw2, "new1[%d] = %14.4f\n", i, new1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(new2[i])>.000001) fprintf(fw2, "new2[%d] = %14.4f\n", i, new2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(new3[i])>.000001) fprintf(fw2, "new3[%d] = %14.4f\n", i, new3[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "new4 = %12.6f\n", new4);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(newcal[i])>.000001) fprintf(fw2, "newcal[%d] = %14.4f\n", i, newcal[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(newl[i])>.000001) fprintf(fw2, "newl[%d] = %14.4f\n", i, newl[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(newncal[i])>.000001) fprintf(fw2, "newncal[%d] = %14.4f\n", i, newncal[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(newp[i])>.000001) fprintf(fw2, "newp[%d] = %14.4f\n", i, newp[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(newp1[i])>.000001) fprintf(fw2, "newp1[%d] = %14.4f\n", i, newp1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(newp2[i])>.000001) fprintf(fw2, "newp2[%d] = %14.4f\n", i, newp2[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "Nfav = %12.6f\n", Nfav);
    fprintf(fw2, "Nfc48a = %12.6f\n", Nfc48a);
    fprintf(fw2, "Nfcba = %12.6f\n", Nfcba);
    fprintf(fw2, "nfcf = %12.6f\n", nfcf);
    fprintf(fw2, "Nfcw = %12.6f\n", Nfcw);
    fprintf(fw2, "Nffa = %12.6f\n", Nffa);
    fprintf(fw2, "Nfmat = %12.6f\n", Nfmat);
    fprintf(fw2, "Nfrp = %12.6f\n", Nfrp);
    fprintf(fw2, "Nmc48a = %12.6f\n", Nmc48a);
    fprintf(fw2, "Nmcba = %12.6f\n", Nmcba);
    fprintf(fw2, "nmcf = %12.6f\n", nmcf);
    fprintf(fw2, "Nmcf = %12.6f\n", Nmcf);
    fprintf(fw2, "Nmcfb = %12.6f\n", Nmcfb);
    fprintf(fw2, "Nmcfc = %12.6f\n", Nmcfc);
    fprintf(fw2, "Nmcw = %12.6f\n", Nmcw);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(np[i])>.000001) fprintf(fw2, "np[%d] = %14.4f\n", i, np[i]);
      }
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(npc[i])>.000001) fprintf(fw2, "npc[%d] = %14.4f\n", i, npc[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(npcsn[i])>.000001) fprintf(fw2, "npcsn[%d] = %14.4f\n", i, npcsn[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(npcsp[i])>.000001) fprintf(fw2, "npcsp[%d] = %14.4f\n", i, npcsp[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "nphs = %12.6f\n", nphs);
    fprintf(fw2, "nphsold1 = %12.6f\n", nphsold1);
    fprintf(fw2, "nphsold2 = %12.6f\n", nphsold2);
    fprintf(fw2, "nr = %12.6f\n", nr);
    fprintf(fw2, "p1 = %d\n", p1);
    fprintf(fw2, "p2 = %d\n", p2);
    fprintf(fw2, "\n");
    for (i=0; i<p1; i++) {
      for (j=0; j<p2; j++) 
	fprintf(fw2, "Pb[%d][%d] = %12.4f\n", i, j, Pb[i][j]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "pbf = %d\n", pbf);
    for (i=0; i<p1; i++) {
      for (j=0; j<p2; j++) 
	fprintf(fw2, "Pc[%d][%d] = %12.4f\n", i, j, Pc[i][j]);
      }
    fprintf(fw2, "\n");
    for (i=0; i<p1; i++) {
      for (j=0; j<p2; j++) 
	fprintf(fw2, "Pc0[%d][%d] = %12.4f\n", i, j, Pc0[i][j]);
      }
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(pcal[i])>.000001) fprintf(fw2, "pcal[%d] = %14.4f\n", i, pcal[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(pcalc[i])>.000001) fprintf(fw2, "pcalc[%d] = %14.4f\n", i, pcalc[i]);
      }
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(pcdys[i])>.000001) fprintf(fw2, "pcdys[%d] = %14.4f\n", i, pcdys[i]);
      }
    fprintf(fw2, "\n");
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfc[%d] = %12.6f\n", i, Pcfc[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfcd[%d] = %12.6f\n", i, Pcfcd[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfcdl[%d] = %12.6f\n", i, Pcfcdl[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfcdr[%d] = %12.6f\n", i, Pcfcdr[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfcl[%d] = %12.6f\n", i, Pcfcl[i]);
    fprintf(fw2, "\n");      
    fprintf(fw2, "Pcfcmc = %12.4f\n", Pcfcmc);
    fprintf(fw2, "Pcfcmcc = %12.4f\n", Pcfcmcc);
    fprintf(fw2, "Pcfcmcb = %12.4f\n", Pcfcmcb);
    fprintf(fw2, "Pcfcmch = %12.4f\n", Pcfcmch);
    if (pcmf > 0.000001) fprintf(fw2, "Pcfcmcca = %12.4f\n", Pcfcmcca);
    fprintf(fw2, "\n");    
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfcql[%d] = %12.6f\n", i, Pcfcql[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfcqm[%d] = %12.6f\n", i, Pcfcqm[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfcqr[%d] = %12.6f\n", i, Pcfcqr[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p2; i++)
      fprintf(fw2, "Pcfcr[%d] = %12.6f\n", i, Pcfcr[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcfl[%d] = %12.6f\n", i, Pcfl[i]);
    fprintf(fw2, "\n");    
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcfld[%d] = %12.6f\n", i, Pcfld[i]);
    fprintf(fw2, "\n");    
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcfldl[%d] = %12.6f\n", i, Pcfldl[i]);
    fprintf(fw2, "\n");    
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcfldr[%d] = %12.6f\n", i, Pcfldr[i]);
    fprintf(fw2, "\n");    
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcfll[%d] = %12.6f\n", i, Pcfll[i]);
    fprintf(fw2, "\n");        
    fprintf(fw2, "Pcflmc = %12.4f\n", Pcflmc);
    fprintf(fw2, "Pcflmcc = %12.4f\n", Pcflmcc);
    fprintf(fw2, "Pcflmcb = %12.4f\n", Pcflmcb);
    fprintf(fw2, "Pcflmch = %12.4f\n", Pcflmch);
    if (pcmf > 0.000001) fprintf(fw2, "Pcflmcca = %12.4f\n", Pcflmcca);
    fprintf(fw2, "\n");
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcflql[%d] = %12.6f\n", i, Pcflql[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcflqm[%d] = %12.6f\n", i, Pcflqm[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcflqr[%d] = %12.6f\n", i, Pcflqr[i]);
    fprintf(fw2, "\n");      
    for (i=0; i<p1; i++)
      fprintf(fw2, "Pcflr[%d] = %12.6f\n", i, Pcflr[i]);
    fprintf(fw2, "\n");
    fprintf(fw2, "pchf = %d\n", pchf);          
    for (i=0; i<LL; i++) {
      if (fabs(pclos[i])>.000001) fprintf(fw2, "pclos[%d] = %14.4f\n", i, pclos[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "pcmf = %12.6f\n", pcmf);
    fprintf(fw2, "\n");
    if (pcmf > 0.000001) {
      for (i=0; i<p1; i++) {
	for (j=0; j<p2; j++) 
	  fprintf(fw2, "Pcs[%d][%d] = %12.4f\n", i, j, Pcs[i][j]);
	}
      fprintf(fw2, "\n");
      }
    for (i=0; i<LL; i++) {
      if (fabs(pcul[i])>.000001) fprintf(fw2, "pcul[%d] = %14.4f\n", i, pcul[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(pdi[i])>.000001) fprintf(fw2, "pdi[%d] = %14.4f\n", i, pdi[i]);
      }
    fprintf(fw2, "\n");        
    for (i=1; i<=CC; i++) {
      if (fabs(pdias[i])>.000001) fprintf(fw2, "pdias[%d] = %14.4f\n", i, pdias[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "pdibbm = %12.6f\n", pdibbm);
    fprintf(fw2, "pdibbs = %12.6f\n", pdibbs);
    fprintf(fw2, "pdibbsl = %12.6f\n", pdibbsl);
    fprintf(fw2, "pdibbw = %12.6f\n", pdibbw);
    fprintf(fw2, "pditb = %12.6f\n", pditb);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(pdidf[i])>.000001) fprintf(fw2, "pdidf[%d] = %14.4f\n", i, pdidf[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(pdidfx[i])>.000001) fprintf(fw2, "pdidfx[%d] = %14.4f\n", i, pdidfx[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(pdids[i])>.000001) fprintf(fw2, "pdids[%d] = %14.4f\n", i, pdids[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "pdidt = %12.6f\n", pdidt);
    fprintf(fw2, "pdidtb = %12.6f\n", pdidtb);
    fprintf(fw2, "pdidtse = %12.6f\n", pdidtse);
    fprintf(fw2, "\n");    
    for (i=1; i<=CC; i++) {
      if (fabs(pdidw[i])>.000001) fprintf(fw2, "pdidw[%d] = %14.4f\n", i, pdidw[i]);
      }
    fprintf(fw2, "\n");     
    for (i=1; i<=CC; i++) {
      if (fabs(pdigs[i])>.000001) fprintf(fw2, "pdigs[%d] = %14.4f\n", i, pdigs[i]);
      }
    fprintf(fw2, "\n");           
    for (i=1; i<=CC; i++) {
      if (fabs(pdigw[i])>.000001) fprintf(fw2, "pdigw[%d] = %14.4f\n", i, pdigw[i]);
      }
    fprintf(fw2, "\n");           
    for (i=1; i<=CC; i++) {
      if (fabs(pdims[i])>.000001) fprintf(fw2, "pdims[%d] = %14.4f\n", i, pdims[i]);
      }
    fprintf(fw2, "\n");                 
    for (i=1; i<=CC; i++) {
      if (fabs(pdimw[i])>.000001) fprintf(fw2, "pdimw[%d] = %14.4f\n", i, pdimw[i]);
      }
    fprintf(fw2, "\n");                 
    for (i=1; i<=GG; i++) {
      if (fabs(pdipc[i])>.000001) fprintf(fw2, "pdipc[%d] = %14.4f\n", i, pdipc[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(pdis[i])>.000001) fprintf(fw2, "pdis[%d] = %14.4f\n", i, pdis[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdis0[i])>.000001) fprintf(fw2, "pdis0[%d] = %14.4f\n", i, pdis0[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdis1[i])>.000001) fprintf(fw2, "pdis1[%d] = %14.4f\n", i, pdis1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdis2[i])>.000001) fprintf(fw2, "pdis2[%d] = %14.4f\n", i, pdis2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdis3[i])>.000001) fprintf(fw2, "pdis3[%d] = %14.4f\n", i, pdis3[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(pdiscal[i])>.000001) fprintf(fw2, "pdiscal[%d] = %14.4f\n", i, pdiscal[i]);
      }
    fprintf(fw2, "\n");                 
    for (i=1; i<=CC; i++) {
      if (fabs(pdisl[i])>.000001) fprintf(fw2, "pdisl[%d] = %14.4f\n", i, pdisl[i]);
      }
    fprintf(fw2, "\n");                 
    for (i=1; i<=CC; i++) {
      if (fabs(pdisncal[i])>.000001) fprintf(fw2, "pdisncal[%d] = %14.4f\n", i,
      pdisncal[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(pdisp[i])>.000001) fprintf(fw2, "pdisp[%d] = %14.4f\n", i, pdisp[i]);
      }
    fprintf(fw2, "\n");                     
    fprintf(fw2, "pdit = %12.6f\n", pdit);
    fprintf(fw2, "pditse = %12.6f\n", pditse);
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(pdiw[i])>.000001) fprintf(fw2, "pdiw[%d] = %14.4f\n", i, pdiw[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdiw1[i])>.000001) fprintf(fw2, "pdiw1[%d] = %14.4f\n", i, pdiw1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdiw2[i])>.000001) fprintf(fw2, "pdiw2[%d] = %14.4f\n", i, pdiw2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdiw3[i])>.000001) fprintf(fw2, "pdiw3[%d] = %14.4f\n", i, pdiw3[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "pdiw4 = %12.6f\n", pdiw4);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(pdiwcal[i])>.000001) fprintf(fw2, "pdiwcal[%d] = %14.4f\n", i, pdiwcal[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(pdiwl[i])>.000001) fprintf(fw2, "pdiwl[%d] = %14.4f\n", i, pdiwl[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(pdiwncal[i])>.000001) fprintf(fw2, "pdiwncal[%d] = %14.4f\n", i,
      pdiwncal[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdiwp[i])>.000001) fprintf(fw2, "pdiwp[%d] = %14.4f\n", i, pdiwp[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(pdiwp1[i])>.000001) fprintf(fw2, "pdiwp1[%d] = %14.4f\n", i, pdiwp1[i]);
      }
    fprintf(fw2, "\n");        
    for (i=1; i<=GG; i++) {
      if (fabs(pdiwp2[i])>.000001) fprintf(fw2, "pdiwp2[%d] = %14.4f\n", i, pdiwp2[i]);
      }
    fprintf(fw2, "\n");        
    for (i=1; i<=CC; i++) {
      if (fabs(pf[i])>.000001) fprintf(fw2, "pf[%d] = %14.4f\n", i, pf[i]);
      }
    fprintf(fw2, "\n");            
    fprintf(fw2, "pff = %12.6f\n", pff);
    fprintf(fw2, "\n");
    for (i=0; i<p1; i++) {
      for (j=0; j<p2; j++) 
	fprintf(fw2, "Ph[%d][%d] = %12.4f\n", i, j, Ph[i][j]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "phc1 = %12.6f\n", phc1);
    fprintf(fw2, "phc2 = %12.6f\n", phc2);
    fprintf(fw2, "phc3 = %12.6f\n", phc3);
    fprintf(fw2, "phmat1 = %12.4f\n", phmat1);
    fprintf(fw2, "phmat2 = %12.4f\n", phmat2);   
    fprintf(fw2, "php1 = %12.6f\n", php1);
    fprintf(fw2, "php2 = %12.6f\n", php2);
    fprintf(fw2, "php3 = %12.6f\n", php3);
    fprintf(fw2, "phs = %12.6f\n", phs);
    fprintf(fw2, "\n");
    if (insc == 1) {
      for (i=0; i<LL; i++) {
	if (fabs(pinmatd[i])>.000001) fprintf(fw2, "pinmatd[%d] = %14.4f\n", i,
	pinmatd[i]);
	}
      fprintf(fw2, "\n");      
      for (i=0; i<LL; i++) {
	if (fabs(pinmatnd[i])>.000001) fprintf(fw2, "pinmatnd[%d] = %14.4f\n", i,
	pinmatnd[i]);
	}
      fprintf(fw2, "\n");      
    }
    fprintf(fw2, "pl = %12.6f\n", pl);
    fprintf(fw2, "\n");
    for (i=1; i<=acs+acd+1; i++) {
      for (j=1; j<=acs+acd+1; j++)     
        if (fabs(PM[i][j])>.000001) fprintf(fw2, "PM[%d][%d] = %12.6f\n", i, 
	j, PM[i][j]);
      }
    fprintf(fw2, "\n");            
    for (i=1; i<=CC; i++) {
      if (fabs(pm[i])>.000001) fprintf(fw2, "pm[%d] = %14.4f\n", i, pm[i]);
      }
    fprintf(fw2, "\n"); 
    for (i=0; i<LL; i++) {
      if (fabs(pncal[i])>.000001) fprintf(fw2, "pncal[%d] = %14.4f\n", i, pncal[i]);
      }
    fprintf(fw2, "\n");                      
    for (i=1; i<=CC; i++) {
      if (fabs(pncalc[i])>.000001) fprintf(fw2, "pncalc[%d] = %14.4f\n", i, pncalc[i]);
      }
    fprintf(fw2, "\n");                  
    for (i=1; i<=CC; i++) {
      if (fabs(pp[i])>.000001) fprintf(fw2, "pp[%d] = %14.4f\n", i, pp[i]);
      }
    fprintf(fw2, "\n"); 
    for (i=1; i<=CC; i++) {
      if (fabs(pr[i])>.000001) fprintf(fw2, "pr[%d] = %14.4f\n", i, pr[i]);
      }
    fprintf(fw2, "\n");                      
    fprintf(fw2, "prai = %12.6f\n", prai);
    fprintf(fw2, "prair = %12.6f\n", prair);
    fprintf(fw2, "\n"); 
    for (i=1; i<=CC; i++) {
      if (fabs(pras[i])>.000001) fprintf(fw2, "pras[%d] = %14.4f\n", i, pras[i]);
      }
    fprintf(fw2, "\n");    
    for (i=0; i<p1; i++) {
      for (j=0; j<p2; j++) 
	fprintf(fw2, "Prb[%d][%d] = %12.4f\n", i, j, Prb[i][j]);
      }
    fprintf(fw2, "\n");    	 
    fprintf(fw2, "prb = %12.6f\n", prb);
    fprintf(fw2, "prbb = %10.0f\n", prbb);
    fprintf(fw2, "prbbcull = %12.6f\n", prbbcull);
    fprintf(fw2, "prbbsel = %10.0f\n", prbbsel);
    fprintf(fw2, "\n");
    for (i=0; i<p1; i++) {
      for (j=0; j<p2; j++) 
	fprintf(fw2, "Prc[%d][%d] = %12.4f\n", i, j, Prc[i][j]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "prc = %12.6f\n", prc);
    fprintf(fw2, "\n");        
    if (pcmf > 0.000001) {
      for (i=0; i<p1; i++) {
	for (j=0; j<p2; j++) 
	  fprintf(fw2, "Prcs[%d][%d] = %12.4f\n", i, j, Prcs[i][j]);
	}
      fprintf(fw2, "\n");                
    fprintf(fw2, "prcs = %12.6f\n", prcs);
    }
    fprintf(fw2, "prdg = %12.6f\n", prdg);
    fprintf(fw2, "\n"); 
    for (i=0; i<LL; i++) {
      if (fabs(preg2nmc[i])>.000001) fprintf(fw2, "preg2nmc[%d] = %14.4f\n", i,
      preg2nmc[i]);
      }
    fprintf(fw2, "\n");         
    fprintf(fw2, "preg2nmh = %12.6f\n", preg2nmh);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(preg3nmc[i])>.000001) fprintf(fw2, "preg3nmc[%d] = %14.4f\n", i,
      preg3nmc[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "preg3nmh = %12.6f\n", preg3nmh);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(pregaic[i])>.000001) fprintf(fw2, "pregaic[%d] = %14.4f\n", i,
      pregaic[i]);
      }
    fprintf(fw2, "\n");        
    fprintf(fw2, "pregaih = %12.6f\n", pregaih);
    fprintf(fw2, "\n"); 
    for (i=1; i<=CC; i++) {
      if (fabs(prf[i])>.000001) fprintf(fw2, "prf[%d] = %14.4f\n", i, prf[i]);
      }
    fprintf(fw2, "\n");         
    for (i=0; i<p1; i++) {
      for (j=0; j<p2; j++) 
	fprintf(fw2, "Prh[%d][%d] = %12.4f\n", i, j, Prh[i][j]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "prh = %12.6f\n", prh);
    fprintf(fw2, "\n");         
    for (i=1; i<=CC; i++) {
      if (fabs(prm[i])>.000001) fprintf(fw2, "prm[%d] = %14.4f\n", i, prm[i]);
      }
    fprintf(fw2, "\n");                 
    fprintf(fw2, "prnphse = %12.6f\n", prnphse);
    fprintf(fw2, "prodsys = %d\n", prodsys);    
    fprintf(fw2, "profitab = %12.2f\n", profitab);
    fprintf(fw2, "profitabd = %12.2f\n", profitabd);
    fprintf(fw2, "prot = %12.6f\n", prot);
    fprintf(fw2, "prphse = %12.6f\n", prphse);
    fprintf(fw2, "prrep = %12.6f\n", prrep);
    fprintf(fw2, "\n");  
    for (i=1; i<=CC; i++) {
      if (fabs(prs[i])>.000001) fprintf(fw2, "prs[%d] = %14.4f\n", i, prs[i]);
      }
    fprintf(fw2, "\n");                                        
    fprintf(fw2, "prst = %12.6f\n", prst);
    fprintf(fw2, "prt = %12.6f\n", prt);
    fprintf(fw2, "prtb = %12.6f\n", prtb);
    fprintf(fw2, "prtse = %12.6f\n", prtse);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(prw[i])>.000001) fprintf(fw2, "prw[%d] = %14.4f\n", i, prw[i]);
      }
    fprintf(fw2, "\n");    
    fprintf(fw2, "prwt = %12.6f\n", prwt);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(qc[i])>.000001) fprintf(fw2, "qc[%d] = %14.4f\n", i, qc[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(qr[i])>.000001) fprintf(fw2, "qr[%d] = %14.4f\n", i, qr[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(rev[i])>.000001) fprintf(fw2, "rev[%d] = %14.4f\n", i, rev[i]);
      }
    fprintf(fw2, "\n");
    if (rfi_cow + rfi_h + rfi_fa + rfi_fx > 0) {
      for (i = 4; i <= 17 ; i++) {
        if (i == 7) i = 12;
	/* if (fabs(rfi[i]) > .000001) */ 
          fprintf(fw2, "rfi[%d] = %10.4f\n", i, rfi[i]);
	}
      fprintf(fw2, "\n");
      }
    fprintf(fw2, "rfi_cow = %d\n", rfi_cow);
    fprintf(fw2, "rfi_f = %d\n", rfi_f);
    fprintf(fw2, "rfi_fa = %d\n", rfi_fa);
    fprintf(fw2, "rfi_fx = %d\n", rfi_fx);
    fprintf(fw2, "rfi_h = %d\n", rfi_h);
    if (rfi_cow + rfi_h + rfi_fa + rfi_fx > 0) {
      fprintf(fw2, "\n");
      for (i = 1; i <= CC ; i++) {
	/* if (fabs(rfis[i]) > .000001) */ 
          fprintf(fw2, "rfis[%d] = %10.4f\n", i, rfis[i]);
	}
      fprintf(fw2, "\n");
      }
    if (rfi_fx == 1) fprintf(fw2, "rfisc = %10.4f\n", rfisc);      
    if (rfi_fx == 1) fprintf(fw2, "rfisf = %10.4f\n", rfisf);          
    if (rfi_fa == 1) fprintf(fw2, "rfit = %10.3f\n", rfit);
    if (rfi_fa == 1) fprintf(fw2, "rfitb = %10.3f\n", rfitb);    
    if (rfi_fa == 1) fprintf(fw2, "rfits = %10.3f\n", rfits);      
    if (rfi_cow + rfi_h + rfi_fa + rfi_fx > 0) {
      fprintf(fw2, "\n");      	
      for (i = 1; i <= CC ; i++) {
	/* if (fabs(rfis[i]) > .000001) */ 
          fprintf(fw2, "rfiw[%d] = %10.4f\n", i, rfiw[i]);
	}    
      fprintf(fw2, "\n");
      }
    fprintf(fw2, "sdcd = %10.4f\n", sdcd);
    fprintf(fw2, "sdce = %10.4f\n", sdce);
    fprintf(fw2, "sfrp = %12.6f\n", sfrp);
    fprintf(fw2, "sigmawh = %12.6f\n", sigmawh);
    fprintf(fw2, "\n");     
    for (i=1; i<=CC; i++) {
      if (fabs(sl[i])>.000001) fprintf(fw2, "sl[%d] = %14.4f\n", i, sl[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=CC; i++) {
      if (fabs(sl_1[i])>.000001) fprintf(fw2, "sl_1[%d] = %14.4f\n", i, sl_1[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=CC; i++) {
      if (fabs(sl_2[i])>.000001) fprintf(fw2, "sl_2[%d] = %14.4f\n", i, sl_2[i]);
      }
    fprintf(fw2, "\n");       
    for (i=1; i<=CC; i++) {
      if (fabs(sl_3[i])>.000001) fprintf(fw2, "sl_3[%d] = %14.4f\n", i, sl_3[i]);
      }
    fprintf(fw2, "\n");       
    fprintf(fw2, "sl2 = %12.4f\n",sl2);    
    fprintf(fw2, "startbt = %12.6f\n", startbt);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(stcd[i])>.000001) fprintf(fw2, "stcd[%d] = %14.4f\n", i, stcd[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(stce[i])>.000001) fprintf(fw2, "stce[%d] = %14.4f\n", i, stce[i]);
      }
    fprintf(fw2, "\n"); 
    for (i=1; i<=CC; i++) {
      if (fabs(straw[i])>.000001) fprintf(fw2, "straw[%d] = %14.4f\n", i, straw[i]);
      }
    fprintf(fw2, "\n"); 
    fprintf(fw2, "strawbb = %12.6f\n", strawbb);
    fprintf(fw2, "strawfi = %12.6f\n", strawfi);
    fprintf(fw2, "strawfx = %12.6f\n", strawfx);
    fprintf(fw2, "suml1 = %12.6f\n", suml1);
    fprintf(fw2, "\n"); 
    for (i=1; i<=TT; i++) {
      for (j=1; j<=TT; j++)     
        if (fabs(t[i][j])>.000001) fprintf(fw2, "t[%d][%d] = %12.6f\n", i, 
	j, t[i][j]);
      }
    fprintf(fw2, "\n"); 
    for (i=1; i<=CC; i++) {
      if (fabs(tc[i])>.000001) fprintf(fw2, "tc[%d] = %14.4f\n", i, tc[i]);
      }
    fprintf(fw2, "\n");     
    fprintf(fw2, "Tcost = %12.6f\n", Tcost);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(tdry[i])>.000001) 
        fprintf(fw2, "tdry[%d] = %14.4f\n", i, tdry[i]);
      }
    fprintf(fw2, "\n");
    fprintf(fw2, "tdrybbs = %10.4f\n", tdrybbs);
    fprintf(fw2, "tdrybbse = %10.4f\n", tdrybbse);
    fprintf(fw2, "tdrybbspdi = %10.4f\n", tdrybbspdi);
    fprintf(fw2, "tdrybbw = %10.4f\n", tdrybbw);
    fprintf(fw2, "tdrybbwe = %10.4f\n", tdrybbwe);
    fprintf(fw2, "tdrybbwpdi = %10.4f\n", tdrybbwpdi);
    fprintf(fw2, "tdryt = %10.4f\n", tdryt);
    fprintf(fw2, "tdrytb = %10.4f\n", tdrytb);
    fprintf(fw2, "tdrytbe = %10.4f\n", tdrytbe);
    fprintf(fw2, "tdrytbpdi = %10.4f\n", tdrytbpdi);
    fprintf(fw2, "tdryte = %10.4f\n", tdryte);
    fprintf(fw2, "tdrytpdi = %10.4f\n", tdrytpdi);
    fprintf(fw2, "tdryts = %10.4f\n", tdryts);
    fprintf(fw2, "tdrytse = %10.4f\n", tdrytse);
    fprintf(fw2, "tdrytspdi = %10.4f\n", tdrytspdi);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(tdrye[i])>.000001) 
        fprintf(fw2, "tdrye[%d] = %14.4f\n", i, tdrye[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(tdryfas[i])>.000001) 
        fprintf(fw2, "tdryfas[%d] = %14.4f\n", i, tdryfas[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(tdryfase[i])>.000001) 
        fprintf(fw2, "tdryfase[%d] = %14.4f\n", i, tdryfase[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(tdryfaspdi[i])>.000001) 
        fprintf(fw2, "tdryfaspdi[%d] = %14.4f\n", i, tdryfaspdi[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(tdrypdi[i])>.000001) 
        fprintf(fw2, "tdrypdi[%d] = %14.4f\n", i, tdrypdi[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(tdrys[i])>.000001) 
        fprintf(fw2, "tdrys[%d] = %14.4f\n", i, tdrys[i]);
      }
    fprintf(fw2, "\n");
    for (i = 1; i <= CC ; i++) {
      if (fabs(tdryse[i]) > .000001) 
        fprintf(fw2, "tdryse[%d] = %10.4f\n", i, tdryse[i]);
      }    
    fprintf(fw2, "\n");
    for (i = 1; i <= CC ; i++) {
      if (fabs(tdryspdi[i]) > .000001) 
        fprintf(fw2, "tdryspdi[%d] = %10.4f\n", i, tdryspdi[i]);
      }    
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(tdryw[i])>.000001) 
        fprintf(fw2, "tdryw[%d] = %14.4f\n", i, tdryw[i]);
      }
    fprintf(fw2, "\n");
    for (i = 1; i <= CC ; i++) {
      if (fabs(tdrywe[i]) > .000001) 
        fprintf(fw2, "tdrywe[%d] = %10.4f\n", i, tdrywe[i]);
      }    
    fprintf(fw2, "\n");
    for (i = 1; i <= CC ; i++) {
      if (fabs(tdrywpdi[i]) > .000001) 
        fprintf(fw2, "tdrywpdi[%d] = %10.4f\n", i, tdrywpdi[i]);
      }    
    fprintf(fw2, "\n");
    fprintf(fw2, "tech1 = %d\n", tech1);    
    fprintf(fw2, "Tprof = %12.6f\n", Tprof);
    fprintf(fw2, "Tprofh = %12.6f\n", Tprofh);
    fprintf(fw2, "Tprofl = %12.6f\n", Tprofl);
    fprintf(fw2, "\n"); 
    for (i=1; i<=CC; i++) {
      if (fabs(tr[i])>.000001) fprintf(fw2, "tr[%d] = %14.4f\n", i, tr[i]);
      }
    fprintf(fw2, "\n");         
    fprintf(fw2, "Trev = %12.6f\n", Trev);
    fprintf(fw2, "TT = %d\n", TT);
    for (i = 1; i < NT; i++) fprintf(fw2, "to[%d] = %d\n", i, to[i]);  
    for (i = 1; i < NT; i++) fprintf(fw2, "tt[%d] = %d\n", i, tt[i]);  
    fprintf(fw2, "tvh = %12.6f\n", tvh);
    fprintf(fw2, "tvl = %12.6f\n", tvl);
    fprintf(fw2, "tvm = %12.6f\n", tvm);
    fprintf(fw2, "\n");    
    fprintf(fw2, "u = %12.6f\n", u);
    fprintf(fw2, "\n");
    for (j=0; j<DD; j++)
      fprintf(fw2, "vetdys[%d] = %14.6f\n", j, vetdys[j]);
    fprintf(fw2, "\n");   
    fprintf(fw2, "w1conf = %12.6f\n", w1conf);
    fprintf(fw2, "w1conm = %12.6f\n", w1conm);
    fprintf(fw2, "w2conf = %12.6f\n", w2conf);
    fprintf(fw2, "w2conm = %12.6f\n", w2conm);
    fprintf(fw2, "w3conf = %12.6f\n", w3conf);
    fprintf(fw2, "w3conm = %12.6f\n", w3conm);
    fprintf(fw2, "\n");       
    for (i=1; i<=CC; i++) {
      if (fabs(wat[i])>.000001) fprintf(fw2, "wat[%d] = %14.4f\n", i, wat[i]);
      }
    fprintf(fw2, "\n");               
    fprintf(fw2, "wbbse = %12.6f\n", wbbse);
    fprintf(fw2, "wbbst = %12.6f\n", wbbst);
    fprintf(fw2, "wbbt = %12.6f\n", wbbt);
    fprintf(fw2, "wbfat = %12.6f\n", wbfat);
    fprintf(fw2, "\n");
    for (i=0; i<LL; i++) {
      if (fabs(wcacal[i])>.000001) fprintf(fw2, "wcacal[%d] = %14.4f\n", i,
      wcacal[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(wccal[i])>.000001) fprintf(fw2, "wccal[%d] = %14.4f\n", i, wccal[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(wcc[i])>.000001) fprintf(fw2, "wcc[%d] = %14.4f\n", i, wcc[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(wccw[i])>.000001) fprintf(fw2, "wccw[%d] = %14.4f\n", i, wccw[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(wcd[i])>.000001) fprintf(fw2, "wcd[%d] = %14.4f\n", i, wcd[i]);
      }
    fprintf(fw2, "\n");      
    for (i=0; i<LL; i++) {
      if (fabs(wcdys[i])>.000001) fprintf(fw2, "wcdys[%d] = %14.4f\n", i, wcdys[i]);
      }
    fprintf(fw2, "\n");      
    if (pcmf > 0.000001) fprintf(fw2, "wcfat = %12.6f\n", wcfat);
    if (pcmf > 0.000001) fprintf(fw2, "wcwsc = %12.6f\n", wcwsc);
    fprintf(fw2, "wcwsf = %12.6f\n", wcwsf);
    fprintf(fw2, "wcwsm = %12.6f\n", wcwsm);
    if (pcmf > 0.000001) {
      fprintf(fw2, "wcxfat = %12.6f\n", wcxfat);
      fprintf(fw2, "wcxs = %12.6f\n", wcxs);
      fprintf(fw2, "wcxw = %12.6f\n", wcxw);
      }
    fprintf(fw2, "wdcwf = %12.6f\n", wdcwf);
    fprintf(fw2, "wdcwm = %12.6f\n", wdcwm);
    if (pcmf > 0.000001) fprintf(fw2, "wdwsc = %12.6f\n", wdwsc);
    fprintf(fw2, "wdwsf = %12.6f\n", wdwsf);
    fprintf(fw2, "wdwsm = %12.6f\n", wdwsm);
    fprintf(fw2, "wfrep = %12.6f\n", wfrep);
    fprintf(fw2, "wfxs = %12.6f\n", wfxs);
    fprintf(fw2, "wfxw = %12.6f\n", wfxw);
    fprintf(fw2, "wh1cal = %12.6f\n", wh1cal);
    fprintf(fw2, "wh2cal = %12.6f\n", wh2cal);
    fprintf(fw2, "wh3cal = %12.6f\n", wh3cal);
    fprintf(fw2, "whcal = %12.6f\n", whcal);
    fprintf(fw2, "whcmat = %12.6f\n", whcmat);
    fprintf(fw2, "whcmat1 = %12.6f\n", whcmat1);
    fprintf(fw2, "whcmat2 = %12.6f\n", whcmat2);
    fprintf(fw2, "whcmat3 = %12.6f\n", whcmat3);
    fprintf(fw2, "whdmh = %12.6f\n", whdmh);
    fprintf(fw2, "whfat = %12.6f\n", whfat);
    fprintf(fw2, "whmat = %12.6f\n", whmat);
    fprintf(fw2, "whmat1 = %12.6f\n", whmat1);
    fprintf(fw2, "whmat2 = %12.6f\n", whmat2);
    fprintf(fw2, "whmat3 = %12.6f\n", whmat3);
    fprintf(fw2, "whmin = %12.6f\n", whmin);
    fprintf(fw2, "whxfat = %12.6f\n", whxfat);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(wl[i])>.000001) fprintf(fw2, "wl[%d] = %14.4f\n", i, wl[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(wl_1[i])>.000001) fprintf(fw2, "wl_1[%d] = %14.4f\n", i, wl_1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(wl_2[i])>.000001) fprintf(fw2, "wl_2[%d] = %14.4f\n", i, wl_2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=CC; i++) {
      if (fabs(wl_3[i])>.000001) fprintf(fw2, "wl_3[%d] = %14.4f\n", i, wl_3[i]);
      }
    fprintf(fw2, "\n");    
    fprintf(fw2, "wnphse = %12.6f\n", wnphse);
    fprintf(fw2, "wphse = %12.6f\n", wphse);
    fprintf(fw2, "wpreg = %12.6f\n", wpreg);
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(ws0[i])>.000001) fprintf(fw2, "ws0[%d] = %14.4f\n", i, ws0[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(ws1[i])>.000001) fprintf(fw2, "ws1[%d] = %14.4f\n", i, ws1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(ws2[i])>.000001) fprintf(fw2, "ws2[%d] = %14.4f\n", i, ws2[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "ws3 = %12.6f\n", ws3);
    fprintf(fw2, "\n");
    for (i=1; i<=CC; i++) {
      if (fabs(ww[i])>.000001) fprintf(fw2, "ww[%d] = %14.4f\n", i, ww[i]);
      }
    fprintf(fw2, "\n");
    for (i=1; i<=GG; i++) {
      if (fabs(ww1[i])>.000001) fprintf(fw2, "ww1[%d] = %14.4f\n", i, ww1[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(ww2[i])>.000001) fprintf(fw2, "ww2[%d] = %14.4f\n", i, ww2[i]);
      }
    fprintf(fw2, "\n");      
    for (i=1; i<=GG; i++) {
      if (fabs(ww3[i])>.000001) fprintf(fw2, "ww3[%d] = %14.4f\n", i, ww3[i]);
      }
    fprintf(fw2, "\n");      
    fprintf(fw2, "wwf = %12.6f\n", wwf);
    fprintf(fw2, "wwm = %12.6f\n", wwm);
    fprintf(fw2, "\n");      
    for (i=1; i<50; i++)
      if (fabs(zzlosc[i])>.000001) fprintf(fw2, "zzlosc[%d] = %12.6f\n",
       i, zzlosc[i]);
    fclose(fw2);  
  } /* End of writing to CHECK - condition zr == 134 */

  /* Printing data to FROM1_3.TXT for program EWDC */
  if (zr == 134 && prodsys == 3) {
    fw3 = fopen("FROM1_3.TXT", "w");
    fprintf(fw3, "/* Data from Production System 3\n");
    fprintf(fw3, "   Structure of the file:\n   - production system (1st value)\n   - number of reproductive cycles (2nd value)\n");
    fprintf(fw3, "   - crh1mp (3rd value)\n   - vector l3 (LL values),\n");
    fprintf(fw3, "   - vector of economic values (NT-1 values)*/\n"); 
    fprintf(fw3, "%d\n", prodsys);
    fprintf(fw3, "%d\n", LL);
    fprintf(fw3, "%12.8f\n", crh1mp);
    for (i = 0; i < LL; i++) fprintf(fw3, "%16.8f\n", l3[i]);  
    for (i = 1; i < NT; i++) fprintf(fw3, "%18.4f\n", ew[i]);    
    fclose(fw3);
    }

END:  
  printf("\nThank you for using the program EWBC.\n");
  printf("The results are in the file %s.\n", out);
  printf("Some preliminary results are in the file CHECK.\n");
  kon = clock();
  printf("The program needed %6.2f seconds.\n\n\n", ((double) (kon - zac)) / ((double) CLOCKS_PER_SEC));
  return 0;
} /* End of function main */

/* Function for reading system variables and writing them to output file */
void sysvar(FILE *fr, FILE *fw)
{
  int a, b, i, z;
  for (i = 1; i <= 14; i++)
  { fscanf(fr, "%d", &b);
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;
	if (z != '"') putc(z, fw); 
       } while (a<2);
    fprintf(fw, ":  %d", b);   
  }
  fprintf(fw, "\n\n");   
}

/* Function for reading system variables to the main program */
int readsyva(FILE *fr)
{
  int a, b, z;
  fscanf(fr, "%d", &b);
  a = 0;
  do {z = getc(fr);
      if (z=='"') a++;
  } while (a < 2);  
  return b;
}

/* Function for reading the head of a input file
   and writing it to the output file*/
void inp07(FILE *fw, int n2, int zz)
{
  if (zz<10) fprintf(fw, "2.%1d Data from file ", zz);
    else fprintf(fw, "2.%2d Data from file ", zz);
  if (n2<10) fprintf(fw, "INPUT0%d.TXT\n", n2);
  if (n2>9) fprintf(fw, "INPUT%d.TXT\n", n2);
  if (zz<10) fprintf(fw, "------------------------------\n");
    else fprintf(fw, "-------------------------------\n");
}  

/* Function for reading data from file TEXT_OUT.TXT and writing them to the output file*/
void outputrw(FILE *fr, FILE *fw)
{
  int a, z;
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;
	if (z != '"') putc(z, fw); 
       } while (a<2);
}

/* Function for reading data from file TEXT_OUT.TXT without writing them to the output file*/
void outputr(FILE *fr)
{
  int a, z;
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;	
       } while (a<2);
}

/* Function for calculating days from January 1st from month and day */
int dsjf(int m, int d)
{ 
  int ds;
  ds = d;
  if (m >= 2) ds=ds+31;
  if (m >= 3) ds=ds+28;
  if (m >= 4) ds=ds+31;
  if (m >= 5) ds=ds+30;
  if (m >= 6) ds=ds+31;
  if (m >= 7) ds=ds+30;
  if (m >= 8) ds=ds+31;
  if (m >= 9) ds=ds+31;
  if (m >= 10) ds=ds+30;
  if (m >= 11) ds=ds+31;
  if (m >= 12) ds=ds+30;
  return ds;
}  

/* Function calculating month and day from days since January 1st */
void dfdsjf(FILE *fw, int d2)
{
  int m, d;
  if (d2 <= 31) {
    m = 1;
    d = d2; }
  if (d2 >= 32 && d2 <= 59) {
    m = 2;
    d = d2 - 31; }
  if (d2 >= 60 && d2 <= 90) {
    m = 3;
    d = d2 - 59; }
  if (d2 >= 91 && d2 <= 120) {
    m = 4;
    d = d2 - 90; }
  if (d2 >= 121 && d2 <= 151) {
    m = 5;
    d = d2 - 120; }
  if (d2 >= 152 && d2 <= 181) {
    m = 6;
    d = d2 - 151; }
  if (d2 >= 182 && d2 <= 212) {
    m = 7;
    d = d2 - 181; }
  if (d2 >= 213 && d2 <= 243) {
    m = 8;
    d = d2 - 212; }
  if (d2 >= 244 && d2 <= 273) {
    m = 9;
    d = d2 - 243; }
  if (d2 >= 274 && d2 <= 304) {
    m = 10;
    d = d2 - 273; }
  if (d2 >= 305 && d2 <= 334) {
    m = 11;
    d = d2 - 304; }
  if (d2 >= 335 && d2 <= 365) {
    m = 12;
    d = d2 - 334; }
  fprintf(fw, "%d %d", m, d);         
}

/* Function for reading data in format month-day */
int readmd(FILE *fr)
{
  int mo, da, dsj;
  fscanf(fr, "%d %d", &mo, &da);
  dsj = dsjf(mo,da);
  readdes(fr);
  return dsj;
}     

/* Skipping the comment at the beginning of the input file */
void readcom(FILE *fr)
{
  int a, z;
  a = 0;
  do {z = getc(fr);
      if (z=='/') a++;
  } while (a < 2);  
}

/* Skipping the description and the unit of the input parameter */
void readdes(FILE *fr)
{
  int a, z;
  a = 0;
  do {z = getc(fr);
      if (z=='"') a++;
  } while (a < 4);  
}

/* Function for reading data in format int and writing them to results */
float readint(FILE *fw, FILE *fr)
{
  int a, a1, z, d2;
  fscanf(fr, "%d", &d2);
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"') putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
    fprintf(fw,"):  %d ", d2);   
  return d2;
}

/* Function for reading data in format float and writing them to results */
float readfloat(FILE *fw, FILE *fr)
{
  int a, a1, z;
  float d2;
  fscanf(fr, "%f", &d2);
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"') putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
    fprintf(fw,"):%12.4f ", d2);   
  return d2;
}  

/* Function for reading data in format month-day and writing them to results */
int readdatum(FILE *fr, FILE *fw)
{
  int mo, da, dsj;
  fscanf(fr, "%d %d", &mo, &da);
  wrides(fr, fw);
  dsj = dsjf(mo,da);
  fprintf(fw, " %d  %d\n", mo, da);
  fprintf(fw, "   (days from January 1st):  %d", dsj);   
  return dsj;
}     

/* Function for reading and writing the description of a variable */
void wrides(FILE *fr, FILE *fw)
{
int a, a1, z;
  fprintf(fw, "\n");
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"' && a > 0) putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
  fprintf(fw,"):");
}

/* Maximum of two numbers */
float maxi(float a, float b) {
  float c;
  c = a;
  if (a < b) c = b;
  return c;
}

/* Probit function */
double probit (double y) {
  double x1, x2, y1, y2;
  int i;
  x1=-5;
  x2=5;  
  for (i=1; i<=200; i++){
  y1=normdis(x1);
  y2=normdis(x2);
  if (y2<y) x2=x2+(x2-x1)/2;
  if (y1>y) x1=x1-(x2-x1)/2;
  if (y2-y>y-y1) x2=x2-(x2-x1)/10;
    else x1=x1+(x2-x1)/10;
    }
  return (x1+x2)/2;
  }

/* Normal distribution */    
double normdis(double x) {
  double u;
  if (x<=0) u = .5 - erf(-x/sqrt(2.))/2;  
  if (x>0) u = .5 + erf(x/sqrt(2.))/2;  
  return u;
  }

/* Wrong input parameters for lactation curve */
void nonsense1()
{
  printf("\nSomething is going wrong with the parameters for the laction curve\n");
  printf("Correct your input parameters in INPUT20.TXT and restart the program\n\n");
  }

/* Wrong indices for summation in category 20 */
void nonsense2()
{
  printf("\n\n\nSomething is going wrong with category 20\n");
  printf("Days of pregnancy of purchased female for replacement is\n");
  printf(" greater than length of pregnancy)\n");
  printf("Correct these input parameters in INPUT13.TXT and INPUT03.TXT,\n");
  printf("  respectively, and restart the program.\n\n");
  }

/* Wrong parameters exmc and mtest */
void nonsense3()
{
  printf("\n\n\nSomething is going wrong.\n");
  printf("The sum of the following two input parameters from the file \n");
  printf("  INPUT03.TXT must be less than 1 or equal to 1:\n");
  printf("- Male calves sold for export expressed as proportion of male weaned calves \n");
  printf("- Proportion of weaned male calves sold to the bull test stations\n");
  printf("Correct these input parameters in INPUT03.TXT and restart the program.\n\n");
  }

/* Wrong parameters pff, exfc, phs and nphs*/
void nonsense4()
{
  printf("\n\n\nSomething is going wrong.\n");
  printf("The sum of the following input parameters from the files \n");
  printf("  INPUT03.TXT and INPUT13.TXT must be equal to 1:\n");
  printf("- Female calves sold expressed as proportion of surplus female calves\n");
  printf("- Proportion of surplus female calves for fattening\n");
  printf("- Pregnant heifers sold expressed as proportion of surplus female calves\n");
  printf("- Breeding heifers sold before mating expressed as proportion of surplus\n"); 
  printf("  female calves\n");
  printf("Correct these input parameters in input files INPUT03.TXT\n");
  printf("  and/or INPUT13.TXT and restart the program.\n\n");
  }

/* Wrong parameters pff and exfc*/
void nonsense4a()
{
  printf("\n\n\nSomething is going wrong.\n");
  printf("The sum of the following input parameters from the file \n");
  printf("  INPUT03.TXT must be equal to 1:\n");
  printf("- Female calves sold expressed as proportion of surplus female calves\n");
  printf("- Proportion of surplus female calves for fattening\n");
  printf("Correct these input parameters in input file INPUT03.TXT\n");
  printf("  and restart the program.\n\n");
  }

void nonsense5()
{
  printf("\nWarning: Something is going wrong with vector l1\n\n");
  }

/* Wrong parameters wcacal[0], wfrep */
void nonsense6()
{
  printf("\nSomething is going wrong.\n");
  printf("At least one of these input parameters is wrong:\n");
  printf("- Weight of female for replacement at purchase\n");
  printf("- Weight of cows after 1st calving\n");
  printf("Correct these input parameters in input file INPUT14.TXT.\n");
  printf("  and restart the program\n\n");
  }

/* Wrong parameter wcacal[1] */
void nonsense7()
{
  printf("\nSomething is going wrong.\n");
  printf("The following input parameter is wrong:\n");
  printf("- Weight of cows after 2nd calving\n");
  printf("Correct this input parameter in input file INPUT03.TXT.\n");
  printf("  and restart the program\n\n");
  }
  
/* Number of reproductive cycles too low or two high */
void nonsense8()
{
  printf("\nSomething is going wrong.\n");
  printf("The number of lactions (reproductive cycles) is not in the range\n");
  printf("it should be. Correct the value in PARA.TXT and restart the program.\n\n");
  }
/* Wrong proportions of male calves for export and performance test */
void nonsense9()
{
  printf("\nSomething is going wrong.\n");
  printf("If there is no fattening at all or no fattening of bulls and castrates\n");
  printf("  the sum of Male calves sold at weaning expressed as proportion of\n");
  printf("  male weaned calves and the Proportion of weaned male calves which\n");
  printf("  are performance tested must be 1. Correct these values in \n");
  printf("  INPUT03.TXT and restart the program.\n\n");
  }
/* Wrong proportion of male calves for export */
void nonsense10()
{
  printf("\nSomething is going wrong.\n");
  printf("If there is no fattening at all or no fattening of bulls and castrates\n");
  printf("  in Production Systems 2 or 3, then the Proportion of male calves\n");
  printf("  sold must be 1.\n");
  printf("  Correct this value in INPUT03.TXT and restart the program.\n\n");
  }
/* Wrong date of calving */
void nonsense11()
{
  printf("\nSomething is going wrong.\n");
  printf("The date of calving must be outside the pasture period.\n");
  printf("  Correct the appropriate dates in INPUT01.TXT and restart the program.\n\n");
  }
void print23(float a, float b, float c, float d, FILE *fw)
{
  if (a > 0.000001 && b > 0.000001) fprintf(fw, "%9.1f %9.1f", c, d);
  if (a > 0.000001 && b <= 0.000001) fprintf(fw, "%9.1f      -", c);
  if (a <= 0.000001 && b > 0.000001) fprintf(fw, "     -    %9.1f", d);
  }
